






     '-------------------------------------------------------------------------
     'PRINTS A TARGET NAME & ADDRESS LABELS       08JUN87        File:Label.Bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables the user to print out a set of name & address labels for all the 
     'prospects who are on a specified Target List.
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'A=single precision for elapsed time Routine
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     dim rec$(12)                  'Array to hold name & address data
     dim pp$(20)                   'Holds printer port specs & control codes
     dim LabelLine$(7)
     dim FourLabel$(7,4)           'Array for one row of 4 labels
     '
     if op = 4 then            'If tractor-fed matrix printer labels, then
        NumAcross = 4          'set for 4 labels across the web, else
        PrtType$="DQ"
 elseif op = 5 then
        NumAcross = 3          'set for 3 across a laser-label sheet @ 12 pitch
        PrtType$="LQ"
 elseif op = 8 then
        NumAcross = 2          'set for 2 across a laser-label sheet @ 12 pitch
        PrtType$="LQ"
        end if
     FMMflag=0                 'Set to 1 to display FMM states
     RecFileNum=1              'File N under which Records File is opened
     AreaFileNum=2             'File N under which Sales Areas File is opened
     TargFileNum=3             'File N under which Target List File is opened
     PrtBufNum=4               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 2                 'To be printed on 15 by 12 label stationery
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     BlankLine$=space$(5)+chr$(13)
     PostAreaList$="ABALB BABBBDBHBLBNBRBSBTCACBCFCHCMCOCRCTCVCWDADDDEDGDHDL"_
                  +"DNDTDYEHENEXFKFYG GLGUHAHDHGHPHRHUHXIGIPIVKAKTKWKYL LALD"_
                  +"LELLLNLSLUM MEMKMLNENGNNNPNROLOXPAPEPHPLPOPRRGRHRMS SASG"_
                  +"SKSLSMSNSOSPSRSSSTSYTATDTFTNTQTRTSTWUBWAWDWFWNWRWSWVYOZE"_
                  +"E ECN NWSESWW WC"
     gosub ExpiryTest
     '
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub ShowStates3
     column=45:colour=14
     ps$="PRINTER'S AUTO PERFORATION SKIP":row=13:gosub 50
     ps$="  MUST BE DISABLED FOR LABELS  ":row=14:gosub 50
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     FromEntryState=1
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
     While Terminate=0
     gosub ListInit       'Load printer codes/error messages/initialize loop
     gosub KeyBoard       'Keyboard input/output FMM
     gosub PrintIO        'Printer input/output FMM
     gosub LoopCtrl       'Record print loop control
     gosub FileCtrl       'Controls opening and closing of the required files
     gosub RecordIO       'Handles the input of the main prospect records
     gosub GetAreas       'Handles the input of the sales area data
     gosub TargetIO       'Handles the input of the target list of prospects
     gosub OpenFileFMM    'General file opener FMM
     gosub SetUpNextLabel 'Set up lines of print as required
     gosub KeybCtrl       'Loop escape watch dog for exiting this load module
     gosub FromEntry      'To set start row for labels
     gosub PrtInteg       'Printer opener & interity watch dog
     gosub ShowMsgs       'Display any DOS messages picked up by above routines
     gosub ShowStates     'Display FMM states
     wend
     FileNum=0:gosub CloseFile   'close printer & all files
     ps$="":gosub ShowMsgs1      'clear error message field
     prog$="LABEL"               'Set program identification variable
     chain"Lmenu2"               'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
50   Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'LabelIni.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     rem $include: 'EdField.FMM'
     rem $include: 'FROM.FMM'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
DeActivate:
     '
     PrintIOState=0     'Printer input/output FMM
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     RecordIOState=0    'Handles the input of the main prospect records
     GetAreasState=0    'Handles the input of the sales area data
     TargetIOState=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     '
     FileNum=0:gosub CloseFile:return       'Close printer & all files
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     '
     if ShowMessages=0 then return   'No messages waiting to be displayed
     '
     if DosClr>0 then           _    'If there is a DOS message to be displayed
        colour=DosClr           _    'set the appropriate message colour
       :DosClr=0                _    'Message colour acts as message trigger
       :ps$=DosMsg$             _    'set up the message in the display string
       :gosub ShowMsgs1              'display message
     '
     if PrtClr>0 then           _    'If there's a Printer Status message to be
        colour=PrtClr           _    'displayed, set appropriate message colour
       :PrtClr=0                _    'Message colour acts as message trigger
       :row=23:column=46        _
       :ps$=Pstatus$            _    'set up the message in the display string
       +space$(30-len(pstatus$))_    'Pad out to 30 character message field
       :gosub 50                _    'display message
       :gosub ShowPlamps             'display pritner status lamps
     '
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     '
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl: If CWPstate=0 then return
     '                                
     if KbStr$="" then return             'No key has been struck
     KbChar=asc(left$(KbStr$,1))          'Get ASCII value of next character &
     KbStr$=right$(KbStr$,len(KbStr$)-1)  'pop it off the Keyboard input stack
     '
     if KbChar=27 then Terminate=1  'If the `Esc' key has been pressed
     '
     if KbChar<>13 then return      'Invalid key stroke if not a C/R
     '
     if LoopCtrlState=0          _  'If the print loop FMM not active
        goto KeybCtrl1              'then see if it can be activated.
     '
     if HaltPrinterFlag=0        _  'If not currently in a halt state
        then HaltPrinterFlag=1   _  'then set printer to halt state
        else HaltPrinterFlag=0   _  'else clear the halt state
            :ps$=""              _
            :gosub ShowMsgs1        'clear possible error message.
     '
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     '
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then        'and the Lister Module initialized
        gosub SetUpTitleLabel     
        LoopCtrlState=1             'then activate the print loop FMM.
        end if
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoopCtrl:
     '
     on LoopCtrlState goto _   'State 0: inactive
        LoopCtrl1,         _   'State 1: Initiate opening of all required files
        LoopCtrl2,         _   'State 2: wait for file-opening to complete
        LoopCtrl3,         _   'State 3: process next prospect on target list
        LoopCtrl4,         _   'State 4: get next list member's record number
        LoopCtrl5,         _   'State 5: get the next list member's record
        LoopCtrl6,         _   'State 6: get the next list member's sales area
        LoopCtrl7,         _   'State 7: drain printer output stack
        LoopCtrl8,         _   'State 8: wait for next print line
        LoopCtrl9              'State 9: confirm storage of `list printed' flag
     '
     return
     '
     '-------------------------------------------------------------------------
     'INITIATE THE OPENING OF ALL REQUIRED FILES
     '
LoopCtrl1:
     '
     FileCtrlState=1            'Activate the file opening process
     LoopCtrlState=2            'Advance to next machine state
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR FILE-OPENING TO COMPLETE
     '
LoopCtrl2:
     if FileCtrlState=5 then    'If all files opened successfully, then
        if op = 5 then          'If dot-matrix labels, then
           x$ = pp$(18)         'pitch, pointsize, typeface
           PrStr$ = pp$(8) + x$ 'else do inkjet/laser initialisation.
           '                 E(s10h.....
           '                    
           pitch! = val(mid$(x$,4,2))
           if pitch! < 12! or pitch! > 17! then pitch! = 12!
           if pitch! >= 16! and pitch <= 17! then pitch! = 16.67! 
           x! = 33! * pitch! / 12!
           Interlabel = x!
      else PrStr$ = pp$(2)      'do dot-matrix/avery initialisation,
           Interlabel = 33
           end if
        LoopCtrlState=3         'set to loop advancement state
        goto LoopCtrl3          'Proceed to loop advancement process
 elseif FileCtrlState=8 then    'If the file opening process failed, then
        gosub DeActivate        'De-activate all FMMs
        end if
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'ADVANCE TO NEXT PROSPECT ON THE TARGET LIST
     '
LoopCtrl3:
     '
     if TargItem<TargSize then _   'If last list member has been printed
        TargItem=TargItem+1    _   'Advance to [next] member of target list
       :TargetIOstate=4        _   'Activate getting of the next targ list rec
       :LoopCtrlState=4        _   'Advance to the Get Record state
       :goto LoopCtrl4             'Go to wait for record to arrive.
     '
     '-------------------------------------------------------------------------
     'LAST RECORD HAS BEEN PROCESSED; DRAIN REMAINDER OF PRINT OUTPUT STACK
     '
     if PrStr$="" then         _   'When printer output stack is finally
        PrtfFlag=1             _   'set the `list printed' flag
       :TargItem=0             _   'Target List Record#0
       :TargetIOstate=6        _   'Store Record of Target List File
       :LoopCtrlState=9            'Advance to next machine state
     '
     return                        'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
LoopCtrl4:
     '
     if TargetIOstate=5  then   _  'If the next target list record got OK then
        RecordIOstate=4         _  'Activate the main record `get' process
       :LoopCtrlState=5         _  'Advance to the next machine state
       :goto LoopCtrl5             'Go straight to monitor next state
     '
     if TargetIOstate=10 then   _  'If error occurred while getting record,
        gosub DeActivate           'then de-activate all FMMs
     '
     return                        'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD
     '
LoopCtrl5:
     '
     if RecordIOstate=5  then _  'If the next target list record got OK then
        GetAreasState=4       _  'Activate the sales area search
       :LoopCtrlState=6       _  'Advance to next state
       :goto LoopCtrl6
     '
     if RecordIOstate=10 then _  'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs

     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S SALES AREA
     '
LoopCtrl6:
     '
     if GetAreasState=5  then _  'If the next target list record got OK then
        LoopCtrlState=7       _
       :goto LoopCtrl7
     '
     if GetAreasState=8  then _  'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs

     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINT OUTPUT STACK TO EMPTY
     '
LoopCtrl7:
     '
     if len(PrStr$)<20   then _  'If there is plenty of room on the printer
        NextLabelState=1      _  'output stack then ask PrintLine.FMM to set up
       :LoopCtrlState=8          'another line & return to get the next record.
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR NEXT PRINT LINE TO BE SET UP
     '
LoopCtrl8:
     '
     if NextLabelState=2 then    _  'If the next print line has been set up
        NextLabelState=0         _  'then de-activate the print line setter up
       :LoopCtrlState=3             'output stack and go for next record.
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'CONFIRM STORAGE OF `LIST PRINTED' FLAG
     '
LoopCtrl9:
     '
     if TargetIOstate=7 then     _   'If the record has been stored OK
        Pstatus$="FINISHED"      _
       :PrtClr=10:ShowMessages=1 _   '
       :gosub DeActivate             'De-activate all FMM/close files & printer
     '
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT LINE ROUTINE
     '
     'When externally set to State 1, this routine assembles the name & address
     'details of the record just retrieved into the order required for labels
     'and puts them in the appropriate lable slot in the 4-label array ready to
     'for printing. In the process, it also strips off any asterisked comments
     'and the contact's `familiar name' if present. It also de-rationalizes the
     'postcode into the normal free-form appearance. This FMM assumes that the
     '[next] record is sitting in rec$().
     '
     '--------------------------------------------------------------------------
     'SET UP NEXT LABEL FOR PRINTING
     '
SetUpNextLabel:                        'State 0: inactive
     if NextLabelState<>1 then return  'State 1: set up print line
                                       'State 2: print line ready
     '
     LabelNum=LabelNum+1      'Advance to the first/next label.
     '
     gosub CommentFilter      'Strip comments & familiar name from the name &
     gosub ReSequenceFields   'address details, put them in the order required
     gosub CloseUpBlanks      'for labels, close up over any blank name/address
     gosub TransferLabel      'lines and transfer result to the 4-label array.
     '
     if LabelNum=NumAcross     _  'If a complete row or 4 labels is set up
        then gosub Print4Labels_  'then print the completed row of 4 labels.
        else                   _  'otherwise'
     if TargItem=TargSize      _  'if there are more labels still to do, then
        and LabelNum>0         _  'and an incomplete row of labels is set up at
        then gosub Print4Labels   'the end of the printout, then print them.
     '
     NextLabelState=2         'Set to `next print line now set up' state
     return                   'Return control to the FMM polling loop.
     '
     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FiveDigit: LenFld=5:goto Digits:
FourDigit: LenFld=4
Digits:
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM
     '
FileCtrl:
     '
     on FileCtrlState goto _    'State 0: Inactive
        FileCtrl1,         _    'State 1: Activate Records file opening
        FileCtrl2,         _    'State 2: Activate Areas file opening
        FileCtrl3,         _    'State 3: Activate Target file opening
        FileCtrl4,         _    'State 4: If all files open goto Wait State
        FileCtrl5,         _    'State 5: File open wait state
        FileCtrl6               'State 6: Close all involved files
     '                          'State 7: Successful Termination state
     return                     'State 8: Error state
     '
     '--------------------------------------------------------------------------
     'OPEN MAIN RECORDS FILE
     '
FileCtrl1:
     '
     RecordIOstate=1            'Activate the record input/output FMM to open
     FileCtrlState=2            'the records file and advance to next state.
     return
     '
     '--------------------------------------------------------------------------
     'OPEN SALES AREAS FILE
     '
FileCtrl2:
     '
     if RecordIOstate=3  then _ 'If the records file is now open, then
        GetAreasState=1       _ 'Activate areas file input FMM to open
       :FileCtrlState=3         'the target list file; advance to next state.
     '
     if RecordIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN TARGET LIST FILE
     '
FileCtrl3:
     '
     if GetAreasState=3  then _ 'If the areas file is now open, then
        TargetIOstate=1       _ 'Activate target file input/output FMM to open
       :FileCtrlState=4         'the target list file; advance to next state.
     '
     if GetAreasState=8       _ 'If areas file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'WAIT FOR TARGET LIST FILE TO OPEN
     '
FileCtrl4:
     if TargetIOstate=3  then   'If the records file is now open, then
        FileCtrlState=5         'the target list file; advance to next state.
 elseif TargetIOstate=10 then   'If records file wouldn't open, then
        goto FileCtrl8          'de-activate all FMMs involved and exit.
        end if
     return
     '
     '--------------------------------------------------------------------------
     'ALL FILES OPEN & READY FOR I/O
     '
FileCtrl5: return               'All files open Wait State
     '
     '--------------------------------------------------------------------------
     'CLOSE ALL FILES
     '
FileCtrl6:
     FileNum=1:gosub CloseFile  'Close Records File
     FileNum=2:gosub CloseFile  'Close Areas File
     FileNum=3:gosub CloseFile  'Close Target File
     gosub DeActivate           'De-activate
     FileCtrlState=7            'Successful Termination State
     '
     '--------------------------------------------------------------------------
     'ALL FILES CLOSED OK
     '
FileCtrl7: return               'Wait State
     '
     '--------------------------------------------------------------------------
     'FILE OPENING FAILED
     '
FileCtrl8:                      'Open failure
     gosub DeActivate           'De-activate
     FileCtrlState=8            'Set this FMM to its error state
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3: column=41:colour=grey
     ps$="                                        ":row= 5:gosub 50
     for row=6 to 14:gosub 50:next
     ps$="                                        ":row=15:gosub 50
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of prospects on list   0000    ":row=17:gosub 50
     ps$="    Now printing prospect N  0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     '
     number=TargSize:row=17:colour=7:gosub ShowStates1:return
     '
     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES
     '
ShowStates: colour=7
     '
     if LastTargItem<>TargItem then _
        LastTargItem =TargItem      _
       :row=18:number=TargItem:gosub ShowStates1
     return
     '
ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     If PrtIntegState=1 then            'WAIT FOR INITIALIZATION TO COMPLETE
        if ListInitState=4 then _       'If initialization process completed
           PrtIntegState=2              'Initiate opening of the printer
        if ListInitState=5 then _       'If initialization process has failed
           ListInitState=1              'the re-activate it & try again.
 elseIf PrtIntegState=2 then            'SEE IF PRINTER IN OPEN
        if PrintIOstate=3 then return   'Printer I/O FMM in normal active state
        if PrintIOstate=4 then return   'Printer I/O FMM in X-off state
        PrtIntegState=3                 'Advance to wait for printer on
        PrintIOstate=1                  'Activate the printer I/O FMM
        gosub ShowPreStartMsgs          'Show the `switch on printer' message
 elseIf PrtIntegState=3 then            'WAIT FOR PRINTER TO OPEN
        if PrintIOstate>2 then      _   'If the printer is on and ready or
           PrtIntegState=2              're-set Printer Watchdog to monitoring
        end if
     return                             'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CHOP OFF ASTERISKED COMMENTS AND FAMILIAR NAME
     '
CommentFilter:                          'Record fields in rec$(12)
     for RecField=1 to 11               'Fields which can carry comments
     rec$=rec$(RecField)                'Get [next] name & address field
     x=instr(rec$,"*")                  'Position of comment delimiter asterisk
     if x>0 then rec$=left$(rec$,x-1)   'If present chop off * and beyond.
     if RecField=10 then                'If this is the contact name field
        x=instr(rec$,"{"):if x>0 then mid$(rec$,x,1)=" "
        x=instr(rec$,"}"):if x>0 then mid$(rec$,x,1)=" "
        x=instr(rec$,"(")               'Position of familiar name delimiter
        if x>0 then rec$=left$(rec$,x-1)'if present, chop off familiar name.
        end if
     rec$(RecField)=rec$                'Get [next] name & address field
     next:return                        'Next field/return to calling routine.
     '
     '-------------------------------------------------------------------------
     'NAME & ADDRESS RE-SEQUENCING
     '
ReSequenceFields:                      'Ref format: ssssssssssss00000 A 00 0000
     '
     if ShowRef then
     Number=RecNum  :gosub FiveDigit:RefNum$ =Number$
     '
     LabelLine$(0)=space$(12)        _  'Right-justifying spacer
                  +RefNum$     +" "  _  'Reference Number
                  +SalesAreaID$+" "  _  'Sales Area Identifier letter A thru R
                  +TargNum$    +" "  _  'Target extraction serial number
                  +SerNum$              'Extraction serial number
     end if
     '
     LabelLine$(1)=rec$(10)    'Name of person to whom label is addressed
     LabelLine$(2)=rec$(11)    'The above person's job title
     LabelLine$(3)=rec$( 1)    'Name of the company
     LabelLine$(4)=rec$( 3)    'Address Line #1: Premises name (House name etc)
     LabelLine$(5)=rec$( 4)    'Address Line #2: Premises number & Street Name
     LabelLine$(6)=rec$( 5)    'Town
     '
     Postcode$=rec$(7):gosub DeRationalizePostcode
     '                  '
     x$ = rec$(6): y$ = "  "
     if x$ = "" then y$ = ""
     LabelLine$(7)=x$        _  'Line #6 comprises the County name
                  +y$        _  'plus a two-character separator
                  +Postcode$    'plus the 8-chracter postcode
     return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CLOSE UP BLANK ADDRESS LINES & PUT ADDRESS IN LabelLine$ ARRAY
     '
     'Name & address lables comprise 8 lines or 27 characters each.
     '
     'Name & address data is stored in          This routine therefore closes
     'the name & address record in              up the name & address to cut
     'rationalized form with each field         out blank lines as shown below.
     'in a fixed position. This would           This gives a much more
     'make a name & address with absent         acceptible presentation for
     'to be printed as below:                   a printed name & address label.
     '
     'Ŀ              Ŀ
     '             0340 A 02 9999                           0340 A 02 9999
     'Mr R J Morton                            Mr R J Morton              
     '                                         Eastern Business Systems   
     'Eastern Business Systems                 13 Thornbera Close         
     '                                         Bishops Stortford          
     '13 Thornbera Close                       Herts CM23 3NR             
     'Bishops Stortford                                                   
     'Herts  CM23 3NR                                                     
     '              
     '
CloseUpBlanks:
     DownBias=0            'Start by assuming all name & address line occupied
     for LineNum=1 to 7    'For each of the label's 7 name & address lines...
     '
     if LabelLine$(LineNum)<=" " then   'If this label line contains nothing
        DownBias=DownBias+1             'increment the number of lines you
 elseif DownBias>0 then                 'otherwise, if you have to push back,
        LabelLine$(LineNum-DownBias) _  'then push the current occupied line
        =LabelLine$(LineNum)            'back the required number of lines
        LabelLine$(LineNum)=""          'and clear the current line element.
        end if
     next:return                        'Go back & do the next label line
     '
     '-------------------------------------------------------------------------
     'TRANSFER FINISHED LABEL INTO THE FOUR-ACROSS PRINT ARRAY
     '
     'Ŀ                  This routine transfers the newly assembled
     'xxxxxxxxxxx LabelLine$(x)    label text into the 4-across labels array.
     'xxxxxxxxxxxĿ
     '       
     'Ŀ Ŀ Ŀ Ŀ
     'wwwwwwwwwww xxxxxxxxxxx                         FourLabel$(x,y)
     'wwwwwwwwwww xxxxxxxxxxx                        
     '   
     '
TransferLabel: for k=0 to 7:FourLabel$(k,LabelNum)=LabelLine$(k):next:return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'PRINT A ROW OF LABELS
     '
     'Each line of print comprises Line `n' of Label#1 + Line `n' of Label#2 +
     'Line `n' of Label#3 + Line `n' of Label#4.
     '
Print4Labels:
     FOR LabelLine=0 TO 7               'For each line of print...
     LastLabel=0                        'Find last label in row whose Line N
     for Label=1 to LabelNum            '`LabelLine' contains some text.
     if FourLabel$(LabelLine,Label)>" " then LastLabel=Label
     next
     if LastLabel>0 then                'If text exists for at least one label
        for Label=1 to LastLabel        'on this line number, then...
        LabelLine$=left$(FourLabel$(LabelLine,Label),InterLabel)
        if Label<LastLabel then       _ 'If this is not last occupied column,
           LabelLine$=LabelLine$      _ 'pad out this label line with enough
           +space$(InterLabel-len(LabelLine$))  'spaces to reach start of next label.
        PrStr$=PrStr$+LabelLine$        'Add label line to current print line.
        next:PrStr$=PrStr$+chr$(13)     'Carriage return at end of print line
        else PrStr$=PrStr$+BlankLine$   'else make this whole line a blank line
        end if
     NEXT                               'Next print line
     PrStr$=PrStr$+BlankLine$           'Blank line between rows of labels
     LabelNum=0                         'Reset `label number within row' counter
     return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SET UP THE TITLE LABEL
     '
     'The very first label of the printout identifies the whole printout by
     'specifying the Target N and Serial N from which the label listing
     'was extracted.
     '
SetUpTitleLabel:
     if CompanyName$="" then _            'If no company name specified
        CompanyName$="E.B.S. MARKETEER"   'then use EBS as default name.
     '  
     CompanyName$=left$(CompanyName$,27)  'Safety limit for company name
     '
     x=len(CompanyName$)                  'Calculate the spacing to
     if x<27 then y=27-x:z=y/2:x=y-z      'centrallize the company name.
     '
     Number=ExtrFlag:gosub FourDigit:SerNum$ =Number$           'Serial Number
     Number=TargNum :gosub FourDigit:TargNum$=right$(Number$,2) 'Target Number
     '
     if SeqTyp=1 then ListingOrder$="     ALPHABETIC ORDER      "
     if SeqTyp=2 then ListingOrder$="     REF NUMBER ORDER      "
     if SeqTyp=3 then ListingOrder$="  ALPHABETIC WITHIN AREA   "
     if SeqTyp=4 then ListingOrder$="ALPHABETIC WITHIN DISTRICT "
     if SeqTyp=5 then ListingOrder$=" ALPHABETIC WITHIN SECTOR  "
     if SeqTyp=6 then ListingOrder$="      POSTCODE ORDER       "
     '
     FourLabel$(0,1)=space$(x)+CompanyName$+space$(z)
     FourLabel$(1,1)="  NAME AND ADDRESS LABELS  "
     FourLabel$(2,1)="                           "
     FourLabel$(3,1)="Target "+TargNum$+" Serial "+SerNum$
     FourLabel$(4,1)=TargName$
     FourLabel$(5,1)="Extract "+ListDate$
     FourLabel$(6,1)="Listing order:"
     FourLabel$(7,1)=ListingOrder$
     '
     LabelNum=1:return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'DE-RATIONALIZE THE POSTCODE
     '
     'The rationalized version of the postcode as stored in the prospect's
     'name & address record is stored in a standard format: AANX#NAA where
     '
     'A represents a capital letter
     'N represents a number 0 thru 9
     'X represents a capital letter or a number
     '# represents a space
     '
     'If the post area (the first 2 letters) is represented by only one letter
     'eg M for Manchester, then a space is inserted to make up the standard
     'format within the name & address record's postcode field. Similarly, if
     'the sector number (the two digits in positions 3 & 4) is only a single
     'digit, it is preceded by a leading zero in position 3 with the single
     'digit placed in position 4 when stored on the name & address record.
     '
     'This routine removes the possible extra space and `0' when they appear
     'so that the postcode is printed on the name & address lable in the
     'conventional de-rationalized format, eg M1 5XT.
     '
DeRationalizePostcode:
     Postcode$=Postcode$+space$(8-len(Postcode$))  'Ensure postcode is 8 chrs
     '
     y$=left$(PostCode$,2)
     j=0:K=len(PostAreaList$)-1
     while j=0 and k>0
     if mid$(PostAreaList$,k,2)=Y$ then j=1 else k=k-2
     wend
     if k>0 then                            'If it is an existing UK post area
        if mid$(Postcode$,3,1)="0" then     'If the 3rd character is a leading
           Postcode$=left$(Postcode$,2) _   'zero, then remove it and contract
                    +right$(Postcode$,5)    'the postcode string accordingly.
           end if
        if mid$(Postcode$,2,1)=" " then     'If the 2nd character is a trailing
           Postcode$=left$(Postcode$,1) _   'space, then remove it and contract
           +right$(Postcode$,len(PostCode$)-2) 'postcode string accordingly.
           end if
   else PostCode$=""
        end if
     Postcode$=Postcode$+space$(8-len(Postcode$))  'Ensure postcode is 8 chrs
     return
     '
     '-------------------------------------------------------------------------

