


     '                                  1


     'BINARY INDEX SEARCH SUBROUTINE    Author : R J Morton          BinSrch.INC



     'Inputs SearchKey$  - an upto 8 chr key field
     '       LastElement - number of entries on index
     '       FileName$   - Assumes appropriate index file open as IndxFileNum

     'Output RecNum - interger record number
     '       HighFlag  =1 means high element is closer match
     '       ElementNum  - main index-search index

     'Locals CE$ - current index entry
     '       BL  - binary jump [number of entries]
     '       BD  - binary divisor re: jump
     '       SKL - length of Search Key [input string]
     '       HEP - Character search index for HE$
     '       LEP - Character search index for LE$
     '       HE$ - High index entry being compared
     '       HE  - main record pointer for the above
     '       LE$ - Low index element being compared
     '       LE  - main record pointer for the above
     '       LTBN  - Current Block (of 256 index records)

     '                                                                 Ŀ
     'BINARY SEARCH                                             INDEX     
     '                                                                    
     'The first attempt at finding                                        
     'the desired record is made                                          
     'by testing the index's middle                                       
     'entry against the entered                                           
     'key field. If the key field                    
     'is lower, make the next test                                      
     'on the index entry half way                                       
     'between the middle entry and                          
     'the start of the index;                                            
     'otherwise try half way                                             
     'between the middle of the           
     'index and the end of the                                            
     'index.                                                              
     '                                                                    
     'According to whether each                                           
     'successive test gives the                                           
     'key as being higher or                                              
     'lower, the next test is                                             
     'made above or below the                                             
     'last one half way between                                           
     'it and the entry tested                                             
     'before it.                                                          
     '                                                                 
     '


     '                                  2


     'INITIALIZATION
     '
BinarySearch:
     LTEN=0:LTEB=0:LTBN=0:TTBN=1        'See BS7:
     HighFlag=0                         'Assume exact match to start with
     if LastElement=0 then              'If index empty
        RecNum=0:goto BS3               'Set `record not found' and exit.
        end if
     on error goto BS8                  'Set local error trapping
     if LastElement=1 then              'If only one element in the index
        ElementNum=1:gosub BS7:goto BS1
        end if                          '
     ElementNum=fix(LastElement/2)      'Set element number half way up index
     BD=4                               'Halve the divisor for next pass
     SKL=len(SearchKey$)                'N of chars to be used for match test


     'BINARY SEARCH LOOP

     F=0                                'Loop exit trigger flag
     M=0                                'Exact match indicator flag
     WHILE F=0
     gosub BS7:CE$=X$                   'Get next index element from disk
     BL=fix(LastElement/BD)             'Compute binary jump size for next pass
     if SearchKey$=CE$ then M=1         'Set the Match Flag
     if BL>0 and M=0 then               'If Binary Leap exists & still no match
        BD=BD+BD                        'Set to halve next time's jump size.
        if SearchKey$>CE$ then          'If index element still too low, leap
           ElementNum=ElementNum+BL     'half way back up to prev test point;
      else ElementNum=ElementNum-BL     'half way back down to prev test point.
           end if
   else F=1                             'Set loop escape [F]lag because no
        end if                          'match yet and Binary Leap is now zero.
     WEND
     if BL=0 and M=0 goto BS4           'If Binary Leap<1 go to single stepping
BS1: RecNum=RN                          'Exit with Record N if perfect match
BS2: F=0:While ElementNum>1 and F=0     'AN EXACT MATCH, BUT IS IT THE FIRST?
     ElementNum=ElementNum-1:gosub BS7  'Back up to the previous element
     if SearchKey$=X$ then              'If search key matches prev element
        RecNum=RN
   else F=1:ElementNum=ElementNum+1     'then back up and try further.
        end if
     wend
BS3: on error goto 0:return             'Normal exit

     '


     '                                  3


     'SINGLE-STEP SEARCHES You will only have to search a maximum of one elemen
     '
BS4: IF SearchKey$>CE$ THEN             'SEARCH UPWARDS ONE ELEMENT AT A TIME
        LE$=CE$:LE=RN:F=0               'Set current element as low element
        While F=0 and ElementNum<LastElement
        ElementNum=ElementNum+1
        gosub BS7:HE$=X$:HE=RN          'Make next higher element current HE
        if SearchKey$>HE$ then          'If search key > high test element then
           LE$=HE$:LE=HE                'make it the low test element,
    elseif SearchKey$<HE$ then          'If search key lower than high element
           ElementNum=ElementNum-1:F=3  'then re-set EN to point to low element
      else F=2:RecNum=HE                'else we have a exact match
           end if
        wend      
        ELSE                            'SEARCH DOWNWARDS ONE ELEMENT AT A TIME
        HE$=CE$:HE=RN                   'Set current element as high element
        F=0:While F=0 and ElementNum>1
        ElementNum=ElementNum-1
        gosub BS7:LE$=X$:LE=RN          'Make next lower element current LE
        if SearchKey$<LE$ then          'If search key < low test element then
           HE$=LE$:HE=LE                'make it the new low test element.
    elseif SearchKey$>LE$ then          '
           F=3
      else F=1:RecNum=LE                'Exact match
           end if
        wend
        END IF
     on F+1 goto BS1,BS2,BS3

     '


     '                                  4


     'FIND WHETHER THE HIGH OR THE LOW ELEMENT IS THE CLOSER MATCH

     LEP=1                              'Pos'n of first dissimilar char in LE$
     While mid$(LE$,LEP,1)= _           'While corresponding characters of low
     mid$(SearchKey$,LEP,1)             'element and Search Key identical, go
     LEP=LEP+1:wend                     'test the next character along.
     HEP=1                              'Pos'n of first dissimilar char in HE$
     While mid$(HE$,HEP,1)= _           'While corresponding characters of high
     mid$(SearchKey$,HEP,1)             'element and Search Key identical, go
     HEP=HEP+1:wend                     'test the next character along.
     if LEP>HEP goto BS5                'LE$ has more identical chars than HE$
     if LEP<HEP goto BS6                'HE$ has more identical chars than LE$
     z=asc(mid$(SearchKey$,LEP,1))      'ASCII value of 1st mismatchinf chr
     if asc(mid$(HE$,LEP,1))-z<z-asc(mid$(LE$,LEP,1)) goto BS6
BS5: RecNum=LE:goto BS3                 'Return the lower element
BS6: RecNum=HE                          'Return the higher element
     ElementNum=ElementNum+1            'Adjust the element number
     HighFlag=1:goto BS3                'Indicate that it's the higher element


     'INDEX RECORD ACCESS SUBROUTINE

     'LTEB=N of last time's element within Block
     'LTEN=Last time's Element N within Index file
     'LTBN=Last Time's Block N
     'TTEB=This time's Element N within Block
     'TTBN=This time's Block N
     'NEPB=N of elements per block
     'NBPE=N of bytes per element
     'NBPB=N of bytes per block

BS7: X=ElementNum+1
     TTEB=X-LTEN+LTEB:LTEN=X            'N of new element within block LTBN
     if TTEB< 1 then                    'If new element is in a lower block
        while TTEB<   1:TTBN=TTBN-1:TTEB=TTEB+NEPB:wend
 elseif TTEB>NEPB then                  'If new element is in a higher block
        while TTEB>NEPB:TTBN=TTBN+1:TTEB=TTEB-NEPB:wend
        end if
     LTEB=TTEB                          'Set Last Time's value for next time
     if TTBN<>LTBN then get IndxFileNum,TTBN:LTBN=TTBN
     X=(TTEB-1)*NBPE+1                  'First byte of namecode within block
     X$=mid$(N1$,X,SKL)                 'Get the required index text entry
     RN=cvi(mid$(N1$,X+8,2)):return     'Get the required records N


     'LOCAL ERROR HANDLING & EXIT ROUTINES

BS8: DOSmsg$="Binary:"+er$(err)         'Set up the error message for display
     DOSclr=12                          'Set error message colour to bright red
     RecNum=0                           'Set Record N to zero to show error
     resume BS8a                        'Disable error trapping
BS8a:on error goto 0                    'De-activate the local error trap
     gosub FileError                    'Close file & activate error message
     return                             'Return to the calling program

