






     '-------------------------------------------------------------------------
     'COMPILE SALES AREAS               10FEB87                File: CompSA.bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'This program uses the post area codes which have been pre-allocated to
     'each sales area to generate the main map plots file PLOTS.BAS and its
     'index file PLOTI.BAS containing the start-record number for each sales
     'areas map plots within PLOTS.BAS
     '
     'Input Files: AreaFile$ - post areas in each sales area
     '             PapsFile$ - post area populations file
     'Output File: PapsFile$ - sales area populations file
     '
     'Input Files: PltiFile$ - index file containing start addresses
     '                         (record Ns) for each post area's plotting
     '                         co-ordinates.
     'Output File: SafsFile$ - sales area plotting information
     '
     '-------------------------------------------------------------------------
     '
     DefInt a-z
     rem $include: 'ComVars.INC'
     '
     common DmapFlag  'Indicates whether we exit to Dmap instead of Menu
     '
     dim pc$(18,100)  '2-letter identifiers of Post Areas in each Sales Area
     dim pc%(18)      'N of Post Areas in each of the 18 Sales Areas
     '
     dim pap$(120)    'Two-letter identifier for each of the 120 Post Areas
     dim pap#(120)    'N of postal addresses in each of the 120 Post Areas
     '
     dim sap#(18)     'N of postal addresses in each of the 18 Sales Areas
     '
     dim SAF%(18,100) 'Record N in Map Plots file at which the pixel plots
                      'start for each post area within each sales area.
     '
     Retries=5       'N of allowed re-tries at opening a file in case of error
     goto CompSA1
     '
     rem $include: 'InChar.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'OpenFile.INC'
     rem $include: 'Expiry.INC'
     '
Display:
     row=row+1
50   call ScrSub(ps$,row,column,colour):return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'DISPLAY THE MESSAGE PANEL
     '
CompSA1: gosub ExpiryTest
     row=4:column=41:colour=9
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="           Ŀ             ":gosub Display
     ps$="            RE-COMPILING              ":gosub Display
     ps$="             SALES AREA               ":gosub Display
     ps$="            INFORMATION:              ":gosub Display
     ps$="                                      ":gosub Display
     ps$="            PLEASE WAIT.              ":gosub Display
     ps$="                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     ps$="                                        ":gosub Display
     '
     ErrMsgRow=20:ErrMsgCol=45
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'INPUT SALES AREA POSTCODES
     '
     FileName$=AreaFile$:FileNum=1:RecLen=202:gosub OpenFile
     field#1,2 as f1$,200 as f2$
     for i=1 to 18                  'For each sales area
     get#1,i          
     a=cvi(f1$):pc%(i)=a            'Number of postcodes in this sales area
     for j=1 to a
     pc$(i,j)=mid$(f2$,j+j-1,2)     'Two-letter Post Area identifier
     next:next
     close
     '
     '-------------------------------------------------------------------------
     'LOAD EACH POST AREA'S TWO-LETTER IDENTIFIER + POPULATION
     '
     FileName$=PapsFile$:FileNum=1:RecLen=6:gosub OpenFile
     field#1,2 as f1$,4 as f2$
     for i=1 to 120:get#1,i
     pap$(i)=f1$                     'Two-letter PostArea identifier
     pap#(i)=cvs(f2$)                'Post Area's Population
     next:close
     '
     '-------------------------------------------------------------------------
     'COMPUTE THE NUMBER OF POSTAL ADDRESSES IN EACH SALES AREA
     '
     for i=1 to 18           'For each of the 18 Sales Areas..
     x=pc%(i)                'Get N of post areas in this sales area
     for j=1 to x            'For each Post Area within this Sales Area..
     y$=pc$(i,j)             'Get its Two-letter Post Area identifier
     k=1
     '                              'If it matches the [next] post area in the
CompSA2: if y$=pap$(k) then _       'post area population array then add this
         sap#(i)=sap#(i)+pap#(k)_   'Post Area's population to the population
         :goto CompSA3              'for the current Sales Area.
     '
     if k<120 then k=k+1:goto CompSA2   'Next post area in population array
     '
CompSA3: next:next           'Next Post Area in; Next Sales Area.
     '
     '-------------------------------------------------------------------------
     'STORE THE NUMBER OF POSTAL ADDRESSES IN EACH SALES AREA
     '
     FileName$=SapsFile$:FileNum=1:RecLen=-1:gosub OpenFile  'Open for output
     for i=1 to 18
     x#=sap#(i)/1000#     'N of `k' postal addresses in sales area
     x=x#                 'Now within single precision ~23000
     print#1,str$(x)       
     next:close
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SET UP SALES AREA PIXEL PLOTTING REFERENCES FOR SALES AREA MAP DISPLAY
     '-------------------------------------------------------------------------
     '
     '  Record N in Plots File at      Plots   N of plots in this 
     '  which plots data for 3rd        File    Post Area's display
     '  post area in 1st sales area     Rec N       
     '  begin.                                     Co-ordinates of a line
     '              0822 pp     
     '  SAF Array                       0825 xxxyyyxxxyyy  line
     '  nnnn nnnn 0822 nnnn ....          0826 xxxyyy        dot
     '  nnnn nnnn nnnn nnnn ....          0827 xxxyyyxxxyyy  line
     '  nnnn nnnn nnnn nnnn ....          0829 xxxyyy        dot
     '  .... .... .... .... ....          0830 pp another
     '  (18 by 100)                       0831 xxxyyyxxxyyy       post area
     '
     'The Plots File is produced by the Marketeer utility `PlotGen*.bas' which
     'is not part of the user-package.
     '
     '-------------------------------------------------------------------------
     'SET UP POST AREA PLOT ADDRESSES FOR ALL THE SALES AREAS
     '
     FileName$=PltiFile$:FileNum=1:RecLen=4:gosub OpenFile
     field#1,2 as f1$,2 as f2$
     '
     for i=1 to 18     'For each sales area
     a=pc%(i)          'get N of post areas therein
     '
     for j=1 to 120    'Compare each post area
     get#1,j           'found in the Map Plots Index File
     k=1               'with each post area found in the current sales area
     '
CompSA4: if f1$=pc$(i,k) _            'If they match, put N of record of 
            then SAF%(i,k)=cvi(f2$)_  'Map Plots file at which the graphics 
            :goto CompSA5             'plotting data for this post area starts.
     '
     if k<a then k=k+1:goto CompSA4   'Next post area in this sales area
     '
CompSA5: next:next:close
     '
     '-------------------------------------------------------------------------
     'STORE THE ADDRESSES IN THE SAF FILE
     '
     FileName$=SafsFile$:FileNum=1:RecLen=-1:gosub OpenFile  'Open for output
     '
     for i=1 to 18
     a=pc%(i):print#1,str$(a)
     for j=1 to a
     print #1,str$(SAF%(i,j))
     next:next:close
     '
     prog$="COMPSA"
     if DmapFlag=1 then chain"Dmap"
     chain"Menu"
     '
     '-------------------------------------------------------------------------
     '
