


     '                                  1


     'DELETE A TARGET LIST   by  R J Morton                         DELTARG.BAS

     'This program deletes a target list from the main database. Use it with
     'extreme care. 

     defint a-z
     '$include: 'Comvars.INC'
     '$include: 'Comvart.INC'
     dim FS$(2)                         'File names
     dim FS%(4,2)                       'Numeric file-attributes

     TRUE = -1 : FALSE = 0
     LineEnd$ = chr$(13) + chr$(10)

Initialise:
     MustReEnterGoahead   = FALSE
     WarningMsgVisible    = FALSE
     OpeningFiles         = FALSE
     Finished             = FALSE
     Terminated           = FALSE
     AllFilesOpen         = FALSE
     DatabaseExport       = FALSE
     DeletingList         = FALSE
     ShowMessage          = FALSE
     GoaheadGiven         = FALSE

     OpenFileState = 0
     CWPstate      = 0
     TargItem      = 0


     B$ = ""             'Clear the Export File output stack

     goto SetUpFileIO


     'EXTERNAL ROUTINES

     '$include: 'Keyboard.FMM'
     '$include: 'EdField.FMM'
     '$include: 'OpenFile.FMM'

Show:call ScrSub( show$, row, column, colour ) : return
50   call ScrSub(   ps$, row, column, colour ) : return

     '


     '                                  2


     'FILE I/O SPECIFICATION FOR THIS LOAD MODULE

     'DiskFile is the array index number of a file's details
     'This could be different from the buffer number.

     'Record Length > 0 it means record length for the above file 
     '              = 0 open a file for input
     '              =-1 open a file for output
     '              =-2 open a file for appending

     '                     SELF      OTHERS
     '      LockFile    READ WRITE READ WRITE
     '          0         Y    Y     Y    Y        Y=PERMISSION GIVEN
     '          1         Y    Y     Y    N        N=PERMISSION DENIED
     '          2         Y    N     Y    Y
     '          3         Y    N     Y    N


SetUpFileIO:

     'FILE   PATH/NAMEBUFFER N   LOCK TYPE   RECORD LENGTH  OPEN/CLOSED
     FS$(1) = KeysFile$:FS%(1,1) = 3:FS%(2,1) = 0:FS%(3,1) =    8:FS%(4,1) = 0
     FS$(2) = TargFile$ + TargNum$
                       :FS%(1,2) = 8:FS%(2,2) = 0:FS%(3,2) =    8:FS%(4,2) = 0


     OpenFiles$ = chr$(1) _     'Set up requests for opening: the keys file
                + chr$(2)       '                            target list file

     CloseFiles$ = OpenFiles$   'Set up the closing requests

     MaxDiskFiles = 2 : goto PollingLoop



     'FILE RECORD FIELD FORMAT SPECIFICATIONS

SetField: on DiskFile goto SF1, SF2

     SF1: field FS%(1,1), FS%(3,1) as Field11$ : return
     SF2: field FS%(1,2), 2        as Field21$ : return
     '


     '                                  3


     'FMM POLLING LOOP

PollingLoop:
     WHILE NOT FINISHED                 'Do until the finished flag gets set

     IF AllFilesOpen = TRUE THEN        'If all required files now open, then
        if DeletingList = TRUE then
           if TargItem < TargSize then  'If not yet reached end of list
              TargItem = TargItem + 1   'Move on to next list member
              gosub ShowListNumber
              gosub DeleteRecord        'Get next list member's data
              gosub DeleteDossier       'Export next list member's dossier
           else
              DeletingList = FALSE      'Stop the exporting process
              Terminated = TRUE         'Set the `termination' flag
           end if
        end if
     ELSE
        if GoaheadGiven = FALSE then
           gosub AcceptGoahead          'Accept export file name from keyboard
        else
           gosub OpenFiles              'Open files as required
           gosub CheckFilesStatus       'Check closed/open/opening error
        end if                          'status of all files.
     END IF

     if Terminated = TRUE then          'If export process has been terminated
        gosub CloseFiles                'go and close all the files.
        if CloseFiles$ = "" then        'If no more close request messages
           Finished = TRUE              'set the Finished flag.
        end if
     end if

     if ShowMessage = TRUE then         'ERROR MESSAGES DISPLAY
        ps$ = left$( DosMsg$, 80 )
        ps$ = DosMsg$ + space$( 80 - len(DosMsg$) )
        row = 3 : column = 1 : colour = DosClr : gosub 50
        DosClr = 0 
        ShowMessage = FALSE
     end if

     gosub Keyboard                     'Poll the keyboard
     if KbChar = 27 then                'If Escape key hit
        Terminated = TRUE               'Terminate the loop
        AbortExport = TRUE              'Keystroke aborts export
     end if

     WEND




     ps$ = space$(80) : column = 1 : colour = 7 : row = 4 : gosub 50

     RecNum = 0                         'To reset global record search
     chain"Lmenu2"                      'Return to the Target List Menu.
     '


     '                                  4


     'UNIVERSAL DISK FILE OPENER

OpenFiles:
     if OpenFiles$ = "" then return     'Exit if no files waiting to be opened



     if OpeningFiles = FALSE then       'If file opener is not initialised,

        DiskFile = asc( left$( OpenFiles$, 1 ) )

        if DiskFile > MaxDiskFiles then 'If DiskFile N is invalid, then
           gosub CloseFiles2            'Show error message
           goto OpenFiles1
        end if

        FileName$ = FS$(    DiskFile )  'Set up File Name
        FileNum   = FS%( 1, DiskFile )  '       File's buffer N
        LockFile  = FS%( 2, DiskFile )  '       Type of locking required
        RecLen    = FS%( 3, DiskFile )  '       Record Length
        OpenFileState = 1               'Activate the file opener FMM
        OpeningFiles = TRUE             'Advance to wait state
     end if



     gosub OpenFileFMM                  'Shot thru the File Opener FMM

     if OpenFileState < 5 then return   'Exit if File Opener FMM still busy

     if OpenFileState = 5 then          'If File Opener FMM terminated OK, then
        gosub SetField                  'Set up appropriate field format
        FS%(4,DiskFile) = 1             'Set file status to `open'
     else
        ShowMessage = TRUE 
        DosClr = 12                     'Prefix error msg with file I/D
        FS%(4,DiskFile) = -1            'Set file status to `opening error'
     end if                       

     OpenFileState = 0                  'Deactivate the file opener FMM
     OpeningFiles = FALSE               'Deactivate self



OpenFiles1:  'Remove the file open request from request stack

     OpenFiles$ = right$( OpenFiles$, len( OpenFiles$ ) - 1 )

     return

     '


     '                                  5


     'UNIVERSAL DISK FILE CLOSER

CloseFiles:
     if CloseFiles$ = "" then return    'Exit if no closing requests pending

     DiskFile = asc( left$( CloseFiles$, 1 ) ) 'Get DiskFile N of next file

     if DiskFile > MaxDiskFiles then    'If it is in valid range, then
        gosub CloseFiles2               'Error message
     else
        FileNum = FS%( 1, DiskFile )    'set up the files Buffer N
        gosub CloseFile                 'close the file
        FS%( 4, DiskFile ) = 0          'Set the file to `closed'
     end if



     'Remove the file open request from request stack.

     CloseFiles$ = right$( CloseFiles$, len( CloseFiles$ ) - 1 ) 
     return



CloseFiles2:  'Set up the DOS error message

     DosMsg$ = "DiskFile" _
             + str$( DiskFile ) _
             + "/MaxDiskFiles" _
             + str$( MaxDiskFiles )

     DosClr = 12                        'Display message in bright red
     ShowMessage = TRUE                 'Activate the message displayer
     return

     '


                                        6


     'CHECK THE CLOSED/OPEN/ERROR STATUS OF ALL FILES. SET THE ALL-FILES-OPEN 
     'FLAG WHEN ALL FILES HAVE BEEN OPENED SUCCESSFULLY. SET THE FILE-ERROR-
     'OCCURRED FLAG AND THE OPENER'S TERMINATION SWITCH IF AN ERROR OCCURRED 
     'WHEN TRYING TO OPEN ONE OF THE FILES.

CheckFilesStatus: 
     AllFilesOpen = TRUE                'Set to indicate All Files Open

     K = 0                              'File N

     WHILE K < MaxDiskFiles             'While all files not yet checked

     K = K + 1                          'Advance to test status of next file
     X = FS%(4,K)                       'Get the file's current status
     if x <> 1 then                     'If it is not yet open
        AllFilesOpen = FALSE            'All files are not yet open
        if x = -1 then                  'If an error occurred opening it
           Terminated = TRUE            'Terminate the file opening operation
        end if
     end if

     WEND


     IF AllFilesOpen = TRUE and _       'If all files now open OK, and
        Terminated = FALSE THEN         '
        BufLen = FS%(3,1)               'Buffer Length of FILENAME.MDB

        KeysHandle = FS%(1,1)           'Keys File handle
        TargHandle = FS%(1,2)           'Target List File handle 

        get TargHandle, 1               'Get the first target list record
        TargSize = CVI( Field21$ )      'N of members of this list
        gosub ShowExportMsg             'Display initial progress message
        DeletingList = TRUE             'Activate the data export routine

     END IF                             'De-activate this load module

     return
     '


     '                                  7


     'ACCEPT KEYBOARD INPUT OF EXPORT FILE NAME

AcceptGoahead:
     IF WarningMsgVisible = FALSE THEN
        if MustReEnterGoahead = FALSE then
           gosub DisplayEntryWindow
           FieldRow = 7
           FieldCol = 42
           FieldLen = 38
           FieldStr$ = ""               'Clear the field contents string
           MustReEnterGoahead = TRUE
        end if
        caps=1                          'Set to convert lower case to caps
        CharCol=1                       'Set cursor to start of field
        EdFieldState=1                  'Activate the field editor FMM
        WarningMsgVisible = TRUE        'Set `initialized' flag
     ELSE
        gosub EdFieldFMM                'Pass thru the field editor FMM
        if EdFieldState < 3 then return 'Field editor not yet terminated.
        EdFieldState = 0 : caps = 0     'De-activate it.
        if FieldStr$ <> "YES I DO" then
           Terminated = TRUE            'quit the program
        else
           GoaheadGiven = TRUE
        end if
        WarningMsgVisible = FALSE       'De-activate self
     END IF
     RETURN

     '


                                        8


     'DISPLAY THE WINDOW WHERE THE EXPORT FILESPEC IS ENTERED

DisplayEntryWindow:
     column = 41  :colour = 1
     ps$ = "" : row =  5 : gosub 50
     colour = 19
     ps$ = "                                        " : row =  7 : gosub 50
     ps$ = "  " : row =  8 : gosub 50
     ps$ = "                                        " : row =  6 : gosub 50
     for row = 9 to 22 : gosub 50 : next
     colour = 1
     ps$ = "" : row = 23 : gosub 50

     column = 42 : colour = 27
     ps$ = "IF YOU PROCEED, YOU WILL WIPE EVERY   " : row =  6 : gosub 50
     ps$ = "MEMBER OF THIS TARGET LIST OFF THE    " : row =  9 : gosub 50
     ps$ = "MAIN DATABASE - PERMANENTLY! ARE YOU  " : row = 10 : gosub 50
     ps$ = "REALLY SURE YOU WANT TO?              " : row = 11 : gosub 50
     ps$ = "                                      " : row = 12 : gosub 50
     ps$ = "IF YOU WANT TO PRESERVE THEM YOU MUST " : row = 13 : gosub 50
     ps$ = "EXPORT THEM TO ANOTHER MARKETEER      " : row = 14 : gosub 50
     ps$ = "DATABASE OR EXPORT FILE BEFORE YOU    " : row = 15 : gosub 50
     ps$ = "DELETE THEM FROM THIS DATABASE.       " : row = 16 : gosub 50
     ps$ = "                                      " : row = 17 : gosub 50
     ps$ = "IF YOU ARE ABSOLUTELY SURE YOU WANT   " : row = 18 : gosub 50
     ps$ = "TO DELETE THEM, TYPE IN THE WORDS:    " : row = 19 : gosub 50
     ps$ = "                                      " : row = 20 : gosub 50
     ps$ = "       `YES I DO' IN CAPITALS         " : row = 21 : gosub 50
     ps$ = "                                      " : row = 22 : gosub 50

     return



ShowExportMsg:               'Display the initial exporting message
     x$ = str$(TargSize)
     ps$ = "  Deleting List Member N      of" + space$( 6 - len(x$) ) + x$
     column = 41 : colour = 7 : row = 4 : goto 50



ShowListNumber:              'Display record currently being exported
     ps$ = str$(TargItem)
     ps$ = space$( 6 - len(ps$) ) + ps$
     row = 4 : column = 65 : colour = 7 : goto 50

     '


     '                                  9


     'GET THE NAME & ADDRESS, KEYS, ATTRIBUTES & SELECTOR CODE DATA FOR
     'EXPORT LIST MEMBER N TargItem


DeleteRecord:
     on error goto GetExpErr1
     get TargHandle, TargItem + 1       'Get the next target list record
     RecNum = CVI( Field21$ )           'Get RecNum of next List Member

     get KeysHandle, RecNum             'Get the List Member's Keys Record
     x$ = Field11$
     mid$( x$, 6, 1 ) = "@"             'Set record status = unoccupied
     lset Field11$ = x$
     put KeysHandle, RecNum

DeleteRecord2:
     on error goto 0                    'Clear the error trap
     return



GetExpErr1:
     DosMsg$ = er$( err )    'Get text of DOS error message
     resume GetExpErr2       'POP out of error status
GetExpErr2:
     DosClr = 12             'Set error message display colour to bright red
     ShowMessage = TRUE      'Trigger message display
     Terminated = TRUE       'Activate the termination procedure
     goto DeleteRecord2








     'DELETE THE DOSSIER FILE RELATING TO THE CURRENT RECORD

     'Marketeer's dossier file names are of the form Dnnnnn where nnnnn is the 
     'Ref N of the name & address record to which it pertains.

DeleteDossier:
     x = RecNum : gosub DossierName         'Form the dossier name based
     on error goto ExpDossErr1              'Set the error trap
     kill DossFile$ + x$                    'on the addressee's main Ref N

DeleteDossier2: on error goto 0 : return    'Clear the error trap and exit


DossierName:
     x$ = str$( x )                         'Dossier's filename number
     x$ = right$( x$, len(x$) - 1 )         'chop off BASIC's leading space
     x$ = string$( 5 - len(x$), "0" ) _     'Add leading zeros.
        + x$
     return


ExpDossErr1: resume DeleteDossier2




