





     '-------------------------------------------------------------------------
     'SINGLE COLUMN BLOCK EDITOR USING EDFIELD   27NOV86    [File: EDBLOCK.BAS]
     '-------------------------------------------------------------------------
     'ENTRY POINTS:
5605 GOTO EdBlock1 'Display the operator's editing instructions
5606 GOTO EdBlock2 'Display title-less editing instructions (save line 20)
5607 GOTO EdBlock3 'Display the single-column block of fields
5608 GOTO EdBlock4 'Edit the single-column block of fields
5609 GOTO EdBlock5 'Re-entry at start of main control loop (eg after PgUp/PgDn)
5610 GOTO EdBlock6 'Edit starting at a field `I' other than the first
     '
     'Allows entry & editing of data in a block of displayed fields. Fields
     'may be text (with or without auto capital convertion) or numerics.
     'Numeric fields are displayed with digits blocked in 3's with alternate
     'blocks bright & dim.
     '
     'Inputs     BLOCKROW - Top row of block
     '           BLOCKCOL - First column of fields
     '           InstrCol - Column for instructions
     '           LENFIELD - Length of each field
     '           AMENDF   - Set =1 if and of the text has been modified
     '           NUMFLDS  - Number of fields in the block
     '           MULTIBLK - Set to 1 if more than one column of fields
     '           MsgPos   - INSERT message position override flag
     '
     'Outputs    FIELDS$(18) - Name & Address array (max 18 fields)
     '           AMENDF - Set =1 if and of the text has been modified
     '
     '
     '-------------------------------------------------------------------------
     'DISPLAY OPERATOR COMMANDS
     '
EdBlock1:
     colour= 2    :if InstrCol=0 then column= 1 else column=InstrCol
     row=20:ps$="                                        ":gosub 50
EdBlock2:
     colour= 2    :if InstrCol=0 then column= 1 else column=InstrCol 
     row=21:ps$="      move cursor    Ins insert on/off  ":GOSUB 50
     row=22:ps$="   backspace/erase   Del erase character":GOSUB 50
     row=23:ps$="   go to next line   Home start of line ":GOSUB 50
     if NoFkeys=0 then
        ps$="       F2-SAVEF3-EXIT WITHOUT SAVING  "
        COLOUR=112:row=24:GOSUB 50
        end if
     colour=10
     row=21:ps$=chr$(24)+chr$(25)+" "+chr$(26)+chr$(27)   :gosub 50
     row=22:ps$=chr$(17)+chr$(196)                        :gosub 50
     row=23:ps$=chr$(17)+chr$(217)                        :gosub 50
     if InstrCol=0 then column=22 else column=InstrCol+21
     row=21                   :ps$="Ins"                  :gosub 50
     row=22                   :ps$="Del"                  :gosub 50
     row=23                   :ps$="Home"                 :gosub 50
     '
     return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
EdBlock4:
     if MsgPos=0 _               'Insert messages position override flag
        then Msg.V=BlockRow-4_   'Row for INSERT & Count displayed
            :Msg.H=21            'Position of INSERT message display
     '
     kolour=23           'Initial group's colour for colour band display
     pad$=" "            'Use space padding
     k=0                 'Set initial cursor 1 less than start of field
     lastk=0             'Set position of last keyed character to same place
     '
EdBlock7:
     i=1                 'Set to first name & address line
EdBlock6:
     a$=fields$(i)       'Load the first line
     AmendF=0            'Clear the "any field amended" flag
     h=BlockCol          'Set start of field to start of block column
     b=LenField          'Set field length
EdBlock5:
     v=BlockRow+i-1      'Set field row to top field of the block
     '
     '-------------------------------------------------------------------------
     'CONTROL LOOP FOR THE SINGLE-COLUMN BLOCK
     '
     gosub EdField           'General field editor
     '
     if kolour=23 then            'Toggle the colour of the first group of
        kolour=31                 'the line ready for the next line to be
   else kolour=23                 'displayed.
        end if
     if af=1 then            'If t The field was updated
        fields$(i)=a$        'Store the edited field in the fields array
        AmendF=1             'At least one field of the block has been amended
        end if
     if x=13 goto EdBlock10             'C/R
     if y=80 goto EdBlock10             'Cursor down
     if y=72 goto EdBlock11             'Cursor up
     if y=61 or X=27 then AmendF=0:return  'Escape or F3
     if y=60 then return                'F2 = store & exit
     '
     if WScroll=1 then return                'Page scrolling active
     if MultiBlk=0 then beep:goto EdBlock5   'Bum keystroke
     '
     return                  'Exit MULTIBLK
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CURSOR DOWN/CARRIAGE RETURN
     '
EdBlock10:
     if I<NumFlds then i=i+1:goto EdBlock12 else i=1      'Move to next line
     if MultiBlk=1 then return else goto EdBlock12
     '
     '-------------------------------------------------------------------------
     'CURSOR UP/DOWN
     '
EdBlock11:
     if i>1 then i=i-1:goto EdBlock12 else i=NumFlds      'Move to next line
     if MultiBlk=1 then return
EdBlock12:
     a$=fields$(i):L=Len(a$):k=LastK       'Get the next line
     if k>L+1 then k=L+1                   'Keep cursor within field of text
     if k>0 then k=k-1
     if x=13 then k=0                      'Start of field if C/R was struck
     goto EdBlock5
     '
     '-------------------------------------------------------------------------
     'DISPLAY FIELDS INITIALLY [SINGLE-COLUMN BLOCK]
     '
EdBlock3:
     if numerics=1 goto EdBlock14   'Colour banded display
     '
     column=BlockCol:colour=23
     for y=1 to NumFlds          'For all the fields (rows) in the block
     row=BlockRow+y-1            'Screen row on which field is to be displayed
     '
     x$=fields$(y)
     x$=left$(x$,LenField)            'Chop to field width if necessary
     ps$=x$+space$(LenField-len(x$))  'Pad to full field width
     '
     gosub 50:next:return             'Exit
     '
     '-------------------------------------------------------------------------
     'CLEAR THE FIELDS ARRAY
     '
EdBlock13:
     for y=1 to NumFlds
     fields$(y)=""
     next:return
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'DISPLAY FIELDS INITIALLY [SINGLE-COLUMN BLOCK] [colour-banded in 3's]
     '
     'This routine displays a field of characters as a number of groups-of-3
     'characters. The colour of each group alternates as you go along the
     'line [field]. Each new line [field] of a block of fields begins in the
     'alternate colour from the one above, thus giving the displayed block a
     'chequer board appearance. This makes it easier to read, for example,
     'fields comprising a string of 3-digit ASCII codes. This routine is
     'invoked by entering EdBlock.bas with `numerics=1'.
     '
EdBlock14:
     colour=23                   'Colour of the current group of 3 characters
     kolour=23                   'Colour of first group of the row
     l=LenField-2                'Marks first character of last group of three
     '
     for y=1 to NumFlds          'For all the fields (rows) in the block
     row=BlockRow+y-1            'Screen row on which field is to be displayed
     column=BlockCol             'Starting column for each new row
     '
     x$=fields$(y)                   'The input string to be displayed
     x$=left$(x$,LenField)           'Chop to field width if necessary
     x$=x$+space$(LenField-len(x$))  'Pad to full field width
     '
     colour=kolour                'Set colour for initial group of the new row
     column=BlockCol              'Starting column for the new row
     for x=1 to l step 3          'For each 3-digit group
     '
     if colour=23 then            'Toggle the colour ready to display the
        colour=31                 'new group of three characters on the
   else colour=23                 'current line.
        end if
     ps$=mid$(x$,x,3):gosub 50    'Print 3-digit group
     column=column+3              'Move to next group position
     next                         'Next group [of 3 digits on current line]
     if kolour=23 then            'Toggle the colour of the first group of
        kolour=31                 'the line ready for the next line to be
   else kolour=23                 'displayed.
        end if
     next:return                  'Next line [display field];   Exit
     '
     '-------------------------------------------------------------------------
     '
