





     '-------------------------------------------------------------------------
     'GENERAL FIELD EDITOR           08DEC86                [File: EDFIELD.BAS]
     '-------------------------------------------------------------------------
     '
     '5005 goto EdField  'Entry Point     Used in: PHONE, CONF, SKEYS, AMEND, ENTER,
     '5030 goto EdField
     '
     'Inputs  H - Screen column position of first character in the field
     '        V - Screen row in which the field is shown
     '        B - Maximum length of field
     '        A$- Contents of the field
     '      PAD$- Character with which empty positions are padded
     '    MSG.H - Screen column position of first character of insert message
     '    MSG.V - Screen row position for the above
     '    CNT.H - Column after the LS digit of the character count display
     '       DC - Display Count flag [=1 display count =0 don't]
     '    C.MAX - Maximum permitted character count
     ' NUMERICS - =1 if numerics-only field with 3-digit colour groups
     '   kolour - starting colour for current line
     '
     'Outputs A$ - The amended field string
     '        AF - Amend Flag [=1 if field has been altered; =0 if not]
     '     LASTK - Character position in field at which last char was entered
     '
     'Locals  K - Current character pointer within field
     '        L - Length of input/output field
     '          + variables declared in INCHAR
     '        W - Insert flag [=1 when in Insert Mode; =0 when not]
     '
EdField1:
     row=v:column=h+k-1:colour=23:goto 50   'Special screen display subroutine
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION & LOOP CONTROL
     '
EdField:
     IF PAD$="" THEN PAD$=" "          'Space is the default PAD character
     dlen=LenField-2                   'For colour-band display
     a$=left$(a$,b)                    'Make sure initial string <= field width
     W=0                               'Insert flag
     AF=0                              'Local field amended flag
     GOSUB EdField21                   'Display initial count
     '
     '-------------------------------------------------------------------------
     'CHARACTER LOOP CONTROL
     '
EdField2: L=LEN(A$)                    'Length of input field
EdField3: IF K<B THEN K=K+1            'Advance cursor position
EdField4: LOCATE V,H+K-1               'Set cursor position
EdField5: GOSUB InChar                 'Get next character
     if x=32 then x$=pad$              'Substitute PAD character for space
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CHARACTER VALIDATION & ACCEPTANCE
     '
     if x<32 goto EdField6       'TTY characters not allowed
     '
     if numerics=1 _
        and (x<48 or x>57) _     'Non-numeric in numerics field
        goto EdField7 
     '
     af=1                              'Set amendment flag
     if w=1 goto EdField13             'Jump if insert mode
     '
     if k>l _
        then gosub EdField19:a$=a$+x$ _
        else mid$(a$,k,1)=x$
     '
     ps$=x$:gosub EdField12:goto EdField2   'Locate & display entered character
     '
     '-------------------------------------------------------------------------
     'CONTROL CHARACTER HANDLING
     '
EdField6:
     IF Y=77 GOTO EdField9      'Cursor right
     IF Y=75 GOTO EdField8      'Cursor left
     IF Y=82 GOTO EdField14     'Insert
     IF Y=83 GOTO EdField10     'Delete
     if y=71 then k=1:goto EdField4        'Home
     if y=79 then k=len(a$):goto EdField3  'End
     IF Y>0 GOTO EdField16      'Controls not dealt with by EDFIELD
     IF X=13 GOTO EdField16     'C/R
     '
     IF X=27 GOTO EdField18     'Escape - leave field as was and quit
     IF X= 8 GOTO EdField11     'Back-space character
     '
EdField7: BEEP:GOTO EdField4    'Bum character has been keyed
     '
     '-------------------------------------------------------------------------
     'HORIZONTAL CURSOR CONTROL [cursor left; cursor right
     '
EdField8: gosub EdField15:if k=1 then goto EdField7 else k=k-1:goto EdField4 
EdField9: gosub EdField15:if k=b or k>l then goto EdField7 else goto EdField3
     '
     '-------------------------------------------------------------------------
     'DELETE A CHARACTER
     '
EdField10:
     AF=1:GOSUB EdField15            'Set amend flag & wipe INSERT msg
     IF K>L GOTO EdField7            'Out of range
     PS$=RIGHT$(A$,L-K)              'Form contracted field string
     A$=LEFT$(A$,K-1)+PS$
     L=LEN(A$)                       'New length of field string
     PS$=PS$+STRING$(B-L,PAD$)       'Pad the display string
     GOSUB EdField12                 'Re-display contracted field
     GOSUB EdField20:GOTO EdField4   'Re-display contracted field
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'DESTRUCTIVE BACK-SPACE CONTROL
     '
EdField11:
     AF=1:GOSUB EdField15              'Set amend flag & wipe INSERT msg
     IF K>1 THEN K=K-1 Else goto EdField7   'Out of range
     PS$=RIGHT$(A$,L-K)                'Form contracted field string
     A$=LEFT$(A$,K-1)+PS$
     L=LEN(A$)                         'New length of field string
     PS$=PS$+STRING$(B-L,PAD$)         'Pad the display string
     GOSUB EdField12                   'Re-display contracted field
     GOSUB EdField20                   'Update the character count
     GOTO EdField4                     'Back up the cursor
     '
     '-------------------------------------------------------------------------
     'DISPLAY NUMERIC FIELD IN COLOUR BANDS
     '
EdField12:
     if numerics=0 then gosub EdField1:return   'Normal display
     '
     row=v:column=h:colour=kolour
     da$=a$+space$(LenField-len(a$))    'Pad display field to full width
     for x=1 to dlen step 3
     '
     if colour=23      _    'Toggle the colour ready to display
        then colour=31 _    'the new group of three digits.
        else colour=23
     '
     ps$=mid$(da$,x,3):gosub 50:column=column+3:next:return
     '
     '-------------------------------------------------------------------------
     'INSERT A CHARACTER
     '
EdField13:
     IF K>L OR L=>B GOTO EdField7        'Out of range for inserting
     GOSUB EdField19                     'Counter control
     PS$=X$+RIGHT$(A$,L-K+1)             'Insert chr into string
     A$=LEFT$(A$,K-1)+PS$
     L=LEN(A$)                           'Pad the display string
     PS$=PS$+STRING$(B-L,PAD$)           'Pad the display string
     GOSUB EdField12                     'Re-display amended field
     GOSUB EdField19:GOTO EdField3       'Update & display character counter
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'INSERT MESSAGE CONTROL
     '
EdField14:
     IF W=1 THEN GOSUB EdField15:GOTO EdField4     'Cancel INSERT mode
        W=1                                        'Set the INSERT flag
     CURSOR=3                                      'Set cursor large
     PS$="INSERT":ROW=MSG.V:COLUMN=MSG.H:COLOUR=14 'Display the INSERT message
     GOSUB 50:COLOUR=23:GOTO EdField4
     '
EdField15:
        W=0                                        'Clear the INSERT flag
     CURSOR=6                                      'Set cursor small
     PS$="      ":ROW=MSG.V:COLUMN=MSG.H           'Wipe the INSERT message
     GOSUB 50:COLOUR=23:RETURN
     '
     '-------------------------------------------------------------------------
     'PRESENT THE EDITED FIELD & EXIT
     '
EdField16:
     gosub EdField15                        'Clear the possible INSERT message
     L=len(A$)                              'Length of the occupied field
EdField17:
     if L>0 then                            'If there are chrs in A$, then
     '
        if mid$(a$,L,1)<"!" then _          'then chop off all rightmost chrs
           L=L-1                 _          'that are of ASCII value of a
          :C=C-DC                _          'space chr or less.
          :goto EdField17                   ' 
     '
        else
        a$=left$(a$,L)
        end if
     '
EdField18:
     GOSUB EdField21                        'Display character count & exit
     IF AF=1 THEN LASTK=K                   'Position at which last chr struck
     CURSOR=6:LOCATE,,,6,7:RETURN           'Reset cursor to normal size
     '
     '-------------------------------------------------------------------------
     'CHARACTER COUNT CONTROL SUBROUTINE
     '
EdField19:
     IF DC=0 THEN RETURN                    'Character counting not required
     IF C<C.MAX THEN C=C+1:GOTO EdField22   'Max character count not reached
     W=0                                    'Kill INSERT mode
     ROW=MSG.V:COLUMN=MSG.H:COLOUR=12
     PS$="  MAX ":          GOSUB 50        'Display the MAX message
                            GOSUB EdField23 'Display count bright red
     BEEP:RETURN EdField4                   'Do not accept new character
EdField20:
     IF DC=0 THEN RETURN ELSE C=C-1:GOTO EdField22
EdField21:
     IF DC=0 THEN RETURN
EdField22:
     COLOUR=23
EdField23:
     PS$=STR$(C):ROW=MSG.V:COLUMN=CNT.H-LEN(PS$)    'Display counter
     GOSUB 50
     COLOUR=23:RETURN
     '
     '-------------------------------------------------------------------------
     '
