
'ELAPSED TIME ROUTINE         09DEC86                  [File: ELAPSED.INC]
'by Robert J Morton<robmorton@clara.net>
'Computes the elapsed time in days between System Date (Today) and the
'dates of a prospect's last and next events.

'Inputs:  REC$(0)  'Packed dates of prospect's last & next events

'Outputs: LASTDATE$  Date of last event in display form
'         NEXTDATE$    "  "  next   "   "     "     "
'         LASTDAYS$  Elapsed time [in days] from last event
'         NEXTDAYS$    "      "       "     to next event


'COMPUTE TIMES [DAYS] FROM LAST EVENT & TO NEXT EVENT
Elapsed:
     dait$=left$(rec$(0),14)           'Get packed pair of dates from Field#0
     dait$=dait$+space$(14-len(dait$)) 'of the name & address record
     LastDate$=left$ (dait$,7)         'Date of last (latest) event
     NextDate$=right$(dait$,7)         'Date of next [scheduled] event
     dait$=LastDate$                   'Date input to elapsed time calculator
     gosub Elapsed2:LastDays$=lapse$   'Elapsed days since last event
     gosub Elapsed1:LastDate$=dait$    'Date in display form
     dait$=NextDate$                   'Date input to elapsed time calculator
     gosub Elapsed2:NextDays$=lapse$   'Days to go to next scheduled event
     gosub Elapsed1:NextDate$=dait$    'Date in display form
     return

'CONVERT DATES TO DISPLAY FORM
Elapsed1:
     x = asc( mid$ (dait$, 5, 1) ) - 64
     if x < 1 or x > 12 then x = 0
     x$ = "///JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC"
     dait$ = right$(dait$, 2) _
           + mid$(x$, X + X + X + 1, 3) _
           + left$(dait$, 4)
     return



'ELAPSED TIME CALCULATOR     [Entry Point Elapsed2]    [File: ELAPSED.BAS]

'Computes the elapsed time in days between System Date (Today) and a
'a specified reference date.
'Inputs  DATE$ - System date     MM-DD-YYYY  [American unrationalized   ]
'        DETA$ - System date     YYYYMDD     [rationalized 7-byte format]
'        DAIT$ - Reference date  YYYYMDD     [rationalized 7-byte format]

'Outputs  LAPSE$ - Elapsed time in days  DDDD
'          T  - Elapsed time in days  interger

'Locals  SD - System date: day       D - reference date: day
'        SM -              month     M                   month
'        SY -              year      Y                   year
'         A - single precision real


'UNPACK THE DATES [Rationalize System Date from MM-DD-YYYY to YYYYMDD]
Elapsed2:
     gosub RatSysDate : deta$ = x$     'Form the rationalized system date 
     gosub Elapsed5:sd=d:sm=m:sy=y     'Unpack system date

     'Protect against invalid data in dates file

     x$ = left$(dait$,7) : x = len(x$)
     if x = 7 then
        while x > 0
        if x <> 5 then
           z$ = mid$(x$, x, 1)
           if z$ < "0" or z$ > "9" then x$ = "////@//" : x = 0
        end if
        x = x - 1
        wend
     else
        x$ = "////@//"
     end if
     gosub Elapsed5                    'Unpack reference date
     t=0
     if m>0 and m<13 and  _            'If the month number is valid
        d>0 and d<32 then              'and the day number is valid, then

        if deta$=dait$ then            'If reference date is today's date
           t=0                         'then exit with zero elapsed time.
        else
           if deta$>dait$ then         'If reference date is in the past, then
              future=0                 'set the future flag = zero [means past]
           else
              future=1                 'else set future flag = one [=future]
              swap d,sd                'and swap the reference date's and the
              swap m,sm                'system date's day, month and year
              swap y,sy                'values.
           end if                      '[if deta$>date$]
           gosub Elapsed6              'Compute elapsed time
           if future = 1 then t = -t   'Invert sign if future
        end if                         '[if deta$=date$]
        lapse$ = str$(t)               'form the elapsed time as a string
        lapse$ = right$( lapse$, 4 )
        x = len(lapse$)                'and get its length (N of digits +1)
        if x < 5 then                  'If elapsed time magnitude within range
           lapse$ = space$(4-x) + lapse$   'pad out the figure with leading spaces
        else
           lapse$=">>>>"               'else put it as too big.
        end if                         '
     else
     lapse$="////"                     'Show an invalid elapsed time as ////
     end if                            '[if month & day numbers are valid]
     return

'UNPACK THE DATE YYYYMDD INTO SEPARATE DAY, MONTH, YEAR
Elapsed5:
     d = val( right$( x$, 2 ) )       'Extract the day (a 2-digit number)
     m = asc( mid$( x$, 5, 1 ) ) - 64 'Extract month (a single letter A to L)
     y = val( left$( x$, 4 ) )        'Extract the year (a 4-digit number)
     return


'COMPUTE THE ELAPSED TIME

Elapsed6: t = -d                  'Set the elapsed time to minus the day number of current month
Elapsed7:                     
     if sm = m and sy = y then          'If system month = reference month
        t = t + sd                      'and system year = reference year
        return                          'then the elapsed time is simply the
     end if                             'difference between the day numbers.
     t = t + 30                         'Add a normal month of days to elapsed time

                                        'FEBRUARY LEAP YEAR CALCULATION
     if m = 2 then                      'If it is February, then
        t = t - 2                       'Take 2 days off to make it 
                                        'a normal 28-day February
        y! = y                          'Put year number in a `real' variable
        mn! = y! / 1000!                'millennium number
        cn! = y! / 100!                 'century number
        ly! = y! / 4!                   'leap year number

        if mn! = fix(mn!)         _     'if it is a millennium year
        or (                      _     'or ...
              ly! = fix(ly!) and  _     'the year number is divisible by 4
              cn! > fix(cn!)      _     'but it is not a century year
           )                      _
        then t = t +1                   'then it's a leap year, so add
                                        'an extra day to the elapsed time

     else                               'Else ADD AN EXTRA DAY IF IT IS AN ODD MONTH
        m! = m                          'Put month number as a `real' variable
        if m > 7 then m! = m! + 1       'Augmented Month N
        m! = m! / 2!                    'If the augmented month N is even, then
        if m! > fix(m!) then t = t + 1  'it's a 31-day month, so add extra day.
        if m = 12 then                  'If month is December, then set month=0
           m = 0                        '(it will be incremented next pass)
           y = y + 1                    'and increment to the following year.
        end if
     end if

     if t > 32700 then return           'Beyond max displayable elapsed time
     m = m + 1 : goto Elapsed7          'Advance to the next month
     '
     '-------------------------------------------------------------------------
     'Also used by START.BAS directly
RatSysDate:
     x$ = right$( date$, 4 ) _                     'Start with 4-digit year n
        + chr$( val( left$( date$, 2 ) ) + 64 ) _  'month letter [A thru L]
        + mid$( date$, 4, 2 )                      'day number [1 thru 31]
     return
     '
     '-------------------------------------------------------------------------

