





     'GENMENU [Entry: ShowMenu ChooseMenu]    08DEC86       [File: GENMENU.INC]
     '-------------------------------------------------------------------------
     'Generates a menu with options numbered 1 to 9 which can be selected
     'either directly by number, or by highlighting the required option using
     'cursor control keys and then selecting it using the C/R key.
     '
     'Inputs  menu$    - Name of the menu [must be odd no of chrs <=25]
     '        menu$(9) - Array containing names of options each <=27 chrs.
     '        MENU     - Number of valid options available
     '        MPOS     - =0 display menu centrally else in left half of screen
     '        ABORT    - Number of an option that was aborted last time
     '     GenMenuMsg$ - Message to put on line 17 (upto 20 characters)
     '     AlphaChoice - Max number of alphabetic A-I choices permitted
     '
     'Output  OP  - The menu option selected [1 to 10] [=0 no selection]
     '       LOP  - Letter (alpha) option value
     '
     'Locals  DSP - duck shoot position
     '        B$  - blank line [auto-adjusted for central or left display]
     '        HENU- Column position of error messages
     '
     '
     '
     '-------------------------------------------------------------------------
     'DISPLAY MENU TITLE
     '
ShowMenu0:
     X$=" "+string$((20-len(menu$))/2,chr$(196))+" "   'Form horizontal line
     X$=X$+" "+menu$+" Menu "+X$                'to go each side of menu title.
     MenuWidth=len(x$)
     ps$=space$(5):colour=1:column=1:for row=4 to 24:gosub 50:next
     ps$=space$(35-MenuWidth):column=MenuWidth+6:for row=4 to 24:gosub 50:next
     b$=space$(MenuWidth)
     column=6
     row=4:ps$=b$:gosub 50                      'Clear Row 4
     row=5:ps$=string$(MenuWidth,220):gosub 50  'Clear Row 5
     row=6:colour=31:ps$=X$:gosub 50            'Display the menu title
     row=7:ps$=b$:gosub 50                      'Clear Row 7
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE MENU ITEMS (OPTIONS)
     '
     x=9   'x is now column position of menu option
     '
     for k=1 to menu
     if Prog$="MENU" and mid$(AltColor$,k,1)=">" then j=4 else j=0
     row=7+k:column=6:ps$=str$(k)+" ":colour=31-j:gosub 50
     ps$=left$(menu$(k),27):ps$=ps$+space$(MenuWidth-3-len(ps$))
     column=x:colour=23-j:gosub 50
     next

     if menu<9 then
        column=6:ps$=b$:for k=menu+1 to 9:row=7+k:gosub 50:next
        end if
     row=17:column=6:colour=1:ps$=string$(MenuWidth,223):gosub 50
     column=6:colour=2:ps$=b$
     row=18:goto 50
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'DISPLAY THE OPERATOR INSTRUCTIONS
     '
ShowMenu:
     gosub ShowMenu0:colour=2
     row=19:ps$="[ ] Please type-in the number   ":gosub 50
     row=20:ps$="    of the Option you require   ":gosub 50
     row=21:ps$="    or use  to highlight it   ":gosub 50
     row=22:ps$="    then press C/R to action.   ":gosub 50
     row=23:ps$=b$:gosub 50
     row=24:ps$="    Press Esc to quit.          ":gosub 50
     column=x+7:colour=10:ps$="Esc":gosub 50
     '
     henu=1                             'Horizontal position of messages
     dsp=0                              'Clear duck shoot position
     if abort>0 then row=6+abort:column=henu:colour=4:ps$="Abort":gosub 50:beep
     if GenMenuMsg$>"" then row=18:column=henu+9:ps$=GenMenuMsg$:gosub 50:beep 
     '
     '-------------------------------------------------------------------------
     'ACCEPT THE MENU SELECTION
     '
ChooseMenu: gosub ChooseMenu6
     locate 19,henu+6:op=0:lop=0:y=0:hash=0
ChooseMenu1:
     gosub InChar:if from<>0 goto ChooseMenu1    'Get char; ignore modem inputs
     row=18:column=henu+9:ps$=space$(20):gosub 50
     if x=35 then hash=1:return                  'For drop into password
     if x=27 then gosub ChooseMenu3:return       'Escape from menu
     if x>31 then row=19:column=henu+6:ps$=x$:gosub 50
     '
     if y=72 then y=-1:goto ChooseMenu4  'Cursor up
     if y=80 then y= 1:goto ChooseMenu4  'Cursor down
     if x=32 then y= 1:goto ChooseMenu4  'Space bar (equivalent to cursor down)
     if y=71 then ManualState=1:return   'Access the User Manual
     '
     if x=13 and dsp>0 then x=dsp+48
     op=x-48
     if op>0 and op<=menu goto ChooseMenu7     'Valid numeric choice
     if AlphaChoice=0 goto ChooseMenu2         'No alphabetic choice permitted
     lop=x-64:op=0
     if lop>0 and lop<=AlphaChoice _           'Valid alphabetic choice 
            goto ChooseMenu7
     '
     '-------------------------------------------------------------------------
     'MESSAGE SUBROUTINES
     '
ChooseMenu2: row=19:column=henu:colour= 4:ps$="WRONG":gosub 50:beep
             goto ChooseMenu
ChooseMenu3: row=19:column=henu:colour=14:ps$="BUSY ":gosub 50:return
ChooseMenu6: row=19:column=henu:colour=7: ps$="     ":gosub 50:return
ChooseMenu7:
     if dsp>0 then
        ps$=space$(40):column=41:colour=7
        for row=3 to 24:gosub 50:next
        end if
     gosub ChooseMenu3:dsp=op:colour=31:gosub ChooseMenu5:return  'Exit
     '
     '-------------------------------------------------------------------------
     'DUCK-SHOOT SELECTION ROUTINE
     '
ChooseMenu4:
     if dsp>0 then colour=23:gosub ChooseMenu5
     dsp=dsp+y                           'Number of new highlighted option
     if y= 1 and dsp>menu then dsp=0     'Going down
     if y=-1 and dsp<0 then dsp=menu     'Going back up
     colour=31:gosub ChooseMenu5:goto ChooseMenu
ChooseMenu5:
     row=dsp+7:column=henu+8:ps$=menu$(dsp):gosub 50
     if MenuHelp=0 or y=0 then return
     if dsp=0 then colour=6 else colour=7
     column=41
     on dsp+1 goto _
        MenuHelp0, _
        MenuHelp1, _
        MenuHelp2, _
        MenuHelp3, _
        MenuHelp4, _
        MenuHelp5, _
        MenuHelp6, _
        MenuHelp7, _
        MenuHelp8, _
        MenuHelp9   
     '
     '-------------------------------------------------------------------------
     '
