






     '-------------------------------------------------------------------------
     'GENERAL INCHAR SUBROUTINE [ENTRY POINTS 4020 & 4025] Filename INCHAR.INC
     '-------------------------------------------------------------------------
     'Used by all modules. Polls keyboard & modem and updates screen clock
     '
     '4020 goto ClrKbdBuf   'Numbered entry point for clearing keyboard buffers
     '4025 goto InChar      'Numbered entry point for general character input
     'GetTimeINC:           'Returns am/pm version of `time$' in `clock$'
     '
     'Inputs  TIME$ - System Time
     '        CAPS  - [=1 present lower case letters as caps; =0 letters as is]
     '      TXCHAR$ - Character to be transmitted via the modem
     '         ECHO - =1 await echo of TXCHAR$ from modem  =0 don't
     '       CURSOR - Cursor size parameter
     '      TIMEOUT - Timeout counter (seconds left to wait)
     '                =1 on exit of timed out; else =0
     '
     'Locals SysTime$ - Globally preserved; contains last displayed time
     '       TIMEOUT$ - Holds reference value of system clock
     '
     '-------------------------------------------------------------------------
     'CLEAR THE KEYBOARD INPUT BUFFER
     '
ClrKbdBuf: def seg=0:poke 1050,peek(1052):def seg:poke 106,0:return 
     '
     '-------------------------------------------------------------------------
     'DEFINE & INITIALIZE OUTPUTS
     '
InChar: if shot=1 goto InChar0
     colour=7                       'White is default colour for keyboard input
     if cursor=0 then cursor=6
     locate,,1,cursor,7             'Switch on the cursor (make it visible)
InChar0:
     X$=""              'Normal character received from keyboard
     X=0                'ASCII value of normal character from keyboard
     Y$=""              'Control character received from keyboard
     Y=0                'ASCII values of control character from keyboard
     RxChar$=""         'Character received from the modem
     RxChar=0           'ASCII value of character received from modem
     Fkey=0             'Function key number of function key struck
     from=0             'Source of the incoming character 0=keyboard; 1=modem
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SEE IF THERE IS A CHARACTER WAITING IN THE KEYBOARD BUFFER
     '
InChar1:
     x$=inkey$                          'Poll the keyboard input buffer
     if x$="" then
        gosub GetTimeInc                'If no char waiting, go check time
        if shot=0 goto InChar1          'Don't exit if not single shot
        else  
        if len(x$)=2 then               'If a control character has been input
           y=asc(right$(x$,1))          'Extract ASCII value of control char
           x$=""                        'Return a null when a control is input
           if y>58 and y<69 then Fkey=y-58 'Set function key if Y in range
      else x=asc(x$)                    'ASCII value of normal character
           if caps=1 and x>96 and x<123 then
              x=x-32:x$=chr$(x)         'Convert to upper case
              end if
           end if
        if shot=0 then         
           locate,,0,6,7                'Switch off cursor and return
      else shot=0                       'with character
           end if
        end if
     return                             'Clear the SINGLE-SHOT flag
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'UPDATE THE CLOCK DISPLAY
     '
GetTimeInc:
     if SysTime$<>left$(time$,5) then          'Return if less than a minute
                                               'since the last clock display
        locate,,O                              'Suppress cursor
        SysTime$=left$(time$,5)                'Align CLOCK to System Time
        hour=val(left$(SysTime$,2))            'Extract the Hour as an interger
        '
        if hour>11 then daytime$="p" else daytime$="a"   'Set AM or PM
        '
        if hour>12 then hour=hour-12        'Change to 12 day + 12 night clock
        if hour= 0 then hour=12             'Change 00:01 hrs to 12:01 AM et
        hour$=str$(hour)
        if hour<10 then hour$=" "+hour$ 
        clock$=hour$+right$(SysTime$,3)+daytime$+"m"
        '
        ClockRow=1:ClockCol=60-len(hour$):ClockColour=7
        call ScrSub(clock$,ClockRow,ClockCol,ClockColour)
        locate,,1                              'Switch cursor back on
        end if
     return
     '
     '-------------------------------------------------------------------------
     '
