






     '-------------------------------------------------------------------------
     'PRINTS A TARGET NAME & ADDRESS LIST         29MAY87        File:List1.Bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables the user to print out a list of the names & addresses of all the 
     'prospects who are on a specified Target List.
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'All interger
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     dim rec$(12)                  'Array to hold name & address data
     dim pp$(20)                   'Holds printer port specs & control codes
     '
     dim Punc$(11)             'INTER-FIELD PUNCTUATION [Total 24 bytes]
     Punc$( 3)=", "            ' 2   These punctuation items 
     Punc$( 4)=", "            ' 2   appear immediately before
     Punc$( 5)=", "            ' 2   the record field of the
     Punc$( 6)=", "            ' 2   same number.
     Punc$( 8)=", Ph:"         ' 4
     Punc$( 9)=", Tx:"         ' 4
     Punc$(10)=", "            ' 2
     Punc$(11)=", "            ' 2
     '
     PrRecLen = 4096
     FMMflag=0                 'Set to 1 to display FMM states
     RecFileNum=1              'File N under which Records File is opened
     AreaFileNum=2             'File N under which Sales Areas File is opened
     TargFileNum=3             'File N under which Target List File is opened
     PrtBufNum=4               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ReSetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     locate 21,32              'Cursor in printer control box
     '
     ReportTitle$="NAME & ADDRESS LIST"
     gosub ExpiryTest
     '
     gosub SetUpReportHeading
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub showstates3
     FromEntryState=1          'Activate for entry of from List N
     ListInitState=1  'Activate the Initialization FMM
     PrtIntegState=1  'Activate the Printer Integrity Watch Dog FMM
     goto StartLoop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     rem $include: 'EdField.FMM'
     rem $include: 'FROM.FMM'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
StartLoop:
     ACTIVE = 1
     WHILE ACTIVE
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub FromEntry
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub FileCtrl      'Controls opening and closing of the required files
     gosub RecordIO      'Handles the input of the main prospect records
     gosub GetAreas      'Handles the input of the sales area data
     gosub TargetIO      'Handles the input of the target list of prospects
     gosub OpenFileFMM   'General file opener FMM
     gosub PrintLine     'Set up lines of print as required
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub ShowStates    'Display FMM states
     WEND
     FileNum=0:gosub CloseFile       'then close printer & all files
     ps$="":gosub ShowMsgs1          'clear error message field
     prog$="LIST1"                   'Set program identification variable
     chain"Lmenu2"                   'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
DeActivate:
     PrintIOState=0     'Printer input/output FMM
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     RecordIOState=0    'Handles the input of the main prospect records
     GetAreasState=0    'Handles the input of the sales area data
     TargetIOState=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     FileNum=0:gosub CloseFile
     return             'Close printer & all files
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     if ShowMessages=0 then return   'No messages waiting to be displayed
     if DosClr>0 then                'If there is a DOS message to be displayed
        colour=DosClr                'set the appropriate message colour
        DosClr=0                     'Message colour acts as message trigger
        ps$=DosMsg$                  'set up the message in the display string
        gosub ShowMsgs1              'display message
        end if
     if PrtClr>0 then                'If there's a Printer Status message to be
        colour=PrtClr                'displayed, set appropriate message colour
        PrtClr=0                     'Message colour acts as message trigger
        row=23:column=46         
        ps$=Pstatus$            _    'set up the message in the display string
       +space$(30-len(pstatus$))     'Pad out to 30 character message field
        gosub 50                     'display message
        gosub ShowPlamps             'display pritner status lamps
        end if
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl:
     if FromEntryState > 0 then return
     gosub NextChar
     if CtrlChar = 87 then              'If Shif-F4 hit
        FMMflag = 1                     'Enable diagnostic display
        goto ShowStates3                'of FMMstates.
     end if
     if KbChar = 27 or CtrlChar = 61 then active = 0 : return
     if KbChar <> 13 and CtrlChar <> 60 then return
     if LoopCtrlState=0 goto KeybCtrl1  'Activate printer if not active
     if HaltPrinterFlag=0 then          'If not currently in a halt state, then
        HaltPrinterFlag=1               'set printer to halt state
   else HaltPrinterFlag=0               'else clear the halt state
        ps$="":gosub ShowMsgs1          'clear possible error message.
        end if
     gosub ShowPostStartMsgs            'Display appropriate messages.
     return                             'Return control to the Polling Loop
     '
KeyBCtrl1:                              'Try to activate the Print Loop FMM
     if PrtIntegState=2 and      _      'If printer Integrity Watch Dog active
        ListInitState=4 then     _      'and the Lister Module initialized
        LoopCtrlState=1                 'then activate the print loop FMM.
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs            'Display appropriate messages.
     return                             'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoopCtrl:
     '
     on LoopCtrlState goto _   'State 0: inactive
        LoopCtrl1,         _   'State 1: Initiate opening of all required files
        LoopCtrl2,         _   'State 2: wait for file-opening to complete
        LoopCtrl3,         _   'State 3: process next prospect on target list
        LoopCtrl4,         _   'State 4: get next list member's record number
        LoopCtrl5,         _   'State 5: get the next list member's record
        LoopCtrl6,         _   'State 6: get the next list member's sales area
        LoopCtrl7,         _   'State 7: drain printer output stack
        LoopCtrl8,         _   'State 8: wait for next print line
        LoopCtrl9              'State 9: confirm storage of `list printed' flag
     return
     '
     '-------------------------------------------------------------------------
     'INITIATE THE OPENING OF ALL REQUIRED FILES
     '
LoopCtrl1:
     FileCtrlState=1            'Activate the file opening process
     LoopCtrlState=2            'Advance to next machine state
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR FILE-OPENING TO COMPLETE
     '
LoopCtrl2:
     if FileCtrlState=5 then _  'If all files opened successfully, then
        LoopCtrlState=3      _  'set to loop advancement state
       :goto LoopCtrl3          'Proceed to loop advancement process
     '
     if FileCtrlState=8 then _  'If the file opening process failed, then
        gosub DeActivate        'De-activate all FMMs
     '
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'ADVANCE TO NEXT PROSPECT ON THE TARGET LIST
     '
LoopCtrl3:
     if TargItem<TargSize then     'If last list member has been printed
        TargItem=TargItem+1        'Advance to [next] member of target list
        TargetIOstate=4            'Activate getting of the next targ list rec
        LoopCtrlState=4            'Advance to the Get Record state
     '
     '-------------------------------------------------------------------------
     'LAST RECORD HAS BEEN PROCESSED; DRAIN REMAINDER OF PRINT OUTPUT STACK
     '
     else
     if PrStr$="" then             'When printer output stack is finally
        PrtfFlag=1                 'set the `list printed' flag
        TargItem=0                 'Target List Record#0
        TargetIOstate=6            'Store Record of Target List File
        LoopCtrlState=9            'Advance to next machine state
     end if
     PrintIOflush = 1              'set to flush the printer output stack
     end if
     return                        'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
LoopCtrl4:
     if TargetIOstate=5  then      'If the next target list record got OK then
        RecordIOstate=4            'Activate the main record `get' process
        LoopCtrlState=5            'Advance to the next machine state
        goto LoopCtrl5             'Go straight to monitor next state
        end if
     if TargetIOstate=10 then    'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs
        end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD
     '
LoopCtrl5:
     if RecordIOstate=5  then    'If the next target list record got OK then
        GetAreasState=4          'Activate the sales area search
        LoopCtrlState=6          'Advance to next state
        goto LoopCtrl6
        end if
     if RecordIOstate=10 then    'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs
        end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S SALES AREA
     '
LoopCtrl6:
     if GetAreasState=5  then    'If the next target list record got OK then
        LoopCtrlState=7        
        goto LoopCtrl7
        end if
     if GetAreasState=8  then    'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs
        end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINT OUTPUT STACK TO EMPTY
     '
LoopCtrl7:
     if len(PrStr$)<=PrRecLen then  'If plenty of room on printer output stack
        PrintLineState=1            'then ask PrintLine.FMM to set up another
        LoopCtrlState=8             'line & return to get the next record.
        end if
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR NEXT PRINT LINE TO BE SET UP
     '
LoopCtrl8:
     if PrintLineState=2 then       'If the next print line has been set up
        PrintLineState=0            'then de-activate the print line setter up
        PrStr$=PrStr$+PrintLine$    'add the new print line to the printer
        LoopCtrlState=3             'output stack and go for next record.
        end if
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'CONFIRM STORAGE OF `LIST PRINTED' FLAG
     '
LoopCtrl9:
     if TargetIOstate=7 then         'If the record has been stored OK
        Pstatus$="FINISHED"       
        PrtClr=10:ShowMessages=1     '
        gosub ShowMsgs
        gosub DeActivate             'De-activate all FMM/close files & printer
        end if
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT LINE ROUTINE
     '
     'When externally set to State 1, this routine assembles the namecode, Ref
     'N, Cross Ref, postcode, sales area letter and name & address fields for
     'one prospect on the target list into a print line. It then transmutes to
     'State 2 indicating that the assembled print line is ready for printing.
     '
     '--------------------------------------------------------------------------
     'SET UP KEY FIELDS IN PRINT LINE
     '
PrintLine:                             'State 0: inactive
     if PrintLineState<>1 then return  'State 1: set up print line
                                       'State 2: print line ready
     PrintLine$=""                     'Clear the print line assembly string
     '
     if PageLineNum=0 then             'If it is the start of a new page
        gosub PageHeader               'then set up a new page heading
        end if
     gosub PrintLine1                   'Set up a normal print line
     '
     if TargItem=TargSize then          'If this is the final line of print
        gosub FinalFooter               'then append the final page footer
   else BlockLineNum=BlockLineNum+1     'Increment N of line in current block
        if BlockLineNum=5 and  _        'If now 5 lines in latest block
           PageLineNum<39 then          'and the page is not full
           BlockLineNum=0               'then reset block line count to start 
           PrintLine$=PrintLine$ _      'next block and add a line feel in
                     +BlankLine$        'order to skip a line between blocks.
           end if
        PageLineNum=PageLineNum+1       'Increment N of lines on current page
        if PageLineNum=40 then          'If there are now 40 lines on this page
           PageLineNum=0                'clear line count for next page and
           BlockLineNum=0               'clear block line count for first block
           end if
        if PageLineNum=0 then           'If about to begin a new page, then
           gosub NormalFooter           'print normal page footer and
           PageNum=PageNum+1            'and increment the page number.
           end if
        end if
     PrintLineState=2                   'Set to `print line ready' state
     return                            'Return to line control loop
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'ASSEMBLE A NORMAL PRINT LINE
     '
PrintLine1:
     Number=RecNum                     'Form the record number (Ref N) 
     gosub FiveDigit                   'of the current record in to a
     RecNum$=Number$                   '5-digit string with leading zeros.
     '
     NameCode$=left$(rec$( 2),8):NameCode$=NameCode$+space$(8-len(NameCode$))
     CrossRef$=left$(rec$(12),8):CrossRef$=CrossRef$+space$(8-len(CrossRef$))
     PostCode$=left$(rec$( 7),8):PostCode$=PostCode$+space$(8-len(PostCode$))
     '
     PrintLine$=PrintLine$         _
               +NameCode$          _   'Namecode     8
               +" "                _   'separator    1
               +RecNum$            _   'Ref number   4
               +" "                _   'separator    1
               +CrossRef$          _   'Xref         8
               +" "                _   'separator    1
               +PostCode$          _   'Postcode     8
               +"  "               _   'separator    2
               +SalesAreaID$       _   'Sales Area   1
               +"  "                   'separator    3
     'Total                                         37
     '
     '--------------------------------------------------------------------------
     'ADD THE NAME & ADDRESS FIELDS
     '
     for FieldNum=1 to 11              '10 name & address fields
     '
     if FieldNum=2 or              _   'If it is the namecode field
        FieldNum=7                 _   'or the postcode field, then
        goto PrintLine2                'skip over it (do not include it here)
     '
     rec$=rec$(FieldNum)               'Get text of this name & address field
     '
     if rec$>" " then              _   'If it is more than just a space
        PrintLine$=PrintLine$      _   'then add the punctuation prefix
                  +Punc$(FieldNum) _   'and the field content
                  +rec$                'to the print line
     '
PrintLine2: next                       'Next name & address field
     '
     PrintLine$=PrintLine$         _   'To the new completed print line add a
               +NewLine$               'carriage-return at the end of the line.
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT NEW PAGE HEADING
     '
PageHeader:
     if PageNum=1 then                  'If this is the first page, then 
        PrintLine$=PrintLine$ _         'add to the print line
                  +pp$(2)     _         'initialise printer & set draft mode
                  +pp$(5)               'and set printer to landscape mode
        end if                          'if necessary.
     PageNum$=str$(PageNum)             'Form the page number
     PageNum$=space$(4-len(PageNum$)) _ 'into a 4-character string
             +PageNum$                  'with leading spaces.
     '
     PrintLine$=PrintLine$        _
               +pp$(7)            _    'Set printer to 8.25 characters per inch
               +HeaderLine1$      _    'Print the first title line
               +PageNum$+NewLine$ _    'Page number
               +BlankLine$        _
               +pp$(6)            _    'Switch to 16.5 chrs/inch
               +HeaderLine2$      _    'Print second title line
               +ColumnHeadings$        'Print column headings
     '
     return
     '
     '--------------------------------------------------------------------------
     'PRINT NORMAL PAGE FOOTER
     '
NormalFooter:
     PrintLine$=PrintLine$        _   'Add to the print line:
               +BlankLine$        _
               +"Continued..."    _   'Normal page footer
               +chr$(12)              'Throw the page
     '
     return
     '
     '--------------------------------------------------------------------------
     'PRINT THE FINAL FOOTER
     '
FinalFooter:
     PrintLine$=PrintLine$ _   'Add to the printer output stack:
               +BlankLine$ _
               +"END"      _   'Print final footer
               +chr$(12)   _   'Throw the page
               +pp$(4)     _   'Reset printer to 10 cpi
               +pp$(3)         'Reset draft printer to defaults
ReSetNums:
     PageNum=1                 'Current page number
     PageLineNum =0            'N of lines printed so far on this page
     BlockLineNum=0            'N of lines printed so far in this 5-line block
     return
     '
     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FiveDigit: LenFld=5:goto Digits
FourDigit: LenFld=4
     '
Digits:
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM
     '
FileCtrl:
     '
     on FileCtrlState goto _    'State 0: Inactive
        FileCtrl1,         _    'State 1: Activate Records file opening
        FileCtrl2,         _    'State 2: Activate Areas file opening
        FileCtrl3,         _    'State 3: Activate Target file opening
        FileCtrl4,         _    'State 4: If all files open goto Wait State
        FileCtrl5,         _    'State 5: File open wait state
        FileCtrl6               'State 6: Close all involved files
     '                          'State 7: Successful Termination state
     return                     'State 8: Error state
     '
     '--------------------------------------------------------------------------
     'OPEN MAIN RECORDS FILE
     '
FileCtrl1:
     '
     RecordIOstate=1            'Activate the record input/output FMM to open
     FileCtrlState=2            'the records file and advance to next state.
     return
     '
     '--------------------------------------------------------------------------
     'OPEN SALES AREAS FILE
     '
FileCtrl2:
     '
     if RecordIOstate=3  then _ 'If the records file is now open, then
        GetAreasState=1       _ 'Activate areas file input FMM to open
       :FileCtrlState=3         'the target list file; advance to next state.
     '
     if RecordIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN TARGET LIST FILE
     '
FileCtrl3:
     '
     if GetAreasState=3  then _ 'If the areas file is now open, then
        TargetIOstate=1       _ 'Activate target file input/output FMM to open
       :FileCtrlState=4         'the target list file; advance to next state.
     '
     if GetAreasState=8       _ 'If areas file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'WAIT FOR TARGET LIST FILE TO OPEN
     '
FileCtrl4:
     '
     if TargetIOstate=3  then _ 'If the records file is now open, then
        FileCtrlState=5         'the target list file; advance to next state.
     '
     if TargetIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl8        _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'ALL FILES OPEN & READY FOR I/O
     '
FileCtrl5: return               'All files open Wait State
     '
     '--------------------------------------------------------------------------
     'CLOSE ALL FILES
     '
FileCtrl6:
     '
     FileNum=1:gosub CloseFile  'Close Records File
     FileNum=2:gosub CloseFile  'Close Areas File
     FileNum=3:gosub CloseFile  'Close Target File
     gosub DeActivate           'De-activate
     FileCtrlState=7            'Successful Termination State
     '
     '--------------------------------------------------------------------------
     'ALL FILES CLOSED OK
     '
FileCtrl7: return               'Wait State
     '
     '--------------------------------------------------------------------------
     'FILE OPENING FAILED
     '
FileCtrl8:                      'Open failure
     '
     gosub DeActivate           'De-activate
     FileCtrlState=8            'Set this FMM to its error state
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 1 - PACKAGE NAME, LISTING TITLE, SERIAL, DATE, PAGE
     '
     'Note: The first line is printed in 8.25 chr/inch lettering which allows
     '      108 characters across the standard 15-inch platen.
     '
SetUpReportHeading:
     '
     HeaderDrop$=BlankLine$+BlankLine$+BlankLine$+BlankLine$+BlankLine$
     '
     if CompanyName$="" then CompanyName$="E.B.S. MARKETEER"
     '
     CompanyName$=left$(CompanyName$,27) 'Safety limit for company name
     ReportTitle$=left$(ReportTitle$,24) 'Safety limit for report title
     '
     x=53                     _          'N of spare character spaces
      -len(CompanyName$)      _          'minus lengths of company name &
      -len(ReportTitle$)                 'report title giving spaces left.
     '
     y=x/2:x=x-y                         'Divide the spaces left in two.
     Number=ExtrFlag:gosub FourDigit
     '
     HeaderLine1$=HeaderDrop$         _  'First heading line comprises...
       +CompanyName$+space$(x)        _  'Company name + padding
       +ReportTitle$+space$(y)        _  '+ Report Title + padding =   52 chrs
       +"TARGET NO "+TargNum$+"  "    _  '10+4+2 characters            16 chrs
       +"SERIAL NO "+Number$ +"  "    _  '10+4+2 characters            16 chrs
       +sd$                  +"  "    _  'System date  15+2            17 chrs
       +"PAGE"                           'Page N  4+4=                 8 chrs
     '                                                                ---
     'Total                                                           109 chrs
     '
     'Note: The page number which is 4-characters long is appended to this
     '      string at the time each page heading is set up during printing.
     '
     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 2 - TARGET PROFILE REFERENCE & LISTING ORDER
     '
     if SeqTyp=2 then y$="ref number order":goto SetUpReportHeading1
     if SeqTyp=6 then y$="postcode order"  :goto SetUpReportHeading1
     y$="alphabetic order"
     if SeqTyp=1 goto SetUpReportHeading1
     y$=y$+" within post "
     if SeqTyp=3 then y$=y$+"area"
     if SeqTyp=4 then y$=y$+"district"
     if SeqTyp=5 then y$=y$+"sector"
     '
SetUpReportHeading1:
     '
     x$=space$((193-len(TargName$)-len(y$)-len(ListDate$))/2)  'Left indent
     '
     HeaderLine2$=x$                       _  'Second line of report heading:
       +TargName$                          _  'Target Profile name
       +" extracted at"                    _  '13 chrs
       +ListDate$                          _  'of latest extraction
       +" listed in "                      _  '11 chrs
       +y$+NewLine$+BlankLine$                'Listing order
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 4 - THE COLUMN HEADINGS
     '
SetUpReportHeading3:
     '
     ColumnHeadings$                            _
       ="NAMECODE -REF- CROSSREF POSTCODE AREA" _   '37       37
       +"----------NAME OF PERSON/COMPANY"      _   '10+22    32
       +"----------POSTAL ADDRESS"              _   '10+14    24
       +"----------TELEPHONE NUMBER"            _   '10+16    26
       +"----------TELEX/E-MAIL NUMBER"         _   '10+19    29
       +"----------NAME & TITLE OF CONTACT"     _   '10+23    33
       +"----------FREE-FORM NOTES"             _   '10+15    25
       +"-----------"                           _   '10+ 1    11
       +NewLine$+BlankLine$
     '                                               Total   217
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3: column=41:colour=grey
     '
     ps$="                                        ":row= 5:gosub 50
     if FMMflag=0 then
     for row=6 to 14:gosub 50:next
     else
     ps$="    Ŀ    ":row= 6:gosub 50
     ps$="    FMM STATES                        ":row= 7:gosub 50
     ps$="    Ĵ    ":row= 8:gosub 50
     ps$="    ListInit  0        GetAreas  0    ":row= 9:gosub 50
     ps$="    PrintI/O  0        TargetIO  0    ":row=10:gosub 50 
     ps$="    LoopCtrl  0        OpenFile  0    ":row=11:gosub 50
     ps$="    FileCtrl  0        PrtInteg  0    ":row=12:gosub 50
     ps$="    RecordIO  0                       ":row=13:gosub 50
     ps$="        ":row=14:gosub 50
     end if
     ps$="                                        ":row=15:gosub 50
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of prospects on List   0000    ":row=17:gosub 50
     ps$="    Now printing prospect N  0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     '
     number=TargSize:row=17:colour=7:gosub ShowStates1
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES
     '
ShowStates: colour=7:if FMMflag=0 goto ShowStates4
     '
     column=55
     '
     if LastListInitState<>ListInitState then _
        LastListInitState =ListInitState      _
       :row= 9:Ps$=str$(ListInitState):gosub 50
     '
     if LastPrintIOstate<>PrintIOState  then  _
        LastPrintIOstate =PrintIOState        _
       :row=10:Ps$=str$(PrintIOstate):gosub 50
     '
     if LastLoopCtrlState<>LoopCtrlState then _
        LastLoopCtrlState =LoopCtrlState      _
       :row=11:Ps$=str$(LoopCtrlState):gosub 50
     '
     if LastFileCtrlState<>FileCtrlState then _
        LastFileCtrlState =FileCtrlState      _
       :row=12:Ps$=str$(FileCtrlState):gosub 50
     '
     if LastRecordIOstate<>RecordIOState then _
        LastRecordIOstate =RecordIOState      _
       :row=13:Ps$=str$(RecordIOstate):gosub 50
     '
     column=74
     if LastGetAreasState<>GetAreasState then _
        LastGetAreasState =GetAreasState      _
       :row= 9:Ps$=str$(GetAreasState):gosub 50
     '
     if LastTargetIOstate<>TargetIOState then _
        LastTargetIOstate =TargetIOState      _
       :row=10:Ps$=str$(TargetIOstate):gosub 50
     '
     if LastOpenFileState<>OpenFileState then _
        LastOpenFileState =OpenFileState      _
       :row=11:Ps$=str$(OpenFileState):gosub 50
     '
     if LastPrtIntegState<>PrtIntegState then _
        LastPrtIntegState =PrtIntegState      _
       :row=12:Ps$=str$(PrtIntegState):gosub 50
     '
ShowStates4:
     if LastTargItem<>TargItem then _
        LastTargItem =TargItem      _
       :row=18:number=TargItem:gosub ShowStates1
     '
     return
     '
ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50
     '
     '-------------------------------------------------------------------------
     '






     'PRINTER INITIALIZATION & INTEGRITY MONITOR

PrtInteg:
     on PrtIntegState goto  _  'State 0: inactive
        PrtInteg1,          _  'State 1: wait for initialization to complete
        PrtInteg2,          _  'State 2: check printer initially or after error
        PrtInteg3              'State 3: wait for the printer to open
     return                    'Return to the FMM polling loop


     'WAIT FOR THE INITIALIZATION PROCESS TO COMPLETE

PrtInteg1:
     if ListInitState=4 then _      'If the initialization process completed
        PrtIntegState=2             'Initiate the opening of the printer
     if ListInitState=5 then _      'If the initialization process has failed
        ListInitState=1             'the re-activate it & try again.
     return                         'Return control to the Polling Loop


     'SEE IF PRINTER IN OPEN

PrtInteg2:
     if PrintIOstate=3 then return  'Printer I/O FMM in normal active state
     if PrintIOstate=4 then return  'Printer I/O FMM in X-off state
     PrtIntegState=3                'Advance to wait for printer on
     PrintIOstate=1                 'Activate the printer I/O FMM
     gosub ShowPreStartMsgs         'Show the `switch on the printer' message
     return                         'Return to the FMM polling loop


     'WAIT FOR PRINTER TO OPEN

PrtInteg3:
     if PrintIOstate>2 then      _  'If the printer is on and ready or
        PrtIntegState=2             're-set the Printer Watchdog to monitoring
     return                         'Return to the FMM polling loop

