






     '-------------------------------------------------------------------------
     'PRINTS A TARGET NAME & KEY VALUES LIST      29MAY87        File:List2.Bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables the user to print out a list of the names & key values of all the 
     'prospects who are on a specified Target List.
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'All interger
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     dim rec$(12)                  'Array to hold name & address data
     dim pp$(20)                   'Holds printer port specs & control codes
     '
     PrRecLen = 4096           'Block length when outputting to a spool file.
     RecFileNum =1             'File N under which Records File is opened
     AreaFileNum=2             'File N under which Sales Areas File is opened
     KeysFileNum=3             'File N under which Keys File is opened
     AttrFileNum=4             'File N under which Attributes File is opened
     CodeFileNum=5             'File N under which Selector Codes File opened
     TargFileNum=6             'File N under which Target List File is opened
     PrtBufNum  =7             'File N under which Printer I/O File is opened
     GetKeyvsFlag=1            'Enabe Key Values acquisition by ListInit.FMM
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ReSetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     locate 21,32              'Cursor in printer control box
     '
     ReportTitle$="KEY VALUES LISTING"
     gosub ExpiryTest
     '
     gosub SetUpReportHeading
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub ShowStates3
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     FromEntryState=1
     goto  StartLoop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'KeysIO.FMM'
     rem $include: 'AttrIO.FMM'
     rem $include: 'CodeIO.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Elapsed.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     rem $include: 'EdField.FMM'
     rem $include: 'From.FMM'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
StartLoop:
     active = 1
     WHILE active
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub LoadRecs      'Load all records required for a print line's data
     gosub FileCtrl      'Controls opening and closing of the required files
     gosub ShowStates    'Display FMM states
     gosub RecordIO      'Handles the input of the main prospect records
     gosub GetAreas      'Handles the input of the sales area data
     gosub KeysIO        'Handles the input of the key values
     gosub AttrIO        'Handles the input of the attributes
     gosub CodeIO        'Handles the input of the selector codes
     gosub TargetIO      'Handles the input of the target list of prospects
     gosub OpenFileFMM   'General file opener FMM
     gosub PrintLine     'Set up lines of print as required
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub FromEntry
     WEND
     FileNum=0:gosub CloseFile  'then close printer & all files
     ps$="":gosub ShowMsgs1     'clear error message field
     prog$="LIST2"              'Set program identification variable
     chain"Lmenu2"              'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     '
     if ShowMessages=0 then return   'No messages waiting to be displayed
     '
     if DosClr>0 then           _    'If there is a DOS message to be displayed
        colour=DosClr           _    'set the appropriate message colour
       :DosClr=0                _    'Message colour acts as message trigger
       :ps$=DosMsg$             _    'set up the message in the display string
       :gosub ShowMsgs1              'display message
     '
     if PrtClr>0 then           _    'If there's a Printer Status message to be
        colour=PrtClr           _    'displayed, set appropriate message colour
       :PrtClr=0                _    'Message colour acts as message trigger
       :row=23:column=46        _
       :ps$=left$(Pstatus$,30)  _    'set up the message in the display string
       :ps$=ps$+space$(30-len(ps$))_ 'Pad out to 30 character message field
       :gosub 50                _    'display message
       :gosub ShowPlamps             'display pritner status lamps
     '
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1: ps$=left$(ps$,36)
     '
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl:
     if FromEntryState>0 then return
     gosub NextChar                   
     if CtrlChar = 87 then              'If Shift-F4 hit, then
        FMMflag = 1                     'Enable FMM states display
        goto ShowStates3                'Show the display panel
     end if
     if KbChar=27 or CtrlChar=61 then active=0:return
     if KbChar<>13 and CtrlChar<>60 then return
     if LoopCtrlState=0 goto KeybCtrl1   'Activate printer if not active
     if HaltPrinterFlag=0 then           'If not currently in a halt state
        HaltPrinterFlag=1                'then set printer to halt state
   else HaltPrinterFlag=0                'else clear the halt state
        ps$="":gosub ShowMsgs1           'clear possible error message.
 end if
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     '
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then     _  'and the Lister Module initialized
        LoopCtrlState=1             'then activate the print loop FMM.
     '
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoopCtrl:
     '
     on LoopCtrlState goto _   'State 0: inactive
        LoopCtrl1,         _   'State 1: Initiate opening of all required files
        LoopCtrl2,         _   'State 2: wait for file-opening to complete
        LoopCtrl3,         _   'State 3: process next prospect on target list
        LoopCtrl4,         _   'State 4: get next list member's record number
        LoopCtrl5,         _   'State 9: drain printer output stack
        LoopCtrl6,         _   'State10: wait for next print line
        LoopCtrl7              'State11: confirm storage of `list printed' flag
     '
     return
     '
     '-------------------------------------------------------------------------
     'INITIATE THE OPENING OF ALL REQUIRED FILES
     '
LoopCtrl1:
     '
     FileCtrlState=1            'Activate the file opening process
     LoopCtrlState=2            'Advance to next machine state
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR FILE-OPENING TO COMPLETE
     '
LoopCtrl2:
     '
     if FileCtrlState=8 then _  'If all files opened successfully, then
        LoopCtrlState=3      _  'set to loop advancement state
       :goto LoopCtrl3          'Proceed to loop advancement process
     '
     if FileCtrlState=11 then_  'If the file opening process failed, then
        gosub DeActivate        'De-activate all FMMs
     '
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '







     'ADVANCE TO NEXT PROSPECT ON THE TARGET LIST

LoopCtrl3:
     if TargItem < TargSize then        'If last list member has been printed
        TargItem = TargItem + 1         'Advance to [next] member of target list
        LoadRecsState = 1               'Activate the records loader
        LoopCtrlState = 4               'Advance to the Get Record state

     else                               'Last record processed; drain 
                                        'remainder of print output stack

     if PrStr$ = "" then                'When printer ouput stack is finally
        PrtfFlag = 1                    'set the `list printed' flag
        TargItem = 0                    'Target List Record#0
        TargetIOstate = 6               'Store Record of Target List File
        LoopCtrlState = 7               'Advance to next machine state
     end if

     PrintIOflush = 1                   'Set to flush the print output stack

     end if
     return                             'Return control to the Polling Loop


     'GET THE NEXT LIST MEMBER'S RECORDS
     '
LoopCtrl4:
     if LoadRecsState=8  then _  'If the next target list record got OK then
        LoopCtrlState=5          'Advance to the next machine state
     if LoadRecsState=9  then _  'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs
     return                      'Return control to the Polling Loop


     'WAIT FOR PRINT OUTPUT STACK TO EMPTY

LoopCtrl5:
     if len(PrStr$) < PrRecLen then   'If there is plenty of room on the printer
        PrintLineState=1              'output stack then ask PrintLine.FMM to
        LoopCtrlState=6               'set up another line & return to get the
     end if                           'next record.
     return                           'Return control to the Polling Loop

     '






     '-------------------------------------------------------------------------
     'WAIT FOR NEXT PRINT LINE TO BE SET UP
     '
LoopCtrl6:
     '
     if PrintLineState=2 then    _  'If the next print line has been set up
        PrintLineState=0         _  'then de-activate the print line setter up
       :PrStr$=PrStr$+PrintLine$ _  'add the new print line to the printer
       :LoopCtrlState=3             'output stack and go for next record.
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'CONFIRM STORAGE OF `LIST PRINTED' FLAG
     '
LoopCtrl7:
     '
     if TargetIOstate=7 then     _   'If the record has been stored OK
        Pstatus$="FINISHED"      _
       :PrtClr=10:ShowMessages=1 _   '
       :gosub ShowMsgs _
       :gosub DeActivate             'De-activate all FMM/close files & printer
     '
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'FMM DE-ACTIVATOR/CLOSER
     '
DeActivate:
     '
     PrintIOState=0     'Printer input/output FMM
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     LoadRecsState=0    'Controls the acquisition of data records
     RecordIOState=0    'Handles the input of the main prospect records
     GetAreasState=0    'Handles the input of the sales area data
     KeysIOState=0      'Handles the input of the Key Values
     AttrIOState=0      'Handles the input of the Attributes
     CodeIOState=0      'Handles the input of the Selector Codes
     TargetIOState=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     '
     FileNum=0:gosub CloseFile:return       'Close printer & all files
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT LINE ROUTINE
     '
     'When externally set to State 1, this routine assembles the namecode, Ref
     'N, Cross Ref, postcode, sales area letter and name & address fields for
     'one prospect on the target list into a print line. It then transmutes to
     'State 2 indicating that the assembled print line is ready for printing.
     '
     '--------------------------------------------------------------------------
     'SET UP KEY FIELDS IN PRINT LINE
     '
PrintLine:                             'State 0: inactive
     if PrintLineState<>1 then return  'State 1: set up print line
                                       'State 2: print line ready
     PrintLine$=""                     'Clear the print line assembly string
     '
     if PageLineNum=0              _   'If it is the start of a new page
        then gosub PageHeader          'then set up a new page heading
     '
     gosub PrintLine1                  'Set up a normal print line
     '
     if TargItem=TargSize then     _   'If this is the final line of print
        gosub FinalFooter          _   'then append the final page footer
       :goto PrintLine3                'and exit.
     '
     BlockLineNum=BlockLineNum+1       'Increment N of line in current block
     '
     if BlockLineNum=5 and         _   'If now 5 lines in latest block
        PageLineNum<39 then        _   'and the page is not full
        BlockLineNum=0             _   'then reset block line count to start 
       :PrintLine$=PrintLine$      _   'next block and add a line feel in
                  +InterBlockLine$     'order to skip a line between blocks.
     '
     PageLineNum=PageLineNum+1         'Increment N of lines on current page
     '
     if PageLineNum=40 then        _   'If there are now 40 lines on this page
        PageLineNum=0              _   'clear line count for next page and
       :BlockLineNum=0                 'clear block line count for first block
     '
     if PageLineNum=0 then         _   'If about to begin a new page, then
        gosub NormalFooter         _   'print normal page footer and
       :PageNum=PageNum+1              'and increment the page number.
     '
PrintLine3:
     '
     PrintLineState=2                  'Set to `print line ready' state
     return                            'Return to line control loop
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FORMAT THE PRINTLINE DATA INTO FIXED-FORMAT PRINT COLUMNS
     '
PrintLine1:
     '
     x$=rec$(1)      :FieldWidth=27:gosub Trim:Name$        =x$
     x$=rec$(2)      :FieldWidth= 8:gosub Trim:NameCode$    =x$
     x$=SelectorCode$:FieldWidth=16:gosub Trim:SelectorCode$=x$
     x$=Attributes$                :gosub Trim:Attributes$  =x$
     x$=SalesArea$                 :gosub Trim:SalesArea$   =x$
     '
     gosub FormKeyValues                    'Form all keys into 16 chr columns
     gosub Elapsed                          'get dates & elapsed times.
     '
     Number=RecNum:gosub FiveDigit:RecNum$=Number$ 
     '
     '--------------------------------------------------------------------------
     'ASSEMBLE THE PRINT LINE
     '                                              N of Characters
     x$=                "| "    _   '                  2
       +NameCode$     +" | "    _   '             8+3 11
       +RecNum$       +" | "    _   'Ref number   5+3  8
       +Name$         +" | "    _   'Company     27+3 30
       +SIC$          +" |"     _   '             4+3  7
       +SalesArea$    + "|"         '            16+1 17
     y$=Relation$     + "|"     _   '            16+1 17
       +Progress$     + "|"     _   '            16+1 17
       +Attributes$   + "|"     _   '            16+3 19
       +SelectorCode$ + "|"     _   '            16+3 19
       +LastEvent$    + "| "        '            16+1 17
     z$=LastDate$     +" | "    _   '             9+3 12
       +LastDays$     +" |"     _   '             4+3  7
       +NextEvent$    + "| "    _   '            16+1 17
       +NextDate$     +" | "    _   '             9+3 12
       +NextDays$     +" |"     _   '             4+2  6
       +NewLine$      'carriage-return at the end of the line.
     '                                              N of Characters
     PrintLine$=PrintLine$+x$+y$+z$:return   'Total  218
     '
Trim: x$=left$(x$,FieldWidth):x$=x$+space$(FieldWidth-len(x$)):return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FORM THE SIC & KEY VALUE FIELDS
     '
     'A prospect's key values are stored in his 8-byte keys record in the form
     'SSSSRPLN which appears in the string variable Keys$ where:
     '
     'SSSS = 4-digit Standard Industrial Classification (SIC) number.
     '   R = a letter [A thru R] representing his value of the Relation Key
     '   P = a letter [A thru R] representing his value of the Progress Key
     '   L = a letter [A thru R] representing his value of the Last Event Key
     '   N = a letter [A thru R] representing his value of the Next Event Key
     '
     'The text of the key values set up by the user appears in Keyvs$(x,y).
     'This routine puts the text-value corresponding to the prospect's
     'single-letter-value into the respective string variables SIC$, Relation$,
     'Progress$, LastEvent$ and NextEvent$ ready for printing.
     '
FormKeyValues:                                   'Uses Keys$ & Keyvs$(x,y)
     '
     if len(keys$)<8 then keys$=keys$+string$(8-len(keys$),"@")
     '
     SIC$=left$(Keys$,4)                                   'SIC number
     KeyNum=1:KeyType=1:gosub FormKeyValue:Relation$ =x$   'Relation Key value
     KeyNum=2:KeyType=2:gosub FormKeyValue:Progress$ =x$   'Progress Key value
     KeyNum=3:KeyType=3:gosub FormKeyValue:LastEvent$=x$   'Last Event
     KeyNum=4:KeyType=3:gosub FormKeyValue:NextEvent$=x$   'Next Event
     return
     '
FormKeyValue:
     '
     x=asc(mid$(Keys$,4+KeyNum,1))-64          'Extract the key's numeric value
     '
     if x>0 and x<19                        _  'If numeric key value in range
        then x$=left$(keyvs$(KeyType,x),16) _  'then get the textual key value
        else x$=""                             'else make the key value blank.
     '
     goto Trim                                 'Make key value fit 16 chr field.
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINT NEW PAGE HEADING
     '
PageHeader:
     if PageNum=1 then                  'If first page of report, then
        PrintLine$=PrintLine$ _         'Reset printer to default conditions,
                  +pp$(2)     _         'Set the printer to draft mode
                  +pp$(5)               'and set it also to landscape mode
        end if                          'if appropriate.
     PageNum$=right$(str$(PageNum),3)    'Form the page number
     PageNum$=space$(4-len(PageNum$)) _  'into a 4-character string.
             +PageNum$                   '
     '
     PrintLine$=PrintLine$        _
               +pp$(7)            _    'Set printer to 8.25 characters per inch
               +HeaderLine1$      _    'Print the first title line
               +PageNum$+NewLine$ _    'Page number
               +BlankLine$        _
               +pp$(6)            _    'Switch to 16.5 chrs/inch
               +HeaderLine2$      _    'Print second title line
               +ColumnHeadings$        'Print column headings
     '
     return
     '
     '--------------------------------------------------------------------------
     'PRINT NORMAL PAGE FOOTER
     '
NormalFooter:
     PrintLine$=PrintLine$        _   'Add to the print line:
               +BlankLine$        _
               +InterestsKey$     _
               +BlankLine$        _
               +"Continued..."    _   'Normal page footer
               +chr$(12)              'Throw the page
     '
     return
     '
     '--------------------------------------------------------------------------
     'PRINT THE FINAL FOOTER
     '
FinalFooter:
     PrintLine$=PrintLine$        _   'Add to the printer output stack:
               +BlankLine$        _
               +InterestsKey$     _
               +BlankLine$        _
               +"END"             _   'Print final footer
               +chr$(12)          _   'Throw the page
               +pp$(4)            _   'Switch printer back to 10 chrs/inch
               +pp$(3)                'Reset printer to default conditions
ReSetNums:
     PageNum=1                 'Current page number
     PageLineNum =0            'N of lines printed so far on this page
     BlockLineNum=0            'N of lines printed so far in this 5-line block
     return
     '
     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FiveDigit: LenFld=5:goto Digits
FourDigit: LenFld=4
Digits:
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM
     '
FileCtrl:
     '
     on FileCtrlState goto _    'State 0: Inactive
        FileCtrl1,         _    'State 1: Activate Records file opening
        FileCtrl2,         _    'State 2: Activate Areas file opening
        FileCtrl3,         _    'State 3: Activate Target file opening
        FileCtrl4,         _    'State 4: Activate Keys file opening
        FileCtrl5,         _    'State 5: Activate Attributes file opening
        FileCtrl6,         _    'State 6: Activate Selector Codes file opening
        FileCtrl7,         _    'State 7: If all files open goto Wait State
        FileCtrl8,         _    'State 8: File open wait state
        FileCtrl9               'State 9: Close all involved files
     '                          'State10: Successful Termination state
     return                     'State11: Error state
     '
     '--------------------------------------------------------------------------
     'OPEN MAIN RECORDS FILE
     '
FileCtrl1:
     '
     RecordIOstate=1            'Activate the record input/output FMM to open
     FileCtrlState=2            'the records file and advance to next state.
     return
     '
     '--------------------------------------------------------------------------
     'OPEN SALES AREAS FILE
     '
FileCtrl2:
     '
     if RecordIOstate=3  then _ 'If the records file is now open, then
        GetAreasState=1       _ 'Activate areas file input FMM to open
       :FileCtrlState=3         'the target list file; advance to next state.
     '
     if RecordIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl11       _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN KEYS FILE
     '
FileCtrl3:
     '
     if GetAreasState=3  then _ 'If the areas file is now open, then
        KeysIOstate  =1       _ 'Activate Keys file input/output FMM to open
       :FileCtrlState=4         'the target list file; advance to next state.
     '
     if GetAreasState=8       _ 'If areas file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'OPEN ATTRIBUTES FILE
     '
FileCtrl4:
     '
     if KeysIOstate  =3  then _ 'If the Keys file is now open, then
        AttrIOstate  =1       _ 'Activate Attrib file input/output FMM to open
       :FileCtrlState=5         'the target list file; advance to next state.
     '
     if KeysIOstate  =10      _ 'If keys file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN TARGET LIST FILE
     '
FileCtrl5:
     '
     if AttrIOstate  =3  then _ 'If the attributes file is now open, then
        CodeIOstate  =1       _ 'Activate code file input/output FMM to open
       :FileCtrlState=6         'the target list file; advance to next state.
     '
     if AttrIOstate  =10      _ 'If attributes file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN SELECTOR CODES FILE
     '
FileCtrl6:
     '
     if CodeIOstate  =3  then _ 'If the attributes file is now open, then
        TargetIOstate=1       _ 'Activate target file input/output FMM to open
       :FileCtrlState=7         'the target list file; advance to next state.
     '
     if CodeIOstate  =10      _ 'If attributes file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'WAIT FOR TARGET LIST FILE TO OPEN
     '
FileCtrl7:
     '
     if TargetIOstate=3  then _ 'If the records file is now open, then
        FileCtrlState=8         'the target list file; advance to next state.
     '
     if TargetIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'ALL FILES OPEN & READY FOR I/O
     '
FileCtrl8: return               'All files open Wait State
     '
     '--------------------------------------------------------------------------
     'CLOSE ALL FILES
     '
FileCtrl9:
     '
     FileNum=1:gosub CloseFile  'Close Records File
     FileNum=2:gosub CloseFile  'Close Areas File
     FileNum=3:gosub CloseFile  'Close Target File
     gosub DeActivate           'De-activate
     FileCtrlState=10           'Successful Termination State
     '
     '--------------------------------------------------------------------------
     'ALL FILES CLOSED OK
     '
FileCtrl10: return              'Wait State
     '
     '--------------------------------------------------------------------------
     'FILE OPENING FAILED
     '
FileCtrl11:                     'Open failure
     '
     gosub DeActivate           'De-activate
     FileCtrlState=11           'Set this FMM to its error state
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 1 - PACKAGE NAME, LISTING TITLE, SERIAL, DATE, PAGE
     '
     'Note: The first line is printed in 8.25 chr/inch lettering which allows
     '      108 characters across the standard 15-inch platen.
     '
SetUpReportHeading:
     '
     HeaderDrop$=BlankLine$+BlankLine$+BlankLine$+BlankLine$
     '
     if CompanyName$="" then CompanyName$="E.B.S. MARKETEER"
     '
     CompanyName$=left$(CompanyName$,27) 'Safety limit for company name
     ReportTitle$=left$(ReportTitle$,24) 'Safety limit for report title
     '
     x=51                     _          'N of spare character spaces
      -len(CompanyName$)      _          'minus lengths of company name &
      -len(ReportTitle$)                 'report title giving spaces left.
     '
     y=x/2:x=x-y                         'Divide the spaces left in two.
     Number=ExtrFlag:gosub FourDigit
     '
     HeaderLine1$=HeaderDrop$         _  'First heading line comprises...
       +CompanyName$+space$(x)        _  'Company name + padding
       +ReportTitle$+space$(y)        _  '+ Report Title + padding =   52 chrs
       +"TARGET NO "+TargNum$+"  "    _  '10+4+2 characters            16 chrs
       +"SERIAL NO "+Number$ +"  "    _  '10+4+2 characters            16 chrs
       +sd$                  +"  "    _  'System date  15+2            17 chrs
       +" PAGE"                          'Page N  4+4=                 9 chrs
     '                                                                ---
     'Total                                                           110 chrs
     '
     'Note: The page number which is 4-characters long is appended to this
     '      string at the time each page heading is set up during printing.
     '
     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 2 - TARGET PROFILE REFERENCE & LISTING ORDER
     '
     if SeqTyp=2 then y$="ref number order":goto SetUpReportHeading1
     if SeqTyp=6 then y$="postcode order"  :goto SetUpReportHeading1
     y$="alphabetic order"
     if SeqTyp=1 goto SetUpReportHeading1
     y$=y$+" within post "
     if SeqTyp=3 then y$=y$+"area"
     if SeqTyp=4 then y$=y$+"district"
     if SeqTyp=5 then y$=y$+"sector"
     '
SetUpReportHeading1:
     '
     x$=space$((193-len(TargName$)-len(y$)-len(ListDate$))/2)  'Left indent
     '
     HeaderLine2$=x$                       _  'Second line of report heading:
       +TargName$                          _  'Target Profile name
       +" extracted at"                    _  '13 chrs
       +ListDate$                          _  'of latest extraction
       +" listed in "                      _  '11 chrs
       +y$+NewLine$+BlankLine$                'Listing order
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 4 - THE COLUMN HEADINGS
     '
SetUpReportHeading3:
     '
     InterBlockLine$_
       ="|----------|-------|-----------------------------|-"_
       +"-----|----------------|----------------|----------------|"_
       +"----------------|----------------|----------------|-"_
       +"----------|------|----------------|-----------|------|"_
       +NewLine$
     '
     y=16:k=0:gosub SetUpReportHeading4:SalesAreaTitle$=x$+"|"
          k=1:gosub SetUpReportHeading4:RelationTitle$ =x$+"|"
          k=2:gosub SetUpReportHeading4:ProgressTitle$ =x$+"|"
          k=4:gosub SetUpReportHeading4:InterestsTitle$=x$+"|"
     y=11:k=3:gosub SetUpReportHeading4
          LastEventTitle$="LAST "+x$+"| DATE OF   |LAPSE |"
          NextEventTitle$="NEXT "+x$+"| DATE OF   |LAPSE |"
     '
     ColumnHeadings$_
       ="| NAMECODE | -REF- | COMPANY NAME                | SICN |"_
       +SalesAreaTitle$ _
       +RelationTitle$  _
       +ProgressTitle$  _
       +InterestsTitle$ _
       +"SELECTOR CODE   |" _
       +LastEventTitle$_
       +NextEventTitle$_
       +NewLine$+InterBlockLine$
     '
     for k = 0 to 18                        'Set up the Key Table to interpret
     x$ = left$(keyvs$(4,k),16)             'the letters indicating the
     x$ = x$ + space$( 18 - len(x$) )       'range of products or interests.
     if k = 9 then x$ = x$ + NewLine$ + space$(18)
     if k > 0 then x$ = chr$(k+64) + ":" + x$
     InterestsKey$ = InterestsKey$ + x$
     next
     '
     return  
     '
SetUpReportHeading4: x$=left$(keyvs$(k,0),y):x$=x$+space$(y-len(x$)):return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3: column=41:colour=grey
     '
     ps$=space$(40):for row=5 to 15:gosub 50:next
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of prospects on List   0000    ":row=17:gosub 50
     ps$="    Now printing prospect N  0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     '
     number=TargSize:row=17:colour=7:gosub ShowStates1:return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES
     '
ShowStates:
     colour=7
     if LastTargItem <> TargItem then 
        LastTargItem =  TargItem      
        row=18 : number=TargItem : gosub ShowStates1
 end if
     return
     '
ShowStates1: gosub FourDigit : column = 72 : ps$ = number$ : goto 50
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     '
     on PrtIntegState goto  _  'State 0: inactive
        PrtInteg1,          _  'State 1: wait for initialization to complete
        PrtInteg2,          _  'State 2: check printer initially or after error
        PrtInteg3              'State 3: wait for the printer to open
     '
     return                    'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR THE INITIALIZATION PROCESS TO COMPLETE
     '
PrtInteg1:
     '
     if ListInitState=4 then _      'If the initialization process completed
        PrtIntegState=2             'Initiate the opening of the printer
     '
     if ListInitState=5 then _      'If the initialization process has failed
        ListInitState=1             'the re-activate it & try again.
     '
     return                         'Return control to the Polling Loop
     '
     '--------------------------------------------------------------------------
     'SEE IF PRINTER IN OPEN
     '
PrtInteg2:
     '
     if PrintIOstate=3 then return  'Printer I/O FMM in normal active state
     if PrintIOstate=4 then return  'Printer I/O FMM in X-off state
     '
     PrtIntegState=3                'Advance to wait for printer on
     PrintIOstate=1                 'Activate the printer I/O FMM
     gosub ShowPreStartMsgs         'Show the `switch on the printer' message
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINTER TO OPEN
     '
PrtInteg3:
     '
     if PrintIOstate>2 then      _  'If the printer is on and ready or
        PrtIntegState=2          _  're-set the Printer Watchdog to monitoring
     '
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'FMM TO LOAD ALL REQUIRED RECORDS FOR A PRINT LINE
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoadRecs:
     on LoadRecsState goto _   'State 0: inactive
        LoadRecs1,         _   'State 1: initialize
        LoadRecs2,         _   'State 2: get next list member's record number
        LoadRecs3,         _   'State 3: get the next list member's record
        LoadRecs4,         _   'State 4: get the next list member's sales area
        LoadRecs5,         _   'State 5: get the next list member's key values
        LoadRecs6,         _   'State 6: get the next list member's attributes
        LoadRecs7              'State 7: get the next list member's sel codes
     '                         'State 8: successful termination state
     return                    'State 9: error termination state
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
LoadRecs1:
     TargetIOstate=4               'Activate the Target Record retrieval
     LoadRecsState=2               'Advance to the next machine state
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
LoadRecs2:
     if TargetIOstate=5  then     'If the next target list record got OK then
        RecordIOstate=4           'Activate the main record `get' process
        LoadRecsState=3           'Advance to the next machine state
 elseif TargetIOstate=10 then     'If error occurred while getting record, then
        LoadRecsState=9           'Go to error state
 end if
     return                       'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD
     '
LoadRecs3:
     if RecordIOstate=5  then    'If the next main record got OK then
        GetAreasState=4          'Activate the sales area search
        LoadRecsState=4          'Advance to next state
 elseif RecordIOstate=10 then    'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
 end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S SALES AREA
     '
LoadRecs4:
     if GetAreasState=5  then    'If the next target list record got OK then
        KeysIOstate  =4          'Activate the getting of the key values.
        LoadRecsState=5
 elseif GetAreasState=8  then    'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
 end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S KEY VALUES
     '
LoadRecs5:
     if KeysIOstate  = 5 then    'If the next keys record got OK then
        AttrIOstate  = 4         'Activate the attribute getting process
        LoadRecsState= 6         'Advance to next state
 elseif KeysIOstate  =10 then    'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
 end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S ATTRIBUTES
     '
LoadRecs6:
     if AttrIOstate  =5  then    'If the next attribute record got OK then
        CodeIOstate  =4        
        LoadRecsState=7          'Go to successful termination state
 elseif AttrIOstate  =10 then    'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
 end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S SELECTOR CODES
     '
LoadRecs7:
     if CodeIOstate  =5  then    'If the next attribute record got OK then
        LoadRecsState=8          'Go to successful termination state
 elseif CodeIOstate  =10 then    'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
 end if
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------




