





     'PRINTS A TARGET'S LIST OF ORDERS         16MAR88           File:List3.Bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'Enables the user to print out a list of the last line of diary notes for 
     'prospects who are on a specified Target List.
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'All interger
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     dim fields$(12)
     dim stamps$(12)               'Date stamps for the diary notes.
     dim rec$(12)                  'Array to hold name & address data
     dim pp$(20)                   'Holds printer port specs & control Codes
     '
     PrRecLen = 4096           'Block length for spool file output.
     FMMflag=0                 'Set to 1 to display FMM states
     RecFileNum =1             'File N under which Records File is opened
     AreaFileNum=2             'File N under which Sales Areas File is opened
     KeysFileNum=3             'File N under which Keys File is opened
     AttrFileNum=4             'File N under which Attributes File is opened
     NoteFileNum=5             'File N under which Notes File opened
     TargFileNum=6             'File N under which Target List File is opened
     PrtBufNum  =7             'File N under which Printer I/O File is opened
     GetKeyvsFlag=1            'Enabe Key Values acquisition by ListInit.FMM
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ReSetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     '
     ReportTitle$="DIARY NOTES LISTING"
     gosub ExpiryTest
     '
     gosub SetUpReportHeading
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub ShowStates3
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     FromEntryState=1
     goto StartLoop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
50   Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'KeysIO.FMM'
     rem $include: 'AttrIO.FMM'
     rem $include: 'NotesIO.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Elapsed.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'TexCrypt.INC'
     rem $include: 'EdField.FMM'
     rem $include: 'From.FMM'
     '
     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
StartLoop:
     ACTIVE = 1
     While ACTIVE
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub LoadRecs      'Load all records required for a print line's data
     gosub FileCtrl      'Controls opening and closing of the required files
     gosub ShowStates    'Display FMM states
     gosub RecordIO      'Handles the input of the main prospect records
     gosub GetAreas      'Handles the input of the sales area data
     gosub KeysIO        'Handles the input of the key values
     gosub AttrIO        'Handles the input of the attributes
     gosub NotesIO       'Handles the input of the selector Notes
     gosub TargetIO      'Handles the input of the target list of prospects
     gosub OpenFileFMM   'General file opener FMM
     gosub PrintLine     'Set up lines of print as required
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     gosub FromEntry
     wend
     FileNum=0:gosub CloseFile         'then close printer & all files
     ps$="":gosub ShowMsgs1            'clear error message field
     prog$="LIST2"                     'Set program identification variable
     chain"Lmenu2"                     'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     if ShowMessages=0 then return   'No messages waiting to be displayed
     '
     if DosClr>0 then           _    'If there is a DOS message to be displayed
        colour=DosClr           _    'set the appropriate message colour
       :DosClr=0                _    'Message colour acts as message trigger
       :ps$=DosMsg$             _    'set up the message in the display string
       :gosub ShowMsgs1              'display message
     '
     if PrtClr>0 then           _    'If there's a Printer Status message to be
        colour=PrtClr           _    'displayed, set appropriate message colour
       :PrtClr=0                _    'Message colour acts as message trigger
       :row=23:column=46        _
       :ps$=left$(Pstatus$,30)  _    'set up the message in the display string
       :ps$=ps$+space$(30-len(ps$))_ 'Pad out to 30 character message field
       :gosub 50                _    'display message
       :gosub ShowPlamps             'display pritner status lamps
     '
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1: ps$=left$(ps$,36)
     '
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl: if FromEntryState>0 then return

     gosub NextChar                   
     if CtrlChar = 87 then              'If Shift-F4 hit, then
        FMMflag = 1                     'Enable FMM states display
        goto ShowStates3                'Show the display panel
     end if

     if KbChar=27 or CtrlChar=61 then active=0:return  'Esc or F3
     if KbChar<>13 and CtrlChar<>60 then return        'Not a C/R or F2
     '
     if LoopCtrlState=0          _  'If the print loop FMM not active
        goto KeybCtrl1              'then see if it can be activated.
     '
     if HaltPrinterFlag=0        _  'If not currently in a halt state
        then HaltPrinterFlag=1   _  'then set printer to halt state
        else HaltPrinterFlag=0   _  'else clear the halt state
            :ps$=""              _
            :gosub ShowMsgs1        'clear possible error message.
     '
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     '
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then     _  'and the Lister Module initialized
        LoopCtrlState=1             'then activate the print loop FMM.
     '
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoopCtrl:
     '
     on LoopCtrlState goto _   'State 0: inactive
        LoopCtrl1,         _   'State 1: Initiate opening of all required files
        LoopCtrl2,         _   'State 2: wait for file-opening to complete
        LoopCtrl3,         _   'State 3: process next prospect on target list
        LoopCtrl4,         _   'State 4: get next list member's record number
        LoopCtrl5,         _   'State 9: drain printer output stack
        LoopCtrl6,         _   'State10: wait for next print line
        LoopCtrl7              'State11: confirm storage of `list printed' flag
     '
     return
     '
     '-------------------------------------------------------------------------
     'INITIATE THE OPENING OF ALL REQUIRED FILES
     '
LoopCtrl1:
     '
     FileCtrlState=1            'Activate the file opening process
     LoopCtrlState=2            'Advance to next machine state
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR FILE-OPENING TO COMPLETE
     '
LoopCtrl2:
     '
     if FileCtrlState=8 then _  'If all files opened successfully, then
        LoopCtrlState=3      _  'set to loop advancement state
       :goto LoopCtrl3          'Proceed to loop advancement process
     '
     if FileCtrlState=11 then_  'If the file opening process failed, then
        gosub DeActivate        'De-activate all FMMs
     '
     return                     'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'ADVANCE TO NEXT PROSPECT ON THE TARGET LIST
     '
LoopCtrl3:
     if TargItem<TargSize then     'If last list member has been printed
        TargItem=TargItem+1        'Advance to [next] member of target list
        LoadRecsState=1            'Activate the records loader
        LoopCtrlState=4            'Advance to the Get Record state
     '
     '-------------------------------------------------------------------------
     'LAST RECORD HAS BEEN PROCESSED; DRAIN REMAINDER OF PRINT OUTPUT STACK
     '
     else
        if PrStr$="" then               'When printer ouput stack is finally
           PrtfFlag=1                   'set the `list printed' flag
           TargItem=0                   'Target List Record#0
           TargetIOstate=6              'Store Record of Target List File
           LoopCtrlState=7              'Advance to next machine state
        end if
        PrintIOflush = 1                'Trigger flushing of print output stack
     end if
     return                             'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORDS
     '
LoopCtrl4:
     '
     if LoadRecsState=8  then _  'If the next target list record got OK then
        LoopCtrlState=5          'Advance to the next machine state
     '
     if LoadRecsState=9  then _  'If error occurred while getting record, then
        gosub DeActivate         'De-activate all FMMs
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINT OUTPUT STACK TO EMPTY
     '
LoopCtrl5:
     if len(PrStr$)<PrRecLen then 'If there is plenty of room on the printer
        PrintLineState=1          'output stack then ask PrintLine.FMM to set up
        LoopCtrlState=6           'another line & return to get the next record.
        end if
     return                       'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR NEXT PRINT LINE TO BE SET UP
     '
LoopCtrl6:
     if PrintLineState=2 then       'If the next print line has been set up
        PrintLineState=0            'de-activate the print line setter up
        LoopCtrlState=3             'output stack and go for next record.
        end if
     if PrintLineState=3 then       'If the next print line has been set up
        PrintLineState=0            'de-activate the print line setter up
        LoopCtrlState=5             'output stack and go for next record.
        end if
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'CONFIRM STORAGE OF `LIST PRINTED' FLAG
     '
LoopCtrl7:
     if TargetIOstate=7 then         'If the record has been stored OK
        Pstatus$="FINISHED"       
        PrtClr=10:ShowMessages=1     '
        gosub ShowMsgs
        gosub DeActivate             'De-activate all FMM/close files & printer
        end if
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'FMM DE-ACTIVATOR/CLOSER
     '
DeActivate:
     PrintIOState=0     'Printer input/output FMM
     LoopCtrlState=0    'Record print loop control
     FileCtrlState=0    'Controls the opening and closing of the required files
     LoadRecsState=0    'Controls the acquisition of data records
     RecordIOState=0    'Handles the input of the main prospect records
     GetAreasState=0    'Handles the input of the sales area data
     KeysIOState=0      'Handles the input of the Key Values
     AttrIOState=0      'Handles the input of the Attributes
     NotesIOState=0     'Handles the input of the Selector Notes
     TargetIOState=0    'Handles the input of the target list of prospects
     OpenFileState=0    'General file opener FMM
     '
     FileNum=0:gosub CloseFile:return       'Close printer & all files
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINT LINE ROUTINE
     '
     'When externally set to State 1, this routine assembles the namecode, Ref
     'N, Cross Ref, postcode, sales area letter and name & address fields for
     'one prospect on the target list into a print line. It then transmutes to
     'State 2 indicating that the assembled print line is ready for printing.
     '
     '--------------------------------------------------------------------------
     'SET UP KEY FIELDS IN PRINT LINE
     '
PrintLine:
     if PrintLineState<>1 then return
     IF RecordLines=0 THEN
        NotesLine=0:StampLine=0
        S$=space$(7)
        for K=12 to 1 step-1
        Z$=Fields$(K)
        if NotesLine=0 and Z$>" " then
           NotesLine=K                  'Lowest line containing note text.
           end if
        X$=Stamps$(K)                   'Current datestamp under test
        if X$>S$ and Z$>" " then        'If line contains a datestamp, then
           if StampLine=0 then          'If not date stamp encountered yet,
              StampLine=K               'Mark this notes line as first line.
              Y$=X$                     'Set Y$=first-encountered datestamp
       elseif X$=Y$ then                'If datestamp same as latest, then
              StampLine=K               'Mark this notes line as first line.
              end if
           end if
        next:FirstLine=1
        RecordLines=NotesLine-StampLine+1
        END IF
     '
     if PageLine=0 then gosub PageHeader'If it is the start of a new page
     gosub PrintLine1                   'Set up a normal print line
     '
     if RecordLines=0 and _             'If doing last notes line for this rec
        TargItem=TargSize then          'If this is the final line of print
        gosub FinalFooter               'then append the final page footer
   else PageLine=PageLine+1             'Increment N of lines on current page
        if PageLine=50 then             'If there are now 50 lines on this page
           PageLine=0                   'clear line count for next page and
           end if                       
        if PageLine=0 then              'If about to begin a new page, then
           gosub NormalFooter           'print normal page footer and
           PageNum=PageNum+1            'and increment the page number.
           end if
        end if
     '
     if RecordLines=0 then              'If final line of prospect's notes done
        PrintLineState=2                'Set to `print line ready' state
   else PrintLineState=3
        end if
     return                             'Return to line control loop
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FORMAT THE PRINTLINE DATA INTO FIXED-FORMAT PRINT COLUMNS
     '
PrintLine1:
     if FirstLine=1 then
        x$=rec$( 1)          :FieldWidth=27:gosub Trim:Name$     =x$
        x$=rec$( 2)          :FieldWidth= 8:gosub Trim:NameCode$ =x$
        x$=rec$(10)          :FieldWidth=27:gosub Trim:Contact$  =x$
        x$=Stamps$(StampLine):FieldWidth= 7:gosub Trim:DateStamp$=x$
        Number=RecNum:gosub FiveDigit:RecNum$=Number$ 
        FirstLine=0
   else Name$=space$(27)
        Contact$=Name$
        NameCode$=space$(8)
        DateStamp$=space$(7)
        RecNum$=space$(5)
        end if
     x$=Fields$(StampLine):FieldWidth=70:gosub Trim:Notes$=x$
     StampLine=StampLine+1
     RecordLines=RecordLines-1
     '
     '-------------------------------------------------------------------------
     'ASSEMBLE THE PRINT LINE
     '                                              N of Characters
     PrStr$=PrStr$ _
       +                "| "    _   '                  2
       +NameCode$     +" | "    _   '             8+3 11
       +RecNum$       +" | "    _   'Ref number   4+3  7
       +Name$         +" | "    _   'Company     27+3 30
       +Contact$      +" |  "   _
       +DateStamp$   +"  | "    _   '             4+3  7
       +Notes$        +" | "    _   '            14+3 17
       +NewLine$      'carriage-return at the end of the line.
     '                                              N of Characters
     return   'Total  217
     '
Trim: x$=left$(x$,FieldWidth)
      l=len(x$):for k=1 to l:x=asc(mid$(x$,k,1))
      if x<32 or x>126 then mid$(x$,k,1)=" "
      next:x$=x$+space$(FieldWidth-len(x$)):return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINT NEW PAGE HEADING
     '
PageHeader:
     if PageNum=1 then                  'If this is the first page, then
        PrStr$=PrStr$     _             'Reset the printer to default status
              +pp$(2)     _             'and then set it to draft mode
              +pp$(5)                   'set it to landscape mode if 
        end if                          'appropriate
     PageNum$=right$(str$(PageNum),3)   'Form the page number
     PageNum$=space$(4-len(PageNum$)) _ 'into a 4-character string
             +PageNum$                  'with leading spaces.
     PrStr$=PrStr$            _
           +pp$(7)            _    'Set printer to 8.25 characters per inch
           +HeaderLine1$      _    'Print the first title line
           +PageNum$+NewLine$ _    'Page number
           +BlankLine$        _
           +pp$(6)            _    'Switch to 16.5 chrs/inch
           +HeaderLine2$      _    'Print second title line
           +ColumnHeadings$        'Print column headings
     return
     '
     '--------------------------------------------------------------------------
     'PRINT NORMAL PAGE FOOTER
     '
NormalFooter:
     PrStr$=PrStr$            _   'Add to the print line:
           +BlankLine$        _
           +BlankLine$        _
           +"Continued..."    _   'Normal page footer
           +chr$(12)              'Throw the page
     '
     return
     '
     '--------------------------------------------------------------------------
     'PRINT THE FINAL FOOTER
     '
FinalFooter:
     PrStr$=PrStr$            _   'Add to the printer output stack:
           +BlankLine$        _
           +BlankLine$        _
           +"END"             _   'Print final footer
           +chr$(12)          _   'Throw the page
           +pp$(4)            _   'Switch printer back to 10 chrs/inch
           +pp$(3)                'ReSet printer to default conditions
ReSetNums:
     PageNum=1                 'Current page number
     PageLine=0            'N of lines printed so far on this page
     return
     '
     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FiveDigit: LenFld=5:goto Digits
FourDigit: LenFld=4
Digits:
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum>LenFld then
        Number$=string$(LenFld,"/")
        else
        if LenNum<LenFld then Number$=string$(LenFld-LenNum,"0")+Number$
        end if
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'FILE OPENING CONTROL FMM
     '
FileCtrl:
     '
     on FileCtrlState goto _    'State 0: Inactive
        FileCtrl1,         _    'State 1: Activate Records file opening
        FileCtrl2,         _    'State 2: Activate Areas file opening
        FileCtrl3,         _    'State 3: Activate Target file opening
        FileCtrl4,         _    'State 4: Activate Keys file opening
        FileCtrl5,         _    'State 5: Activate Attributes file opening
        FileCtrl6,         _    'State 6: Activate Notes file opening
        FileCtrl7,         _    'State 7: If all files open goto Wait State
        FileCtrl8,         _    'State 8: File open wait state
        FileCtrl9               'State 9: Close all involved files
     '                          'State10: Successful Termination state
     return                     'State11: Error state
     '
     '--------------------------------------------------------------------------
     'OPEN MAIN RECORDS FILE
     '
FileCtrl1:
     '
     RecordIOstate=1            'Activate the record input/output FMM to open
     FileCtrlState=2            'the records file and advance to next state.
     return
     '
     '--------------------------------------------------------------------------
     'OPEN SALES AREAS FILE
     '
FileCtrl2:
     '
     if RecordIOstate=3  then _ 'If the records file is now open, then
        NotesIOstate =1       _ 'Activate Notes file input/output FMM to open
       :NotesIOtask  =1       _ 'Set to open file and wait
       :FileCtrlState=6         'the target list file; advance to next state.
     '
     if RecordIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl11       _ 'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN KEYS FILE
     '
FileCtrl3:
     '
     if GetAreasState=3  then _ 'If the areas file is now open, then
        KeysIOstate  =1       _ 'Activate Keys file input/output FMM to open
       :FileCtrlState=4         'the target list file; advance to next state.
     '
     if GetAreasState=8       _ 'If areas file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'OPEN ATTRIBUTES FILE
     '
FileCtrl4:
     '
     if KeysIOstate  =3  then _ 'If the Keys file is now open, then
        AttrIOstate  =1       _ 'Activate Attrib file input/output FMM to open
       :FileCtrlState=5         'the target list file; advance to next state.
     '
     if KeysIOstate  =10      _ 'If keys file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN TARGET LIST FILE
     '
FileCtrl5:
     '
     if AttrIOstate  =3  then _ 'If the attributes file is now open, then
        NotesIOstate =1       _ 'Activate Notes file input/output FMM to open
       :NotesIOtask  =1       _ 'Set to open file and wait
       :FileCtrlState=6         'the target list file; advance to next state.
     '
     if AttrIOstate  =10      _ 'If attributes file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'OPEN NOTES FILE
     '
FileCtrl6:
     '
     if NotesIOstate =3  then _ 'If the attributes file is now open, then
        TargetIOstate=1       _ 'Activate target file input/output FMM to open
       :FileCtrlState=7         'the target list file; advance to next state.
     '
     if NotesIOstate =10      _ 'If attributes file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'WAIT FOR TARGET LIST FILE TO OPEN
     '
FileCtrl7:
     '
     if TargetIOstate=3  then _ 'If the records file is now open, then
        FileCtrlState=8         'the target list file; advance to next state.
     '
     if TargetIOstate=10      _ 'If records file wouldn't open, then
        goto FileCtrl11         'de-activate all FMMs involved and exit.
     '
     return
     '
     '--------------------------------------------------------------------------
     'ALL FILES OPEN & READY FOR I/O
     '
FileCtrl8: return               'All files open Wait State
     '
     '--------------------------------------------------------------------------
     'CLOSE ALL FILES
     '
FileCtrl9:
     '
     FileNum=1:gosub CloseFile  'Close Records File
     FileNum=2:gosub CloseFile  'Close Areas File
     FileNum=3:gosub CloseFile  'Close Target File
     gosub DeActivate           'De-activate
     FileCtrlState=10           'Successful Termination State
     '
     '--------------------------------------------------------------------------
     'ALL FILES CLOSED OK
     '
FileCtrl10: return              'Wait State
     '
     '--------------------------------------------------------------------------
     'FILE OPENING FAILED
     '
FileCtrl11:                     'Open failure
     '
     gosub DeActivate           'De-activate
     FileCtrlState=11           'Set this FMM to its error state
     return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 1 - PACKAGE NAME, LISTING TITLE, SERIAL, DATE, PAGE
     '
     'Note: The first line is printed in 8.25 chr/inch lettering which allows
     '      108 characters across the standard 15-inch platen.
     '
SetUpReportHeading:
     '
     HeaderDrop$=BlankLine$+BlankLine$+BlankLine$+BlankLine$
     '
     if CompanyName$="" then CompanyName$="E.B.S. MARKETEER"
     '
     CompanyName$=left$(CompanyName$,27) 'Safety limit for company name
     ReportTitle$=left$(ReportTitle$,24) 'Safety limit for report title
     '
     x=53                     _          'N of spare character spaces
      -len(CompanyName$)      _          'minus lengths of company name &
      -len(ReportTitle$)                 'report title giving spaces left.
     '
     y=x/2:x=x-y                         'Divide the spaces left in two.
     Number=ExtrFlag:gosub FourDigit
     '
     HeaderLine1$=HeaderDrop$         _  'First heading line comprises...
       +CompanyName$+space$(x)        _  'Company name + padding
       +ReportTitle$+space$(y)        _  '+ Report Title + padding =   52 chrs
       +"TARGET NO "+TargNum$+"  "    _  '10+4+2 characters            16 chrs
       +"SERIAL NO "+Number$ +"  "    _  '10+4+2 characters            16 chrs
       +sd$                  +"  "    _  'System date  15+2            17 chrs
       +" PAGE"                          'Page N  5+4=                 9 chrs
     '                                                                ---
     'Total                                                           110 chrs
     '
     'Note: The page number which is 4-characters long is appended to this
     '      string at the time each page heading is set up during printing.
     '
     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 2 - TARGET PROFILE REFERENCE & LISTING ORDER
     '
     if SeqTyp=2 then y$="ref number order":goto SetUpReportHeading1
     if SeqTyp=6 then y$="postcode order"  :goto SetUpReportHeading1
     y$="alphabetic order"
     if SeqTyp=1 goto SetUpReportHeading1
     y$=y$+" within post "
     if SeqTyp=3 then y$=y$+"area"
     if SeqTyp=4 then y$=y$+"district"
     if SeqTyp=5 then y$=y$+"sector"
     '
SetUpReportHeading1:
     '
     x$=space$((193-len(TargName$)-len(y$)-len(ListDate$))/2)  'Left indent
     '
     HeaderLine2$=x$                       _  'Second line of report heading:
       +TargName$                          _  'Target Profile name
       +" extracted at"                    _  '13 chrs
       +ListDate$                          _  'of latest extraction
       +" listed in "                      _  '11 chrs
       +y$+NewLine$+BlankLine$                'Listing order
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'SET UP TITLE LINE 4 - THE COLUMN HEADINGS
     '
SetUpReportHeading3:
     '
     ColumnHeadings$_
        ="| NAMECODE |  REF  "           _
        +"| COMPANY NAME                "_
        +"| CONTACT                     "_
        +"| DATESTAMP | LAST DIARY NOTE"+space$(56)+"|"_
        +NewLine$ _
        +"|----------|-------|"+string$(29,"-")+"|"+string$(29,"-")  _
        +"|-----------|"+string$(72,"-")+"|"_
        +NewLine$
     '
     return  
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStates3: column=41:colour=grey
     '
     if FMMflag=0 then 
     ps$=space$(40):for row=5 to 15:gosub 50:next
     else
     ps$="    Ŀ    ":row= 5:gosub 50
     ps$="    FMM STATES                        ":row= 6:gosub 50
     ps$="    Ĵ    ":row= 7:gosub 50
     ps$="    ListInit  0     LoadRecs  0       ":row= 8:gosub 50
     ps$="    GetKeyvs  0     RecordIO  0       ":row= 9:gosub 50
     ps$="    PrintI/O  0     GetAreas  0       ":row=10:gosub 50 
     ps$="    LoopCtrl  0     Keys I/O  0       ":row=11:gosub 50
     ps$="    FileCtrl  0     Attr I/O  0       ":row=12:gosub 50
     ps$="    OpenFile  0     NotesI/O  0       ":row=13:gosub 50
     ps$="    PrtInteg  0     TargetIO  0       ":row=14:gosub 50
     ps$="        ":row=15:gosub 50
     end if
     ps$="    Ŀ    ":row=16:gosub 50
     ps$="    N of prospects on List   0000    ":row=17:gosub 50
     ps$="    Now printing prospect N  0000    ":row=18:gosub 50
     ps$="        ":row=19:gosub 50
     ps$="    Ŀ    ":row=20:gosub 50
     ps$="    PRINTER STATUS                    ":row=21:gosub 50
     ps$="    Ĵ    ":row=22:gosub 50
     ps$="                                      ":row=23:gosub 50
     ps$="        ":row=24:gosub 50
     '
     number=TargSize:row=17:colour=7:gosub ShowStates1:return
     '
     '--------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'DISPLAY THE FMM STATES
     '
ShowStates: colour=7:if FMMflag=0 goto ShowStates4
     '
     column=55
     '
     if LastListInitState<>ListInitState then _
        LastListInitState =ListInitState      _
       :row= 8:Ps$=str$(ListInitState):gosub 50
     '
     if LastGetKeyvsState<>GetKeyvsState then _
        LastGetKeyvsState =GetKeyvsState      _
       :row= 9:Ps$=str$(GetKeyvsState):gosub 50
     '
     if LastPrintIOstate<>PrintIOState  then  _
        LastPrintIOstate =PrintIOState        _
       :row=10:Ps$=str$(PrintIOstate):gosub 50
     '
     if LastLoopCtrlState<>LoopCtrlState then _
        LastLoopCtrlState =LoopCtrlState      _
       :row=11:Ps$=str$(LoopCtrlState):gosub 50
     '
     if LastFileCtrlState<>FileCtrlState then _
        LastFileCtrlState =FileCtrlState      _
       :row=12:Ps$=str$(FileCtrlState):gosub 50
     '
     if LastOpenFileState<>OpenFileState then _
        LastOpenFileState =OpenFileState      _
       :row=13:Ps$=str$(OpenFileState):gosub 50
     '
     if LastPrtIntegState<>PrtIntegState then _
        LastPrtIntegState =PrtIntegState      _
       :row=14:Ps$=str$(PrtIntegState):gosub 50
     '
     column=71
     if LastLoadRecsstate<>LoadRecsState then _
        LastLoadRecsstate =LoadRecsState      _
       :row= 8:Ps$=str$(LoadRecsState):gosub 50
     '
     if LastRecordIOstate<>RecordIOState then _
        LastRecordIOstate =RecordIOState      _
       :row= 9:Ps$=str$(RecordIOstate):gosub 50
     '
     if LastGetAreasState<>GetAreasState then _
        LastGetAreasState =GetAreasState      _
       :row=10:Ps$=str$(GetAreasState):gosub 50
     '
     if LastKeysIOstate<>KeysIOState then _
        LastKeysIOstate =KeysIOState      _
       :row=11:Ps$=str$(KeysIOstate):gosub 50
     '
     if LastAttrIOstate<>AttrIOState then _
        LastAttrIOstate =AttrIOState      _
       :row=12:Ps$=str$(AttrIOstate):gosub 50
     '
     if LastNotesIOstate<>NotesIOState then _
        LastNotesIOstate =NotesIOState      _
       :row=13:Ps$=str$(NotesIOstate):gosub 50
     '
     if LastTargetIOstate<>TargetIOState then _
        LastTargetIOstate =TargetIOState      _
       :row=14:Ps$=str$(TargetIOstate):gosub 50
     '
ShowStates4:
     if LastTargItem<>TargItem then _
        LastTargItem =TargItem      _
       :row=18:number=TargItem:gosub ShowStates1
     '
     return
     '
ShowStates1: gosub FourDigit:column=72:ps$=number$:goto 50
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     on PrtIntegState goto  _  'State 0: inactive
        PrtInteg1,          _  'State 1: wait for initialization to complete
        PrtInteg2,          _  'State 2: check printer initially or after error
        PrtInteg3              'State 3: wait for the printer to open
     '
     return                    'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR THE INITIALIZATION PROCESS TO COMPLETE
     '
PrtInteg1:
     '
     if ListInitState=4 then _      'If the initialization process completed
        PrtIntegState=2             'Initiate the opening of the printer
     '
     if ListInitState=5 then _      'If the initialization process has failed
        ListInitState=1             'the re-activate it & try again.
     '
     return                         'Return control to the Polling Loop
     '
     '--------------------------------------------------------------------------
     'SEE IF PRINTER IN OPEN
     '
PrtInteg2:
     '
     if PrintIOstate=3 then return  'Printer I/O FMM in normal active state
     if PrintIOstate=4 then return  'Printer I/O FMM in X-off state
     '
     PrtIntegState=3                'Advance to wait for printer on
     PrintIOstate=1                 'Activate the printer I/O FMM
     gosub ShowPreStartMsgs         'Show the `switch on the printer' message
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINTER TO OPEN
     '
PrtInteg3:
     '
     if PrintIOstate>2 then      _  'If the printer is on and ready or
        PrtIntegState=2          _  're-set the Printer Watchdog to monitoring
     '
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'FMM TO LOAD ALL REQUIRED RECORDS FOR A PRINT LINE
     '
     'NOTE: Target list parameters (ie the contents of Record#1 of the Target
     '      List File) are already in Local Common Variables.
     '
LoadRecs:
     '
     on LoadRecsState goto _   'State 0: inactive
        LoadRecs1,         _   'State 1: initialize
        LoadRecs2,         _   'State 2: get next list member's record number
        LoadRecs3,         _   'State 3: get the next list member's record
        LoadRecs4,         _   'State 4: get the next list member's sales area
        LoadRecs5,         _   'State 5: get the next list member's key values
        LoadRecs6,         _   'State 6: get the next list member's attributes
        LoadRecs7              'State 7: get the next list member's Notes
     '                         'State 8: successful termination state
     return                    'State 9: error termination state
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
LoadRecs1:
     '
     TargetIOstate=4               'Activate the Target Record retrieval
     LoadRecsState=2               'Advance to the next machine state
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD NUMBER
     '
LoadRecs2:
     '
     if TargetIOstate=5  then   _  'If the next target list record got OK then
        RecordIOstate=4         _  'Activate the main record `get' process
       :LoadRecsState=3            'Advance to the next machine state
     '
     if TargetIOstate=10 then _  'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S RECORD
     '
LoadRecs3:
     '
     if RecordIOstate=5  then _  'If the next main record got OK then
        NotesIOstate =4       _
       :NotesIOtask  =4       _
       :LoadRecsState=7          'Go to successful termination state
     '
     if RecordIOstate=10 then _  'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S SALES AREA
     '
LoadRecs4:
     '
     if GetAreasState=5  then _  'If the next target list record got OK then
        KeysIOstate  =4       _  'Activate the getting of the key values.
       :LoadRecsState=5
     '
     if GetAreasState=8  then _  'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S KEY VALUES
     '
LoadRecs5:
     '
     if KeysIOstate  =5  then _  'If the next keys record got OK then
        AttrIOstate  =4       _  'Activate the attribute getting process
       :LoadRecsState=6          'Advance to next state
     '
     if KeysIOstate=  10 then _  'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S ATTRIBUTES
     '
LoadRecs6:
     '
     if AttrIOstate  =5  then _  'If the next attribute record got OK then
        NotesIOstate =4       _
       :NotesIOtask  =4       _
       :LoadRecsState=7          'Go to successful termination state
     '
     if AttrIOstate  =10 then _  'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     'GET THE NEXT LIST MEMBER'S NOTES
     '
LoadRecs7:
     '
     if NotesIOstate =5  then _  'If the next attribute record got OK then
        LoadRecsState=8          'Go to successful termination state
     '
     if NotesIOstate =10 then _  'If error occurred while getting record, then
        LoadRecsState=9          'Go to error state
     '
     return                      'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------

