





     'SET UP LETTER HEADER ETC     by R J Morton      03JUL87      MailHedr.BAS

     'This subroutine is called by SendTelx when used for printing ordinary
     'letters. It sets up the addressee's name & address and other items of
     'data necessary to the letter, and formats the letter with the name and
     'address set in the standard window position and centrallizes the text of
     'the letter vertically on the A4 page.

LetterFixedData:                        'SET UP FIXED LETTER DATA


     'SET UP THE LETTER REFERENCE & DATE

     if LetterFormat = 6 then
        TopOfForm$ = NewLine$ + rec$(9) + NewLine$ + BlankLine$
     else
        TopOfForm$ = pp$(8) + pp$(9) + pp$(18)
     end if     '                         
     '   Reset letter printer              Set letter printer's default pitch
     '                            
     '            Clear & re-set the left hand margin

     if TopOfForm < 0 or TopOfForm > 9  _     'If retrieved TopOfForm lead-in
        or LetterFormat = 4 then              'or we are doing an envelope.
        TopOfForm = 0                         'out of range, set it to default
     end if                                   'value of 0 lead-in.
     if TopOfForm > 0 then                    'If Top-Of-Form lead-in is > 0
        for k = 1 to TopOfForm                'add appropriate n of blank
        TopOfForm$ = TopOfForm$ + BlankLine$  'lines of lead-in.
        next
     end if


     'FORM THE LETTER DATE INTO CORRESPONDENCE FORMAT

     gd$ = right$(sd$, len(sd$) - 4)          'Miss of the day of the week
     L = len(gd$)
     if L = 10 then gd$ = "0" + gd$           'Leading zero on the day of month
     if odate$ = "" then
        m = val( left$(date$, 2) )
     else
        m = asc( mid$(odate$, 5, 1) ) - 64
     end if
     x$ = "January February March April May June July August September October November December "
     x = 0
     for k = 1 to m
     y = x + 1
     x = instr(y, x$, " ")
     next
     x$ = mid$(x$, y, x - y)

     y=val(mid$(gd$,1,2)):       y$="th"     'Day of the month
     if y=1 or y=21 or y=31 then y$="st"
     if y=2 or y=22         then y$="nd"
     if y=3 or y=23         then y$="rd"

     y$ = ""
     LetterDate$=left$(gd$,2)  _        'The two-character day of the month
                +y$+" "        _        'the `th' etc plus a space
                +x$            _        'the full month-name
                +right$(gd$,5)          '4-character year N incl leading space
     
     if left$(LetterDate$,1) = "0" then 'Cut out leading zero Day-of-the-Month
        LetterDate$ = right$(LetterDate$, len(LetterDate$) - 1)
     end if


     'SET UP BLANK LINES TO CENTRALLIZE TEXT

     x = 26 - TopOfForm - TopOfForm
     Centrallizer$=""
     if NumLines<x then          'If letter contains less than 28 lines of text
        x=fix((x-NumLines)/2)    'then add the required number of blank lines
        for k=1 to x             'after the name & address to centrallize the
        Centrallizer$=Centrallizer$+BlankLine$
        next                     'actual text of the letter vertically on the
     end if                      'A4 page.
        

     'SET SIGNATURE GAP

     SignatureGap$=""          '
     for k=1 to SignatureGap   'Form the N of blank lines required for 
     SignatureGap$    _        'signature.
      =SignatureGap$  _        '
      +BlankLine$              '
     next                      '
     return
     '






     'SET UP LEAD-IN BLANK LINES & LETTER DATE

SetUpHeader:
     LoveFlag$ = "" : LoveFlag = 0
     x$ = rec$(11)                      'Recipient's Job Title
     if len(x$) > 1 then                'if it contains 2 or more characters
        if left$(x$,1) = "/" then
           rec$(11) = right$(x$, len(x$) - 2)   'Chop off the /L
           x$ = mid$(x$,2,1)            'isolate the salutation switch
        if x$ = "A" then LoveFlag$ = "All the best"
        if x$ = "B" then LoveFlag$ = "Best regards"
        if x$ = "C" then LoveFlag$ = "Be seeing you" : LoveFlag = 1
        if x$ = "F" then LoveFlag$ = "Yours faithfully"
        if x$ = "L" then LoveFlag$ = "Love from" : LoveFlag = 1
        if x$ = "N" then LoveFlag$ = "Bye for now" : LoveFlag = 1
        if x$ = "O" then LoveFlag$ = "See you soon" : LoveFlag = 1
        if x$ = "R" then LoveFlag$ = "Regards"
        if x$ = "S" then LoveFlag$ = "Yours sincerely"
        if x$ = "T" then LoveFlag$ = "Tatty bye" : LoveFlag = 1
        if x$ = "U" then LoveFlag$ = "Sincerely up yours"
        if x$ = "W" then LoveFlag$ = "Best wishes"
        if x$ = "Y" then LoveFlag$ = "Yours ever" : LoveFlag = 1
        end if
     end if
     gosub LetterRef           '
     gosub NameAddress         'With comments etc stripped off
     if LetterFormat = 2 or LetterFormat = 6 goto MemoStyle
     gosub DearWho             'Formal or familiar `Dear... '

     if LetterFormat = 3 then           'date + address
        x$ = LetterDate$
        y$ = LetterRef$
        z$ = chr$(12)
     elseif LetterFormat = 4 then       'envelope
        x$ = BlankLine$
        y$ = BlankLine$
        z$ = chr$(12)
     else
        x$ = LetterDate$
        y$ = LetterRef$
        z$ = Centrallizer$ + dear$
     end if

     Header$ = TopOfForm$
     OwnAddr = 0
     s$ = y$         : gosub OwnAddr
     s$ = "        " : gosub OwnAddr
     s$ = x$         : gosub OwnAddr
     s$ = "        " : gosub OwnAddr

     Header$ = Header$ _
             + NameAddress$ _           '7 lines
             + BlankLine$   _
             + z$                       '12 fixed lines in total
     return

OwnAddr:
     if OwnAddrFlag = 1 then
        s$ = s$ + space$(45 - len(s$)) + OwnAddr$(OwnAddr)
        OwnAddr = OwnAddr + 1
     end if
     Header$ = Header$ + s$ + NewLine$
     return



     'SET UP THE LETTER TAIL

SetUpTail:
     if LetterFormat > 1 then Tail$ = "" : return
     Tail$ = Prescribe$                 'Automatic signature print
     if JobTitle$ = "" then y$ = "" else y$ = JobTitle$ + NewLine$
     if LetterFormat = 0 then
        if LoveFlag = 1 then
           Tail$ = LoveFlag$ + NewLine$ + Tail$
        else
           Tail$ = Tail$                  _
                 + SignatureGap$          _   'Blank lines left for signature
                 + Signatory$ + NewLine$  _   'Name of Signatory
                 + y$                     _   'Signatory's job title
                 + BlankLine$
           if mid$(dear$,6,3) = "Sir" then    'Set up the familiar 
              x$ = "Yours faithfully"         'or formal salutation
           else
              x$ = "Yours sincerely"
           end if
           if LoveFlag$ > "" then x$ = LoveFlag$
           Tail$ = x$ + NewLine$ + Tail$
        end if
     else
        Tail$ = BlankLine$ + Tail$
     end if

     return
     '





     'SET UP THE LETTER REFERENCE

LetterRef:
     'If we want Ref printed on letter...
     if ShowRef$ = "Y" or ShowRef$ = "y" or TREF = 1 or _
        LetterFormat = 2 or LetterFormat = 6 then

        if MailShotFlag=0 then          'If it is a one-off letter, then Target
           x$=""                        'Profile N & Target Serial N not shown
        else
           x$=TargNum$+TargSer$         'else Target Profile N and
        end if                          'Target Serial N are shown.
        LetterRef$            _         '
          ="Ref"+RefNum$      _         'Prospect's Ref N
          +" "                _         '
          +SalesAreaID$       _         'Sales Area letter
          +x$                 _         'Target Profile N + Target Serial N
          +LetterNum$                   'Letter Serial Number
     
     else
        LetterRef$="        "           'Don't print the Ref
     end if
     if TREF = 1 then LetterRef$ = LetterRef$ + "[COPY]"
     return                             '






     'SET UP THE NAME & ADDRESS

NameAddress:
     NameAddress$ = "" : x = 0          'Clear stack & N of address lines
     x$ = rec$(10)                      'Get the contact name field
     y$ = "{" : gosub NameAddress2      'Replace qualification delimiters
     y$ = "}" : gosub NameAddress2      'with spaces.
     y = instr( x$, "(" )               'Find bracket at start of familiar name
     if y > 0 then x$ = left$(x$,y-1)   'Chop off `familiar' name if present
     OwnAddr = 3                        'Own Name & Address line index
     gosub NameAddress1                 'Set up the contact name
     PunterName$ = x$

     PunterFax$ = rec$(9)
     y = instr( PunterFax$, "*" )       'Find comment delimiter character [*]
     if y > 0 then PunterFax$ = left$(x$,y-1) 'Strip off comment if there is one
     
     x$ = rec$(11) : gosub NameAddress1     'Job title
     x$ = rec$( 1) : gosub NameAddress1     'Company name
     PunterCo$ = x$
     x$ = rec$( 3) : gosub NameAddress1     'House
     x$ = rec$( 4) : gosub NameAddress1     'Street
     x$ = rec$( 5) : gosub NameAddress0     'TOWN
     x$ = rec$( 6) : gosub NameAddress1     'County

     'CHECK THAT THE POSTCODE IS AN ACTUAL UK POSTCODE

     z$ = rec$( 7)                      'Post Code
     y$ = left$( z$, 2 )                'First letter of two-letter post area
     j = 0
     K = len(PostAreaList$) - 1
     WHILE j = 0 and k > 0
     if mid$( PostAreaList$, k, 2 ) = Y$ then j = 1 else k = k - 2
     WEND


     'DE-RATIONALISE THE POSTCODE

     if k>0 then
        if mid$(z$,3,1) = "0" then z$ = left$(z$,2) + right$(z$,5)
        if mid$(z$,2,1) = " " then z$ = left$(z$,1) + mid$(z$,3,6)
        x$ = z$
     else
        x$ = "        "
     end if

     j = len(x$)
     for k = 1 to j
     if mid$(x$,k,1) = "0" then         'Replace computer zero by letter O
        mid$(x$,k,1) = "O"              'because Royal Mail OCR can't read
     end if                             'computer zeros 0.
     next

     'Add phone number if reference (carbon) copy 
     if TREF = 1 then x$ = x$ + "  [Tel " + rec$(8) + "]"

     gosub NameAddress1                'Add postcode to name & address

     if x < 8 then                     'If there were less than 8 name & address
        for k = x + 1 to 8             'lines, then add the difference as extra
        NameAddress$ = NameAddress$ _
                     + BlankLine$      'blank lines to make up the standard 
        next                           '7-line depth of the name & address block
     end if
     return



     'STRIP COMMENTS OFF ADDRESS LINES AND ADD STRIPPED LINES TO OUTPUT STACK

NameAddress0:
     l = len(x$)                        'To put posttown in caps
     for k = 1 to l
     y = asc( mid$(x$, k, 1) )
     if y > 96 and y < 123 then
        mid$(x$, k, 1) = chr$(y - 32)
     end if
     next
NameAddress1:
     y = instr(x$, "*")                 'Find comment delimiter character [*]
     if y > 0 then
        x$ = left$(x$, y - 1)           'Strip off comment if there is one
     end if
     if x$ > " " then                   'If this address line is not null then
        x = x + 1                       'Advance to next address line
        if LetterFormat = 4 then
           x$ = space$(18) + x$         'Extra margin for envelope addr.
        end if
        if OwnAddrFlag = 1 then
           if OwnAddr < 6 then
              OwnAddr = OwnAddr + 1
              if OwnAddr$(OwnAddr) > "" then
                 x$ = x$ + space$(45 - len(x$)) + OwnAddr$(OwnAddr)
              end if
           end if
        end if
        NameAddress$ = NameAddress$ + x$ + NewLine$
     end if
     return                             'Return to above routine.

NameAddress2:                           'Replace { or } with a space.
     x=instr(x$,y$):if x>0 then mid$(x$,x,1)=" "
     return                             '





     'EXTRACT & PRINT CONTACT'S FORENAME NAME IF GIVEN
     '
DearWho:
     if LetterFormat > 1 then dear$ = "" : return
     if LetterFormat = 1 then dear$ = BlankLine$ + BlankLine$ : return
     z$=rec$(10):z=instr(z$,"*")        'Get `contact name'
     if z>0 then z$=left$(z$,z-1)       'Strip off beyond *
     if len(z$)<2 then                  'If no contact name specified, then
        if len(rec$(11))<2 then         'if no office/job title given, then
           dear$="Sirs"                 'address the company as Sirs
        else
           dear$="Sir/Madam"            'else address the officer as Sir etc
        end if
        goto DearWho7                   'No contact name
     end if
     x$="{":y$="}":gosub DearWho8       'Cut out qualification letters.
     x$="(":y$=")":gosub DearWho8       'Isolate the contact's familiar name.
     if x>0 goto DearWho7               'Familiar name given.
     '
     x=instr(z$," Esq")                 'Change Esq format to Mr format
     if x=0 then x=instr(z$," ESQ")
     if x>0 then
        z$="Mr "+left$(z$,x-1)+right$(z$,len(z$)-x-3)
     end if
     y=instr(z$," ")                    'Find first space in the contact field
     if y>0 then                        '(ie the space following Mr, Mrs etc.)
        x$=left$(z$,y-1)                'If found, extract contact's title
     else
        x$=""                           'else title is null
     end if
DearWho5:
     if right$(z$,1)=" " then           'Chop any trailing spaces which may
        z$=left$(z$,len(z$)-1)          'be on the end of the contact name
        goto DearWho5                   'string
     end if
DearWho6:
     y=instr(z$," ")                    'Locate [next] space along the string
     if y>0 then                        'If one is found,
        z$=right$(z$,len(z$)-y)         'chop off everything before it
        goto DearWho6                   'and the space itself.
     end if
     dear$=x$+" "+z$
     '
DearWho7: dear$="Dear "+dear$+NewLine$+BlankLine$:return
     '
DearWho8:                               'ISOLATE TEXT BETWEEN DELIMITERS
     x=instr(z$,x$)                     'Delimiters for first-name addressing
     y=instr(z$,y$)                     '
     if x>0 then
        if y<x then z$=z$+y$:y=len(z$)  'y cannot = x!
        dear$=mid$(z$,x+1,y-x-1)
        z$=left$(z$,x-1)+right$(z$,len(z$)-y)
     end if
     return                             '





     'MEMO STYLE LETTER [EG TO BE SENT MANUALLY AS A FAX MESSAGE]

MemoStyle:
     Header$ = TopOfForm$ _
             + LetterRef$ + NewLine$ _
             + LetterDate$ + NewLine$ _
             + BlankLine$ _
             + "  TO: " + PunterName$ + "/" + PunterCo$ _
             + "/" + PunterFax$ + NewLine$

     Header$ = Header$  _
             + "FROM: " + TelexSig$ + NewLine$ _
             + "SUBJ: " + MsgTitle$ + NewLine$ _
             + string$(65,196) + NewLine$ + BlankLine$

     return
