 


     '                                  1


     'NAME & ADDRESS EXPORT  by  R J Morton                         MEXPORT.BAS

     'This program exports a line-delimited text file containing names and
     'addresses of prospects from the main database. 

     defint a-z
     '$include: 'Comvars.INC'
     '$include: 'Comvart.INC'
     dim rec$(12)
     dim FS$(8)                         'File names
     dim FS%(4,8)                       'Numeric file-attributes

     TRUE = -1 : FALSE = 0
     LineEnd$ = chr$(13) + chr$(10)
     FileEnd$ = chr$(26)                'End-of-file market

Initialise:
     MustReEnterFileSpec  = FALSE
     EntryBoxVisible      = FALSE
     OpeningFiles         = FALSE
     Finished             = FALSE
     Terminated           = FALSE
     AllFilesOpen         = FALSE
     MustTryAgain         = FALSE
     DatabaseExport       = FALSE
     ExportingData        = FALSE
     ShowMessage          = FALSE

     OpenFileState = 0
     CWPstate      = 0
     TargItem      = 0


     B$ = ""             'Clear the Export File output stack

     goto SetUpFileIO


     'EXTERNAL ROUTINES

     '$include: 'Keyboard.FMM'
     '$include: 'EdField.FMM'
     '$include: 'OpenFile.FMM'
     '$include: 'TexCrypt.INC'

Show:call ScrSub( show$, row, column, colour ) : return
50   call ScrSub(   ps$, row, column, colour ) : return

     '


     '                                  2


     'FILE I/O SPECIFICATION FOR THIS LOAD MODULE

     'DiskFile is the array index number of a file's details
     'This could be different from the buffer number.

     'Record Length > 0 it means record length for the above file 
     '              = 0 open a file for input
     '              =-1 open a file for output
     '              =-2 open a file for appending

     '                     SELF      OTHERS
     '      LockFile    READ WRITE READ WRITE
     '          0         Y    Y     Y    Y        Y=PERMISSION GIVEN
     '          1         Y    Y     Y    N        N=PERMISSION DENIED
     '          2         Y    N     Y    Y
     '          3         Y    N     Y    N


SetUpFileIO:

     'FILE   PATH/NAMEBUFFER N   LOCK TYPE   RECORD LENGTH  OPEN/CLOSED
     FS$(1) = ""       :FS%(1,1) = 1:FS%(2,1) = 0:FS%(3,1) =  128:FS%(4,1) = 0
     FS$(2) = RecsFile$:FS%(1,2) = 2:FS%(2,2) = 0:FS%(3,2) =  256:FS%(4,2) = 0
     FS$(3) = KeysFile$:FS%(1,3) = 3:FS%(2,3) = 0:FS%(3,3) =    8:FS%(4,3) = 0
     FS$(4) = AttrFile$:FS%(1,4) = 4:FS%(2,4) = 0:FS%(3,4) =   16:FS%(4,4) = 0
     FS$(5) = CodeFile$:FS%(1,5) = 5:FS%(2,5) = 0:FS%(3,5) =   16:FS%(4,5) = 0
     FS$(6) = NoteFile$:FS%(1,6) = 6:FS%(2,6) = 0:FS%(3,6) =  924:FS%(4,6) = 0
     FS$(7) = ""       :FS%(1,7) = 7:FS%(2,7) = 0:FS%(3,7) =  924:FS%(4,7) = 0
     FS$(8) = TargFile$ + TargNum$
                       :FS%(1,8) = 8:FS%(2,8) = 0:FS%(3,8) =    8:FS%(4,8) = 0


     OpenFiles$ = chr$(1) _     'Set up requests for opening: the export file
                + chr$(2) _     '                            the records file
                + chr$(3) _     '                               the keys file
                + chr$(4) _     '                               the code file
                + chr$(5) _     '                           and the attr file
                + chr$(6) _     '                           and the note file
                + chr$(7) _     '                         exported notes file
                + chr$(8)       '                            target list file

     CloseFiles$ = OpenFiles$   'Set up the closing requests

     MaxDiskFiles = 8 : goto PollingLoop



     'FILE RECORD FIELD FORMAT SPECIFICATIONS

SetField: on DiskFile goto SF1, SF2, SF3, SF4, SF5, SF6, SF7, SF8

     SF1: field FS%(1,1), FS%(3,1) as Field11$ : return
     SF2: field FS%(1,2), FS%(3,2) as Field21$ : return
     SF3: field FS%(1,3), FS%(3,3) as Field31$ : return
     SF4: field FS%(1,4), FS%(3,4) as Field41$ : return
     SF5: field FS%(1,5), FS%(3,5) as Field51$ : return
     SF6: field FS%(1,6), FS%(3,6) as Field61$ : return
     SF7: field FS%(1,7), FS%(3,7) as Field71$ : return
     SF8: field FS%(1,8), 2        as Field81$ : return
     '


     '                                  3


     'FMM POLLING LOOP

PollingLoop:
     WHILE NOT FINISHED                 'Do until the finished flag gets set

     IF AllFilesOpen = TRUE THEN        'If all required files now open, then
        if ExportingData = TRUE then
           if TargItem < TargSize then  'If not yet reached end of list
              TargItem = TargItem + 1   'Move on to next list member
              gosub ShowListNumber
              gosub GetExportData       'Get next list member's data
              gosub PutExportData       'Output next block of data
              gosub ExportDossier       'Export next list member's dossier
           else
              ExportingData = FALSE     'Stop the exporting process
              Terminated = TRUE         'Set the `termination' flag
              gosub PutExportData       'Flush the export file output stack
           end if
        end if
     ELSE
        if FS$(1) = "" then             'then if Export File name not yet given
           gosub AcceptFileName         'Accept export file name from keyboard
        else
           gosub OpenFiles              'Open files as required
           gosub CheckFilesStatus       'Check closed/open/opening error
        end if                          'status of all files.
     END IF

     if Terminated = TRUE then          'If export process has been terminated
        gosub CloseFiles                'go and close all the files.
        if CloseFiles$ = "" then        'If no more close request messages
           Finished = TRUE              'set the Finished flag.
        end if
     end if

     if ShowMessage = TRUE then         'ERROR MESSAGES DISPLAY
        ps$ = left$( DosMsg$, 80 )
        ps$ = DosMsg$ + space$( 80 - len(DosMsg$) )
        row = 3 : column = 1 : colour = DosClr : gosub 50
        DosClr = 0 
        ShowMessage = FALSE
     end if

     gosub Keyboard                     'Poll the keyboard
     if KbChar = 27 then                'If Escape key hit
        Terminated = TRUE               'Terminate the loop
        AbortExport = TRUE              'Keystroke aborts export
     end if

     WEND



     if MustTryAgain = TRUE goto Initialise

     ps$ = space$(80) : column = 1 : colour = 7 : row = 4 : gosub 50

     RecNum = 0                         'To reset global record search
     chain"Lmenu"                       'Return to the Target Menu.
     '


     '                                  4


     'UNIVERSAL DISK FILE OPENER

OpenFiles:
     if OpenFiles$ = "" then return     'Exit if no files waiting to be opened



     if OpeningFiles = FALSE then       'If file opener is not initialised,

        DiskFile = asc( left$( OpenFiles$, 1 ) )

        if DiskFile > MaxDiskFiles then 'If DiskFile N is invalid, then
           gosub CloseFiles2            'Show error message
           goto OpenFiles1
        end if

        FileName$ = FS$(    DiskFile )  'Set up File Name
        FileNum   = FS%( 1, DiskFile )  '       File's buffer N
        LockFile  = FS%( 2, DiskFile )  '       Type of locking required
        RecLen    = FS%( 3, DiskFile )  '       Record Length
        OpenFileState = 1               'Activate the file opener FMM
        OpeningFiles = TRUE             'Advance to wait state
     end if



     gosub OpenFileFMM                  'Shot thru the File Opener FMM

     if OpenFileState < 5 then return   'Exit if File Opener FMM still busy

     if OpenFileState = 5 then          'If File Opener FMM terminated OK, then
        gosub SetField                  'Set up appropriate field format
        FS%(4,DiskFile) = 1             'Set file status to `open'
     else
        ShowMessage = TRUE 
        DosClr = 12                     'Prefix error msg with file I/D
        FS%(4,DiskFile) = -1            'Set file status to `opening error'
     end if                       

     OpenFileState = 0                  'Deactivate the file opener FMM
     OpeningFiles = FALSE               'Deactivate self



OpenFiles1:  'Remove the file open request from request stack

     OpenFiles$ = right$( OpenFiles$, len( OpenFiles$ ) - 1 )

     return

     '


     '                                  5


     'UNIVERSAL DISK FILE CLOSER

CloseFiles:
     if CloseFiles$ = "" then return    'Exit if no closing requests pending

     DiskFile = asc( left$( CloseFiles$, 1 ) ) 'Get DiskFile N of next file

     if DiskFile > MaxDiskFiles then    'If it is in valid range, then
        gosub CloseFiles2               'Error message
     else
        FileNum = FS%( 1, DiskFile )    'set up the files Buffer N
        gosub CloseFile                 'close the file
        FS%( 4, DiskFile ) = 0          'Set the file to `closed'
     end if



     'Remove the file open request from request stack.

     CloseFiles$ = right$( CloseFiles$, len( CloseFiles$ ) - 1 ) 
     return



CloseFiles2:  'Set up the DOS error message

     DosMsg$ = "DiskFile" _
             + str$( DiskFile ) _
             + "/MaxDiskFiles" _
             + str$( MaxDiskFiles )

     DosClr = 12                        'Display message in bright red
     ShowMessage = TRUE                 'Activate the message displayer
     return

     '


                                        6


     'CHECK THE CLOSED/OPEN/ERROR STATUS OF ALL FILES. SET THE ALL-FILES-OPEN 
     'FLAG WHEN ALL FILES HAVE BEEN OPENED SUCCESSFULLY. SET THE FILE-ERROR-
     'OCCURRED FLAG AND THE OPENER'S TERMINATION SWITCH IF AN ERROR OCCURRED 
     'WHEN TRYING TO OPEN ONE OF THE FILES.

CheckFilesStatus: 
     AllFilesOpen = TRUE                'Set to indicate All Files Open

     K = 0                              'File N

     WHILE K < MaxDiskFiles and _       'While all files not yet checked
           MustTryAgain = FALSE         'and a re-start has not been forced

     K = K + 1                          'Advance to test status of next file
     X = FS%(4,K)                       'Get the file's current status
     if x <> 1 then                     'If it is not yet open
        AllFilesOpen = FALSE            'All files are not yet open
        if x = -1 then                  'If an error occurred opening it
           Terminated = TRUE            'Terminate the file opening operation
           MustTryAgain = TRUE          'Say file opening error has occurred
        end if
     end if

     WEND


     IF AllFilesOpen = TRUE and _       'If all files now open OK, and
        Terminated = FALSE THEN         '
        BufLen = FS%(3,1)               'Buffer Length of FILENAME.MDB

        RExpHandle = FS%(1,1)           'File Buffer N of FILENAME.MDB 
        RecsHandle = FS%(1,2)           'Name & address File's handle
        KeysHandle = FS%(1,3)           'Keys File handle
        AttrHandle = FS%(1,4)           'Attributes File handle
        CodeHandle = FS%(1,5)           'Selector Codes File handle
        NoteHandle = FS%(1,6)           'Diary Notes File handle
        NExpHandle = FS%(1,7)           'Diary Notes Export-File handle
        TargHandle = FS%(1,8)           'Target List File handle 

        get TargHandle, 1               'Get the first target list record
        TargSize = CVI( Field81$ )      'N of members of this list
        gosub ShowExportMsg             'Display initial progress message
        ExportingData = TRUE            'Activate the data export routine

     END IF                             'De-activate this load module

     return
     '


     '                                  7


     'ACCEPT KEYBOARD INPUT OF EXPORT FILE NAME

AcceptFileName:
     IF EntryBoxVisible = FALSE THEN
        if MustReEnterFileSpec = FALSE then
           gosub DisplayEntryWindow
           FieldRow = 7
           FieldCol = 42
           FieldLen = 38
           FieldStr$ = ""               'Clear the field contents string
           MustReEnterFileSpec = TRUE
        end if
        caps=1                          'Set to convert lower case to caps
        CharCol=1                       'Set cursor to start of field
        EdFieldState=1                  'Activate the field editor FMM
        EntryBoxVisible = TRUE          'Set `initialized' flag
     ELSE
        gosub EdFieldFMM                'Pass thru the field editor FMM
        if EdFieldState < 3 then return 'Field editor not yet terminated.
        EdFieldState = 0 : caps = 0     'De-activate it.
        if FieldStr$ > "" and _
           AmendFlag > 0 then           'If the field were amended, then
           gosub CheckExportType
        else
           Finished = TRUE              'quit the program
           MustTryAgain = TRUE
        end if
        EntryBoxVisible = FALSE         'De-activate self
     END IF
     RETURN


     'Export files containing an exported Marketeer database have an .MDB
     'filename extension and are accompanied by another file of the same
     'name but with a .NOT extension containing the associated diary notes.

CheckExportType:
     v = instr( FieldStr$, "." )              'Find filename extension delimiter
     if v > 0 then                            'If a file extension present
        FieldStr$ = left$( FieldStr$, v - 1 ) 'chop it off.
     end if
     FS$(1) = FieldStr$ + ".MDB"
     FS$(7) = FieldStr$ + ".NOT"

     l = len( FieldStr$ ) : v = 0             'Isolate export file's path
     while l > 0
     if mid$( FieldStr$, l, 1 ) = "\" then    'If a `\' found,
        v = l : l = 0                         'mark its position and exit
     else                                     'else
        l = l - 1                             'back up to previous character
     end if
     wend

     ExpDir$ = left$( FieldStr$, v ) + "D"    'Export dossiers path spec.
     return
     '


                                        8


     'DISPLAY THE WINDOW WHERE THE EXPORT FILESPEC IS ENTERED

DisplayEntryWindow:
     column = 41  :colour = 1
     ps$ = "" : row =  5 : gosub 50
     colour = 19
     ps$ = " [path][filename]                       " : row =  7 : gosub 50
     ps$ = "  " : row =  8 : gosub 50
     ps$ = "                                        " : row =  6 : gosub 50
     for row = 9 to 22 : gosub 50 : next
     colour = 1
     ps$ = "" : row = 23 : gosub 50

     column = 42 : colour = 27
     ps$ = "Export Marketeer database files to:   " : row =  6 : gosub 50
     ps$ = "Enter the path and filename for the   " : row =  9 : gosub 50
     ps$ = "database export files. If you enter a " : row = 10 : gosub 50
     ps$ = "filename extension it will be ignored." : row = 11 : gosub 50
     ps$ = "                                      " : row = 12 : gosub 50
     ps$ = "The following files are produced on   " : row = 13 : gosub 50
     ps$ = "drive and in the directory specified  " : row = 14 : gosub 50
     ps$ = "by the filespec path you enter above: " : row = 15 : gosub 50
     ps$ = "                                      " : row = 16 : gosub 50
     ps$ = " FILENAME.MDB containing the names and" : row = 17 : gosub 50
     ps$ = "              addresses + key settings" : row = 18 : gosub 50
     ps$ = " FILENAME.NOT containing diary notes  " : row = 19 : gosub 50
     ps$ = " A set of dossier files Dnnnnn where  " : row = 20 : gosub 50
     ps$ = " nnnnn is the Export List N of the   " : row = 21 : gosub 50
     ps$ = " prospect to whom the dossier relates." : row = 22 : gosub 50

     column  =41  :colour  =2
     ps$ = "       Press Esc to cancel export       "  :row = 24  :gosub 50
     ps$ = "Esc" : column = 54 : colour = 10 : gosub 50
     return



ShowExportMsg:               'Display the initial exporting message
     x$ = str$(TargSize)
     ps$ = " Exporting List Member N      of" + space$( 6 - len(x$) ) + x$
     column = 41 : colour = 7 : row = 4 : goto 50



ShowListNumber:              'Display record currently being exported
     ps$ = str$(TargItem)
     ps$ = space$( 6 - len(ps$) ) + ps$
     row = 4 : column = 65 : colour = 7 : goto 50

     '


     '                                  9


     'GET THE NAME & ADDRESS, KEYS, ATTRIBUTES & SELECTOR CODE DATA FOR
     'EXPORT LIST MEMBER N TargItem


GetExportData:
     on error goto GetExpErr1
     get TargHandle, TargItem + 1       'Get the next target list record
     RecNum = CVI( Field81$ )           'Get RecNum of next List Member
     get RecsHandle, RecNum + 1         'Get the name & address record 
     y$ = Field21$                      'put it in y$ so that SetUpRecord can
     gosub SetUpRecord                  'decrypt it and put it in Rec$()
     get KeysHandle, RecNum             'Get the List Member's Keys Record
     get AttrHandle, RecNum             'Get his Attributes Record
     get CodeHandle, RecNum             'and his Selector Codes Record


     'FORMAT FOR LINE 12 OF THE EXPORT FILE FILENAME.MDB
     '
     '   KEYSĿ
     '                                                            dates
     '   SIC NĿ 
     '                           ATTRIBUTES        CODES       LAST   NEXT
     '   XREFĿ                                        EVENT  EVENT
     '                                                              
     '                                                              
     '                                                              
     Line12$ = "xxxxxxxx0000@A@@aaaaaaaaaaaaaaaacccccccccccccccc////@//////@//"

     mid$( Line12$,  1,  8 ) = rec$(12)      'XREF
     mid$( Line12$,  9,  8 ) = Field31$      'Keys
     mid$( Line12$, 17, 16 ) = Field41$      'Attribs
     mid$( Line12$, 33, 16 ) = Field51$      'Codes
     mid$( Line12$, 49, 14 ) = rec$( 0)      'Exported last & next event dates
     
     for k = 1 to 62                    'Make sure no control characters are
     if mid$(Line12$,k,1) < " " then _  'present so that Line 12 cannot
        mid$(Line12$,k,1) = "@"         'be split by a carriage-return etc.
     next                               '

     Rec$(12) = Line12$                 'Put line 12 in the reecord array


     for k = 1 to 12                    'Put the main record + the special
     B$ = B$ + rec$(k) + LineEnd$       'Line 12 details onto the
     next                               'output stack.

     get NoteHandle, RecNum             'Get this List Member's notes
     lset Field71$ = Field61$
     put NExpHandle, TargItem           'Export this List Member's notes

GetExportData2:
     on error goto 0                    'Clear the error trap
     return



GetExpErr1:
     DosMsg$ = er$( err )    'Get text of DOS error message
     resume GetExpErr2       'POP out of error status
GetExpErr2:
     DosClr = 12             'Set error message display colour to bright red
     ShowMessage = TRUE      'Trigger message display
     Terminated = TRUE       'Activate the termination procedure
     goto GetExportData2
     '


     '                                 10


     'SET UP NAME & ADDRESS RECORD IN ITS HOLDING ARRAY Rec$()

     'Encrypted record as received from disk is passed in y$


SetUpRecord:
     x = 1                              'Character pointer within input string
     y = 0                              'length of current field within record
     z = 0                              'Error field marker
     k = 0                              'Field N of the record array rec$(12)
     l = len(y$)

     WHILE k < 13 and y = 0 and x < l   'While field N<=12 & field length valid
     y = cvi( mid$(y$, x, 2) )          'Get 2-byte Length for [next] field

     if y < 0 or y > 29 _               'If length of text outside valid range
        or x + y => l then              'or specified length beyond reclen,
        y = 0                           'set y to indicate a field format error
        z = k                           'mark field in which error occurred
        if k < 11 then
           for j = k + 1 to 12          'Clear remainder of the array.
           rec$(k) = ""
           next
        end if

     else
        x = x + 2                       'move pointer to start of field's text
        Scrambled$ = mid$(y$, x, y)     'transfer text field to array
        gosub TextDecrypt
        rec$(k) = PlainText$            'transfer text field to array
        x = x + y                       'Move pointer to start of next field
        y = 0
     end if
     k = k + 1
     WEND

     PlainText$ = ""                    'free the string space
     Scrambled$= " "
     y$ = ""

     if z > 0 then rec$(z) = "CORRUPT!" 'If a field format error occurred

     RETURN

     '


     '                                 11


     'OUTPUT THE DATA TO THE .MDB FILE

PutExportData:
     on error goto PutExpErr1              'Set error trap

     WHILE len(B$) => BufLen               'While there is more than a buffer-
                                           'full of data on the output stack 
     lset Field11$ = left$( B$, BufLen )   'get one buffer-full from the stack
     put RExpHandle                        'and put it to disk
     B$ = right$( B$, len(B$) - BufLen )   'chop that buffer-full off the stack
                                           'see if there is another buffer-full
     WEND

     if Terminated = TRUE then             'If all List Members data dealt
        if B$ > "" then
           lset Field11$ = B$              'with, then flush the remaining
           put RExpHandle                  'output data into the disk file.
        end if
     end if


PutExportData2:
     on error goto 0                       'Clear error trap
     return


PutExpErr1:
     DosMsg$ = er$( err )    'Get text of DOS error message
     resume PutExpErr2       'POP out of error status
PutExpErr2:
     DosClr = 12             'Set error message display colour to bright red
     ShowMessage = TRUE      'Trigger message display
     Terminated = TRUE       'Activate the termination procedure
     goto PutExportData2

     '


     '                                 12


     'EXPORT THE DOSSIER FILE RELATING TO THE CURRENT RECORD

     'Marketeer's dossier file names are of the form Dnnnnn where nnnnn is the 
     'Ref N of the name & address record to which it pertains. Marketeer's 
     'database export facility in Main Menu option 2 F8 copies this dossier 
     'file into a new dossier file where nnnnn is the list member's number 
     'within the export list. On export the exported dossier file is copies 
     'into a dossier file within the new database where nnnnn is the persons 
     'Ref N within the new database.

ExportDossier:
     x = RecNum : gosub DossierName         'Form the dossier name based
     y$ = DossFile$ + x$                    'on the addressee's main Ref N
     on error goto ExpDossErr1              'Set the error trap
     open y$ as #9 len = 128                'Open the source dossier file
     field#9, 128 as DF1$                   'in current database.

     if LOF(9) = 0 then                     'If there is nothing in the 
        close#9                             'dossier file, then close it
        kill y$                             'and kill it.
     else
        x = TargItem                        'Form the export dossier file
        gosub DossierName                   'name based on the addressee's
                                            'Export List N.
        open ExpDir$ + x$ as #10 len = 128  'Add path spec to file name
        field#10, 128 as DF2$               'and open the export dossier
        WHILE not EOF(9)                    'Copy each 128-byte block of the
        get#9 : lset DF2$ = DF1$ : put#10   'source dossier file in turn into
        WEND                                'the destination (export) dossier
        close#9 : close#10                  'Close both dossier files
     end if

ExportDossier2: on error goto 0 : return    'Clear the error trap and exit


DossierName:
     x$ = str$( x )                         'Dossier's filename number
     x$ = right$( x$, len(x$) - 1 )         'chop off BASIC's leading space
     x$ = string$( 5 - len(x$), "0" ) _     'Add leading zeros.
        + x$
     return


ExpDossErr1:
     DosMsg$ = y$ + er$( err )              'Get text of DOS error message
     resume ExpDossErr2                     'POP out of error status
ExpDossErr2:
     on error goto ExpDossErr5              'Set special error trap, then
     close#9                                'try to close the source file
ExpDossErr3:
     on error goto ExpDossErr6              'Set special error trap, then
     close#10                               'try to close destination file
ExpDossErr4:
     DosClr = 12                            'Show error message in bright red
     ShowMessage = TRUE                     'Trigger message display
     goto ExportDossier2
ExpDossErr5: resume ExpDossErr3
ExpDossErr6: resume ExpDossErr4

