


     '                                  1


     'NAME & ADDRESS IMPORT  by  R J Morton                         MIMPORT.BAS

     'This program imports a line-delimited text file containing names and
     'addresses of prospects into the main database. 


     defint a-z
     '$include: 'Comvars.INC'
     dim rec$(12)
     dim FS$(9)                         'File names
     dim FS%(4,9)                       'Numeric file-attributes

     dim FL%(12)                        'Field lengths
     FL%( 0) = 29 : FL%( 1) = 29 : FL%( 2) =  8 : FL%( 3) = 29 : FL%( 4) = 29
     FL%( 5) = 29 : FL%( 6) = 17 : FL%( 7) =  8 : FL%( 8) = 29 : FL%( 9) = 29
     FL%(10) = 29 : FL%(11) = 29 : FL%(12) =  8

     TRUE = -1 : FALSE = 0
     LineEnd$ = chr$(13) + chr$(10)
     FileEnd$ = chr$(26)                'End-of-file market

Initialise:
     MustReEnterFileSpec  = FALSE
     ImportFileSpecified  = FALSE
     OpeningFiles         = FALSE
     Finished             = FALSE
     Terminated           = FALSE
     AllFilesOpen         = FALSE
     MustTryAgain         = FALSE
     DatabaseImport       = FALSE
     ImportingData        = FALSE
     ShowMessage          = FALSE

     OpenFileState = 0
     CWPstate      = 0

     goto SetUpFileIO


     'EXTERNAL ROUTINES

     '$include: 'Keyboard.FMM'
     '$include: 'EdField.FMM'
     '$include: 'OpenFile.FMM'
     '$include: 'TexCrypt.INC'

Show:call ScrSub( show$, row, column, colour ) : return
50   call ScrSub(   ps$, row, column, colour ) : return

     '


     '                                  2


     'FILE I/O SPECIFICATION FOR THIS LOAD MODULE

     'DiskFile is the array index number of a file's details
     'This could be different from the buffer number.

     'Record Length > 0 it means record length for the above file 
     '              = 0 open a file for input
     '              =-1 open a file for output
     '              =-2 open a file for appending

     '                     SELF      OTHERS
     '      LockFile    READ WRITE READ WRITE
     '          0         Y    Y     Y    Y        Y=PERMISSION GIVEN
     '          1         Y    Y     Y    N        N=PERMISSION DENIED
     '          2         Y    N     Y    Y
     '          3         Y    N     Y    N


SetUpFileIO:

     'FILE   PATH/NAMEBUFFER N   LOCK TYPE   RECORD LENGTH  OPEN/CLOSED
     FS$(1) = ImptFile$:FS%(1,1) = 1:FS%(2,1) = 3:FS%(3,1) = 4096:FS%(4,1) = 0
     FS$(2) = RecsFile$:FS%(1,2) = 2:FS%(2,2) = 0:FS%(3,2) =  256:FS%(4,2) = 0
     FS$(3) = NameFile$:FS%(1,3) = 3:FS%(2,3) = 1:FS%(3,3) =   16:FS%(4,3) = 0
     FS$(4) = PostFile$:FS%(1,4) = 4:FS%(2,4) = 1:FS%(3,4) =   16:FS%(4,4) = 0
     FS$(5) = KeysFile$:FS%(1,5) = 5:FS%(2,5) = 0:FS%(3,5) =    8:FS%(4,5) = 0
     FS$(6) = AttrFile$:FS%(1,6) = 6:FS%(2,6) = 0:FS%(3,6) =   16:FS%(4,6) = 0
     FS$(7) = CodeFile$:FS%(1,7) = 7:FS%(2,7) = 0:FS%(3,7) =   16:FS%(4,7) = 0
     FS$(8) = NoteFile$:FS%(1,8) = 8:FS%(2,8) = 0:FS%(3,8) =  924:FS%(4,8) = 0
     FS$(9) = ""       :FS%(1,9) = 9:FS%(2,9) = 0:FS%(3,9) =  924:FS%(4,9) = 0

     OpenFiles$ = chr$(1) _     'Set up requests for opening: the import file,
                + chr$(2) _     '                             the records file,
                + chr$(3) _     '                             the namecode file
                + chr$(4) _     '                             the postcode file
                + chr$(5) _     '                             the keys file
                + chr$(6) _     '                             the code file
                + chr$(7) _     '                             and the attr file
                + chr$(8)       '                             and the note file

     CloseFiles$ = OpenFiles$   'Set up the closing requests

     MaxDiskFiles = 8 : goto PollingLoop


     'FILE RECORD FIELD FORMAT SPECIFICATIONS

SetField: on DiskFile goto SF1, SF2, SF3, SF4, SF5, SF6, SF7, SF8, SF9

     SF1: field FS%(1,1), FS%(3,1) as Field11$                 : return
     SF2: field FS%(1,2), FS%(3,2) as Field21$                 : return
     SF3: field FS%(1,3), 8        as Field31$,  2 as Field32$ : return
     SF4: field FS%(1,4), 8        as Field41$,  2 as Field42$ : return
     SF5: field FS%(1,5), FS%(3,5) as Field51$                 : return
     SF6: field FS%(1,6), FS%(3,6) as Field61$                 : return
     SF7: field FS%(1,7), FS%(3,7) as Field71$                 : return
     SF8: field FS%(1,8), FS%(3,8) as Field81$                 : return
     SF9: field FS%(1,9), FS%(3,9) as Field91$                 : return
     '


     '                                  3


     'FMM POLLING LOOP

PollingLoop:
     WHILE NOT FINISHED                 'Do until the finished flag gets set

     IF AllFilesOpen = TRUE THEN        'If all required files now open, then
        gosub Import                    'Import the file
     ELSE
        if FS$(1) = "" then             'then if Import File name not yet given
           gosub AcceptFileName         'Accept import file name from keyboard
        else
           gosub OpenFiles              'Open files as required
           gosub CheckFilesStatus       'Check closed/open/opening error
        end if                          'status of all files.
     END IF

     if Terminated = TRUE then          'If import process has been terminated
        gosub CloseFiles                'go and close all the files.
        if CloseFiles$ = "" then        'If no more close request messages
           Finished = TRUE              'set the Finished flag.
        end if
     end if

     if ShowMessage = TRUE then         'ERROR MESSAGES DISPLAY
        gosub ShowDosMsg
        ShowMessage = FALSE
     end if

     gosub Keyboard                     'Poll the keyboard
     if KbChar = 27 then
        Terminated = TRUE
        AbortImport = TRUE              'Keystroke aborts import
     end if

     WEND

     if MustTryAgain = TRUE goto Initialise
     gosub ClearRecordCount
     RecNum = 0                         'To reset search routines
     if AbortImport = TRUE then         'If import session was aborted,
        chain"CONF"                     'return to the CONF.EXE overlay
     end if
     chain"INDRECON"                    'Proceed to the index build.
     '

 
     '                                  4


     'UNIVERSAL DISK FILE OPENER

OpenFiles:
     if OpenFiles$ = "" then return     'Exit if no files waiting to be opened



     if OpeningFiles = FALSE then       'If file opener is not initialised,

        DiskFile = asc( left$( OpenFiles$, 1 ) )

        if DiskFile > MaxDiskFiles then 'If DiskFile N is invalid, then
           gosub CloseFiles2            'Show error message
           goto OpenFiles1
        end if

        FileName$ = FS$(    DiskFile )  'Set up File Name
        FileNum   = FS%( 1, DiskFile )  '       File's buffer N
        LockFile  = FS%( 2, DiskFile )  '       Type of locking required
        RecLen    = FS%( 3, DiskFile )  '       Record Length
        OpenFileState = 1               'Activate the file opener FMM
        OpeningFiles = TRUE             'Advance to wait state
     end if



     gosub OpenFileFMM                  'Shot thru the File Opener FMM

     if OpenFileState < 5 then return   'Exit if File Opener FMM still busy

     if OpenFileState = 5 then          'If File Opener FMM terminated OK, then
        gosub SetField                  'Set up appropriate field format
        FS%(4,DiskFile) = 1             'Set file status to `open'
     else
        ShowMessage = TRUE
        DosClr = 12                     'Prefix error msg with file I/D
        FS%(4,DiskFile) = -1            'Set file status to `opening error'
     end if                       

     OpenFileState = 0                  'Deactivate the file opener FMM
     OpeningFiles = FALSE               'Deactivate self



OpenFiles1:  'Remove the file open request from request stack

     OpenFiles$ = right$( OpenFiles$, len( OpenFiles$ ) - 1 )

     return

     '


     '                                  5


     'UNIVERSAL DISK FILE CLOSER

CloseFiles:
     if CloseFiles$ = "" then return    'Exit if no closing requests pending

     DiskFile = asc( left$( CloseFiles$, 1 ) ) 'Get DiskFile N of next file

     if DiskFile > MaxDiskFiles then    'If it is in valid range, then
        gosub CloseFiles2               'Error message
     else
        FileNum = FS%( 1, DiskFile )    'set up the files Buffer N
        gosub CloseFile                 'close the file
        FS%( 4, DiskFile ) = 0          'Set the file to `closed'
     end if


     'Remove the file open request from request stack.

     CloseFiles$ = right$( CloseFiles$, len( CloseFiles$ ) - 1 ) 
     return


CloseFiles2:  'Set up the DOS error message

     DosMsg$ = "DiskFile" _
             + str$( DiskFile ) _
             + "/MaxDiskFiles" _
             + str$( MaxDiskFiles )

     DosClr = 12                        'Display message in bright red
     ShowMessage = TRUE                 'Activate the message displayer
     return
     '


     '                                   6


     'CHECK THE CLOSED/OPEN/ERROR STATUS OF ALL FILES. SET THE ALL-FILES-OPEN 
     'FLAG WHEN ALL FILES HAVE BEEN OPENED SUCCESSFULLY. SET THE FILE-ERROR-
     'OCCURRED FLAG AND THE OPENER'S TERMINATION SWITCH IF AN ERROR OCCURRED 
     'WHEN TRYING TO OPEN ONE OF THE FILES.


CheckFilesStatus: 
     AllFilesOpen = TRUE                'Set to indicate All Files Open

     K = 0                              'File N

     WHILE K < MaxDiskFiles and _       'While all files not yet checked
           MustTryAgain = FALSE         'and a re-start has not been forced

     K = K + 1                          'Advance to test status of next file
     X = FS%(4,K)                       'Get the file's current status
     if x <> 1 then                     'If it is not yet open
        AllFilesOpen = FALSE            'All files are not yet open
        if x = -1 then                  'If an error occurred opening it
           Terminated = TRUE            'Terminate the file opening operation
           MustTryAgain = TRUE          'Say file opening error has occurred
        end if
     end if

     WEND


     IF AllFilesOpen = TRUE and _       'If all files now open OK, and
        Terminated = FALSE THEN

        RImpHandle = FS%(1,1)           'Main Import File's Handle
        RecsHandle = FS%(1,2)           'Records File's Handle
        NameHandle = FS%(1,3)           'Namecodes File's Handle
        PostHandle = FS%(1,4)           'Postcode File's Handle
        KeysHandle = FS%(1,5)           'Keys File's Handle
        AttrHandle = FS%(1,6)           'Attributes File's Handle
        CodeHandle = FS%(1,7)           'Code File's Handle
        NoteHandle = FS%(1,8)           'Diary Notes File's Handle
        NImpHandle = FS%(1,9)           'Import Diary File's Handle

        get NameHandle, 1               'Get N of highest currently
        RecNum = cvi(Field32$)          'occupied name & address record.
        gosub ShowImportMessage
        ImportingData = TRUE            'Activate the data import routine
     END IF                             'De-activate this load module

     return
     '


     '                                  7


     'ACCEPT KEYBOARD INPUT OF IMPORT FILE NAME

AcceptFileName:
     IF ImportFileSpecified = FALSE THEN
        if MustReEnterFileSpec = FALSE then
           gosub DisplayEntryWindow
           FieldRow = 7
           FieldCol = 42
           FieldLen = 38
           FieldStr$ = ""               'Clear the field contents string
           MustReEnterFileSpec = TRUE
        end if
        caps=1                          'Set to convert lower case to caps
        CharCol=1                       'Set cursor to start of field
        EdFieldState=1                  'Activate the field editor FMM
        ImportFileSpecified = TRUE      'Set `initialized' flag
     ELSE
        gosub EdFieldFMM                'Pass thru the field editor FMM
        if EdFieldState < 3 then return 'Field editor not yet terminated.
        EdFieldState = 0 : caps = 0     'De-activate it.
        if FieldStr$ > "" and _
           AmendFlag > 0 then           'If the field were amended, then
           gosub CheckImportType
	else
           Finished = TRUE              'quit the program
           MustTryAgain = TRUE
        end if
        ImportFileSpecified = FALSE     'De-activate self
     END IF
     RETURN



     'Import files containing an exported Marketeer database have an .MDB
     'filename extension and are accompanied by another file of the same
     'name but with a .NOT extension containing the associated diary notes.
     '
CheckImportType:
     FS$(1) = FieldStr$                 'Filespec (Path+File Name) of Prospect
     v = instr( FieldStr$, "." )        'Find filename extension delimiter
     if v = 0 then return               'No extension

     if len( FieldStr$ ) < v + 3 then return       'Extension > 3 chars long

     if mid$( FieldStr$, v + 1, 3 ) = "MDB" then   'If a Marketeer DataBase,
        FS$(9) = left$( FieldStr$, v ) + "NOT"     'Name of import notes file
        OpenFiles$ = OpenFiles$ + chr$(9)          'Set to open IMPORT.NOT
        CloseFiles$ = OpenFiles$                   'and to close it afterwards
        MaxDiskFiles = 9                           'Now 9 files in all.
        l = len( FieldStr$ ) : v = 0               'Isolate import file's path
        while l > 0
        if mid$( FieldStr$, l, 1 ) = "\" then v = l : l = 0 else l = l - 1
        wend
        ImpDir$ = left$( FieldStr$, v )            'Path to import database
        DatabaseImport = TRUE
     end if
     return
     '


                                        8


DisplayEntryWindow:
     column = 41  :colour = 1
     ps$ = "" : row =  5 : gosub 50
     colour = 19
     ps$ = " [path][filename]                       " : row =  7 : gosub 50
     ps$ = "  " : row =  8 : gosub 50
     ps$ = "                                        " : row =  6 : gosub 50
     for row = 9 to 22 : gosub 50 : next
     colour = 1
     ps$ = "" : row = 23 : gosub 50

     column = 42 : colour = 27
     ps$ = "Import names & addresses from:" : row =  6 : gosub 50
     ps$ = "The source file must be a CR+LF delim-" : row =  9 : gosub 50
     ps$ = "ited text file formatted as follows:  " : row = 10 : gosub 50

     colour = 19
     ps$ = " COMPANY NAME           up to 29 chrs " : row = 11 : gosub 50
     ps$ = " NAMECODE               up to  8 chrs " : row = 12 : gosub 50
     ps$ = " PREMISES               up to 29 chrs " : row = 13 : gosub 50
     ps$ = " N & STREET            up to 29 chrs " : row = 14 : gosub 50
     ps$ = " TOWN                   up to 29 chrs " : row = 15 : gosub 50
     ps$ = " COUNTY                 up to 17 chrs " : row = 16 : gosub 50
     ps$ = " POSTCODE               up to  8 chrs " : row = 17 : gosub 50
     ps$ = " TELEPHONE N           up to 29 chrs " : row = 18 : gosub 50
     ps$ = " TELEX N + ANSWER-BACK up to 29 chrs " : row = 19 : gosub 50
     ps$ = " CONTACT                up to 29 chrs " : row = 20 : gosub 50
     ps$ = " JOB TITLE              up to 29 chrs " : row = 21 : gosub 50
     ps$ = " blank line separator                " : row = 22 : gosub 50

     column  =41  :colour  =2
     ps$ = "       Press Esc to cancel import       "  :row = 24  :gosub 50
     ps$ = "Esc" : column = 54 : colour = 10 : gosub 50

     return


ShowImportMessage:
     ps$ = " Importing Record                       "
     column = 41 : colour = 7 : row = 4 : goto 50


ShowRecordCount:
     ps$ = str$(RecCount)
     column = 60 : colour = 7 : row = 4 : goto 50 


ClearRecordCount:
     ps$ = space$(80)
     column =  1 : colour = 7 : row = 4 : goto 50


ShowDosMsg:
     ps$ = left$( DosMsg$, 80 )
     ps$ = DosMsg$ + space$( 80 - len(DosMsg$) )
     row = 3 : column = 1 : colour = DosClr : gosub 50
     DosClr = 0
     return
     '


     '                                  9


     'IMPORT THE TEXT

Import:
     if ImportingData = FALSE then return 'Import machine idle

     v = instr( B$, FileEnd$ )          'Search for an end-of-file character
     if v > 0 then                      'if found,
        B$ = left$( B$, v - 1 )         'chop B$ off just before it.
     end if
     LineEnd = instr( B$, LineEnd$ )    'Find position of next line end

     IF LineEnd = 0 THEN                'If no line end found, then
        on error goto ImportError       'Set local error trap
        if not EOF(RImpHandle) then     'if we have not yet reached end of file
           get RImpHandle               'get next 4096-byte block from disk and
           B$ = B$ + Field11$           'append it to the input stack, else
        else
           rset Field32$ = mki$(RecNum) : put NameHandle, 1  'Store the new
           rset Field42$ = mki$(RecNum) : put PostHandle, 1  'Highest Record N
           ImportingData = FALSE
           Terminated = TRUE            'Set the `termination' flag
        end if
        on error goto 0                 'Clear the error trap
     ELSE                               'Otherwise [if next line-end found OK]
        LineNum = LineNum + 1           'Increment the line count
        if LineNum = 12 then            'If incremented line is last line
           LineNum = 0                  'reset line count to 0
           RecCount = RecCount + 1      'increment the record count
           gosub ShowRecordCount        'display the new record count
        end if
        L$ = left$(B$, LineEnd - 1)               'Set new line as input stack
        B$ = right$(B$,len(B$) - LineEnd - 1)     'upto line end, and chop it 
                                                  'off the input stack.
        while right$( L$, 1 ) = " "
          L$ = left$( L$, len(L$) - 1 ) 'Ensure line ends with just one space!
        wend
        FieldNum = FieldNum + 1         'Advance to the first/next field
        rec$( FieldNum ) = L$           'Put the new line in the record array
        if FieldNum = 12 then 
           gosub StoreData              'Reorganise and store the data record
           gosub ImportDossier
           FieldNum = 0                 'reset field N
        end if
     END IF
     return


ImportError:
     DosMsg$ = er$( err )               'Get text of DOS error message
     resume ImportError1
ImportError1:
     on error goto 0                    'Clear the local error trap
     DosClr = 12                        'Display message in bright red
     ShowMessage = TRUE
     ImportingData = FALSE
     Terminated = TRUE
     return
     '


     '                                 10


     'REORGANISE THE IMPORTED DATA AND STORE IT IN MARKETEER'S DATABASE

StoreData:

     '   KEYSĿ
     '                                                            dates
     '   SIC NĿ 
     '                           ATTRIBUTES        CODES       LAST   NEXT
     '   XREFĿ                                        EVENT  EVENT
     '                                                              
     Line12$ = "        0000@A@@                                ////@//////@//"
     
     if DatabaseImport = TRUE then           'If importing a Marketeer database
        lset Line12$ = left$(rec$(12),62)    'Set up new input line in template
     end if
     
     rec$(0) = right$( Line12$, 14 )         'Imported last & next event dates
     rec$(12) = left$( Line12$,  8 )         'XREF
     gosub EncryptRecord

     on error goto StoreDataError            'Set the error trap

     lset Field21$ = y$ : y$ = ""            'Record
     lset Field51$ = mid$(Line12$, 9, 8)     'Keys
     lset Field61$ = mid$(Line12$,17,16)     'attrs
     lset Field71$ = mid$(Line12$,33,16)     'codes

     if DatabaseImport = TRUE then      'If importing a Marketeer database
        get NImpHandle
        lset Field81$ = Field91$
     else                               'If importing just names & addresses
        lset Field81$ = space$(924)
     end if
     
     RecNum = RecNum + 1                'Increment the Record N

     put RecsHandle, RecNum + 1         'Store the main name & address record
     put KeysHandle, RecNum             'store the keys record
     put AttrHandle, RecNum             'store the attributes record
     put CodeHandle, RecNum             'store the selector codes record
     put NoteHandle, RecNum             'store the diary notes record

StoreData2: on error goto 0 : return


StoreDataError:
     DosMsg$ = er$( err )               'Get text of DOS message
     resume StoreDataError2
StoreDataError2:
     DosClr = 12                        'Display error message in bright red
     ShowMessage = TRUE                 'Trigger display routine
     Terminated = TRUE                  'Activate the termination procedure
     goto StoreData2
     '


     '                                 11


     'ENCRYPT & PACK RECORD IN REC$() INTO Y$

EncryptRecord:
     y$=""

     FOR k = 0 TO 12                    '12 fields in record
     X$ = rec$(k)
     X = FL%(k)                         'Get length of this field 
     X$ = left$(X$, X)                  'Get the field

     if X = 8 then                      'Namecode
        X$ = X$ + space$( 8 - len(X$) ) 'Pad field to a full 8 spaces
        for J = 1 to 8
        X = asc( mid$( X$, J, 1 ) )
        if X > 96 and X < 123 then             'Make all letters
           mid$( X$, J, 1 ) = chr$( X - 32 )   'into capitals.
        end if
        next
     end if

     if k = 7 and _                     'If doing postcode field
        DatabaseImport = FALSE then
        gosub ValiPost                  'validate the postcode
        X$ = left$( x$, 8 ) 
     end if

     PlainText$ = x$
     gosub TextEncrypt                                  'Encrypt the record 
     y$ = y$ + mki$( len( Scrambled$ ) ) + Scrambled$   'details into y$

     NEXT

     PlainText$ = ""                    'Free the string space
     Scrambled$ = ""

     return
     '


     '                                 12


     'IMPORT THE DOSSIER FILE RELATING TO THE CURRENT RECORD

     'Marketeer's dossier file names are of the form Dnnnnn where nnnnn is the 
     'Ref N of the name & address record to which it pertains. Marketeer's 
     'database export facility in Main Menu option 2 F8 copies this dossier 
     'file into a new dossier file where nnnnn is the list member's number 
     'within the export list. On import the exported dossier file is copies 
     'into a dossier file within the new database where nnnnn is the persons 
     'Ref N within the new database.


ImportDossier:
     if DatabaseImport = FALSE then return
     x = RecCount : gosub DossierName : impdoss$ = ImpDir$ + "D" + x$
     DossErr$ = x$ + " "
     on error goto ImpDossErr1
     open impdoss$ as #10 len = 128 : field#10, 128 as DF1$

     if LOF(10) = 0 then                'If import dossier file did not
        close#10 : kill impdoss$        'exist, close it and kill it.
     else
        x = RecNum : gosub DossierName : dossier$ = DossFile$ + x$
        open dossier$ as #11 len = 128 : field#11, 128 as DF2$
        while not EOF(10) : get#10 : lset DF2$ = DF1$ : put#11 : wend
        close#10 : close#11
     end if

ImportDossier2:
     on error goto 0
     return



DossierName:
     x$ = str$( x )                     'Dossier's filename number
     x$ = right$( x$, len(x$) - 1 )     'chop off BASIC's leading space
     x$ = string$( 5 - len(x$), "0" ) _ 'Add leading zeros.
        + x$
     return




ImpDossErr1:
     DosMsg$ = DossErr$ + er$( err )    'Get text of DOS error message
     resume ImpDossErr2
ImpDossErr2:
     on error goto ImpDossErr5          'Set special error trap, then
     close#10                           'try to close the import file
ImpDossErr3:
     on error goto ImpDossErr6          'Set special error trap, then
     close#11                           'try to close the database file
ImpDossErr4:
     DosClr = 12                        'Display error message bright red
     ShowMessage = TRUE                 'Trigger display of error message
     goto ImportDossier2
ImpDossErr5: resume ImpDossErr3
ImpDossErr6: resume ImpDossErr4
     '


     '                                 13


     'RATIONALIZATION AND VALIDATION ROUTINE

ValiPost:
     if X$ = space$(8) then return      'Exit validation if address unpostcoded

     CharCol = 1 : h = 2 : gosub ValiPost2

     x = asc( mid$( X$, 2, 1 ) )        'Get the second character
     if x > 32 and x < 65 then          'If 2nd char is a number, then
        X$ = left$( X$, 1 ) _
           + " " _                      'insert a space immediately after first
           + mid$( X$, 2, 6 )           'char and tack on rest of postcode.
        end if

     CharCol = 2 : h = 2 : gosub ValiPost2
     CharCol = 3 : h = 1 : gosub ValiPost2

     if x <> 32 then                    'If char not a space, then
        if mid$( X$, 4, 1 ) = " " or _  'If 4th char is a space
           mid$( X$, 5, 1 ) > "@" then  'or 5th char is a letter, then
           X$ = left$( X$, 2 ) _
              + "0" _                   'inject a 0 after the first 2 letters.
              + mid$( X$, 3, 5 )
           end if
        end if

     CharCol = 4 : h = 3 : gosub ValiPost2

     if mid$( X$, 5, 1 ) > " " then     'If 5th char not a space, then
        X$ = left$( X$, 4 ) _
           + " " _                      'inject a space at the 5th chr posn.
           + mid$( X$, 5, 3 )
        end if

     CharCol = 6 : h = 1 : gosub ValiPost2
     CharCol = 7 : h = 2 : gosub ValiPost2
     CharCol = 8 : h = 2 : gosub ValiPost2

     return


     'VALIDATION SUBROUTINE

ValiPost2:
     x = asc( mid$( X$, CharCol, 1 ) )  'Get CHARCOLth chr of postcode
     if x = 32 then return
     if x > 47 and x < 58 and ( h = 1 or h = 3 ) then return
     if x > 64 and x < 91 and ( h = 2 or h = 3 ) then return
     X$ = space$( 8 )
     return
