





      '------------------------------------------------------------------------
      'MULTIBLOCK DRIVER FOR EDBLOCK        27NOV86        [File: MULTIBLK.BAS]
      '------------------------------------------------------------------------
      'ENTRY POINTS:
      '12405 GOTO ShowBlocks      'Display all blocks initially
      '12406 GOTO EdBlocks        'Edit the multiple blocks
      '
      'Inputs:
      Dim MULTIBLK$(100) ' Contains all the fields concerned
      '   NUMBLKS     - Number of single-column blocks
      '   NUMFLDS     - Number of fields per single-column block
      '   FIELDS$(10) - Contains the fields for the current block
      '   INTERBLK    - Hor distance between starts of adjacent blocks
      '   LenOcol     - Lengths of the left and right columns for the special
      '   LenEcol     - case of handling two columns of fields with the fields
      '                 in each column having different lengths.
      '
      'Locals:   WHICHBLK    - Single column block number
      '
      'Passes to EDBLOCK:  MULTIBLK - Set to 1 to indicate multiple blocks
      '
      '
      '
      '
      '------------------------------------------------------------------------
      'TRANSFER A SINGLE-COLUMN BLOCK OF FIELDS TO FIELDS$
      '
EdBlocks1:
      temp=(WhichBlk-1)*NumFlds     'First-1 MULTIBLK$() element of block
      for tempk=1 TO NumFlds
      Fields$(tempk)=MultiBlk$(tempk+temp)  'Copy field into FIELDS$ array
      next:return
      '
      '------------------------------------------------------------------------
      'TRANSFER A SINGLE-COLUMN BLOCK OF FIELDS FROM FIELDS$ TO MULTIBLK$()
      '
EdBlocks2:
      temp=(WhichBlk-1)*NumFlds     'First-1 MULTIBLK$() element of block
      for tempk=1 TO NumFlds
      MultiBlk$(tempk+temp)=Fields$(tempk)  'Copy field into multiblk$() element
      next:return
      '
      '------------------------------------------------------------------------
      'DISPLAY THE MULTIPLE COLUMNS OF FIELDS
      '
ShowBlocks:
      BlockRow=MultiRow           'Set top row for all blocks
      MultiBlk=1
      if LenField=0 then LenField=LenOcol
      for WhichBlk=1 to NumBlks   'For all the blocks
      gosub EdBlocks3             'Set horiz posn of current block
      gosub EdBlocks1             'Transfer [next] block to FIELDS$( )
      gosub EdBlock3              'Display the block
      gosub EdBlocks8             'Flip the LenField variable
      next:gosub EdBlock1:return  'Display operator instructions
      '
      '------------------------------------------------------------------------
      'SET THE START-OF-FIELD COLUMN FOR THE CURRENT BLOCK
      '
EdBlocks3:
      BlockCol=MultiCol+(WhichBlk-1)*InterBlk  'Set horiz posn of current block
      return
      '
      '------------------------------------------------------------------------
     '






      '------------------------------------------------------------------------
      'INITIALIZATION
      '
EdBlocks:
      if LenField=0 then LenField=LenOcol
      WhichBlk=1            'Set up the first block of fields
      MultiBlk=1            'Set to indicate multiblock mode to EDBLOCK
      AmendM=0              'Clear the MultiBlock amendment flag
      y=0
      gosub EdBlocks1       'Load the appropriate set of fields into FIELDS$( )
      gosub EdBlocks3       'Set start-of-field column for current block
      gosub EdBlock4        'Call EDBLOCK
      '
      '------------------------------------------------------------------------
      'MULTIBLOCK CONTROL LOOP
      '
EdBlocks4: if AmendF=1 then AmendM=1:gosub EdBlocks2  'Save block if amended
      '
      k=k-1                        'To counteract auto increment by EDFIELD
      if y=72 goto EdBlocks6       'Cursor up: goto previous block if possible
      if y=80 goto EdBlocks5       'Cursor down: goto next block if possible
      if x=13 then k=0:goto EdBlocks5  'C/R goto next block if possible
      if x=27 or y=61 then AmendM=0        'Cancel the store to disk
      '
      EdBlocksTemp1=i              'Variables which have to be preserved if
      EdBlocksTemp2=k              'you want to re-enter MultiBlk at the
      EdBlocksTemp3=LenField       'same cursor position.
      if LenOcol>0 then LenField=0
      EdBlocksTemp4=WhichBlk
      EdBlocksTemp5=BlockRow
      EdBlocksTemp6=BlockCol
      '
      return                       'Esc, End ,Esc F-Keys etc
      '
      '------------------------------------------------------------------------
      'CURSOR UP/DOWN
      '
EdBlocks5:
      if WhichBlk<NumBlks then WhichBlk=WhichBlk+1 else WhichBlk=1
      goto EdBlocks7
      '
EdBlocks6:
      if WhichBlk>1 then WhichBlk=WhichBlk-1 else WhichBlk=NumBlks
EdBlocks7:
      gosub EdBlocks8       'Flip field-length if using unequal block-pairs
      gosub EdBlocks1       'Load the appropriate set of fields into FIELDS$( )
      gosub EdBlocks3       'Set start-of-field column for current block
EdBlocks9:
      gosub EdBlock6        'Call EDBLOCK with initial I & K values
      goto  EdBlocks4
      '
      '------------------------------------------------------------------------
      'HANDLING OF ODD-EVEN COLUMNS OF ALTERNATIVE FIELD-LENGTHS
      '
EdBlocks8:
      if LenOCol=0 then return
      '
      if LenField=LenOCol     _    'Indicates WhichBlk is odd
         then LenField=LenEcol_    'Field length for even columns
         else LenField=LenOcol     'Field length for odd columns
      '
      return
      '
      '------------------------------------------------------------------------
      'RE-ENTER AT THE ORIGINAL CURSOR POSITION
      '
ReEdBlocks:
      i=EdBlocksTemp1              'Variables which have to be preserved if
      k=EdBlocksTemp2              'you want to re-enter MultiBlk at the
      LenField=EdBlocksTemp3       'same cursor position.
      WhichBlk=EdBlocksTemp4
      BlockRow=EdBlocksTemp5
      BlockCol=EdBlocksTemp6
      '
      goto EdBlocks9
      '
      '------------------------------------------------------------------------
     '
