






     '-------------------------------------------------------------------------
     'FILE OPENING ERROR HANDLER           16JAN87          [File: OErrHdlr.bas]
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton
     '
     'This routine attempts to open a disk file as file number FileNum and
     'then return with the named file open and locked. If an error occurs
     'during the attempt to open the file, the routine first checks the
     'MS-DOS error code to see if the error is one likely to have resulted from
     'a file being already in use by another PC on the network. If it is, then
     'the routine waits 3 to 4 seconds and then tries again to open the file.
     'It retries upto 9 times before giving up and regarding the error as a
     'fatal error. If the error were a fatal error in the first place, it
     'displays the MS-DOS error message in bright red at the screen position
     'specified in ErrMsgRow and ErrMsgCol and then returns to a label in the
     'calling program called FatalError. When a possible temporary access error
     'occurs, it displays the error message in bright amber while retrying.
     'It caters for having upro 9 files open concurrently.
     '
     'Inputs:  FileNum   - number under which the file is to be opened
     '         ErrMsgRow - screen co-ordinates for error message display
     '         ErrMsgCol -
     '
     'Locals:  ErrNum - preserving variable for the MS-DOS error number
     '         Delay  - number of seconds delay between re-tries
     '         Timeout - number of seconds left to run before a re-try
     '         Tries   - number of re-tries so far made
     '         Tyme$   - reference string to capture & hold system time
     '
     'Return Labels: FatalError - return point in calling routine after
     '                            a fatal error or failure after 9 re-tries
     '
     'Goto Labels: File1 ... File9 - labels for OPEN & FIELD lines in
     '                               calling routine. These lines are
     '                               at the same `program level' as
     '                               this subroutine and are, in effect,
     '                               part of it.
     '
     '-------------------------------------------------------------------------
     'ERROR MESSAGE DISPLAY SUBROUTINE
     '
OpenFileH:
     if ErrNum=0 then ps$=space$(30) _
                 else ps$=left$(er$(ErrNum),30)+str$(FileNum)
     row=ErrMsgRow
     column=ErrMsgCol
     gosub 50:return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
OpenFile:
     Tries=9                    'Set number of permitted re-tries
     Delay=4                    'Set delay [in seconds] between re-tries
     '
OpenFileA:                      'Entry point for re-tries
     ErrNum=0                   'Clear local error number variable
     gosub OpenFileH            'Clear error message
     on error goto OpenFileB    'Set error trap label
     '
     '-------------------------------------------------------------------------
     'OPEN THE REQUIRED FILE
     '
     'The OPEN and FIELD statement for each file is kept in a `table' of
     'OPEN + FIELD statements in the main program, each ending with a 
     '`goto FileOpen' command.
     '
     on FileNum goto File1,File2,File3,File4,File5,File6,File7,File8,File9
FileOpen:
     on error goto 0:return
     '
     '-------------------------------------------------------------------------
     'ERROR ROUTINE
     '
OpenFileB:
     ErrNum=err             'Preserve the MS-DOS error number
     resume OpenFileC       'Kill the error situation
     '
OpenFileC:                          'POSSIBLE TEMP NETWORK-ACCESS DENIALS
     if ErrNum=53 goto OpenFileE    'File not found
     if ErrNum=75 goto OpenFileE    'Path not found
     if ErrNum=76 goto OpenFileE    'Path/File access error
     '
OpenFileD:
     close:on error goto 0
     colour=12:gosub OpenFileH      'Display error message bright red
     return FatalError              'Fatal error return point in calling
     '                               routine
     '-------------------------------------------------------------------------
     'RE-TRY AND TIMEOUT DELAY ROUTINE
     '
OpenFileE:
     if Tries<1 goto OpenFileD       'No success after 9 retries; fatal error
     Tries=Tries-1
     colour=14:gosub OpenFileH       'Display temporary error message amber
     Timeout=Delay                   'Set to re-try in 4 to 5 seconds time
     '
     while Timeout>0
     Tyme$=Time$                     'Set Retry time to current system time
     while tyme$=Time$:wend          'One-second delay
     Timeout=Timeout-1               'Decrement the `seconds to go'
     wend:goto OpenFileA
     '
     '-------------------------------------------------------------------------
     '
