





     '--------------------------------------------------------------------------
     'EXTRACT & VALIDATE PROSPECT'S TELEPHONE NUMBER [N$=valid phone number]
     '
     'This routine scans the telephone number line in the name & address record
     'and extracts from it two versions of the prospect's phone number: 1) An
     'all-numeric (numerics only) version for the autodialler, and 2) A display
     'version containing hyphens, spaces and brackets present in the original.
     '
     'Input:    Phone number from Rec$(8) of the prospect name & address array
     '
     'Outputs:  PhoneNum$ - numerics-only phone number
     '                 n$ - display version of the phone number
     '
     '--------------------------------------------------------------------------
     '
ExtrPhoneNum:
     y$=rec$(8)                      'Phone N element in prospect record array
     y=instr(y$,"*")
     if y>0 then y$=left$(y$,y-1)       'Chop at asterisk if present
     n$=""                              'Validated phone number string
     PhoneNum$=""                       'De-hyphenated number for autodialler
     l=len(y$):k=0
     while k<l:k=k+1:x$=mid$(y$,k,1)    'Get [next] chr from phone N string
     if x$="/" or x$="*" then           '* is comment delimiter, so terminator
        k=l                             '/is a phone number terminator
 elseif x$>"/" and x$<":" then          'Numeric only
        PhoneNum$=PhoneNum$+x$          'Add char into numerics-only version
        n$=n$+x$                        'Add character into the display version
 elseif x$="-" or x$=" " or _           'Hyphen or Space
        x$="(" or x$=")" then           '() round the STD code
        n$=n$+x$                        'Add character into the display version
        end if
     wend
     if len(PhoneNum$)<2 then
        CallResult=9:errer$="Absent or invalid phone number"
   else CallResult=0:errer$=""
        end if
     return
     '
     '--------------------------------------------------------------------------
     '
