






     '-------------------------------------------------------------------------
     'PRINTER CONTROL PANEL              09DEC86             [File: PPANEL.BAS]
     '-------------------------------------------------------------------------
     'Used by: SELCT, WRITE, XMIT, PRINT, EMAIL,
     '         LIST, LABEL, XMREP, PRREP, EMREP, PHREP
     '
     'Inputs  PRTCOL - Column marking left edge of printer panel display
     '        PRTROW - First row of the printer panel display
     '        PRTLAMP- Status lamp to be lit [1-4; 0 means all lamps out]
     '
     'Entry Points: ShowPPanel for initial display of the printer control panel
     '              ShowPLamps to update the printer status lamps
     '
     'Printer display panel is 5 rows by 38 columns
     '
     '
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE PRINTER STATUS PANEL
     '
ShowPPanel:
     column=PrtCol:colour=grey
     row=PrtRow  :ps$="PRINTER CONTROLĿ STATUS":gosub 50
     row=PrtRow+1:ps$="                              Print":gosub 50
     row=PrtRow+2:ps$="                              Halt ":gosub 50
     row=PrtRow+3:ps$="                              Xoff ":gosub 50
     row=PrtRow+4:ps$=" Error":gosub 50
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE PRINTER STATUS LAMPS
     '
ShowPLamps:
     column=PrtCol+32:colour=grey:ps$=""
     for k=1 to 4:row=k+PrtRow:gosub 50:next      'Kill all lamps
     if PrtLamp<1 or PrtLamp>4 then return        'Exit if lamp out of range
     if PrtLamp=1 then colour=10
     if PrtLamp=2 then colour=14                  'Set colour of
     if PrtLamp=3 then colour=14                  'appropriate lamp.
     if PrtLamp=4 then colour=12
     row=PrtRow+PrtLamp:gosub 50                  'Light appropriate lamp
     return                                       'Exit
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'DISPLAY PRINTER CONTROL MESSAGES   09DEC86      [File: PPANEL.BAS cont'd]
     '-------------------------------------------------------------------------
     '
     'Inputs PAPER - Type of paper to be loaded
     '       HALT  - Flag indicating temporary halt [1=halt; 0=resume]
     '
     'Entry Points:  ShowPreStartMsgs to display the pre-start messages
     '               ShowPostStartMsgs to display halt/error situations
     '
     '
     '
     '
     '
     '
     '
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE PRE-START MESSAGES
     '
ShowPreStartMsgs:
     column=PrtCol+1:colour=2
     row=PrtRow+1:ps$="Switch on the printer        ":gosub 50
     '
     if paper=1 then ps$="Load 15 by 11 listing paper  ":goto ShowPreStartMsgs1
     if paper=2 then ps$="Load label stationery        ":goto ShowPreStartMsgs1
     if paper=3 then ps$="Load headed notepaper        ":goto ShowPreStartMsgs1
     if paper=4 then ps$="Load plain A4 typing paper   ":goto ShowPreStartMsgs1
                     ps$="                             "
     '
ShowPreStartMsgs1:
     row=PrtRow+2                                    :gosub 50
     row=PrtRow+3:ps$="Press    to print/    to quit":gosub 50
     colour=10
     column=PrtCol+ 7:ps$=chr$(17)+"":gosub 50
     column=PrtCol+19:ps$="Esc"       :gosub 50

     return
     '
     '
     '
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE POST-START MESSAGES
     '
ShowPostStartMsgs:
     column=PrtCol+1:colour=2
     ps$=space$(29):row=PrtRow+1:gosub 50
     '
     if halt=0 _
        then ps$="Press    to halt printer     " _
        else ps$="Press    to resume printing  "
     '
     row=PrtRow+2                                    :gosub 50
     row=PrtRow+3:ps$="Press     to abort print run ":gosub 50
     '
     column=PrtCol+7:colour=10
     row=PrtRow+2:ps$=chr$(17)+""                   :gosub 50
     row=PrtRow+3:ps$=      "Esc"                    :gosub 50
     '
     if halt=0                           _
        then ps$=space$(36)              _    'Wipe possible error message
        else ps$=left$(er$(prterr),36)   _    'Display error message
            :ps$=ps$+space$(36-len(ps$))
     '
     row=3:column=45:colour=12:gosub 50:return  'Show error message
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOAD PRINTER CONTROL INFORMATION                [File: PPANEL.BAS cont'd]
     '-------------------------------------------------------------------------
     'Loads the following array from disk file PRTCODES$ & decode for printer
     '
     'IMPORTANT! This routine translates the 3-digit ASCII codes loaded from
     '           the PrtCodes data file into the equivalent control characters
     '           before putting them into PP$(). The GetPrtCodes routine used
     '           to get the codes for editing loads the actual 3-digit groups
     '           into PP$(). This routine is the one to use when getting the
     '           codes for use by a print routine!
     '
     'PP$(0) - Draft printer's Output Port 'File' Specification
     'PP$(1) - Correspondence printer's Output Port 'File' Specification
     'PP$(2) - Draft Printer enable
     'PP$(3) - Draft Printer disable
     'PP$(4) - Set draft printer to 10 chrs/inch
     'PP$(5) - Set draft printer to 16.5 chrs/inch
     'PP$(6) - Set draft printer to 5 chrs/inch
     'PP$(7) - Set draft printer to 8.25 chrs/inch
     'PP$(8) - Set correspondence printer to 10 chrs/inch
     'PP$(9) - Set correspondence printer's left margin
     '
     '-------------------------------------------------------------------------
     'LOAD THE PRINTER CONTROL STRINGS
     '
GetPrtCodes:
     open PrtCFile$ as #1 len=500
     get#1,1                           'One-record random file for fast load
     '
     for i=0 to 1                      'The two printer filespecs
     x=cvi(input$(2,1))                'Length of contents of [next] field
     '
     if x>0 and x<47            _
        then pp$(i)=input$(x,1) _      'Field is within correct length range
        else pp$(i)=""                 'Field length out of range
     '
     next
     '
     for i=2 to 9                      'The 8 control code fields
     x=cvi(input$(2,1))                'Length of contents of [next] field
     '
     if x>0 and x<46 then             _    'If field length is within range
        y$=""                        :_    'Clear the control character string
        x$=input$(x,1)               :_    'Get contents of [next] field
        x=x-2                        :_    'First chr of last 3-digit group
        for k=1 to x step 3          :_    'For each 3-digit ASCII code
        y$=y$+chr$(val(mid$(x$,k,3))):_    'Convert to character & add to Y$
        next                         :_    'Next 3-digit group
        pp$(i)=y$                          'Store completed control string
     '
     next:close:return                 'Next field
     '
     '-------------------------------------------------------------------------
     '
