





     'PRINT TARGET PROFILE DEFINITION        05JAN87        File: PRINTARG.BAS]
     '-------------------------------------------------------------------------
     '
     'This routine provides a printed version of the current Target Profile
     'specification (TargNum). It places the report in the universal print
     'stack PrStr$ and then calls the general print handler `PrintIO'.
     '
     'Author : R J Morton
     '
     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
     DefInt a-z                    'A=single precision for elapsed time Routine
     rem $include: 'ComVars.INC'   'Merge in the common variables
     rem $include: 'ComVarT.INC'   'Local group commons
     dim pp$(15)                   'Holds printer port specs & control codes
     dim y$(5)
     '
     PrtBufNum=4               'File N under which Printer I/O File is opened
     ErrMsgRow= 3              'Row on which DOS error messages are displayed
     ErrMsgCol=45              'Start column for DOS error message displays
     paper = 1                 'To be printed on 15 by 11 inch listing paper
     PrtRow=20                 'First row of printer display panel
     PrtCol= 3                 'Left-most column of printer display panel
     gosub ReSetNums
     NewLine$=chr$(13)+chr$(10)
     BlankLine$=space$(5)+NewLine$
     locate 21,32              'Cursor in printer control box
     '
     gosub ExpiryTest
     '
     ps$=space$(40):row=19:column=1:gosub 50  'Clear row above printer box
     gosub ShowPpanel                         'Display printer control panel
     gosub ShowStatus
     ListInitState=1           'Activate the Initialization FMM
     PrtIntegState=1           'Activate the Printer Integrity Watch Dog FMM
     prog$="PRINTARG"
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'FMM CONTROL LOOP
     '
     active = 1                         'Activate the FMM polling loop
     '
     WHILE active
     gosub ListInit      'Load printer codes & error messages & initialize loop
     gosub KeyBoard      'Keyboard input/output FMM
     gosub PrintIO       'Printer input/output FMM
     gosub LoopCtrl      'Record print loop control
     gosub OpenFileFMM   'General file opener FMM
     gosub KeybCtrl      'Loop escape watch dog for exiting this load module
     gosub PrtInteg      'Printer opener & interity watch dog
     gosub ShowMsgs      'Display any DOS messages picked up by above routines
     WEND
     '
     FileNum = 0 : gosub CloseFile      'close printer & all files
     ps$ = "" : gosub ShowMsgs1         'clear error message field
     prog$ = "LIST1"                    'Set program identification variable
     chain "Lmenu"                      'exit this load module back to Lmenu
     '
     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
 50  Call ScrSub(ps$,row,column,colour):return
     '
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'PPanel.FMM'
     rem $include: 'ListInit.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SHOW MESSAGES
     '
ShowMsgs:
     '
     if ShowMessages=0 then return   'No messages waiting to be displayed
     '
     if DosClr>0 then           _    'If there is a DOS message to be displayed
        colour=DosClr           _    'set the appropriate message colour
       :DosClr=0                _    'Message colour acts as message trigger
       :ps$=DosMsg$             _    'set up the message in the display string
       :gosub ShowMsgs1              'display message
     '
     if PrtClr>0 then           _    'If there's a Printer Status message to be
        colour=PrtClr           _    'displayed, set appropriate message colour
       :PrtClr=0                _    'Message colour acts as message trigger
       :row=23:column=46        _
       :ps$=Pstatus$            _    'set up the message in the display string
       +space$(30-len(pstatus$))_    'Pad out to 30 character message field
       :gosub 50                _    'display message
       :gosub ShowPlamps             'display pritner status lamps
     '
     ShowMessages=0                  'Cancel the `message display request'
     return                          'Return control to the Polling Loop
     '
ShowMsgs1:
     '
     row=ErrMsgRow:column=ErrMsgCol  'Set message co-ordinates
     ps$=ps$+space$(36-len(ps$))     'Pad out to 36 character message field
     gosub 50                        'Call the fast screen display routine
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'KEYBOARD CONTROL
     '
KeybCtrl: gosub NextChar
     '                                
     if KbChar = 27 or CtrlChar = 61 then active = 0 : return
     if KbChar <> 13 and CtrlChar <> 60 then return
     if LoopCtrlState=0 goto KeybCtrl1
     '
     if HaltPrinterFlag=0 then      'If not currently in a halt state
        HaltPrinterFlag=1           'then set printer to halt state
   else HaltPrinterFlag=0           'else clear the halt state
        ps$="" : gosub ShowMsgs1    'clear possible error message.
        end if
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
KeyBCtrl1:                          'Try to activate the Print Loop FMM
     '
     if PrtIntegState=2 and      _  'If printer Integrity Watch Dog active
        ListInitState=4 then     _  'and the Lister Module initialized
        gosub SetUpReport        _
       :LoopCtrlState=1             'then activate the print loop FMM.
     '
     HaltPrinterFlag=0
     gosub ShowPostStartMsgs        'Display appropriate messages.
     return                         'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOOP CONTROL FMM
     '
LoopCtrl: if LoopCtrlState=0 then return
     '
     if PrStr$="" then           _   'When printer ouput stack is finally
        Pstatus$="FINISHED"      _   '
       :PrtClr=10:ShowMessages=1 _   '
       :LoopCtrlState=0          _   'Record print loop control
       :OpenFileState=0              'General file opener FMM
     '
     return                          'Return control to the Polling Loop
     '
     '-------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'FORM 4-DIGIT NUMBER AS A STRING WITH LEADING ZEROS
     '
FourDigit:
     '
     if Number<0 or Number>9999 then Number$="----":return
     Number$=str$(Number)
     Number$=right$(Number$,len(Number$)-1)
     LenNum=len(Number$)
     if LenNum<4 then Number$=string$(4-LenNum,"0")+Number$
     return
     '
     '--------------------------------------------------------------------------
     'DISPLAY FMM STATES TABLE
     ' 
ShowStatus: row=19:column=41:colour=grey
     ps$="    Ŀ    ":Row=20:gosub 50
     ps$="    PRINTER STATUS                    ":Row=21:gosub 50
     ps$="    Ĵ    ":Row=22:gosub 50
     ps$="                                      ":Row=23:gosub 50
     ps$="        ":Row=24:gosub 50
     '
     return
     '
     '--------------------------------------------------------------------------
     '






     '--------------------------------------------------------------------------
     'PRINTER INITIALIZATION & INTEGRITY MONITOR
     '
PrtInteg:
     '
     on PrtIntegState goto PrtInteg1, PrtInteg2, PrtInteg3 
     '                                              
     '   State 1: wait for     State 2: wait      State 3: wait for
     '   initialisation to          for printer             printer to open.
     '   complete.                  initialisation.
     '
     return                             'State 0 - inactive
     '
     '-------------------------------------------------------------------------
     'WAIT FOR THE INITIALIZATION PROCESS TO COMPLETE
     '
PrtInteg1:
     '
     if ListInitState=4 then _      'If the initialization process completed
        PrtIntegState=2             'Initiate the opening of the printer
     '
     if ListInitState=5 then _      'If the initialization process has failed
        ListInitState=1             'the re-activate it & try again.
     '
     return                         'Return control to the Polling Loop
     '
     '--------------------------------------------------------------------------
     'SEE IF PRINTER IN OPEN
     '
PrtInteg2:
     '
     if PrintIOstate=3 then return  'Printer I/O FMM in normal active state
     if PrintIOstate=4 then return  'Printer I/O FMM in X-off state
     '
     PrtIntegState=3                'Advance to wait for printer on
     PrintIOstate=1                 'Activate the printer I/O FMM
     gosub ShowPreStartMsgs         'Show the `switch on the printer' message
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     'WAIT FOR PRINTER TO OPEN
     '
PrtInteg3:
     '
     if PrintIOstate>2 then      _  'If the printer is on and ready or
        PrtIntegState=2          _  're-set the Printer Watchdog to monitoring
     '
     return                         'Return to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'SET UP TEXT OF REPORT IN PrStr$
     '
SetUpReport:
     x = ExtrFlag : LenFld = 4 : gosub Printarg9 : ExtrFlag$ = x$
     x = TargSize : LenFld = 5 : gosub Printarg9 : TargSize$ = x$
     x = FileSize              : gosub Printarg9 : FileSize$ = x$
     if ExtrFlag = 0 then ListDate$ = "-------"
     TargSize! = TargSize : FileSize! = FileSize
     if FileSize! > 0 then TargCent! = TargSize! * 100! / FileSize!
     x = TargCent! : TargCent$ = str$(x) : l = len(TargCent$)
     if l > 4 then l = 4 : TargCent$ = left$(TargCent$,l)
     TargCent$ = space$(4 - l) + TargCent$ + "%"
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'REPORT TITLE LINE
     '
Printarg1:
     '
     PrStr$=pp$(2)+pp$(5)+pp$(7)+BlankLine$+BlankLine$+BlankLine$+BlankLine$+BlankLine$
     PrStr$=PrStr$_
     +"E.B.S. MARKETEER"+space$(26)+"TARGET PROFILE SPECIFICATION"      +NewLine$_
     +BlankLine$+BlankLine$_
     +pp$(6) _                          '16.25 or 20cpi
     +"Target Lists extracted from the database using this Profile will"+NewLine$_
     +"include all prospects `on file' at the time of extraction whose:"+NewLine$
     '
     '-------------------------------------------------------------------------
     x$="Target Profile Number     "+TargNum$ :gosub Printarg10:a$=x$
     x$="Target Profile Name       "+TargName$:gosub Printarg10:b$=x$
     x$="Profile last edited on   " +TargDate$:gosub Printarg10:c$=x$
     x$="Target List extracted on " +ListDate$:gosub Printarg10:d$=x$
     x$="Target List Serial No.    "+ExtrFlag$:gosub Printarg10:e$=x$
     x$="Prospects on Target List  "+TargSize$+TargCent$:gosub Printarg10:f$=x$
     x$="Total prospects on file   "+FileSize$+" 100%":gosub Printarg10:g$=x$
     '
     PrStr$=PrStr$+BlankLine$_
     +"- SIC No is listed below                            "+a$+NewLine$_
     +"- Sales Area is one of those marked `*'             "+b$+NewLine$_
     +"- Relation key value is one of those marked `*'     "+c$+NewLine$_
     +"- Status key value is one of those marked `*'       "+d$+NewLine$
     PrStr$=PrStr$_
     +"- Product key values include at least one marked `*'"+e$+NewLine$_
     +"- Selection code matches one of those listed below. "+f$+NewLine$_
     +"- Last Event is one of those marked `*', and whose  "+g$+NewLine$
     PrStr$=PrStr$_
     +"  date lies within the time constraint shown.       "   +NewLine$_
     +"- Next Event is one of those marked `*', and whose  "   +NewLine$_
     +"  date lies within the time constraint shown.       "   +NewLine$
     '
     PrStr$=PrStr$+BlankLine$_
     +"Note: A key with no asterisks against any of its values shown"_
     +" below will not cause him to be excluded no matter"     +NewLine$_
     +"      what value(s) he holds for the key concerned. If no SIC"_
     +" Nos appear he will not be excluded on account of"      +NewLine$_
     +"      his SIC number. If no selection codes appear, he will not"_
     +" be excluded on account of his selection code."         +NewLine$_
     +BlankLine$+BlankLine$
     '
     '-------------------------------------------------------------------------
     'COLUMN HEADINGS
     '                                                           Chrs
     y$="|SICs "                          'SIC column heading       6
     x$=keyvs$(0,0)    :gosub Printarg2   'Sales area              17
     x$=keyvs$(1,0)    :gosub Printarg2   'Relation                17
     x$=keyvs$(2,0)    :gosub Printarg2   'Status                  17
     x$=keyvs$(4,0)    :gosub Printarg2   'Products                17
     x$="Selector Code":gosub Printarg2   'Selector code           17
     x$="Last Event"   :gosub Printarg2   'Last Event              17
     x$="Next Event"   :gosub Printarg2   'Next Event              18
     PrStr$=PrStr$+y$+"|"+NewLine$                              'Total 126
     '
     x$="|-----":for k=1 to 7:x$=x$+"|------------------":next
     PrStr$=PrStr$+x$+"|"+NewLine$:goto Printarg3
     '
     '-------------------------------------------------------------------------
     'HEADING LINE SUBROUTINE   Pad it out to 19 characters
     '
Printarg2:  y$ = y$ + "|" + x$ + space$( 18 - len(x$) ) : return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'DATA LINES 
     '
     'Each element of KEY$() contains a string 18 of asterisks & spaces. An
     'asterisk in a given position within the string indicates that the
     'Key Value with the same position in the KEYVS$() array is selected. A
     'space indicates that it is not selected. The asterisk or space prefixes
     'its respective Key Value in the printout.
     '
Printarg3:
     for k=0 to 5
     y$=space$(18)
     x$=key$(k)
     x=len(x$)
     '
     if x>0 then
     for j=1 to x
     x=asc(mid$(x$,j,1))-64
     if x>0 and x<19 then mid$(y$,x,1)="*"
     next
     end if
     '
     y$(k)=y$:next
     '
     for k=1 to 18                                         'For each value
     x$=sic$(k):y$="|"+x$+space$(5-len(x$))                'SIC Number
     x$=mid$(y$(0),k,1)+keyvs$(0,k):gosub Printarg2        'Sales area
     x$=mid$(y$(1),k,1)+keyvs$(1,k):gosub Printarg2        'Relation
     x$=mid$(y$(2),k,1)+keyvs$(2,k):gosub Printarg2        'Status
     x$=mid$(y$(3),k,1)+keyvs$(4,k):gosub Printarg2        'Products
     x$=cde$(k)                    :gosub Printarg2        'Codes
     x$=mid$(y$(4),k,1)+keyvs$(3,k):gosub Printarg2        'Last Event
     x$=mid$(y$(5),k,1)+keyvs$(3,k):gosub Printarg2        'Next Event
     PrStr$=PrStr$+y$+"|"+NewLine$:next:PrStr$=PrStr$+BlankLine$
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'TIME CONSTRAINTS
     '
     y$="TIME CONSTRAINTS:  Last":x=0:gosub Printarg4   'Limits for Last Events
     y$="                   Next":x=2:gosub Printarg4   'Limits for Next Events
     goto Printarg7
     '
     '-------------------------------------------------------------------------
     'PRINT AN EVENT STATEMENT
     '
Printarg4:
     t1=tme(1+x)   'Early cut-off limit (days)
     t2=tme(2+x)   'Later cut-off limit (days)
     f1=tme(5+x)   'Early limit relevant flag
     f2=tme(6+x)   'Later limit relevant flag
     '
     if f1=0 and f2=0           _     'Both entries are null
        then x$="is irrelevant" _
             :goto Printarg5
     '
     if f1=0 and t2=0           _     'First null, second zero
     or t1=0 and f2=0           _     'First zero, second null
     or t1=0 and t2=0           _     'Both zero
        then x$="must be today" _
             :goto Printarg5
     '
     x=t1:gosub Printarg6:t1$=x$
     x=t2:gosub Printarg6:t2$=x$
     '
     if f1=0 then x$="must be before"+t2$:goto Printarg5
     if f2=0 then x$="must be after" +t1$:goto Printarg5
     '
     x$="must be between"+t1$+" and"+t2$
     '
Printarg5: PrStr$=PrStr$+y$+" Event date "+x$+NewLine$:return    'Final print line
     '
     '-------------------------------------------------------------------------
     'FORM A TIME BOUNDARY STATEMENT
     '
Printarg6:
     if x<0 then x$=str$(x)+"days hence "    'Future if negative
     if x>0 then x$=str$(x)+"days ago "      'Past if positive
     if x=0 then x$=" today "
     return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'ORDER IN WHICH PROSPECTS ARE LISTED PLUS END MATTER
     '
     'The target list serial number is what uniquely identifies a target list
     'which was extracted from the database at a specific time and date using
     'a specific target profile as it appeared at the time of extration.
     '
Printarg7:
     '
     if SeqTyp=1 then x$="alphabetic order of namecode."
     if SeqTyp=2 then x$="order of Reference Number."
     if SeqTyp=3 then x$="alphabetic order of namecode within postcode area."
     if SeqTyp=4 then x$="alphabetic order of namecode within postcode district."
     if SeqTyp=5 then x$="alphabetic order of namecode within postcode sector."
     if SeqTyp=6 then x$="alphabetic order of postcode."
     '
     PrStr$=PrStr$+BlankLine$_
           +"Prospects appear on the Target List in "_
           +x$           _
           +NewLine$+BlankLine$+"End"_       'Print `End' messsage
           +chr$(12)            _       'and throw the page.
           +pp$(4)+pp$(3)               'ReSet printer.
ReSetNums:
     PageNum=1                 'Current page number
     PageLineNum =0            'N of lines printed so far on this page
     BlockLineNum=0            'N of lines printed so far in this 5-line block
     return
     '-------------------------------------------------------------------------
     'FORM A NUMBERIC INTO A 4 or 5-DIGIT STRING WITH LEADING ZEROS
     '
Printarg9:
     x$=str$(x)
     x$=right$(x$,len(x$)-1)
     l=len(x$)
     if l>5 then
        x$=string$(LenFld,"-")
        else
        if l<LenFld then x$=string$(LenFld-l,"0")+x$
        end if
     return
     '
     '-------------------------------------------------------------------------
Printarg10:
     x$=left$(x$,46)                 'Limit the value string to 46 characters
     '
     x$ = space$(40) + "|" + x$ + space$( 46 - len(x$) ) + "|"
     '                                                  
     '  spacing from   box   field name   spacing after    box
     '  text at left   edge  or value     field value      edge
     '
     return
     '-------------------------------------------------------------------------

