





     '
     'RX FILE LIBRARY ROUTINE   Author : R J Morton   22FEB87         RXlib.bas
     '
     'This program lets you scan through the messages held in the Received
     'Messages Library. It displays each message in a display window the same
     'size as the terminal's window and allows you to scroll the message up
     'and down within the window. It also allows you to print the message.
     'Messages can be deleted from the Received Messages Library (RxLib) after
     'they have been printed. This ensures that messages cannot be lost with
     'no permanent record of their having been received.
     '
     defint b-z
     rem $include: 'ComVars.INC'
     common ems$, ems, em
     dim fields$(12)               'Used by EDBLOCK to store notes
     dim cmdw$(10)                 'Holds current set of command words
     dim task$(5)                  'Holds the current set of tasks
     dim pp$(20)                   'Holds printer control strings
     gosub ExpiryTest
     ScrRow=6:ScrCol=1:ScrClr=23        'Row, column & colour for main window
     InitState=1                        'Trigger initialisation
     '
     cmdw$(1)="HELP":cmdw$(2)="QUIT":cmdw$(3)="NEXT":cmdw$(4)="PREV":cmdw$(5)="FIND"
     cmdw$(6)="PRNT":cmdw$(7)="HALT":cmdw$(8)="STOP":cmdw$(9)="FILE":cmdw$(10)="KILL"
     '
     task$(1)="SEEKING":task$(2)="LOADING":task$(3)="ERASING"
     task$(4)="PRINTER":task$(5)="FLOW   "
     tasks=3                            'N of effective tasks
     RxLib = 1
     '
     '
     'FMM POLLING LOOP
     '
     ACTIVE=1:WHILE ACTIVE              'Polling loop control
     gosub Initialisation
     gosub Keyboard                     'Keyboard input & clock
     gosub CWPFMM                       'Function Key command processor
     gosub ShowMessages                 'Display DOS error messages
     gosub CWPfKeys                     'Function Key Analysis
     gosub HelpFMM                      'Keyboard input & clock
     gosub OpenFileFMM                  'General file I/O machine
     gosub GetMessage                   'Load the next message in library
     gosub HelpTrip                     'Reinstate main display after help.
     gosub LibLstIO                     'Messages library list
     gosub PrintMachine
     gosub PrintIO
     gosub EraseMessage
     gosub FindString
     WEND
     '
     row=2:column=30:ps$=space$(51):colour=7:gosub 50
     close:prog$="RXLIB":chain"Tmenu"   'Exit this module
     '
     '
     '





     '
     'EXTERNAL MACHINES
     '
     rem $include: 'GetHelp.FMM'
     rem $include: 'FuncKeys.FMM'
     rem $include: 'KeyBoard.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'GetPrt.FMM'
     '
50   call ScrSub(ps$,row,column,colour):return
     '
     '
     'INITIALISATION
     '
Initialisation:
     if InitState=0 then return         'Initialisation completed
     if InitState=1 then
        GetPrtState=1
        InitState=2
        end if
     if InitState=2 then
        gosub GetPrtCodes
        if GetPrtState<3 then return    'Printer codes loader not finished
        '
        row=1:column=19:colour=7:ps$=top$:gosub 50    'Display module name
        row=3:column= 1:ps$="RECEIVED MESSAGES LIBRARY":gosub 50
        ps$="%THRU" : row = 4 : column = 35 : colour = 7 : gosub 50
        ps$=space$(1200):row=6:column=1:colour=23:gosub 50    'Clear window
        gosub ShowBorder
        gosub ShowInstructions
        FuncKeysFlag=23:gosub ShowCmndWords     'FuncKeys.FMM clear lines 23 24
        ps$ = "Esc = QUIT  Home = go to Start of File"
        row = 23 : column = 1 : colour = 2 : gosub 50
        '
        CR$=chr$(13):LF$=chr$(10):LE$=CR$+LF$   'Line-End characters
        LibFileNum=2:LibRecLen=40:LibLstState=1 'Set to load the library list
        '
        MesFileNum=3:MesRecLen=1024:MesRecLen!=1024!
        MesRecLen2=MesRecLen*2
        MesRecLen3=MesRecLen*3
        MsgNum=0:UpDown=1:GetMesState=1         'Load first available message
        '
        PrtBufNum=4:PrtType$="LQ"               'Output to Letter Quality prtr
        PrtFileNum=5:PrtRecLen=1024             'Block length for print file
        '
        InitState=0
        end if
     return
     '
     '
     '





     '
     'DISPLAY ERROR MESSAGES AND TASK LAMPS
     '
ShowMessages:
     if ShowMessages=1 or HelpTrip=1 then
        ps$=left$(DosMsg$,53):ps$=ps$+space$(53-len(ps$))
        row=3:column=27:colour=DosClr:gosub 50
        if Pstatus$>"" then ps$=left$("PRINTER: "+Pstatus$,40) else ps$=""
        ps$=ps$+space$(40-len(ps$))
        row=22:column=1:colour=PrtClr:gosub 50
        ShowMessages=0
        end if
     if LastTask<>Task then LastTask=Task:gosub ShowTaskLamps
     if LastPrTape$<>PrTape$ or HelpTrip=1 then
        LastPrTape$= PrTape$
        ps$=PrTape$:row=22:column=59:colour=121:gosub 50
        end if
     if ShowMessage=1 or HelpTrip=1 then
        ShowMessage=0
        ps$=Message$:row=4:column=42:colour=14:gosub 50
        ps$=MessageNum$:column=59:colour=7:gosub 50
        end if
     if Jobs<>len(Job$) or HelpTrip=1 then
        Jobs=len(Job$)
        if Jobs>0 then
           ps$=str$(Jobs):if len(ps$)>2 then ps$=right$(ps$,2)
           ps$=ps$+" MESSAGES ON PRINT QUEUE"
      else ps$=space$(26)
           end if
        row=4:column=1:colour=7:gosub 50
        end if
     if LastPrintIOstate<>PrintIOstate _   'Change in Print Task Lamp status
        or LastPmessage<>Pmessage or HelpTrip=1 then 'Change in Xon Xoff status
        LastPmessage=Pmessage
        LastPrintIOstate=PrintIOstate
        X=8:Y=8                            'Grey:  Printer inactive
        if PrintIOstate>0 and PrintIOstate<3 then
           X=14                            'Amber: Printer channel initialising
    elseif PrintIOstate=6 then
           X=12                            'Red:   Printer error
    elseif PrintIOstate=3 then
           X=10                            'Green: Printer accepting data
           if Pmessage=2 then Y=10 else Y=12
           end if
        ps$="":row=2
        column=73:colour=Y:gosub 50
        column=64:colour=X:gosub 50
        end if
     HelpTrip=0:return
     '
     '
     '





     '
     'LOAD & DISPLAY THE NEXT AVAILABLE MESSAGE
     '
GetMessage:
     IF GetMesState=0 OR LibLstState<>3 THEN RETURN
     IF GetMesState=1 THEN              'Machine is initialising
        if OpenFileState>0 then return
        MsgCnt=0:While MsgCnt<40        'N of message entries searched
        MsgNum=MsgNum+UpDown            'Advance to next/previous one
        if MsgNum<1 then MsgNum=40
        if MsgNum>40 then MsgNum=1
        if mid$(MsgLst$,MsgNum,1)="E" then 'If this message slot is [E]rased
           MsgCnt=MsgCnt+1              'increment number tried and test again
      else MsgCnt=41                    'else trigger a loop exit.
           end if                       '
        wend
        if MsgCnt=40 then
           DosMsg$="NO RECEIVED MESSAGES PENDING":DosClr=14:ShowMessages=1
           task=0                       'Light the READY lamp
           CWPstate=1                   'Activate the F-Key command processor
           GetMesState=9                'Exit in error state
      else MsgNum$=str$(MsgNum)         'Form the filespec of the
           MsgNum$=right$(MsgNum$,len(MsgNum$)-1)   'message to be displayed.
           if MsgNum<10 then MsgNum$="0"+MsgNum$
           FileName$=ComFile$+MsgNum$
           if FileState = 1 then FileName$ = FileSpec$
           FileNum=MesFileNum
           RecLen=MesRecLen:LockFile=2  'Self=ReadOnly; Others=ReadWrite
           OpenFileState=1:task=2       'Light the loading lamp
           GetMesState=2                'Advance to the loading state
           end if
     '
 ElseIF GetMesState=2 THEN              'AWAIT COMPLETION OF FILE OPENING TASK
        if OpenFileState<5 then return  'Exit if file opening task not finished
        if OpenFileState=5 then         'If file opened successfully, then
           field MesFileNum,MesRecLen as F$   'Define the file-buffer field
           M$="":X=0
           while not EOF(MesFileNum) and X<3    'Get the first 3 blocks
           get MesFileNum:M$=M$+F$:X=X+1:WEND   'of the file into M$.
           MesRecNum=1:Thru!=0!
           L!=LOF(MesFileNum)           'N of bytes in the file
           M=1:gosub Display            'Display first windowful of message
           X!=MesRecLen:Y!=X!
           NumMesRecs=-1                'Compute the N of blocks in the file
           WHILE X!<L!:X!=X!+Y!:NumMesRecs=NumMesRecs+1:WEND
           if FileState then
              FileState = 0
              MessageNum$=left$("FILE: `"+FileSpec$+"'",22)
              MessageNum$=MessageNum$+space$(22-len(MessageNum$))
              Message$="                "      '`Saved-but-not-printed'
           else
              MessageNum$="RECEIVED MESSAGE N "+MsgNum$
              if mid$(MsgLst$,MsgNum,1)="S" then  'S stands for 
                 Message$="NOT YET PRINTED "      '`Saved-but-not-printed'
            else Message$="HAS BEEN PRINTED"
                 end if
              end if
           ShowMessage=1
           end if                       '
        CWPstate=1                      'Activate the F-Key command processor
        OpenFileState=0                 'De-activate the general File I/O FMM
        GetMesState=0                   'De-activate self
        END IF                          '
     RETURN
     '
     '
     '





     '
     'COMMAND EXECUTOR
     '
     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.
     '
CWPfkeys:
     if CWPfkey>0 or CtrlChar>0 then    'If a function key were struck, then
        Pstatus$="":DosMsg$=""
        ShowMessages=1                  'Clear Dos Error Message field
        ps$ = space$(40) : row = 22 : column = 1 : colour = 7 : gosub 50
        IF CtrlChar=73 THEN
           gosub RetardLine             'PgUp Key
    ElseIF CtrlChar=81 THEN
           gosub AdvanceLine            'PgDn Key
    ElseIF CtrlChar=71 THEN             'Back to start of file
           M$="":X=0
           WHILE X<3                    'Get the first 3 blocks
           X = X + 1
           get MesFileNum,X
           M$ = M$ + F$
           WEND                         'of the file into M$.
           MesRecNum=1:Thru!=0!
           M=1:gosub Display            'Display first windowful of message
           CWPstate=1
    ElseIF CtrlChar=80 THEN             'Down arrow = continue search
           DosMsg$ = "SEARCHING for `"+FindString$+"'"
           DosClr=10:ShowMessages=1
           FindState=1 : Found = 0 : CWPstate = 1
           gosub AdvanceLine
    ElseIF CWPfkey=1 THEN
           help=2:HelpState=1           'HELP key
    ElseIF CWPfkey=2 THEN
           ACTIVE=0                     'QUIT  Return to Comms Menu
    ElseIF CWPfkey=3 THEN
           UpDown= 1:GetMesState=1      'NEXT  Get the next message
           FileNum=MesFileNum:gosub CloseFile
    ElseIF CWPfkey=4 THEN
           UpDown=-1:GetMesState=1      'PREV  Get the previous message
           FileNum=MesFileNum:gosub CloseFile
    ElseIF CWPfkey=5 THEN
           locate 22,1 : input"STRING";FindString$
           DosMsg$ = "SEARCHING for `"+FindString$+"'"
           DosClr=10:ShowMessages=1
           FindState=1 : Found = 0 : CWPstate = 1
    ElseIF CWPfkey=9 THEN               'FILE
           locate 22,1 : input"FILE";FileSpec$
           FileState=1
           UpDown= 1:GetMesState=1      'Get the file
           FileNum=MesFileNum:gosub CloseFile
    ElseIF CWPfkey=10 THEN
           EraseState=1                 'KILL  Erase current message
    ElseIF CWPfkey=6 THEN               'PRINT
           if len(Job$)<40 then         'Provided there's room on request stack
              Job$=Job$+chr$(MsgNum)    'N of Msg to be printed to Job stack
         else DosMsg$="PRINTER QUEUE FULL":DosClr=12:ShowMessages=1
              end if                    '
    ElseIF CWPfkey=8 THEN               'STOP
           if PrintState>0 then
              PrintIOstate=5            'Force de-activation of print driver
              PrintState=6              'Await close-down of printer channel.
              Job$=""                   'Clear the Job Stack
         else CWPstate=1                'Else, indicate invalid keystroke.
              end if
    ElseIF CWPfkey=7 THEN               'HALT/RESUME
           if cmdw$(7)="HALT" then      'If F7 represents the HALT command
              if PrintState=4 then      'If in main print phase, then
                 cmdw$(7)="RES "        'and F7 to mean RESUME
                 PrintState=7           'Put print manager in wait state
                 end if
       elseif cmdw$(7)="RES " then      'If F7 represents the RESUME command
              if PrintState=7 then      'Provided the printer driver in WAIT
                 PrintState=4
                 cmdw$(7)="HALT"
                 end if
              end if
           CWPstate=1:gosub ShowCmndWords 'Display new command words
           END IF
        CWPfkey=0:CtrlChar=0:caps=0     'allow upper & lower case letters
        end if
     RETURN                             'Return control to FMM polling loop
     '
     '-
     '





     '
     'DISPLAY LINES IN CURRENT WINDOW
     '
HelpTrip:
     if HelpState<4 then return
     HelpState=0
     gosub ShowInstructions
     gosub ShowBorder
     HelpTrip=1
     CWPstate=1
Display:
     if L! > 0! then
        M! = M : ps$ = str$( int( ( (Thru! + M!) * 100! / L!) ) )
        if len(ps$) > 2 then ps$ = right$(ps$,2)
   else ps$ = "  "
        end if
     row = 4 : column = 33 : colour = 7 : gosub 50
     Y = M : X$ = ""
     for K = 1 to 15
     X = instr(Y, M$, CR$)
     if X = 0 then
        X$ = X$ + space$(80)
   else Y$ = left$(mid$(M$, Y ,X-Y),80) 'Chop long lines at 80 chrs.
        X$ = X$ + Y$ + space$(80 - len(Y$))
        Y = X + 2
        end if
     next
     call scrsub(X$,ScrRow,ScrCol,ScrClr)
     return
     '
     '
     'ERASE CURRENT MESSAGE
     '
EraseMessage:
     IF EraseState=0 THEN RETURN
     IF LibLstState<>3 THEN RETURN      'Exit if Library List FMM not in WAIT
     '
     IF EraseState=1 THEN
        if mid$(MsgLst$,MsgNum,1)="P" then 'Provided message has been printed,
           Task=3                       'light the erasing lamp and
           MsgStatus$="E"               'set this message file's status byte
           LibLstState=4                'in RX message library to `erased'
           EraseState=2
      else sound 3300,1
           DosMsg$="MESSAGE NOT YET PRINTED"
           DosClr=12:ShowMessages=1
           EraseState=0:CWPstate=1
           end if
     '
 ElseIF EraseState=2 THEN
        if LibLstState=4 then return
        FileNum=MesFileNum:gosub CloseFile
        gosub EraseFile
        UpDown=1                        'automatically display next message
        GetMesState=1
        EraseState=0
        END IF
     RETURN
     '
EraseFile: on error goto EraseErrr
           Kill ComFile$+MsgNum$
EraseErr1: on error goto 0:return 
EraseErrr: resume EraseErr1
     '
     '
     '





     '
     'ADVANCE THE DISPLAY ONE LINE FURTHER ALONG THE FILE
     '
AdvanceLine:
     if M > MesRecLen2 and MesRecNum < NumMesRecs then
        MesRecNum = MesRecNum + 1
        Thru! = Thru! + MesRecLen!
        get MesFileNum, MesRecNum + 2
        M$ = right$(M$, MesRecLen2) + F$
        M$ = M$ + space$( MesRecLen3 - len(M$) )
        M = M - MesRecLen
        end if
     X = instr(M, M$, CR$)
     Y = len(M$) - 2                    'Position of next C/R
     if X > 0 and X < Y then
        M = X + 2
        if FindState = 0 then goto Display
   else FindState = 0
        sound 3300,1
        end if
     return
     '
     '
     'BACK-UP THE DISPLAY BT ONE LINE OF TEXT
     '
     'M$=buffer string holding 2*MesRecLen characters.
     'M=position within M$ of start of screen display
     '
RetardLine:
     K = M - 2                    'Back up over the CR/LF at end of prev line
     WHILE K > 0                  'While we are not yet at start of M$
     K = K - 1                    'Backup one chr posn towards start of file
     IF K < 2 THEN                'If we're now 1 chr before start of M$, then
        if MesRecNum = 1 then              'If we're at 1st record in file, then
           M = 1                           'we're at start of M$ which is 
      else MesRecNum = MesRecNum - 1       'start of file else, back-up
           Thru! = Thru! - MesRecLen!      'to previous record
           get MesFileNum, MesRecNum       'Get prev MesRecLen chars of file,
           M$ = F$ + left$(M$,MesRecLen2)  'move M$ MesRecLen bytes further 
           K = K + MesRecLen               'back down file & set New posn of 
           end if                          'current character within M$
 ElseIF mid$(M$,K,1) = LF$ THEN   'If chr in position K in file is a line feed
        M = K + 1                 'Position within M$ of start of prev line
        K = 0                     'Trigger exit of While-Wend loop
        END IF
     WEND : goto display
     '
     '
     'DISPLAY/CLEAR INSTRUCTIONS FOR AMENDING KEYS ETC
     '
ShowBorder:
     column=1:colour=1
     ps$=string$(80,""):row=5:gosub 50
     ps$=string$(80,""):row=21:goto 50
     '
ShowInstructions:
     column=41:colour=2
     PS$="   PRINTER OUTPUT:                      ":row=22:gosub 50
     ps$="   Use ":row=23:gosub 50
     column=48:colour=10:ps$="PgUp PgDn":gosub 50
     column=57:colour=2:ps$=" to scroll message      ":gosub 50
     ShowMessages=1:ShowMessage=1:return
     '
     '
     '





     '
     'LOAD THE RX LIBRARY LIST
     '
LibLstIO:
     IF LibLstState=0 THEN RETURN       'Idle state
     IF LibLstState=3 THEN RETURN       'Wait state
     '
     IF LibLstState=1 THEN
        if OpenFileState>0 then return  'General file opener busy
        FileName$=ComFile$              'Load the RX library status string
        FileNum=LibFileNum
        RecLen=LibRecLen
        LockFile=0
        OpenFileState=1
        LibLstState=2
     '
 ElseIF LibLstState=2 THEN
        if OpenFileState<5 then return
        if OpenFileState=5 then
           field LibFileNum,LibRecLen as LibField$
           get LibFileNum,1
           MsgLst$=LibField$            'Messages' status string
      else MsgLst$=string$(40,"E")      'Default is whole library empty
           end if
        OpenFileState=0
        LibLstState=3                   'Wait state with file open
     '
 ElseIF LibLstState=4 THEN
        if MsgStatus$="P" then          'If updating a printed message, then
           X=PrtMsgNum                  'use printed message number
      else X=MsgNum                     'else use the displayed message number
           end if                       '
        mid$(MsgLst$,X,1)=MsgStatus$    'Set file as printed/erased
        lset LibField$=MsgLst$
        put LibFileNum,1        
        LibLstState=3                   'Go back to wait state
        END IF
     RETURN
     '
     '
     'SEE IF THERE ARE ANY MESSAGE PRINT REQUESTS PENDING
     '
JobStack:
     if Job$="" then PrtMsgNum=0:return
     PrtMsgNum=asc(left$(Job$,1))       'Get N of next message to be printed
     Job$=right$(Job$,len(Job$)-1)      'and chop it off front of job stack
     X$=str$(PrtMsgNum)
     X$=right$(X$,len(X$)-1)
     if len(X$)=1 then X$="0"+X$
     PrtFile$=ComFile$+X$               'Set up name of file to be printed
     RETURN
     '
     '
     '





     '
     'PRINT MESSAGES PENDING ON THE PRINT STACK
     '
     'This FMM is driven entirely from the job input stack Job$ which contains
     'characters whose ASCII values are the Incoming Messages Library Ns of
     'the messages currently waiting to be printed.
     '
PrintMachine:
     IF PrintState=0 THEN               'If machine is currently idle,
        gosub JobStack                  'See if there are any messages to print
        if PrtMsgNum=0 then RETURN      'Exit if not, otherwise
        PrintState=1                    'activate the Print Manager FMM
        PrintIOstate=1                  'Activate the Print I/O Driver FMM
        CWPstate=1                      'Re-activate the command processor
     '
     '
     'WAIT FOR THE PRINTER I/O DRIVER TO ATTAIN DATA ACCEPTANCE STATE
     '
 ElseIF PrintState=1 THEN               'If wait for printer to open, then
        if PrintIOstate<3 then RETURN   'Printer not yet initialised
        if PrintIOstate=3 then          'Printer ready for data
           CWPstate=0                   'De-activate the command processor
           PrintState=2                 'Advance to next machine state
    elseif PrintIOstate=6 then          'If printer opening error, then
           PrintIOstate=1               'do automatic re-try to open printer
      else PrintIOstate=5               'else close the printer
           end if
     '
     '
     'WHEN GENERAL FILE OPENER BECOMES FREE, INITIATE OPENING OF MESSAGE FILE
     '
 ElseIF PrintState=2 THEN               'If awaiting for general file opener
        if OpenFileState>0 then RETURN  'Exit if File Opener FMM busy
        FileName$=PrtFile$              'File name of the file to be printed
        FileNum=PrtFileNum              'File N under which it is opened
        RecLen=PrtRecLen                'Block length for disk grabs
        LockFile=2                      'Read only - others read/write
        OpenFileState=1                 'Activate the file opener.
        PrintState=3                    'Advance to next state
     '
     '
     'AWAIT OPENING OF MESSAGE FILE
     '
 ElseIF PrintState=3 THEN               'If waiting for message file to open
        if OpenFileState<5 then RETURN  'Exit if file opener not yet terminated
        if OpenFileState=5 then         'If file opened OK, then
           field PrtFileNum,PrtRecLen as PrtField$
           X=LOF(PrtFileNum):Y=0
           PrtRecs=0                 'Length of Message File
           WHILE Y<X:Y=Y+PrtRecLen:PrtRecs=PrtRecs+1:WEND
           LenLastPrtRec=PrtRecLen+X-Y
           PrtRec=0
           EndOfPrtFile=0
           PrintState=4                 'Advance to data transfer phase
      else PrintIOstate=5               'Trigger de-activation of Print Driver
           PrintState=6                 'Go await de-activation
           end if
        CWPstate=1                      'Re-activate the command processor
        OpenFileState=0                 'De-activate the file opener
     '
     '
     '





     '
     'TRANSFER DATA FROM FILE TO PRINTER DRIVER INPUT STACK
     '
 ElseIF PrintState=4 THEN
        if PrintIOstate=3 then                      'Able to accept data
           if EndOfPrtFile=0 then                   'If not yet end of file,
              if len(PrStr$)>64 then return         'Exit if Printer Stack full
              PrtRec=PrtRec+1:get PrtFileNum,PrtRec 'Load next block from disk
              if PrtRec<PrtRecs then                'If not last record, then
                 X$=PrtField$                       'include whole block, else
            else X$=left$(PrtField$,LenLastPrtRec)  'include partial block
                 X=instr(X$,chr$(26))               'Search for End-of-File chr
                 if X>0 then X$=left$(X$,X-1)       'Chop off at EOF if found
                 X$=X$+chr$(12)                     'Add page throw character
                 EndOfPrtFile=1                     'Set End Of File flag.
                 end if
              PrStr$=PrStr$+X$                      'Put block on printer stack
       elseif PrStr$="" and PrBlk$="" then
              FileNum=PrtFileNum:gosub CloseFile    'Close message file
              MsgStatus$="P"                        'Set `message printed'
              LibLstState=4                         '& update Message Library
              if MsgNum=PrtMsgNum then
                 Message$="HAS BEEN PRINTED"
                 ShowMessage=1                      'Activate message display
                 end if
              PrintState=5                          'Advance to next state
              end if
    elseif PrintIOstate=6 then                      'If a hard error, then
           PrintIOstate=1:PrintState=1              'Try to re-open printer
           CWPstate=1                               'Re-activate cmnd processor
           end if
     '
     '
     'AWAIT UPDATE OF LIBRARY STATUS THEN CLOSE THE PRINTER CHANNEL
     '
 ElseIF PrintState=5 THEN               'If waiting for LibLst to terminate
     if LibLstState<>3 then return      'Exit if LibLst FMM not in WAIT state
        gosub JobStack                  'See if any more messages to be printed
        if PrtMsgNum=0 then             'If there are no messages to print,
           PrintIOstate=5               'De-activate the Printer Driver
           PrintState=6                 'Go wait for printer to close
      else PrintState=2                 'Open next message file to be printed
           CWPstate=0                   'De-activate the command processor
           end if
     '
 ElseIF PrintState=6 THEN               'AWAIT PRINTER CLOSE-DOWN
        if PrintIOstate<>6 then RETURN  'Exit if printer not yet closed
        PrintIOstate=0                  'De-activate the Printer Driver
        PrintState=0                    'De-activate self
        Pstatus$="FINISHED":ShowMessages=1:PrtClr=10:Pmessage=0
        CWPstate=1                      'Re-activate the command processor
        END IF
     RETURN
     '
     '
FindString:
     if FindState then
        x = instr(M, M$, CR$)           'Position of first C/R on-screen
        if x > 0 then
           FoundPos = instr( mid$(M$, M, x - M), FindString$ )
           if FoundPos > 0 then
              FindState = 0
              gosub Display
              row = ScrRow : column = FoundPos : colour = 112 : ps$ = FindString$ : gosub 50
              sound 3300,1
              DosMsg$ = "FOUND: Press  to find next occurrence"
              DosClr=10:ShowMessages=1
              Found = 1
         else gosub AdvanceLine
              if FindState = 0 then
                 DosMsg$="NOT FOUND"
                 DosClr=12:ShowMessages=1
                 end if
              end if
      else FindState = 0
           DosMsg$="NOT FOUND"
           DosClr=12:ShowMessages=1
           end if
        end if
     return
     '

