




     'LETTER LIBRARY ROUTINE    by R J Morton      17JUN87         SelcLett.bas

     'This program displays the Letter Library list containing the `Subject'
     'titles of the letters produced by Marketeer's Letter Writing option.
     'From this list, you can select a letter to be displayed in a display
     'window. Once displayed, the message can be scrolled up and down. Upto
     '32,000 characters of a Letter or Message can be displayed in this way.
     'Once a message has been displayed, you can scan either way through the
     'actual messages themselves. You may then copy any one message (the one
     'currently displayed) to the print/transmission file (TxFile) ready for
     'printing via the mailshot facility or transmission via the Communication
     'Terminal of TelexShot facility.

     'DEFINITIONS & COMMON VARIABLES

     DefInt a-z                    'All numeric variables are 16-bit intergers
     rem $include: 'ComVars.INC'   'Marketeer's universal common variables
     dim d%(31)           'Number of decipoints to be added to each lone space
     dim q%(31)           'Positions of lone spaces within each line of text
     dim lc%(40)
     dim cmdw$(10)                 'Holds current set of command words
     dim task$(5)                  'Holds the current set of tasks
     dim pp$(20)                   'Holds printer control strings
     dim LibList$(40,1)            'Names of the messages in the letter library
     dim values$(40)               'Same used for the Select.bas routine
     dim rec$(12)                  'Contains the current name & address details
     dim fields$(200)              'Used by EDBLOCK to store notes & dossier
     '$include: 'propspce.inc'     'Proportional space letter widths.
     FuncKeysFlag=20               'FuncKeys FMM, don't clear line 19
     ManChap=8                     'Relevant chapter of the manual.
     NewLine$=chr$(13)+chr$(10):LenNewLine=len(NewLine$)
     LocalHelp=18
     ImportFile=1                  'Buffer N for import source file.
     if op=1 then
        LibType=1                  '1=Letter Library, 0 = Paragraph Library
        FrameDepth=200
   else ParaRecLen=1362
        FrameDepth=14
        end if
     paper=1                       'Set for 15-by-11 inch continuous stationery
     crlf=0                        'Set for no line feed after carriage-return
     row=1:column=19:colour=7:ps$=top$:gosub 50   'Display module name
     gosub 50
     PrRecLen = 1024               'Buffer length for printing to a file.


     'SET UP INITIAL SCREEN DISPLAYS

     PrtRow=20:PrtCol=41       'Positionning of Printer I/O control panel
     PrtType$="LQ"             'Set for letter quality printer
     gosub DefineCmndWords     'Set up command words used in this section
     gosub DefineTasks         'Display the task list
     gosub ExpiryTest          'Don't run if expiry date past
     goto PollingLoop          'Go to the FMM polling loop.

     '





     'EXTERNAL SUBROUTINE

LineOut: ps$=ps$+space$(80-len(ps$)):goto 50
Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return   'Display as is


     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE

     ' $include: 'LettInit.FMM'
     ' $include: 'MsgTitle.FMM'
     ' $include: 'Keyboard.FMM'
     ' $include: 'GetPrt.FMM'
     ' $include: 'OpenFile.FMM'
     ' $include: 'FuncKeys.FMM'
     ' $include: 'GetHelp.FMM'
     ' $include: 'EdField.FMM'
     ' $include: 'EdBlock.FMM'
     ' $include: 'LettIO.FMM'
     ' $include: 'EdLett.FMM'
     ' $include: 'TexCrypt.INC'
     ' $include: 'PrintIO.FMM'
     ' $include: 'Expiry.INC'
     ' $include: 'Select.FMM'
     ' $include: 'ImportL.FMM'
     ' $include: 'LibLstIO.FMM'
     ' $include: 'LibList.INC'
     ' $include: 'Decrypt.INC'
     ' $include: 'Manual.FMM'
     ' $include: 'PrDriver.INC'
     ' $include: 'RtJust.INC'

     '






     'INITIALIZE THE FINITE STATE MACHINE POLLING LOOP

     'The service programs which perform the various tasks here are written as
     'Message-drived Finite State Machines. Each FMM is continually polled in
     'sequence from the following polling loop.

PollingLoop:
     LettInitState = 1      'Kick-statrt the initialization FMM hierarchy
     cmdl          = 4      'Number of characters in command word field
     MessagesVisible=1      'Enable the messages diaplay routine
     caps=1                 'Set caps entry for typing ahead a namecode entry
     DosMsg$="":DosClr=12   'Clear general error message field
     ShowMessages=1         'Activate message display routine
     ACTIVE=-1

     While ACTIVE
     gosub Keyboard             'Add incoming chrs from keyboard to buffer str
     gosub CWPfkeys             'Act on CWP fkey value if present
     gosub CWPFMM               'Command Word Processor FMM
     gosub OpenFileFMM          'General File Opening FMM
     if LettInitState = 0 then
        gosub ShowLetterStatus
        gosub EdLetter          'Letter editor/viewer
        gosub Duplicate         'Letter duplicator
        gosub HelpFMM           'Help Screen Processor FMM
        gosub Trip              'Keystroke-triggered trip out of help screen
        gosub PrtLet            'Print currently selected letter text
        gosub CopyToTxFile      'Copy selected letter to the TxFile
        gosub SelectLetter      'Select letter to be viewed/edited
        gosub EdName            'Edit letter title
        gosub NextPrevMsg       'Go to the next/previous letter
        gosub ShowMessages      'Display current state of each major FMM
        gosub Import            'Letter File Importer
        gosub Manual            'User Manual window FMM
     else
        gosub Initializer       'Transfer of control from initialization
     end if
     WEND                       'Back to the beginning of the polling loop

     CLOSE                      'Close printer and all files.
     ps$=space$(51):row=2:column=30:colour=7:gosub 50
     prog$="SELCLETT"           'say where control came from
     x! = fre(0)
     if ExitPath=1 then op= 0:chain"Menu"
     if ExitPath=2 then op=99:chain"Mail"
     chain"Wmenu"            'Exit this load module; go back to menu

     '






     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION

Initializer:
     if FMMflag then
        ps$ = "PrintIO"+str$(PrintIOstate) +"  " + Pstatus$  
        row = 2 : column = 1 : colour = 7 : gosub 50
     end if

     if LettInitState<8 then            'Initialization in progress
        gosub LettInit                  'Loop initialization FMM else if 
     else
        if LibNum>0 and LibNum<41 then  'Provided LibNum is within permitted
           LibSels$=chr$(LibNum+64)     'limits, set current selection chr
           MsgNum=LibNum
        else
           LibSels$="@"                 'for input to Select.fmm
           LibNum=0                     'Message currently in output file
           MsgNum=0                     'Message currently being viewed
        end if
        if instr(pp$(18),"1P") or instr(pp$(18),"1p") then
           ProplSpace = 1
           MicroGalleyWidth = GalleyWidth * 5
        end if
        pitch! = val(mid$(pp$(18),4,2)) 'E(s10h.....
        gosub PitchCorrection
        '
        if prog$="MAIL" then
           MsgNum=asc(LibSels$)-64   'Form Library N of the selected letter
           UpDown=0                  'Don't advance in either direction
           gosub ShowCmndWords       '
           gosub ShowTasks
           NextPrevMsgState=1        'Activate the letter searcher/loader
        else
           SelectLetterState=1             'activate the Record Search FMM
        end if
        LettInitState=0                 'De-activate the Initialization FMM
     end if
     return                             'Return control to FMM polling loop.

     '



                                                                               



     'KEY-INITIATED EXIT FROM HELP SCREEN

     'Unfortunately, striking a key is the only practical means of exiting the
     'Help Screen. Therefore, this routine has to be somewhat specific to the
     'main program in that it has to test the state of the Help FMM. If the
     'Help FMM is active, this routine therefore re-displays the main screen
     'and de-activates the Help FMM. In this event, the character struck is
     'not regarded as part of a command input, but is ignored.

Trip:if HelpState>3 then         'If Help Screen is active, then
        HelpState=0              'De-activate the help screen
        gosub NextPrevTrip
 elseif ManualState=1 then 
        row=4:column=1:ps$=space$(80):colour=7:gosub 50
 elseif ManualState=8 then       'If the Manual FMM has just terminated, then
        ManualState=0            'De-activate it
        gosub NextPrevTrip
 elseif EdLetterState>7 then     'If EdLetter FMM  has just terminated, then
        EdLetterState=0          'De-activate it
        gosub TripSub         
        end if
     return                      'Return control to FMM polling loop.


     'REINSTATE THE MAIN SCREEN & RE-DISPLAY RECORD

NextPrevTrip:
     gosub TripSub
     CWPstate=1                  'Re-activate the Command Processor FMM
     gosub ShowLetter            'Re-display the record
     return                      'Return control to FMM polling loop.
TripSub:
     MessagesVisible=1           'Enable Modem/Printer/DOS messages display
     LampsVisible=1              'Enable task-lamps display
     ps$=string$(80,220):row= 4:column=1:colour=1:gosub 50
     ps$=string$(80,223):row=19:gosub 50
     gosub ShowInstructions      'Display the lower right window
     ShowMessages=1              'Trigger a display of the messages
     return

ShowLetter: Bias=0:goto EdLetter0

     '






     'COMMAND EXECUTOR

     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.

CWPfkeys:
     if nkey > 0 then             'If a numeric key were pressed by mistake
        CWPfkey = nkey : nkey = 0 'use the numeric as the Fkey number
     end if
     if CWPfkey=0 then return     'Return control to the FMM polling loop
     DosMsg$="":DosClr=12         'Clear general error message field
     ShowMessages=1               'Activate message display routine
     task=0:gosub ShowTaskLamps   'Kill READY lamp; light WAIT lamp
     if CWPfkey=99 then           'ShiftF2 - exit to main menu
        ExitPath=1:active=0
 elseif CWPfkey=5 then            'If the `DUPL' command were entered,
        DuplState=1               'then actrivate the Duplication FMM
 elseif CWPfkey=6 then            'If the `EDIT' command were entered,
        EdLetterState=1           'then actrivate the Letter Editor FMM
 elseif CWPfkey=3 then            'If the `NEXT' command were entered, 
        NextPrevMsgState=1
        updown= 1
 elseif CWPfkey=4 then            'If the `PREV' command were entered, 
        NextPrevMsgState=1
        updown=-1
 elseif CWPfkey=7 then            'If the `MAIL' command were entered,
        CopyToTxFileState=1       'then actrivate the Copy To Tx File FMM
 elseif CWPfkey=8 then            'If the `ADDR' command were entered,
        ExitPath=2:active=0       'Exit to MAIL module
 elseif CWPfkey=9 then            'If the `PRNT' command were entered,
        PrtLetState=1             'then actrivate the Print Letter FMM
        CWPstate=1
 elseif CWPfkey=10 then           'If the `JUST' command were entered,
        if RightJustify then RightJustify=0 else RightJustify=1
        gosub JustMsg
        CWPstate=1
 elseif CWPfkey=2 then            'If the QUIT command was entered,
        if PrtLetState=0 then     'Provided printer is not active,
           close                  'Close all files
           SelectLetterState=1    'Re-activate the search key entry FMM
           DosMsg$="":DosClr=7    'Clear possible error message
           gosub ShowInstructions 'Display the lower right window details
        else
           PrtLetState=4          'Put printer control FMM into close-down
           PrintAbort=1
           DosClr=12
           PrintIOstate=5         'Put main Printer FMM into close-down.
        end if
        ShowMessages=1            'Activate the message display routine
 elseif CWPfkey=1 then            'Help text
        MessagesVisible=0         'Disable modem/printer/DOS messages display
        LampsVisible=0            'Disable task lamp display
        help=LocalHelp            'Help screen for single-shot Phone calls
        HelpState=1               'Set the HelpFMM state to `initializing'
   else CWPstate=1:beep           'Re-activate the Command Word Processor FMM
        end if
     CWPfkey=0:return             'Clear to avoid a repeat next pass

     '






     'NUMERIC FORMATTERS

     'This routine formats an interger x into a string x$ containing the number
     'padded out with leading zeros as necessary to make it y digits long, plus
     'an extra leading space or minus sign according to the sign of x.

LeadingZeros:
     x$=str$(x)        'Number x as a string with a leading space or - sign
     x=len(x$)-1
     if x>y then x$=string$(y,"!"):return   'Out of range
     x$=right$(x$,x)
     if x<y then x$=string$(y-x,"0")+x$
     if x<0 then x$="-"+x$ else x$=" "+x$
     return


     'SHOW DOS MESSAGES

ShowMessages:
     if MessagesVisible>0 and _         'If on main display screen
        ShowMessages>0 then             'and a message has not changed, then
        ShowMessages=0                  'Clear the `display messages' switch
        if DosClr>0 then                     
           ps$=DOSmsg$:colour=DosClr    'Display DOS error message
           ps$=ps$+space$(40-len(ps$))  'Pad message field to 35 chrs
           row=3:column=41:gosub 50     'DosClr used as display trigger
           DosClr=0
           end if
        if PrtClr>0 then                     
           ps$="Printer: "+Pstatus$          
           colour=PrtClr                'Display DOS error message
           ps$=ps$+space$(40-len(ps$))  'Pad message field to 35 chrs
           row=3:column=41:gosub 50     'DosClr used as display trigger
           PrtClr=0
           end if
        end if
     return                             'Return control to FMM polling loop

ShowLetterStatus:
     if CWPstate then
        if ShowLetterStatus then
           ShowLetterStatus = 0
           if MsgNum>0 then
              if LibNum=MsgNum then
                 ps$=" NOW IN MAIL FILE ":colour=10
                 row=20:column=12:goto 50
              end if
           else
              ps$="NOTHING IN LIBRARY":colour=12
              row=20:column=12:goto 50
           end if
        end if
     else
        ShowLetterStatus=1              'Trigger next showing of message
     end if
     return


    'DEFINE COMMAND WORDS & TASKS

DefineCmndWords:
     cmdw$(1)="HELP":cmdw$(2)="QUIT"
     cmdw$(3)="NEXT":cmdw$(4)="PREV"
     cmdw$(5)="DUPL":cmdw$(6)="EDIT"
     cmdw$(7)="MAIL":cmdw$(8)="ADDR"
     cmdw$(9)="PRNT":cmdw$(10)="JUST"
     cmdw=10:return

DefineTasks:
     task$(1)="SEARCH "
     task$(2)="LOADING"
     task$(3)="STORING"
     task$(4)="COPYING"
     task$(5)="PRINT  "
     tasks=5:return          'Number of effective tasks

     '






     'DISPLAY/CLEAR INSTRUCTIONS [LOWER RIGHT WINDOW]

ShowInstructions: column=41:colour=2

     IF SelectLetterState>0 THEN
        if LibType=0 then x$="PARAG." else x$="LETTER"
        ps$="   Move cursor to required position in  ":row=20:gosub 50
        ps$="   library list, then use F-keys below  ":row=21:gosub 50
        ps$="   to enter/EDIT a "+X$+" title or to   ":row=22:gosub 50
        ps$="   IMPORT a "+X$+" from an external WP  ":row=23:gosub 50
        ELSE
        if MsgNum>0 then
           ps$="    This letter/message has 000 lines.  ":row=20:gosub 50
           ps$="    [25 is sensible max for A4 letter]  ":row=21:gosub 50
           ps$="    [40 is sensible max for A4 telex ]  ":row=22:gosub 50
           gosub FindTotalLines
           gosub ChopRightSpaces
           ps$=left$(str$(TotalLines),4):ps$=space$(4-len(ps$))+ps$
           row=20:column=68:colour=10:gosub 50
      else gosub ClearInstructions
           end if
        gosub JustMsg
        END IF
     return


     'DISPLAY THE MESSAGE'S STATUS

ClearInstructions: ps$=space$(40):column=41:for k=20 to 24:gosub 50:next:return

FindTotalLines: TotalLines=200:while fields$(TotalLines)="" and TotalLines>0
                TotalLines=TotalLines-1:wend:return
     '







     'SELECTION ROUTINE [SELF-DEACTIVATING]

SelectLetter: if SelectLetterState=0 then return

     IF SelectLetterState=1 THEN        'INITIALIZE THE LIBRARY SELECTOR
        gosub ShowLibList
        if LibType=0 then
           x$="PARAGRAPH"
      else x$="LETTER"
           end if
        ps$=x$+" LIBRARY":ps$=ps$+space$(80-len(ps$))
        row=3:column=1:colour=11:gosub 50
        row=4:ps$=space$(80):gosub 50
        colour=2
        ps$="Below are the NAMES of the texts currently in this library. You may enter others":row=5:gosub 50
        ps$="using F4. To retrieve a text select its name according to the instructions below":row=6:gosub 50
        ps$="You may also import text from an external word processor file using F5-see below":row=7:gosub 50
        gosub ShowInstructions
        ValuRow = 9                     'First row on which field occurs
        ValuCol = 2                     'First character of first column
        InstrCol= 1
        NumCols = 4                     'Number of columns
        PerCol  =10                     'Number of values per column
        InterCol=20                     'Column separation
        MaxVals =40                     'Maximum number of values displayed
        SelOrder= 0                     'Order of selections is irrelevant
        NumSels = 1                     'Number of selections allowed
        values$ = LibSels$              'Initial value selections on entry
                                        'VALUES$(K) set up in SHOWLIB.BAS
        EditingPermitted=1              'Permit editing of field names
        SelectState=1                   'Activate the selector FMM
        if MsgNum=0 then SelectPtr=LibNum else SelectPtr=MsgNum
        UseOldSelection=1               'Keep this selection for next entry
        SelectLetterState=2             'Activate the library selector
        END IF

     IF SelectLetterState=2 THEN        'AWAIT TERMINATION OF LIBRARY SELECTOR
        gosub Select
        if SelectState>7 then           'If Select.FMM has terminated, then
           if SelectEsc=1 or values$<"A" then
              ACTIVE=0
         else LibSels$=values$          'Modified selection into Library String
              MsgNum=asc(LibSels$)-64   'Form Library N of the selected letter
              UpDown=0                  'Don't advance in either direction
              gosub ShowCmndWords       '
              gosub ShowTasks
              NextPrevMsgState=1        'Activate the letter searcher/loader
              end if
           SelectState=0                'De-activate self
           SelectLetterState=0          'De-activate self
           end if
        END IF
     RETURN
     '







     'FIND THIS/NEXT/PREVIOUS LETTER N

NextPrevMsg: if NextPrevMsgState=0 then return      'FMM not active


     'FIND THE NEXT/PREVIOUS MESSAGE

     IF NextPrevMsgState=1 then
        if UpDown<>0 then
           x=40:y=0:WHILE y=0 and x>0
           MsgNum=MsgNum+UpDown         'Advance to next/previous one
           if MsgNum< 1 then MsgNum=40
           if MsgNum>40 then MsgNum= 1
           if LibList$(MsgNum,LibType)="" then
              x=x-1
         else y=1                       'If this message slot is unoccupied
              end if
           WEND
           if x=0 then
              MsgNum=0
              LettIOstate=0
              NextPrevMsgState=0        'de-activate self
              gosub NextPrevTrip
              return
              end if
           end if
        gosub ShowMsgNum                'Form & display Message Ner FMM
        Task=2:gosub ShowTaskLamps      'Light the `LOADING' task lamp
        LettIOstate=1                   'Activate message loader FMM
        LettIOtask=5                    'for open-load-close operation
        NextPrevMsgState=2
        END IF


     'WAIT FOR MESSAGE TO LOAD

     IF NextPrevMsgState=2 then
        gosub LettIO                    'Call the LettIO FMM
        if LettIOstate>8 then
           LettIOstate=0
           NextPrevMsgState=0           'de-activate self
           gosub NextPrevTrip
           end if
        END IF

     return
     '





     'COPY LETTER TO TX-FILE FOR TRANSMISSION VIA TERMINAL [SELF-DEACTIVATING]

     'IMPORTANT! Please note that the first two bytes of the TX-File are used
     '           to hold the interger number of the library number of the
     '           message currently held in the TX-file itself. Therefore,
     '           when transmitting the TX-file, you must skip these first
     '           two bytes of the file.

CopyToTxFile: if CopyToTxFileState=0 then return


     'ACTIVATE THE FILE OPENER TO OPEN THE Lett FILE

     IF CopyToTxFileState=1 THEN
        gosub ChopRightSpaces
        Task=4:gosub ShowTaskLamps
        FileName$=LettFile$+"00"        'Filespec (Path + File Name)
        if LettFileNum=0 then _         'If no buffer number specified, then
           LettFileNum=1                'Lett File to be opened as File N 1.
        FileNum=LettFileNum             'For OpenFile.FMM
        if TotalLines=0 then  _
           CopyToTxFileState=0:return   'Do not store file if array empty.
        if ProplSpace then gosub Proportional
        MsgTitle$=LibList$(MsgNum,LibType)

        x$=chr$(MsgNum):if LibType=0 then X$=X$+chr$(0) else x$=chr$(0)+X$

        x$=x$                    _      'Message Number of selected file
          +mki$(LetterNum)       _      'Serial Number of selected message
          +mki$(TotalLines)      _      'N of lines in the message
          +chr$(TopOfForm)       _      'N of blank lines before first print line
          +chr$(SignatureGap)    _      'N of blank lines left for signature
          +mki$(len(MsgTitle$))  _      'Length of the message title
          +MsgTitle$                    'The message title itself

        TxFileRecLen=512                'Make file no longer than necessary
        RecLen=TxFileRecLen             'Make file no longer than necessary
        OpenFileState=1                 'Activate the file opener FMM
        CopyToTxFileState=2             'Advance to the next machine-state
        END IF                          '
     '





     'WAIT FOR THE Lett FILE TO OPEN

     IF CopyToTxFileState=2 THEN
        on error goto CopyToTxFileError
        if OpenFileState<5 then return  'If file opening process has finished
        if OpenFileState=5 then         'If file opening process has finished
           field LettFileNum,     _     'define the field.
           TxFileRecLen as LetterField$ 'Text of fields
           CopyToTxFileState=3          'Advance to the post-opening wait state
      else DOSmsg$="Lett:"+DosMsg$      '
           DOSclr=12                    'Display error message in bright red
           ShowMessages=1          
           CopyToTxFileState=0          'De-activate self
           end if
        OpenFileState=0                 'De-activate the file opener FMM
        on error goto 0
        END IF


     'PACK THE Lett ARRAY INTO FIELD STRING

     IF CopyToTxFileState=3 THEN
        RecMsg$="Put"                   'Error marker message
        on error goto CopyToTxFileError 'Set the local error trap

        for LineNumber=1 to TotalLines  'For each line of the letter array
        gosub SmellRoutine              'Chop off widowed spaces from line of
        x$=x$+y$+NewLine$               'text & add it to output string.
        if LineNumber=TotalLines then
           x$=x$+"       "+NewLine$+chr$(26)      'Add the end-of-file mark
           end if
        if len(x$)=>TxFileRecLen then
           lset LetterField$=left$(x$,TxFileRecLen)
           put LettFileNum              'Store as Lett No RecNum
           x$=right$(x$,len(x$)-TxFileRecLen)
           end if
        next
        if x$>"" then
          lset LetterField$=x$
          put LettFileNum               'Store as Lett No RecNum
          x$=""                         'Free space held by the long strings
          end if
        on error goto 0                 'De-activate the local error trap
        FileNum=LettFileNum
        gosub CloseFile                 'Error-protected file closing routine
        LibNum=MsgNum                   'Ratify this as the selected message
        LibSels$=chr$(LibNum+64)        'Set current selection chr
        goto EndCopyToTxFile
        END IF

     RETURN


     'LOCAL ERROR HANDLER

CopyToTxFileError: 

     DOSmsg$=RecMsg$      _    'States whether it was getting or putting
            +"Lett:"      _    'Identifies the file
            +er$(err)     _    'Normal DOS error message
            +str$(RecNum)      'Record N on which error occurred

     DOSclr=12                 'Display it in bright red
     ShowMessages=1            'Set the message display trigger
     resume CopyToTxFileError1 'Kill the error condition
CopyToTxFileError1:
     on error goto 0           'De-activate the local error trap
     gosub FileError           'Close file & activate message display routine
EndCopyToTxFile:
     CopyToTxFileState=0       'De-activate self
     CWPstate=1                'Return control to the FMM polling loop.
     NextPrevMsgState=1        'Activate the letter searcher/loader
     UpDown=0                  'Don't advance in either direction
     return                    'Activate the letter searcher/loader
     '






     'PRINT THE TEXT OF THE CURRENT LETTER

PrtLet:
     if PrtLetState=0 then return
     on PrtLetState goto PrtLet1, PrtLet2, PrtLet3, PrtLet4
     goto PrintIO

PrtLet1:
     BOLD = 0 : UNDERSCORE = 0 : ITALIC = 0
     if ProplSpace then gosub Proportional
     PrintAbort=0
     PrintIOstate=1                  'Activate the printer
     PrtLetState=2                   'Advance to next state
     ps$="":row=2:column=73:colour=10:gosub 50    'Light the print lamp
                   column=30:colour= 8:gosub 50    'Kill READY lamp
     EndOfLetter=0
     goto PrintIO                       'Printer I/O FMM

PrtLet2:
     if PrintIOstate=3 then          '
        PrStr$=pp$(8)+pp$(18)+pp$(9) 'Reset, set pitch and left margin
        if TotalLines<58 then
           x=(58-TotalLines)/2       'Drop required N of lines
           for k=1 to x
           PrStr$=PrStr$+NewLine$
           next                      'to centrallize letter.
        end if
        LineNumber=0
        PrtLetState=3
     end if
     if PrintIOstate=6 then          'If the printer has failed to open
        PrintIOstate=1               'try again to open it
     end if
     goto PrintIO                       'Printer I/O FMM

PrtLet3:
     if EndOfLetter = 1 and PrStr$ = "" and PrBlk$ = "" then
        PrintIOstate = 5                'else activate closing of printer
        PrtLetState = 4                 'and go wait for it to close
        goto PrintIO
     end if

     if PrintIOstate > 4 then
        PrintIOstate = 1
        PrtLetState = 1 : goto PrintIO
     end if

     if PrintIOstate < 3 then goto PrintIO
     if len(PrStr$) > PrRecLen then goto PrintIO

     if LineNumber < TotalLines then
        LineNumber = LineNumber + 1
        gosub SmellRoutine
        PrStr$ = PrStr$ + y$ + NewLine$
     elseif EndOfLetter = 0 then
        PrStr$ = PrStr$ + chr$(12)
        PrintIOflush = 1
        EndOfLetter = 1
     end if

     goto PrintIO                       'Printer I/O FMM

PrtLet4:
     if PrintIOstate>5 then          'If printer now closed, then
        PrintIOstate=0               'De-activaye the printer I/O FMM
        gosub ShowInstructions       'Re-display lower right window
        PrtLetState=0           'De-activate self
        CWPstate=1                   'Re-activate the command-word processor
        PrStr$="":PrBlk$=""          'Clear the printer stacks
        if PrintAbort=1 then
           DosMsg$="PRINT ABORTED":DosClr=12
        else
           DosMsg$="PRINTED":DosClr=10
        end if
        ShowMessages=1
        ps$="":row=2:column=73:colour= 8:gosub 50  'Kill the print lamp
                      column=30:colour=10:gosub 50  'Kill the print lamp
     end if
     goto PrintIO                       'Printer I/O FMM
     '







SmellRoutine:
     w$=Fields$(LineNumber+1)           'Get the line after.

     JustifyLine=0
     if RightJustify then
        JustifyLine=1
        if left$(w$,1)=" " or w$="" then 'If next line is indented or is null
           JustifyLine=0                 'then do not justify this one
        else
           w = len(w$) : x = 0           'Don't justify a line containing
           x = 0                         'box-graphics characters or a 
           while x < w                   'visible C/R (chr$(254)
              x = x + 1
              if mid$( w$, x, 1 ) > "" then
                 JustifyLine = 0 
                 x = w
              end if
           wend
        end if
     end if

     z$ = Fields$( LineNumber )           'Get [next] line of text.
     LineLength = len( z$ )               'Length of occupied part of each line
     if LineLength = 0 then
        y$ = space$(10)
     else
        if right$(z$, 1) = chr$(254) then 'If line ends with a visible C/R
           LineLength = LineLength - 1    'then chop it off.
           z$ = left$(z$, LineLength)
        end if
        if JustifyLine then gosub RightJustify


     'SUBSTITUTE CONTROL CHARACTERS

        y$="":LineLength = len(z$)
        k = 0:while k < LineLength
        k = k + 1                       'Test each character to see if it is a
        RxChar$=mid$(z$,k,1)            'Marketeer bold/underline/font control
        gosub PrintDriver               'code and substitute for it the escape
        y$=y$+RxChar$:wend              'sequence for the appropriate printer.
        end if
     LineLength=len(y$)                 'N of actual text characters in line
     return
     '





     'EDIT/DELETE A LETTER NAME

EdName: if EdNameState=0 then return

     if EdNameState=1 then              'If machine is in State 1, then
        CharCol=1                       'Set cursor to start of field
        Caps=0                          'Permit upper & lower case input
        EdFieldState=1                  'Activate the field editor FMM
        EdNameState=2                   'Advance to the mext machine state
        end if

     if EdNameState=2 then              'If machine is in State 2, then
        gosub EdFieldFMM
        if EdFieldState<3 then return   'Field editor has not terminated
        EdFieldState=0                  'de-activate field editor
        if AmendFlag>0 then             'If the field were amended, then
           LibList$(SelectPtr,LibType)=FieldStr$ 'Put amended title in Library
           LibSels$="@"                 'Say letter is nolonger in output file
           LibLstIOstate=1              'Activate the Library List I/O FMM
           LibLstIOtask=6               'Set its task as storing Library List
           EdNameState=3                'Advance to next machine state to
      else goto EndEdName
           end if
        end if

     if EdNameState=3 then              'If machine is in State 3, then
        gosub LibLstIO
        if LibLstIOstate<8 then return  'When Library List storing termiated
        LibLstIOState=0                 'de-activate the FMM concerned, and
        values$(SelectPtr)=FieldStr$
        goto EndEdName
        end if

     RETURN

EndEdName:
     gosub Select2g                     'Re-highlight field & re-position cursor
     Caps=1                             'Permit upper & lower case input
     SelectState=2                      'revert to this FMM's main state.
     EdNameState=0
     return                             'Return to the main FMM polling loop.
     '





     'DUPLICATE A LETTER FOR EDITING

Duplicate: if DuplState=0 then return

     IF DuplState=1 THEN
        X$=LibList$(MsgNum,LibType)
        DuplMsgNum=1
        while DuplMsgNum<41 and LibList$(DuplMsgNum,LibType)>""
        DuplMsgNum=DuplMsgNum+1:wend
        if DuplMsgNum=41 then
           DosMsg$="LIBRARY FULL: CANNOT DUPLICATE"
           DosClr=14:ShowMessages=1
           DuplState=0:CWPstate=1:return
           end if
        DuplMsgTitle$=left$("&"+X$,16)
        Task=3:gosub ShowTaskLamps      'Light the `LOADING' task lamp
        LettIOstate=1                   'Activate message loader FMM
        LettIOtask=6                    'for open-put-close operation
        MsgNum=DuplMsgNum
        DuplState=2

 ElseIF DuplState=2 THEN
        gosub LettIO                    'Call the LettIO FMM
        if LettIOstate<9 then return
        LettIOstate=0
        LibList$(MsgNum,LibType)=DuplMsgTitle$
        gosub ShowMsgNum
        LibLstIOstate=1                 'Activate the Library List I/O FMM
        LibLstIOtask=6                  'Set its task as storing Library List
        DuplState=3                     'de-activate self

 ElseIF DuplState=3 THEN
        gosub LibLstIO
        if LibLstIOstate<8 then return  'When Library List storing termiated
        LibLstIOState=0                 'de-activate the FMM concerned, and
        DuplState=0:CWPstate=1
        END IF

     RETURN


     'FORM & DISPLAY MESSAGE N

ShowMsgNum:
     x=MsgNum:y=2:gosub LeadingZeros    'Form composite message filespec
     MsgFile$=LettFile$+right$(x$,2) 
     if LibType=0 then y$="PARAGRAPH" ELSE Y$="LETTER"
     ps$=left$(y$+" N"+x$+" "+LibList$(MsgNum,LibType),40)
     ps$=ps$+space$(40-len(ps$))
     row=3:column=1:colour=11:goto 50   'Display Message N & title


JustMsg:
     if RightJustify then
        ps$="       RIGHT-HAND JUSTIFICATION ON      "
   else ps$="                                        "
        end if
     row=23:column=41:colour=14:goto 50







     'SETS RAGGED RIGHT LINES INTO FIELDS$() ASSUMING PROPORTIONAL SPACE 
     'LETTERING
     'MicroGalleyWidth is the width of the galley in microspaces (5 microspaces 
     'per `en'

Proportional:
     l$="":i=0:j=0                      'Carry line
Proportional0:
     j=j+1
     if j>TotalLines then
        if l$>"" then i=i+1:fields$(i)=l$
        TotalLines = i
        return
        end if
     if i=>j then
        DosMsg$="Array back-overwrite"
        DosClr=12:ShowMessages=1
        sound 200,20:return
        end if
     x$=fields$(j)

     if left$(x$,2)=" "+chr$(27) _         'If it begins with `space+escape'
        or x$="" then                      'or it is blank, then
        if l$>"" then i=i+1:fields$(i)=l$:l$=""  'Store carry line if present
        i=i+1:fields$(i)=x$                'Store this line as is.
        inset$ = ""
        goto Proportional0                 'Go for next input line.
        end if                             '

     if l$ > "" then
     lx = len(x$)                       'Find if this line is inset and 
     q = 0                              'if so then by how many spaces.
     p = 0
     while q < lx 
        q = q + 1
        if mid$(x$,q,1) = " " then p = p + 1 else q = lx
        wend
     inset$ = space$(p)
     x$ = right$(x$,lx - p)
     end if
     
     if l$>"" and x$>"" then x$=" "+x$
     l$=l$+x$
     l=len(l$)                          'length of carry line
     LW=0
     s=0                                'points to latest space in the line
     k=0
Proportional1:
     k=k+1
     if k>l goto Proportional0          'Go for next input line.
     c = asc(mid$(l$,k,1))              'Ascii value of current character
     if c < 32 then                     'If char is a control char
        w = 0                           'its width is zero.
 elseif c > 126 then                    'If it's a special or block graphics
        w = 5                           'char, its width is 5
   else w=CharWidth%(c-32)              'Else its width is given in the
        end if                          'Width Table.
     LW = LW + w
     if c=32 then s=k                   'points to latest space char
     if LW > MicroGalleyWidth then
        if s=0 then s=k
        x$ = left$(l$,s-1)
        if x$>"" then i=i+1:fields$(i)=x$                  'Completed line
        if l > s then l$ = inset$ + right$(l$,l - s) else l$ = inset$
        goto Proportional0
        end if
     goto Proportional1


     'CHOP OFF RIGHT SPACES AND PAD OUT BLANK LINES

ChopRightSpaces:
     for j = 1 to TotalLines
     z$=Fields$(j)                               'Get [next] line of text.
     k = len(z$):x=0:while k>0 and x=0           'Chop idle spaces off
     if mid$(z$,k,1)=" " then k=k-1 else x=1     'the right-hand
     wend:Fields$(j)=left$(z$,k)                 'end of the text line.
     next:return

