





      '------------------------------------------------------------------------
      'SELECT VALUE(S) OF A KEY OR LIBRARY ITEM    22NOV86   [File: SELECT.BAS]
      '------------------------------------------------------------------------
      '11100 goto Select
      '
      'Allows the selection of one or more items from a list of key values
      'or letters/paragraphs appearing on a library list.
      '
      'Inputs  VALUROW - Top row of the key values containment box
      '        VALUCOL - Left-most column in the key values containment box
      '       InstrCol - Override column position of editing instructions
      '         PERCOL - Number of values displayed per column
      '        NUMCOLS - Number of columns in the display
      '       INTERCOL - Chr spaces between start of one col & start of next
      '        MAXVALS - Maximum number of values displayable values
      '       SELORDER - =1 if order in which selections are made is relevant
      '        VALUES$ - Sting of letters representing the Values of this ke
      '                   which were originally "selected" prior to entry
      '        NUMSELS - Number of selections allowed (1 or 15)
      '     VALUES$(K) - Array containing name & values of the keys
      '                  where K=1 to MAXVALS
      '
      'Output   VALUES$ - as defined above, but with the new selections
      '         AMENDF  - Set to 1 if selection(s) amended; else set to zero 
      '
      'Locals ASTER$  - Locals containing the asterisks
      '       ASTER   - Local the number of asterisks currently displayed
      '
      '------------------------------------------------------------------------
      'DISPLAY THE SELECTION ASTERISKS [SUBROUTINE]
      '
Select18:
4300  aster=0:for y=1 to PerCol:row=ValuRow+y-1       'Count asterisks also
      if NumCols>0 then x=0:GOSUB Select19
      if NumCols>1 then x=1:GOSUB Select19
      if NumCols>2 then x=2:GOSUB Select19
      if NumCols>3 then x=3:GOSUB Select19
      next:return
Select19:
      ps$=mid$(aster$,y+PerCol*x,1)
      if ps$>" " then aster=aster+1:colour=31 else colour=23
      column=ValuCol+1+InterCol*x:gosub 50:return
      '
      '------------------------------------------------------------------------
     '






      '------------------------------------------------------------------------
      'EXIT ROUTINE [re-pack selections]
      '
Select20:
      VALUES$=""                    'Clear the selected values output string
      IF SELORDER=1 GOTO Select21      'Order of selection must be preserved
      FOR K=1 TO MAXVALS            'Form asterisks back into values string
      IF MID$(ASTER$,K,1)="*" THEN VALUES$=VALUES$+CHR$(K+64)
      NEXT:SelectInstr=0:RETURN     'of letters.
      '
Select21:
      Y$=" "                        'Initialize the highest value character
      FOR K=1 TO MAXVALS            'For each value displayed
      X$=MID$(ASTER$,K,1)           'Get [next] character in asterisk string
      IF X$>Y$ THEN Y$=X$:X=K       'Find the highest [remaining] selection
      NEXT:IF Y$=" " THEN RETURN    'Exit when no selection markers left
      VALUES$=CHR$(X+64)+VALUES$    'Add selection letter to output string
      MID$(ASTER$,X,1)=" "          'Bomb the latest highest selection
      GOTO Select21                    'Next selection
      '
      '------------------------------------------------------------------------
     '






      '------------------------------------------------------------------------
      'FORM THE ASTERISK STRING FROM THE VALUES STRING
      '
Select1:
      X=LEN(VALUES$)                      'Number of selections on entry
      ASTER$=SPACE$(40)                   'Form template string for *'s
      FOR K=1 TO X                        'For each selected value
      Y=ASC(MID$(VALUES$,K,1))-64         'Extract number of [next] value
      IF Y>0 THEN MID$(ASTER$,Y,1)="*"    'Put * in corresponding position
      NEXT:return
      '
Select:
      AmendF=0:gosub Select1              'Initialize the amend flag
      '
      '------------------------------------------------------------------------
      'OPERATOR INSTRUCTIONS
      '
      GOSUB Select18                   'Display the current selection(s)
      if SelectInstr=1 goto Select2    'Don't re-display instructions
      SelectInstr=1
      colour=2
      if InstrCol=0 then InstrCol=ValuCol-1
      column=InstrCol
      ROW=20:PS$="                                        ":GOSUB 50
      ROW=21:PS$=" Use      keys to locate required value ":GOSUB 50
      ROW=22:PS$=" then use Ins to select Del to deselect ":GOSUB 50
      ROW=23:PS$="    [Max number of selections =   ]     ":GOSUB 50
      colour=112
      ROW=24:PS$="       F2-SELECTF3-QUIT              ":GOSUB 50
      '
      COLOUR=10        'Highlighted items
      '
      ROW=21:COLUMN=InstrCOL+ 5:PS$=chr$(27)+chr$(24)+chr$(25)+chr$(26):GOSUB 50
      ROW=22:COLUMN=InstrCOL+10:PS$="Ins"                  :GOSUB 50
             COLUMN=InstrCol+24:PS$="Del"                  :GOSUB 50
      '
      PS$=STR$(NUMSELS):IF LEN(PS$)=2 THEN PS$=PS$+" "
      ROW=23:COLUMN=InstrCol+31                            :GOSUB 50
      '
      '------------------------------------------------------------------------
     '






      '------------------------------------------------------------------------
      'ACCEPT & PROCESS CHARACTER INPUT FROM KEYBOARD
      '
Select2:
      K=0:LASTK=0:GOTO Select6             'Move cursor to first value
      '
Select3:
      GOSUB inchar                         'Get next character from keyboard
      IF Y=72 GOTO Select5                 'Cursor up
      IF Y=80 OR X=32 GOTO Select6         'Cursor down (or space)
      IF Y=75 GOTO Select7                 'Cursor left
      IF Y=77 GOTO Select8                 'Cursor right
      IF Y=82 GOTO Select12                'Insert
      IF Y=83 GOTO Select17                'Delete
      '
      if x=27 or y=61 then                 'Escape or F3
         gosub Select1
         gosub Select18
         AmendF=0:return  
         end if
      '
      IF y=60 GOTO Select20                'Normal exit  F1
Select4:
      BEEP:GOTO Select3                    'Bum character
      '
      '------------------------------------------------------------------------
      'KEY VALUE HIGHLIGHTING CONTROL
      '
Select5:
      IF K<2 THEN K=MAXVALS ELSE K=K-1                    'Cursor up
      GOTO Select9
Select6:
      IF K=MAXVALS THEN K=1 ELSE K=K+1                    'Cursor down
      GOTO Select9
Select7:
      IF K>PERCOL THEN K=K-PERCOL ELSE BEEP               'Cursor left
      GOTO Select9
Select8:
      IF K>(NUMCOLS-1)*PERCOL THEN BEEP ELSE K=K+PERCOL   'Cursor right
      '
Select9:
      COLOUR=23:J=LASTK:GOSUB Select10     'Reset the previous key value
      COLOUR=31:J=K    :GOSUB Select10     'Hightlight current key value
      LASTK=K                           'Preserve this key number as new last
      LOCATE VALUROW+Y-1,VALUCOL+X-1:GOTO Select3
      '
      '------------------------------------------------------------------------
     '






      '------------------------------------------------------------------------
      'HIGHLIGHT/DE-HIGHLIGHT SUBROUTINE
      '
Select10:
      IF J=0 THEN RETURN
      X=2:Y=J  
Select11:
      IF Y>PERCOL THEN X=X+INTERCOL:Y=Y-PERCOL:GOTO Select11
      PS$=VALUES$(J):ROW=VALUROW+Y-1:COLUMN=VALUCOL+X:GOSUB 50:RETURN
      '
      '------------------------------------------------------------------------
      'INSERT AN ASTERISK [SELECT A DISPLAYED VALUE]
      '
Select12:
      IF VALUES$(K)="" GOTO Select4    'No key value exists in this position
      IF ASTER<NUMSELS GOTO Select15   'Max number of permitted selection exist
      if NumSels>1 _                   'If a multi-column list,
         then goto Select4             'cannot select any more
      '
      Y=1                                  'For the single-selection case only
Select13:
      IF MID$(ASTER$,Y,1)=" " GOTO Select14   'Space, therefore not selected
         MID$(ASTER$,Y,1)=" ":GOTO Select15   'Bomb out the old selection
Select14:
      IF Y<MAXVALS THEN Y=Y+1:GOTO Select13   'Check all values incase selected
      '
Select15:
      IF SELORDER=0 THEN X$="*":GOTO Select16 'Order of selections is irrelevant
      X$=STR$(SELORDER):X$=RIGHT$(X$,1)    'Sequence number of this selection
Select16:
      MID$(ASTER$,K,1)=X$                  'Put in approp position in ASTER$
      AMENDF=1                             'Set the amend flag
      GOSUB Select18:GOTO Select3          'Re-display all the asterisks
      '
      '------------------------------------------------------------------------
      'DELETE AN ASTERISK [DESELECT A DISPLAYED VALUE]
      '
Select17:
      IF ASTER=0 GOTO Select4       'No selections to cancel
      IF VALUES$(K)="" GOTO Select4 'No key value exists in this position
      MID$(ASTER$,K,1)=" "       'Remove * from appropriate position in ASTER$
      AMENDF=1                      'Set the amend flag
4399  GOSUB Select18:GOTO Select3      'Re-display all the asterisks
      '
      '------------------------------------------------------------------------
     '
