





     'SIFT THROUGH A TARGET LIST   Author:R J Morton      15JAN89      Sift.BAS

     'Enables the user to retrieve and view each prospect record on the current
     'target list and cull out from the list those individuals he specifically
     'wishes to exclude.

     DefInt a-z                    'All numeric variables are 16-bit intergers
     rem $include: 'ComVars.INC'   'Marketeer's universal common variables
     rem $include: 'ComVart.INC'   'Merge in the common variables


     'DEFINITION & ARRAY DIMENSIONING

     dim rec$(12)              'Contains the current name & address details
     dim CMDW$(10)             'Holds current set of command words
     dim task$(5)              'Holds the current set of tasks
     dim fields$(100)          'Used by EDBLOCK to store notes + dossier
     dim values$(18)           'Used by the block editor
     dim stamps$(12)           'Date stamps for diary notes 
     dim TempRec$(12)          'Stores original name & address prior to an edit
     '                         'which can be reinstated if edit is aborted.

     'BUFFER ALLOCATIONS FOR THE FILES USED BY THIS MODULE

     RecsFileNum=1     'Main prospect records
     AreaFileNum=2     'For finding which sales area a prospect is in
     KeysFileNum=3     'Contains prospect's selecion keys
     KeysRecLen= 8     'Record length of the keys file
     DateFileNum=4     'Dates of his last and next-planned events
     IndxFileNum=5     'Namecode or Postcode index depending on type of search
     IndxRecLen=16     'Record length of an index file
     LocalHelp=15      'N of the `Sift' help record
     ManChap=14        'Relevant chapter of the maual Chapter N +1
     NewLine$=chr$(13)+chr$(10)


     'SET UP INITIAL SCREEN DISPLAYS

     row=1:column=19:colour=7:ps$=top$:gosub 50     'Display module name

     HighestRecord=FileSize
     LastElement=FileSize      'For ShowAbox to display of N prospects on file
     gosub ShowBoxes           'Display the name & address box

     row=3:column=1:colour=grey:ps$="List N       of      ":gosub 50
     ps$=left$("Target "+TargNum$+": "+TargName$,36)
     column=45:colour=3:gosub 50

     gosub DefineCmndWords     'Set up command words used in this section
     gosub DefineTasks         'Display the task list
     gosub ShowTasks           'Display the Task List panel
     locate 24,1,0             'place cursor at bottom left of screen

     column=1:colour=grey:ps$=space$(31):for row=19 to 24:gosub 50:next
     row=22:column=10:colour=10:ps$="INITIALIZING":gosub 50

     gosub ClearInstructions
     gosub ExpiryTest          'Don't run if expiry date past
     prgm$=prog$:prog$="SIFT"  'Set program identification variable
     goto Initialization       'Go to initialize the FMM polling loop.

     '





     'EXTERNAL SUBROUTINE

Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return   'Display as is


     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE

     rem $include: 'Keyboard.FMM'
     rem $include: 'RecordIO.FMM'
     rem $include: 'KeysIO.FMM'
     rem $include: 'DateIO.FMM'
     rem $include: 'AttrIO.FMM'
     rem $include: 'CodeIO.FMM'
     rem $include: 'DistIO.FMM'
     rem $include: 'TargetIO.FMM'
     rem $include: 'LoadRec.FMM'
     rem $include: 'LoadKeys.FMM'
     rem $include: 'LoadAttr.FMM'
     rem $include: 'LoadCode.FMM'
     rem $include: 'LoadTarg.FMM'
     rem $include: 'SaveRec.FMM'
     rem $include: 'SaveAttr.FMM'
     rem $include: 'SaveCode.FMM'
     rem $include: 'SaveDate.FMM'
     rem $include: 'StoreRec.FMM'
     rem $include: 'UpdtRec.FMM'
     rem $include: 'UpdtKeys.FMM'
     rem $include: 'UpdtCode.FMM'
     rem $include: 'IndxShft.FMM'
     rem $include: 'AmendKey.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'EdBox.FMM'
     rem $include: 'EditKeys.FMM'
     rem $include: 'ViewFile.FMM'

     rem $include: 'FuncKeys.FMM'       'OTHERS
     rem $include: 'GetHelp.FMM'
     rem $include: 'ShowAbox.INC'
     rem $include: 'ShowMbox.INC'
     rem $include: 'ShowKbox.INC'
     rem $include: 'Decrypt.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'Elapsed.INC'
     rem $include: 'InDate.FMM'

     rem $include: 'Select.FMM'
     rem $include: 'NotesIO.FMM'
     rem $include: 'EdField.FMM'
     rem $include: 'EdBlock.FMM'
     rem $include: 'EdNotes.FMM'
     rem $include: 'ValiPost.INC'
     rem $include: 'SelKeyvs.FMM'
     rem $include: 'GetKeyvs.FMM'
     rem $include: 'ShoKeyvs.INC'
     rem $include: 'EdDoss.FMM'
     rem $include: 'DossIO.FMM'
     rem $include: 'Texcrypt.INC'
     rem $include: 'BinSrch.INC'
     rem $include: 'Manual.FMM'

     '





     'INITIALIZE THE FINITE STATE MACHINE POLLING LOOP

     'The service programs which perform the various tasks here are written as
     'Message-drived Finite State Machines. Each FMM is continually polled in
     'sequence from the following polling loop.

Initialization:
     DosMsg$="":ShowMessages=1
     GetKeyvsState = 1       'Activate the Key Values input FMM
     cmdl          = 4       'Number of characters in command word field
     caps=1                  'In case people like Dick Stockman type ahead
     MessagesVisible=1       'Enable the messages diaplay routine
     LampsVisible   =1       'Enable task-lamps display

     WHILE QuitFlag=0
     gosub Initializer       'Transfer of control from initialization
     gosub Jump              'Go to a specific record on the Target List
     gosub NextPrev          'Get next/previous subscriber on request
     gosub LoadRecord        'Record loader FMM
     gosub Keyboard          'Add incoming chrs from keyboard to buffer str
     gosub CWPFMM            'Command Word Processor FMM
     gosub CWPfkeys          'Act on CWP fkey value if present
     gosub Cull
     gosub EdBox             'Edit the name & address box
     gosub EditSICN          'Edit the SIC N
     gosub EditKeys          'Edit the Selector Keys & dates
     gosub EditAttr          'Edit the Attributes [ie products/services]
     gosub EditCode          'Edit the Selector Code
     gosub StoreRec          'Store a new or amended name & address
     gosub EdNotesFMM        'Diary Notes  Processor FMM
     gosub EdDossier
     gosub HelpFMM           'Help Screen Processor FMM
     gosub Trip              'Keystroke-triggered trip out of help/note screens
     gosub ViewFile          'Real-time file viewing window
     gosub OpenFileFMM       'General File Opening FMM
     gosub ShowMessages      'Display error messages
     gosub Manual            'Display the manual on request
     WEND                    'Back to the beginning of the polling loop
     close                   'Close all files
     ps$=space$(80):column=1 'Wipe possible error message from the
     row=3:gosub 50          'standard error messages position.
     row=4:gosub 50          '
     if QuitFlag=2 then chain"Menu"
     chain"DefTarg"          'Exit this load module; got back to menu

     '





     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION

Initializer:
     if GetKeyvsState > 0 then          'If initializing, then
        if GetKeyvsState < 3  then _    'Initialization in progress
           gosub GetKeyvs : return      'Loop initialization FMM
        if GetKeyvsState = 4 then beep  'Beep if initialization failed
        gosub ShowMbox                  'Show market profile box
        GetKeyvsState = 0               'De-activate the Initialization FMM
        TargItem = 0
        UpDown = 1
        NextPrevState = 1               'Activate the Record Search FMM
        end if
     return                             'Return control to the FMM polling loop
     '





     'CULL A PROSPECT FROM THE TARGET LIST  write as an FMM with locking

Cull: if CullState=0 then return

     IF CullState=1 THEN                'STATE 1: INITIALIZATION
        FileName$=TargFile$+TargNum$    '
        FileNum=2:RecLen=8              '
        OpenFileState=1                 '
        CullState=2                     '
 ELSEIF CullState=2 THEN                'OPEN THE TARGET LIST FILE
        if OpenFileState<5 then return  '
        if OpenFileState=5 then         '
           OpenFileState=0              '
           CullState=3
      else OpenFileState=0              '
           goto Cull6                   'Terminate
           end if                       '
 ELSEIF CullState=3 THEN                'SHIFT ALL HIGHER LIST RECORDS ONE DOWN
        on error goto Cull4
        field FileNum,2 as S1$,2 as S2$,2 as S3$,2 as S4$
        k=TargItem                      'Move all List File records above the
        while k<TargSize                'one being culled one record-position
        get FileNum,k+2                 'down in the file so that the culled
        put FileNum,k+1                 'record is over-written by one above
        k=k+1:wend                      'and so on up to end of the List File.
        TargSize=TargSize-1             'Decrement number of prospects on list
        get FileNum,1                   'Get the List File's header record
        lset S1$=mki$(TargSize)         'Write in the new decremented List Size
        lset S4$=mki$(0)                'Kill the `listing up to date' flag
        put FileNum,1:close             'Restore updated header record & close
        if TargSize>0 then              'If there are still entries left in the 
           ps$="Previous record deleted"'List file, display message shown and
           TargItem=TargItem-1          'activate loading of
           UpDown=1:NextPrevState=1     'next record on list
           else                         'If we have just culled the last entry
           ps$="Target List now empty  "'then display the message shown here,
           gosub ShowBoxes              'clear the boxes on the screen
           UpDown=0:CWPstate=1          'and return to the command word display
           end if                       '
        colour=2:row=4:column=45:gosub 50:goto Cull7
        END IF                          '
     return

Cull4: DosMsg$=er$(err):resume Cull5    'ERROR HANDLER FOR CULL
Cull5: DosMsg$="Cull:"+DosMsg$
       DosClr=12:ShowMessages=1
Cull6: CWPstate=1:UpDown=0
Cull7: CullState=0:on error goto 0
       close:return
     '






     'NEXT/PREVIOUS RECORD ON TARGET LIST

     'This routine organized the loading of the addressee details of the next
     'telex message to be sent out of a group of telex messages to prospects
     'on a specific target list. After each telex message has been sent it
     'stores the date stamp in the Target List file.

NextPrev: if NextPrevState=0 then return   'machine idle


     'INITIALIZATION

     if NextPrevState = 1 then          'If this machine is in State 1, then
        if TargSize < 1 then            'If there is nothing in the target list
           DosClr = 12                  'If the target list contains nothing
           DosMsg$ = "Target List empty " 'then set up appropriate message
           goto NextPrevA               'Terminate
           end if
        task = 1 : gosub ShowTaskLamps  'Light SEEKING lamp
        TargItem = TargItem + Updown    'Increment the list number
        if TargItem < 1 then              
           TargItem = TargSize          'and safeguard that it is
           end if
        if TargItem > TargSize then
           TargItem = 1                 'within valid limits
           end if
        ShowMessages = 1                'To show updated TargItem
        LoadTargState = 1               'Activate get target list record FMM
        NextPrevState = 2               'Advance to next state to await opening
        end if
     '





     'AWAIT OPENING OF THE TARGET LIST FILE

     if NextPrevState = 2 then
        gosub LoadTarg                        'Get next record N from tgt list
        if LoadTargState < 5 then return      'Next tgt record not yet loaded
        if LoadTargState = 5 then             'If next tgt list record loaded
           LoadTargState = 0                  'de-activate
           if RecNum < 1 or _
              RecNum > MaxRecNum then         'If Rec N in targ list invalid
              NextPrevState = 0               'De-activate self
              DosMsg$ = "RecNum out of range" 'Set up the error message
              goto NextPrevA                  'Go to error state
           else
              LoadRecordState = 1             'Activae prospect record loader
              NextPrevState = 3               'Advance to next machine state
           end if
        else
           LoadTargState = 0                  'de-activate
           goto NextPrevA                     'set self to error state
        end if
     end if


     'WAIT FOR PROSPECT RECORD TO BE LOADED & DISPLAYED

     if NextPrevState=3 then
        gosub LoadRecord                 'General record loader
        if LoadRecordState<8 then return 'next prospect record loading
        if LoadRecordState=8 then        'If next prospect record loaded OK
           LoadRecordState=0             'deactivate the record loader
           gosub DisplayRecord           'Display the Prospect Record
           gosub ShowListNum             '
           goto NextPrevB                'Terminate
      else LoadRecordState=0             'deactivate the record loader
           goto NextPrevA                '
           end if
        end if
     return                             'Return control to the FMM pollong loop


     'ERROR HANDLER

NextPrevA: DosMsg$="Next:"+DosMsg$
           DosClr=12:ShowMessages=1     'set to show the message
NextPrevB: task=0:gosub ShowTaskLamps   'Clear the `load' lamps
           CWPstate=1                   'Activate the command processor
           NextPrevState=0              'set self to error state
           return
     '






     'DISPLAY THE MAIN SET OF COMMAND WORDS

DefineCmndWords:
     CMDE=10              'Don't allow K-key to effect the CULL function
     CMDN=1               'Enable Key N entry
     cmdw=10              'use all 10 command words
     cmdw$( 1)="HELP"     'Get explanation of these command words
     cmdw$( 2)="QUIT"     'Return to the record retrieval screen
     cmdw$( 3)="NEXT"     'Get next record in current index
     cmdw$( 4)="PREV"     'Get previous record in current index
     cmdw$( 5)="JUMP"     'Get a list member of a specified list number
     cmdw$( 6)="EDIT"     'Edit the prospect's name & address data
     cmdw$( 7)="NOTE"     'Display and edit the prospect's diary notes
     cmdw$( 8)="DOSS"     'Dossier command
     cmdw$( 9)="VIEW"     'View real-time file window
     cmdw$(10)="CULL"     'Delete the currently displayed prospect record


     'DISPLAY THE TASKS AVAILABLE

DefineTasks:
     task$(1)="SEEKING "  'Searching current index for the requested record
     task$(2)="LOADING "  'Loading data from database files for found record
     task$(3)="STORING "  'Storing new/amended record and or key information
     task$(4)="SORTING "  'Placing new/amended index entry in appropriate index
     task$(5)="CULLING "  'Deleting record form database & index files.
     tasks=5:return       'Number of effective tasks
     '






     'LIST N DISPLAY

ShowListNum:
     row=3:colour=3:y=5
     x=TargItem:gosub LeadingZeros:ps$=x$:column= 8:gosub 50
     x=TargSize:gosub LeadingZeros:ps$=x$:column=17:gosub 50
     return
     '





     'KEY-INITIATED EXIT FROM HELP SCREEN

     'Unfortunately, striking a key is the only practical means of exiting the
     'Help Screen. Therefore, this routine has to be somewhat specific to the
     'main program in that it has to test the state of the Help FMM. If the
     'Help FMM is active, this routine therefore re-displays the main screen
     'and de-activates the Help FMM. In this event, the character struck is
     'not regarded as part of a command input, but is ignored.

Trip:if HelpState>3 then           'Help screen active or being displayed, then
        gosub TripSub
        CWPstate=1                 're-activate the Command Processor FMM
        gosub DisplayRecord        'Re-display the record
        HelpState=0                'De-activate the help screen
 elseif EdNotesState>7 then        'If EdNotes FMM has just terminated, then
        EdNotesState=0             'De-activate it
        gosub TripSub         
 elseif ViewFileState>7 then       'If EdNotes FMM has just terminated, then
        ViewFileState=0            'De-activate it
        gosub TripSub         
 elseif ManualState>0 then         'If Manual FMM has just terminated, then
        if ManualContents=0 then
           ManChap=14
           end if
        if ManualState=8 then      'If Manual FMM has just terminated, then
           ManualState=0           'De-activate it
           gosub TripSub         
           end if
        end if
     return                        'Return control to FMM polling loop.


     'REINSTATE THE MAIN SCREEN & RE-DISPLAY RECORD

TripSub:
     LeftBox$="" :gosub ShowAbox 'Clear the name & address box
     RightBox$="":gosub ShowMbox 'Display the Market Profile Box
     ShowMessages=1              'Activate the message display routine
     if HelpState=0 then
        gosub DisplayRecord      'Re-display the record
        CurrentDisplay=0
        CWPstate=1               'and re-activate the command word processor.
        end if
     return
     '






     'COMMAND EXECUTOR  modify for amend functions

     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.

CWPfkeys:
     if CWPfkey=0 and Nkey=0 _    'If neither command word or digit entered,
        then return               'return control to the FMM polling loop
     gosub ClearMessage           'Clear the `Call completed' message
     DosMsg$="":DosClr=12         'Clear general error message field
     ShowMessages=1               'Activate message display routine
     task=0:gosub ShowTaskLamps   'Kill READY lamp; light WAIT lamp


     'SELECTIONS FOR WHICH COMMAND PROCESSOR MUST REMAIN INACTIVE

     if CWPfkey=1 then help=LocalHelp:HelpState=1:goto CWPfkeys3  'HELP
     if CWPfkey=6 then EditFlag=1:EdBoxState=1   :goto CWPfkeys3  'EDIT
     if CWPfkey=7 then EdNotesState=1            :goto CWPfkeys3  'NOTE
     if CWPfkey=8 then EdDossierState=1:goto CWPfkeys3            'DOSS
     if CWPfkey=9 then ViewFileState=1:goto CWPfkeys3             'VIEW
     if Nkey>0 then goto NumericsKeys


     'SELECTIONS FOR WHICH COMMAND PROCESSOR NEEDS RE-ACTIVATING

CWPfkeys1:
     if CWPfkey= 3 then updown=  1:NextPrevState=1:goto CWPfkeys3   'NEXT
     if CWPfkey= 4 then updown= -1:NextPrevState=1:goto CWPfkeys3   'PREV
     if CWPfkey= 5 then            JumpState    =1:goto CWPfkeys3   'JUMP
     if CWPfkey= 2 then QuitFlag=1                :goto CWPfkeys3   'QUIT
     if CWPfkey=99 then QuitFlag=2                :goto CWPfkeys3   'EXIT
     if CWPfkey=10 then            CullState    =1:goto CWPfkeys3   'CULL
CWPfkeys5:
     beep:CWPstate=1:goto CWPfkeys3
     '





CWPfkeys2: EdBoxState=1              'Activate the name & address editor
           gosub ClearInstructions   '
CWPfkeys3: CWPfkey=0       'Clear F-Key N to avoid a repeate next pass
           KeyNum=Nkey     'Preserve the `Key Number' as displayed on screen
           Nkey=0          'Clear numeric selection to avoid a repeat next pass
           caps=0          'allow upper & lower case letters
           return          'Return control to the FMM polling loop.


     'NUMERICS KEY TESTS [FOR AMENDING KEY VALUES]

NumericsKeys:
     if Nkey=1 then EditSICNstate=1   :goto NumericsKeys1
     if Nkey=5 then EditAttrState=1   :goto NumericsKeys1       'Products
     if Nkey=6 then EditCodeState=1   :goto NumericsKeys1
     if Nkey=3 then KeyType=1:KeyArr=1:goto NumericsKeys2       'Relation
     if Nkey=4 then KeyType=2:KeyArr=2:goto NumericsKeys2       'Progress
     if Nkey=7 then KeyType=3:KeyArr=3:goto NumericsKeys2       'Last Event
     if Nkey=8 then KeyType=4:KeyArr=3:goto NumericsKeys2       'Next Event
     goto CWPfkeys5

NumericsKeys1: KeyArr=4       :goto CWPfkeys3
NumericsKeys2: EditKeysState=1:goto CWPfkeys3
     '





     'DISPLAY/CLEAR INSTRUCTIONS FOR AMENDING KEYS ETC

ShowInstructions: column=41:colour=2
     PS$="                                        ":ROW=19:GOSUB 50
     PS$="  To amend Market Profile, type in the  ":ROW=20:GOSUB 50
     PS$="  N of the field you wish to amend as  ":ROW=21:GOSUB 50
     PS$="  highlighted on left hand side of box. ":ROW=22:GOSUB 50
     PS$="                                        ":ROW=23:GOSUB 50
     RETURN
ClearInstructions:
     column=41:ps$=space$(40):for row=19 to 23:gosub 50:next:return


     'DISPLAY/CLEAR THE STORED/CULLED MESSAGES

ShowStoredMsg:
StoredAsSeen: ps$=" NOW STORED AS SEEN   ":colour=10:goto ShowMessage
ChangesMade:  ps$=" CHANGES MADE. SAVE?  ":colour=14:goto ShowMessage
ShowKilledMsg:ps$="Previous record erased":colour=10:goto ShowMessage
ShowNoXrefMsg:ps$="    No cross-reference":colour=12:goto ShowMessage
ShowFailedMsg:ps$="Could not store record":colour=12:goto ShowMessage

ClearMessage: ps$=space$(36):gosub ShowMessage1
ClearAsSeen:  ps$=space$(22):colour=10
ShowMessage:  row=4:column=19:goto 50

ShowMessages: if ShowMessages=0 then return
              ps$=left$(DosMsg$,38)
              ps$=ps$+space$(36-len(ps$))
ShowMessage1: ShowMessages=0:row=4:column=43:colour=DosClr:goto 50


     'HIGHLIGHT/LOWLIGHT A KEY NUMBER IN MARKET PROFILE BOX

ShowBright: colour=127:goto ShowBriDim
ShowDim:    colour=112
ShowBriDim: if KeyNum<7 then row=KeyNum+7 else row=KeyNum+9
            column=44:ps$=right$(str$(KeyNum),1):goto 50


     'HIGHLIGHT/LOWLIGHT A DATE IN THE MARKET PROFILE BOX

HighlightDate:
     if KeyType=3 then ps$=LastDate$    'Last Event key
     if KeyType=4 then ps$=NextDate$    'Next Event key
     row=KeyNum+9:column=66:goto 50     'Highlight relevant date

ShowBoxes:
     row=4:column=41:ps$=space$(40):gosub 50   'Clear menu help text
     LeftBox$="" :gosub ShowAbox               'Display the name & address box
     RightBox$="":gosub ShowMbox               'Show market profile box
     return
     '





     'LOAD THE RETRIEVED RECORD

     'Uses LoadRec.FMM RecordIO.FMM and GetAreas.FMM to load the required 
     'prospect record, and then displays the record in the name & address
     'box. Also lights the task lamps as appropriate.

LoadRecord: if LoadRecordState=0 then return   'Machine idle

     if LoadRecordState=1 then     'If this machine is in State 1, then
        task=2:gosub ShowTaskLamps 'Kill `seek' lamp/light the LOADING lamp
        LoadRecState=1             'Activate the Record Loading Supervisor FMM
        LoadRecordState=2          'Advance self to next state
        end if


     'LOAD THE RECORD

     if LoadRecordState=2 then          'If this machine is in State 2, then
        gosub LoadRec                   'Record loading supervisor FMM
        if LoadRecState<6 then return   'If required record not yet loaded
        if LoadRecState=6 then          'If required record now loaded OK
           LoadKeysState=1              'Activate the attr loader FMM
           LoadRecordState=3            'Advance to the next machine state
           else goto LoadRecordA        'and terminate
           end if
        end if


     'LOAD THE RECORD

     if LoadRecordState=3 then          'If this machine is in State 3, then
        gosub LoadKeys                  'Record loading supervisor FMM
        if LoadKeysState<5 then return  'If required record not yet loaded
        if LoadKeysState=5 then         'If required record now loaded OK
           LoadAttrState=1              'Activate the attr loader FMM
           LoadRecordState=4            'Advance to the next machine state
           else goto LoadRecordA        'and terminate
           end if
        end if


     'LOAD THE ATTRIBUTES

     if LoadRecordState=4 then          'If this machine is in State 4, then
        gosub LoadAttr                  'Load the prospect's attributes
        if LoadAttrState<5 then return  'If required record not yet loaded
        if LoadAttrState=5 then         'If required record not yet loaded
           LoadCodeState=1              'Activate the code loader FMM
           LoadRecordState=5            'Advance to the next machine state
           else goto LoadRecordA        'then terminate
           end if
        end if
     '






     'LOAD THE SELECTOR CODE

     if LoadRecordState=5 then          'If this machine is in State 5, then
        gosub LoadCode                  'Load the prospect's code settings
        if LoadCodeState>4 goto LoadRecordA
        end if
     return                         'Return to FMM polling loop.

LoadRecordA:
     task=0:gosub ShowTaskLamps     'Clear the `load' lamps
     LoadRecState=0                 'De-activate the record load supervisor
     LoadKeysState=0                'De-activate the keyss load supervisor
     LoadAttrState=0                'De-activate the attrs load supervisor
     LoadCodeState=0                'De-activate the codes  load supervisor
     LoadRecordState=0              'Go to successful termination state
     if CurrentDisplay = 1 then
        EdNotesState = 1
     elseif CurrentDisplay = 2 then
        EdDossierState = 1
     else
        gosub DisplayRecord         'Display the Prospect Record
        CWPstate=1                  'Activate the Command Word Processor FMM
     end if
     gosub ShowReference
     gosub ShowListNum
     return


     'DISPLAY RETRIEVED RECORD

DisplayRecord:
     gosub ShowAddress            'Display the name & address
     gosub DefineCmndWords        'Display the main command words
     gosub ShowTaskLamps          'Display current task lamps
     gosub Elapsed                'Compute & present the elapsed times
     gosub ShowProfile            '[in ShowMbox]
     gosub ShowInstructions
     return


     'NUMERIC FORMATTER: Formats an interger x into a string x$ containing the 
     'number padded out with leading zeros as necessary to make it y digits 
     'long, + an extra leading space or minus sign according to the sign of x.

LeadingZeros:
     x$=str$(x)        'Number x as a string with a leading space or - sign
     x=len(x$)-1
     if x>y then x$=string$(y,"!"):return   'Out of range
     x$=right$(x$,x)
     if x<y then x$=string$(y-x,"0")+x$
     if x<0 then x$="-"+x$ else x$=" "+x$
     return
     '






     'JUMP TO A PROSPECT OF A SPECIFIED LIST N

Jump: IF JumpState=0 THEN return    'Machine idle

     IF JumpState=1 THEN              'If the machine is in State 1, then
        colour=10:column=10
        ps$="Ŀ":row=20:gosub 50
        ps$="Enter List N       ":row=21:gosub 50
        ps$="":row=22:gosub 50
        ps$=space$(40):row=23:column=1:gosub 50
        ps$=" TO JUMPEsc TO CANCELL"+space$(54):colour=112:row=24:gosub 50
        FieldRow=21
        FieldCol=25
        FieldLen=5
        FieldStr$=""
        caps=1:CharCol=1
        EdFieldState=1
        JumpState=2
        END IF

     IF JumpState=2 THEN              'If the machine is in State 2, then
        gosub EdFieldFMM
        if EdFieldState<3 then return   'Field editor not yet terminated.
        EdFieldState=0                  'De-activate it.
        if AmendFlag>0 then             'If the field were amended, then
           TargItem=val(FieldStr$)
           if TargItem<1 or TargItem>TargSize then
              DosMsg$="LIST N OUT OF RANGE"
              DosClr=12:ShowMessages=1
              JumpState=1:return
         else TargItem=TargItem-1
              UpDown=1
              NextPrevState=1              'activate the next record FMM.
              end if
           end if                       '
           DosMsg$="":DosClr=12:ShowMessages=1
           CWPstate=1
           JumpState=0                'de-activate the FMM concerned, and
        END IF
     RETURN

