






     '-------------------------------------------------------------------------
     'STATISTICS PROGRAM              07FEB87                   File: Stati.bas
     '-------------------------------------------------------------------------
     '
     'Author : R J Morton    compile /X
     '
     'This program generates and displays market structual statistics in both
     'tabulated and graphical form.
     '
     '-------------------------------------------------------------------------
     DefInt a-z
     rem $include: 'ComVars.INC'
     '
     dim StatsCount%(6,18)    '(0,x) = Sales areas statistics counter
                              '(1,x) = Relation    statistics counter
                              '(2,x) = Status      statistics counter
                              '(3,x) = Product     statistics counter
                              '(4,x) = Last Event  statistics counter
                              '(5,x) = Next Event  statistics counter
                              '(6,x) = Sales area Populations
     '
     dim Keyvs$(6,18)         '(1,x) = Relation    key name & values
                              '(2,x) = Status      key name & values
                              '(3,x) = Product     key name & values
                              '(4,x) = Last Event  key name & values
                              '(5,x) = Next Event  key name & values
                              '(6,x) = Sales area Populations
     '
     common StatsCount%()
     common Keyvs$()
     common i.max
     common TotPop
     '
     dim a$(18)          'Values assigned to the 'current' key
     dim disp$(9)        'Statistics display array
     dim pp$(10)         'Printer ports & control strings
     dim values$(18)     'For on-line manual
     ManChap=7           'Chapter on Statistics
     RecNum = 0
     goto Initialize
     '
     '-------------------------------------------------------------------------
     'EXTERNAL & LOCAL SUBROUTINES
     '
     rem $include: 'Decrypt.INC'
     rem $include: 'Ppanel.INC'
     rem $include: 'InChar.INC'
     rem $include: 'Expiry.INC'
     rem $include: 'GrafChar.INC'
     rem $include: 'Manual.FMM'
     rem $include: 'Select.FMM'
     rem $include: 'OpenFile.FMM'
     rem $include: 'KeyBoard.FMM'
     '
LeadingZeros:
     ps$=str$(x):ps$=right$(ps$,len(ps$)-1)   'Print the number x in situ at
     ps=len(ps$)
     if ps<5 then ps$=string$(5-ps,"0")+ps$
     '
50   call ScrSub(ps$,row,column,colour):return
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'INITIALIZATION
     '
Initialize: gosub ExpiryTest:caps=1
     '
     '-------------------------------------------------------------------------
     'INPUT & RE-ARRANGE THE KEY NAMES & VALUES FOR STATISTICS DISPLAYS
     '
     retries=0:on error goto FileProblem
     open keyvfile$ as #1 len=346
     for i=0 to 4                       '5 keys
     get#1,i+1                          'Load the next record
     for k=0 to 18                      'K=0 is Key Name; K=1 to A are Key Values
     x=cvi(input$(2,1))                 'Length of key value string
     if x>1 and x<19 then               'If Key value string length in range
        keyvs$(i,k)=input$(x,1)         'Load the key value string
        end if
     next                               'Next key value
     next                               'Next record
     on error goto 0:close
     '
     for k=1 to 18:keyvs$(6,k)=keyvs$(0,k):next
     keyvs$(6,0)="Population"
     for k=0 to 18:keyvs$(5,k)=keyvs$(4,k):next
     for k=0 to 18:keyvs$(4,k)=keyvs$(3,k):next
     keyvs$(4,0)="Next "+keyvs$(3,0)
     keyvs$(3,0)="Last "+keyvs$(3,0)
     '
     '-------------------------------------------------------------------------
     'GET INDEX FILE & MAIN FILE DIMENSION PARAMETERS
     '
     retries=0:on error goto FileProblem
     open NameFile$ as #1 len=16:field#1,8 as f1$,2 as f2$ 
     get#1,1:i.max=cvi(f1$):r.max=cvi(f2$):close
     '
     '-------------------------------------------------------------------------
     'LOAD CURRENT STATISTICS          This needs multi-user error protection
     '
     retries=0:on error goto FileProblem
     open StatFile$ for input as #3
     input#3,x$
     for j=0 to 5
     for x=1 to 18
     input#3,x$:StatsCount%(j,x)=val(x$)
     next:next
     input#3,x$:npc=val(x$)         'Number of addresses with no postcode
     on error goto 0:close
     '
     '-------------------------------------------------------------------------
     'GET SALES AREA POPULATIONS
     '
     retries=0:on error goto FileProblem
     open SapsFile$ for input as #1
     TotPop=0
     for i=1 to 18:input#1,x$:x=val(x$):StatsCount%(6,i)=x:TotPop=TotPop+x:next
     on error goto 0:close
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'LOCAL MENU
     '
Start:if prog$="STREP" then Prog$="STATI":goto OperInstr
     '
     row= 1:column=19:colour=7:ps$=top$:gosub 50
     row= 4:column= 1:ps$=space$(80):gosub 50
     ps$=" Statistics Menu "
     row= 5:colour= 3:gosub DispSub
     row= 6:ps$=space$(80):gosub 50
     row= 7:colour= 7:ps$="Compile Statistics":gosub DispSub
            column=45:colour=11:ps$=" A ":gosub 50
     row= 8:column= 1:colour= 3:ps$="Print statistics":gosub DispSub
            column=45:colour=11:ps$=" B ":gosub 50
     row= 9:column=1:ps$=space$(80):gosub 50
     row=10:colour= 3:ps$="Display statistics":gosub DispSub
            column=44:colour= 2:ps$="TABLE":gosub 50
            column=53          :ps$="GRAPH":gosub 50
     row=11:column=1:ps$=space$(80):gosub 50
     '
     for i=0 to 6
     row=12+i
     ps$=Keyvs$(i,0):ps$=space$(22)+ps$+space$(23-len(ps$)) 
            column= 1:colour= 2:gosub 50
     ps$=chr$(67+i)+"        "+chr$(74+i)+space$(25)
            column=46:colour=11:gosub 50
     next
     row=19:column=1:ps$=space$(80):gosub 50
     '
     '-------------------------------------------------------------------------
     'OPERATOR INSTRUCTIONS
     '
     column=1:colour=grey
     row= 7:ps$="Recompile":gosub 50
     row= 8:ps$="whenever" :gosub 50
     row= 9:ps$="you alter":gosub 50
     row=10:ps$="or extend":gosub 50
     row=11:ps$="Prospects":gosub 50
     row=12:ps$="Database.":gosub 50
     '
OperInstr:
     column=1:colour= 3
     row=20:ps$="[ ] Please type-in letter relating to":gosub DispSub
     row=21:ps$="    the Option you require."          :gosub DispSub
     colour=2
     row=22:ps$=space$(62)+"Press Home to view":gosub 50
     row=23:ps$=space$(62)+" the User Manual. ":gosub 50
     row=22:column=69:colour=14:ps$="Home":gosub 50:column=1
     row=24:colour=2:ps$="    Press Esc to quit Statistics       ":gosub DispSub
     column=31:colour=10:ps$="Esc":gosub 50
     goto Accept
     '
     '-------------------------------------------------------------------------
     '
DispSub: ps$=space$(20)+ps$+space$(60-len(ps$)):goto 50
     '






     '-------------------------------------------------------------------------
     'ACCEPT THE OPTION
     '
Accept:
     locate 20,22:gosub ClrKbdBuf:gosub InChar
     if y=71 then
        ManualState=1
        while ManualState<8
        gosub KeyBoard
        gosub Manual
        wend:goto Start
        end if
     if x=27 then prog$ = "STATI" : RecNum = 0 : chain"Menu"
     if x>32 then print x$;
     MenuChoice=x-64
     row=20:column=13:colour= 4
     if MenuChoice>0 and MenuChoice<17 then
        ps$="     ":gosub 50
        else
        ps$="Wrong":gosub 50:beep:goto Accept
        end if
     if MenuChoice=1 goto CompileStats
     if MenuChoice=2 then chain"StRep"
     if MenuChoice>9 goto BarCharts
     goto DisplayStats
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'COMPILE STATISTICS
     '
CompileStats:
     row=20:ps$=space$(80):gosub 50
     row=21:ps$=space$(80):gosub 50
     row=24:ps$=space$(80):gosub 50 
     '
     row= 1:column=58:colour=grey:ps$="//://":gosub 50   'Mask the clock
     row=11:column=60:ps$="Ŀ":gosub 50
     row=12          :ps$="    COMPILATION    ":gosub 50
     row=13          :ps$="                   ":gosub 50
     row=14          :ps$="Key                ":gosub 50
     row=15          :ps$="Index N           ":gosub 50
     row=16          :ps$="      of           ":gosub 50
     row=17          :ps$="                   ":gosub 50
     row=18          :ps$="                   ":gosub 50
     row=19          :ps$="":gosub 50
     '
     ps$=str$(i.max):ps$=space$(6-len(ps$))+ps$
     row=16:column=70:colour=3:gosub 50
     row=18:column=65:colour= 9:ps$="Please wait":gosub 50
     '
     for j=0 to 5                       'For each key-type
     for k=1 to 18                      'For each key value
     StatsCount%(j,k)=0                 'Clear statistics counter
     next:next:goto CompileSA
     '
     '-------------------------------------------------------------------------
     'STORE THE CURRENT STATISTICS
     '
SaveStats:
     row=17:column=67:colour= 9:ps$="Storing":gosub 50
     on error goto FileProblem
     open StatFile$ for output as #1:print#1,str$(i.max)
     for j=0 to 5
     for x=1 to 18
     print#1,str$(StatsCount%(j,x))
     next:next
     print#1,str$(npc)
     on error goto 0:close
     column=60:ps$="                     "  'Wipe compillation box
     for row=11 to 19:gosub 50:next
     goto OperInstr
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'COMPILE SALES AREA STATISTICS
     '
CompileSA:
     ps$=Keyvs$(0,0)                       'Show Key title `Sales Areas'
     row=14:column=65:colour=3:gosub 50
     '
     retries=0:on error goto FileProblem
     open PostFile$ as #1 len=16:field#1,8 as f1$,2 as f2$
     open AreaFile$ as #2 len=202:field#2,2 as f3$,200 as f4$
     '
     '-------------------------------------------------------------------------
     npc=0                      'Non-postcoded addresses counter
     i=1                  'Prospect's postcode index within postcode index file
     row=15:column=71:ps$="      ":gosub 50
CompileSA0:
     i=i+1:if i>i.max then on error goto 0:close:goto CompileKeys   'Exit
     ps$=str$(i):column=76-len(ps$):gosub 50    'Display index
     '
     get#1,i+1:a$=left$(f1$,2)  'Get the [next] prospect's two-letter Area Code
     if a$="  " _               'If Area Code is blank, then
        then npc=npc+1:_        'increment number of un-postcoded addresses
        goto CompileSA0         'Next prospect's postcode index entry
     '
     j=0                        'Sequence N of the current sales area
CompileSA1:
     j=j+1:if j>18 goto CompileSA0    '18 possible sales areas
     get#2,j:b=cvi(f3$)               'Get N of post areas in this sales area
     if b<1 or b>100 goto CompileSA1  'Undefined sales area, so next sales area
     '
     '-------------------------------------------------------------------------
     'Take each of the two-letter post area codes of the post areas which
     'make up the sales area currently under test and compare it with the
     'first two letters of the current prospect's postcode. If it matches,
     'increment the number of prospects found in this sales area, then move
     'on to consider the next prospect.
     '
     k=0                             'N of post area within current sales area
CompileSA2:
     k=k+1:if k>b goto CompileSA1    '`b' = N of post areas in this sales area
     x$=mid$(f4$,k+k-1,2)            'Get the two-letter Post Area code
     '
     if a$<>x$ goto CompileSA2       'Not same as prospect's so try next one
     '
     'Post area from current sales area's group is same as current prospect's
     'post area, so increment the N of prospects found in this sales area
     'area, then move on to consider the next prospect.
     '
     StatsCount%(0,j)=StatsCount%(0,j)+1:goto CompileSA0
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'COMPILE KEY STATISTICS
     '
CompileKeys:
     ps$="Key Values     "
     row=14:column=65:colour=3:gosub 50
     ps$=str$(r.max):ps$=space$(6-len(ps$))+ps$
     row=16:column=70:colour=3:gosub 50
     row=15:column=71:ps$="      ":gosub 50
     '
     retries=0:on error goto FileProblem
     open KeysFile$ as #1 len=8:field#1,4 as f1$,4 as f2$
     open AttrFile$ as #2 len=16:field#2,16 as f3$
     for i=1 to r.max
     ps$=str$(i):column=76-len(ps$):gosub 50    'Display index
     '
     get#1,i                          'Get prospect's key values string
     x=asc(mid$(f2$,2,1))-64          'Get the record's status key value
     if x>0 and x<19 then             'If the record is occupied, then
        for j=1 to 4
        x=asc(mid$(f2$,j,1))-64       'Extract N 1-18 of next key value
        if x>0 and x<19 then     _    'If key value valid, increment N
           StatsCount%(j,x)=     _    'of prospects found to have it
           StatsCount%(j,x)+1
        next
        get#2,i                       'Get prospect's attribute string
        for k=1 to 16                 '16 attribute values
        x=asc(mid$(f3$,k,1))-64       'Extract N 1-18 of next attribute value
        if x>0 and x<19 then     _    'If attribute valid, increment N
           StatsCount%(5,x)=     _    'of prospects found to have it
           StatsCount%(5,x)+1
        next
        end if
     next
     on error goto 0:close:goto SaveStats
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'SET UP THE STATISTICS DATA FOR DISPLAY
     '
DisplayStats:
     MenuChoice=MenuChoice-3:gosub GetSAP
     '
     ProspCount=0
     for k=1 to 9
     '
     if a$(k  )>"" then                _     'If the key value is defined, then
        y1=StatsCount%(MenuChoice,k  ) _     'get N of prospects [left column]
       :y1$=str$(y1)                   _
        else y1=0:y1$=""

     if a$(k+9)>"" then                _
        y2=StatsCount%(MenuChoice,k+9) _     'N prospects [right col]
       :y2$=str$(y2)                   _
        else y2=0:y2$=""
     '
     if MenuChoice=0 _
        then ProspCount=ProspCount+y1+y2 'Running total of sales area prospects
     '
     y=y1:gosub CalcPercent:z1$=z$       'Calculate percentage
     y=y2:gosub CalcPercent:z2$=z$       'Calculate percentage
     '
     if MenuChoice=6 _
        then y1$=y1$+"k":_               'x1000 if sales area pops
             y2$=y2$+"k"                 'x1000 if sales area pops
     '
     x1$=left$(a$(k  ),16)
     x2$=left$(a$(k+9),16)
     '
     Disp$(k)=space$(9)+x1$+space$(21-len(x1$)-len(y1$))+y1$_
             +space$(5-len(z1$))+z1$_
             +space$(10)+x2$+space$(21-len(x2$)-len(y2$))+y2$_
             +space$(5-len(z2$))+z2$
     next
     '
     '-------------------------------------------------------------------------
     'DISPLAY STATISTICS TABLE
     '
     column=1
     x$=" "+Keyvs$(MenuChoice,0)+" Statistics "  'Print type of Statistics
     x=62-len(x$):y=x/2:x=x-y                    'display, padded appropriately 
     ps$=space$(9)+string$(x,196)+x$_            'each side with a solid line.
        +string$(y,196)+space$(9)               
     row= 5:colour= 3:gosub 50 
     '
     row= 6:ps$=space$(80):gosub 50
     '
     ps$="         Key Values       Refs   %% "_ 'Display the two sets of 
        +"         Key Values       Refs   %%         " 
     row=7:colour= 2:gosub 50      'column headings.
     row=8:ps$=space$(80):gosub 50
     '
     colour=3:for k=1 to 9:ps$=Disp$(k):row=8+k:gosub 50:next
     '
     row=18:ps$=space$(80):gosub 50
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'UNPOSTCODED ADDRESSES AND INVALID POSTCODES
     '
     if MenuChoice>0 or i.max=0 _
        then row=19:ps$=space$(80):gosub 50:_
             goto FootNotes
     '
     ps$="":if npc>0 then ps$=str$(npc)+" Missing postcodes "
     '
     ipc=i.max-ProspCount-npc
     if ipc>0 _
        then ps$=ps$+str$(ipc)+" Postcodes not found in any "+Keyvs$(0,0)
     '
     x=80-len(ps$):y=x/2
     ps$=space$(y)+ps$+space$(x-y):colour=grey:row=19:gosub 50
     '
     '-------------------------------------------------------------------------
     'FOOTNOTES
     '
FootNotes:
     row=20:ps$=space$(80):gosub 50
     row=21:colour= 2
     if MenuChoice=6 then                  'Population display
        ps$=" Refs = Number of U.K. Postal Addresses " _
           +" located in each respective Sales Area  "
        gosub 50
        x$=str$(TotPop):x=len(x$)
        ps$="   %% = The above as a percentage of the" _
           +space$(x)+"k addresses within the U.K."
        row=22:gosub 50:column=41:colour=10:ps$=x$:gosub 50
        else
        ps$=" Refs = Number of Prospects on file "
        if MenuChoice=0 _
           then ps$=ps$+"located within each respective Sales Area   " _
           else ps$=ps$+"having each respective value of this key:   "
        gosub 50
        ps$="  %% = This expressed as a percentage of the "_
           +"00000 Prospects currently on-file  "
        row=22:gosub 50:column=46:colour=10:x=i.max:gosub LeadingZeros
        end if
     '
     row=23:ps$=space$(80):gosub 50
     ps$=space$(21)+"Press Esc to return to Statistics Menu"+space$(21)
     row=24:column= 1:colour= 2          :gosub 50
            column=28:colour=10:ps$="Esc":gosub 50
     '
     locate 24,60:gosub ClrKbdBuf    'Position cursor & clear keyboard buffer
     gosub InChar:goto Start         'Await a character input
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'BAR CHARTS
     '
BarCharts:
     MenuChoice=MenuChoice-10:gosub GetSAP
     screen 1:color 1,0:color ,0
     kf=1:x=0:y=2:ps$="E.B.S. MARKETEER":gosub GrafChar
     line(0,10)-(75,10),2                               'Underscore
     '
     '-------------------------------------------------------------------------
     'DETERMINE THE VERTICAL SCALING FACTOR
     '
     if MenuChoice=0 then               'If showing population chart, then
        MenuChoice=6:gosub SetScale     'Get scale for prospect-popul'ns
        temp=skale
        MenuChoice=0:gosub SetScale     'Get scale for total populations
        if skale>temp then skale=temp   'Use the smaller scaling factor
        else gosub SetScale             'Set scale for other types of chart
        end if
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE SCALE
     '
     x=14
     kf=2:line(x,49)-(x,148),kf
     Alpha!=10/skale:ii=int(Alpha!)
     '
     for i=0 to ii
     Alpha!=145-10*i*skale:y=int(Alpha!)
     '
     ps$=chr$(i+48)+"0-":x=3
     if i= 0 then ps$= " 0-"
     if i= 1 then ps$= "10-":x=6
     if i=10 then ps$="100-":x=1  
     '
     gosub GrafChar:next
     '
     '-------------------------------------------------------------------------
     'POPULATION BACKGROUND FOR SALES AREA BAR CHART
     '
     if MenuChoice=0 then
        x=21:kf=1:MenuChoice=6           'Switch to TotPop index value
        for q=1 to 18
        if a$(q)>"" then
           y=StatsCount%(MenuChoice,q)
           gosub CalcPercent
           Alpha!=148-skale*y:y=int(Alpha!)
           line(x,148)-(x+6,y),2,bf
           end if
        x=x+10:y=152:next:MenuChoice=0
        end if
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'PLOT EACH BAR
     '
     x=19:kf=1:wi=7
     if MenuChoice=0 then wi=6
     for q=1 to 18
     '
     if a$(q)>"" then
        y=StatsCount%(MenuChoice,q)
        gosub CalcPercent
        Alpha!=148-skale*y
        y=int(Alpha!)
        line(x,148)-(x+wi,y),kf,bf
        end if
        '
     x=x+1:y=152:z=x
     ps$=chr$(64+q):gosub GrafChar          'Bar identification letter
     x=z+9:next
     '
     '-------------------------------------------------------------------------
     'DISPLAY TITLE OF THIS BAR CHART
     '
     if MenuChoice=0 then               'Sales area bars
        x=0:y=18:ps$="Percentage of Prospects in green":gosub GrafChar
        x=0:y=28:ps$="vs percentage population in red.":gosub GrafChar
        x=0:y=38:ps$="     in each "+Keyvs$(0,0)       :gosub GrafChar
     '
 elseif MenuChoice=6 then               'Population bars, else one of the keys
        x=20:y=25:ps$="Percentage of population" :gosub GrafChar
        x=20:y=35:ps$="     in each "+Keyvs$(0,0):gosub GrafChar
        else
        x=20:y=25:ps$="Percentage of Prospects"  :gosub GrafChar
        x=20:y=35:ps$="holding each Key Value"   :gosub GrafChar
        end if
     '
     '-------------------------------------------------------------------------
     'DISPLAY THE KEY (LIST OF KEY VALUES)
     '
     y=4:x=205:z=8
     if MenuChoice=0 or MenuChoice=6 _
        then ps$=Keyvs$(MenuChoice,0) else ps$="Key Values"
     gosub GrafChar:y=16:z=6
     for q=1 to 18
     '
     if a$(q)>"" then
        x=205:ps$=chr$(64+q)
        gosub GrafChar
        x=x+4:line(x,y+3)-(x+2,y+3)
        end if
     '
     x=x+8:ps$=a$(q):gosub GrafChar
     y=y+8:next
     '
     '-------------------------------------------------------------------------
     'OPERATOR INSTRUCTIONS
     '
     locate 22:x$=Keyvs$(MenuChoice,0):print spc((29-len(x$))/2)x$" Statistics"
     locate 24,1:print"  Press Esc to regain statistics menu: ";
     gosub ClrKbdBuf 
     x$=""
     while x$=""
     x$=inkey$
     if x$="S" then                    'Save the screen image in the file
        def seg = &HB800               'Image.BIN in the root directory.
        Bsave"\Image.BIN",0,&H4000     '
        def seg:x$=""
        end if
     wend
     screen 0:width 80
     locate,,0
     colour= 7:row=1:column=1:ps$="E.B.S. MARKETEER"+space$(49)+sd$:gosub 50
     SysTime$="":goto Start
     '
     '-------------------------------------------------------------------------
     '






     '-------------------------------------------------------------------------
     'CHECK THAT POPULATION BARS ARE NOT BEYOND SCALE
     '
SetScale:
     if MenuChoice=6 then TotPop!=TotPop else TotPop!=i.max
     y=0:skale=1
     for k=1 to 18
     x=StatsCount%(MenuChoice,k):if x>y then y=x
     next
     if TotPop!=0 then
        y=0
        else Alpha!=y:Alpha!=100*Alpha!/TotPop!:y=int(Alpha!)
        end if
     if y<50 then skale=2
     if y<33 then skale=3
     if y<25 then skale=4
     if y<20 then skale=5
     return
     '
     '-------------------------------------------------------------------------
     'PERCENTAGE CALCULATION
     '
CalcPercent:
     if MenuChoice=6 then TotPop!=TotPop else TotPop!=i.max
     if TotPop!=0 then
        y=0
        else Alpha!=y:Alpha!=100*Alpha!/TotPop!:y=int(Alpha!)
        end if
     z$=str$(y):return
     '
     '-------------------------------------------------------------------------
     'GET ONE KEY'S SET OF VALUES INTO A$( )
     '
GetSAP:
     a$(0)=Keyvs$(b,0):for i=1 to 18:a$(i)=Keyvs$(MenuChoice,i):next
     return
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'MULTI-USER PROTECTION {NOT A SUBROUTINE}
     '
FileProblem:
     if Retries<20 and inkey$<>chr$(27) then
        ps$="Trying to open a disk file"
        row=3:column=43:colour=14:gosub 50
        retries=retries+1
        timeout=5                       'Delay 4 to 5 seconds
        while timeout>0
        timeout=timeout-1               'and then try again
        Tyme$=Time$
        while Tyme$=time$:wend          'to open the file.
        wend
        ps$="                          "
        row=3:column=43:colour=14:gosub 50
        resume
        end if
     '
     '-------------------------------------------------------------------------
     'NINE AUTOMATIC RETRIES HAVE BEEN MADE, SO MANUAL INTERVENTION REQUIRED
     '
     row=5          :colour= 2:ps$="Press CR to try again":gosub 50
     row=6:                    ps$="Press Esc to abort"   :gosub 50
     row=5:column=49:colour=10:ps$=chr$(17)+chr$(217)     :gosub 50
     row=6                    :ps$="Esc"                  :gosub 50
     gosub ClrKbdBuf
     '
     gosub InChar
     row=3:column=43:ps$=space$(36):gosub 50
     row=5                         :gosub 50
     row=6                         :gosub 50 
     '
     if x=13 then resume                'Manual instruction to try again
     resume FileProblem5
FileProblem5:
     on error goto 0:close:goto Start  'Give up trying
     '
     '-------------------------------------------------------------------------
     '
