





     'EMAIL/TELEX OUTGOING CALL HANDLER  by R J Morton  15NOV88 File: Telex.Bas 

     'This program provides the processing necessary for the sending of a
     'pre-selected message to a specified individual electronic mail or
     'telex subscriber, or to a target group of such subscribers.
     'For load module FMM processing structure, see FMM.DOC file.

     DefInt a-z                  'Default numeric variable = 16-bit interger
     rem $include: 'ComVars.INC' 'Marketeers universal common variables
     common ems$,ems             'Electronic mail service N, service name
     common em                   'Emenu commons


     'DEFINITION & ARRAY DIMENSIONING

     dim Macro$(20)            'Holds the communications macro lines
     dim tty$(31)              'Teletype control code mnemonics
     dim pp$(20)               'Printer control strings
     dim CMDW$(10)             'Holds current set of command words
     dim task$(5)              'Holds the current set of tasks
     dim rec$(12)              'Contains the current name & address details
     dim TempRec$(12)          'To appease EdBox.FMM
     dim EMSD$(6)              'Subscriber data
     dim keyvs$(4,18)          'Referred to by GetRec & PutRec.
     dim values$(18)           'For use by the Manual FMM
     dim Fields$(12)           'For use by NotesIO.FMM for updating notes
     dim Stamps$(12)

     'BUFFER ALLOCATIONS FOR THE FILES USED BY THIS MODULE

     RecsFileNum=1     'Main prospect records
     AreaFileNum=2     'For finding which sales area a prospect is in
     KeysFileNum=1     'Contains prospect's selecion keys
     DateFileNum=1     'Dates of his last and next-planned events
     IndxFileNum=1     'Namecode or Postcode index depending on type of search
     TxFileNum  =1     'Sequential text file containing the message text
     TxRecLen=1024     '1k input block for getting message from message file
     PrtBufNum  =3     'Printer channel opened as a file
     MoFileNum  =4     'Modem I/O port File Buffer N
     MaxStack=255      'Max length of inter-process stack strings
     ManChap=11        'Relevant chapter of the manual

     'SET UP VARIOUS CONSTANTS FOR THIS MODULE

     TickRo1=12        'Screen row on which Modem I/O ticker tape display shown
     TickRo2=13        'Screen row on which Modem I/O ticker tape display shown
     TickCol=57        'First column for the above
     TickClr=23        'Colour in which the ticker tape text is displayed
     PrtType$="LQ"               'Set printer port for matrix printer
     ComType$="EMAIL"            'Set modem for `Terminal Mode' operation and
     ListFile$=TelxList$         'Path/Filespec of the Telex Calling List file
     LastMacroLine=10            'The whole macro procedure is to be used.
     CrLf$=chr$(13)+chr$(10)     'New-Line string as found in text files
     FinalThrow$=""              'No page throw at end of message tail
     NewLine$=CrLf$              'New-line string for outgoing telexes
     BlankLine$="     "+NewLine$ 'Blank line hold character for telexes

     LocalHelp = 10
     if op = 2 then
        TelxShotFlag = 1
        TimeStamp = 1
        LocalHelp = 13
        RecNum = 0
     end if
     row=1:column=19:colour=7:ps$="TELEX/EMAIL/FAX   ":gosub 50   'Module name
     '





     'SET UP INITIAL SCREEN DISPLAYS & INITIALIZE FINITE STATE MACHINE POLLING

     LeftBox$="":gosub ShowAbox    'Display the name & address box
     gosub StatusBoxDisplay    'Modem/printer status messages box etc.
     gosub ClearBottomLeftWindow
     SearchFieldNum = 2                 'Namecode is default search key
     SearchState = 1
     gosub ClearBottomRightWindow
     SearchState = 0
     gosub DefineCmndWords     'Set up command words used in this section
     gosub ShowTasks           'Display the Task List panel
     locate 24,1,0             'place cursor at bottom left of screen
     gosub ExpiryTest          'Protection lock
     '
     TelxInitState = 1      'Kick-statrt the initialization FMM hierarchy
     cmdl          = 4      'Number of characters in command word field
     MessagesVisible=1      'Enable the messages diaplay routine
     LampsVisible   =1      'Enable task-lamps display
     echo          =14      'Default: set to `remote' echo
     connect       = 8      'Call initially not connected
     TxOffLamp     = 8      'Set to X-on [computer to modem]
     RxOffLamp     = 8      'Set to X-on [modem to computer]
     caps = 1               'To cater for typing ahead a namecode etc
     ACTIVE = -1            'Activate the FMM polling loop


     'THE FINITE STATE MACHINE POLLING LOOP

     While ACTIVE
     if CallCtrlState = 0 then
        gosub Initializer    'Transfer of control from initialization
        gosub Search         'Record retrieval control FMM [Resident]
        gosub NextPrevFMM    'Get next/previous subscriber on request
        gosub LoadRecord     'Record loader FMM
        gosub HelpFMM        'Help Screen Processor FMM
        gosub Trip           'Keystroke-triggered trip out of help screen
        end if
     gosub Keyboard          'Add incoming chrs from keyboard to buffer str
     gosub ModemIO           'Modem character & command input/output FMM
     gosub CWPFMM            'Command Word Processor FMM
     gosub CWPfkeys          'Act on CWP fkey value if present
     gosub CallCtrl          'Call Control supervisor FMM
     gosub StakProc          'Inter-stack transfers processor
     gosub PrintIO           'Printer input/output FMM
     gosub PrtrCtrl          'Check printer integrity
     gosub OpenFileFMM       'General File Opening FMM
     gosub Manual            'Access the on-line user manual
     gosub QuitLoop          'Means of escape from the FMM polling loop
     gosub ShowMessages        'Display the modem status messages
     gosub EmergencyMessage    'Display the modem malfunction warning message
     gosub ShowCallResult      'Display call result message
     wend

     'TERMINATION & EXIT FROM THIS OVERLAY

     ps$=space$(40):row=4:column=41:gosub 50    'Wipe possible error message
     ps$=space$(80):row=2:column= 1:gosub 50    'Wipe possible overflow msg.
     gosub WipeV24Lamps                    'Wipe RTS DTR DCD RI DSR CTS display
     FileNum=0:gosub CloseFile
     prog$="TELEX"                         'Set where control came from
     if ExitPath=1 then chain"Menu"
     chain"Emenu"                          'Exit this load module; got back to menu
     '





     'EXTERNAL SUBROUTINE

Display: row=row+1
50   call ScrSub(ps$,row,column,colour)   'Display as is
     return

     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE

     '$include: 'TelxInit.FMM'       'THE INITIALIZATION GROUP
     '$include: 'GetPrt.FMM'
     '$include: 'GetTTY.FMM'
     '$include: 'GetSigna.FMM'
     '$include: 'MsgTitle.FMM'
     '$include: 'GetMacro.FMM'
     '$include: 'GetEMSD.FMM'
     '$include: 'SubstMac.FMM'
     '
     '$include: 'Keyboard.FMM'       'THE GENERAL INPUT/OUTPUT GROUP
     '$include: 'ADM10.FMM'          'Modem currently in use
     '$include: 'PrintIO.FMM'
     '
     '$include: 'Find.FMM'           'THE RECORD RETRIEVAL GROUP
     '$include: 'RecordIO.FMM'
     '$include: 'EdBox.FMM'
     '$include: 'EdField.FMM'
     '$include: 'KeysIO.FMM'
     '$include: 'DateIO.FMM'
     '$include: 'MakeNote.FMM'
     '$include: 'NotesIO.FMM'
     '$include: 'LoadRec.FMM'
     '$include: 'UpdtRec.FMM'
     '$include: 'SaveDate.FMM'
     '$include: 'ListGeIO.FMM'
     '$include: 'UpdtKeys.FMM'
     '$include: 'AmendKey.FMM'
     '$include: 'OpenFile.FMM'
     '
     '$include: 'CallCtrl.FMM'       'THE CALL PROCESSING GROUP
     '$include: 'DataDial.FMM'
     '$include: 'Supercol.FMM'
     '$include: 'Protocol.FMM'
     '$include: 'SendTelx.FMM'
     '$include: 'TelxHedr.INC'
     '$include: 'NextTelx.FMM'
     '$include: 'KillCall.FMM'

     '$include: 'FuncKeys.FMM'       'OTHERS
     '$include: 'GetHelp.FMM'
     '$include: 'ShowAbox.INC'
                'ShowStat.INC'       Was used in pioneering FMM principles
     '$include: 'TelexNum.INC'
     '$include: 'Expiry.INC'
     '$include: 'Decrypt.INC'
     '$include: 'ValiPost.INC'
     '$include: 'TexCrypt.INC'
     '$include: 'Manual.FMM'
     '$include: 'Select.FMM'
     '$include: 'PrDriver.INC'
     '



                                                                               

     'SEACH CONTROL FMM FOR RETRIEVING AN INDIVIDUAL PROSPECT RECORD

Search:
     if SearchState = 0 then return
     gosub FindRecord                   'Search Key Entry/Record Search FMM
     gosub OpenIndexFile                'Index File Opener+get index parameters
     gosub GetKeysRecord                'Gets retrieved record's status keys
     gosub EdBox
     on SearchState goto Search1, Search2, Search3
ShowProfile:                            'Dummy for EdBox.FMM
     return

Search1:
     gosub ShowTasks                    'Display the Task List panel
     Task = 0                           'Clear the task lamps
     EdBoxState = 1                     'Activate Search Key Entry processes
     SearchState = 2                    'Set to await completion of Key Entry
     return

Search2:
     if FindRecState = 3 then           'Await completion of search key entry
        PrevIndexType = IndexType       'Preserve search index type
        Task = 1                        'Light the SEEKING lamp
        ps$ = str$(RecNum)
        on PrevIndexType + 1 gosub  _   'According to type of search,
           ShowRefNumber,           _   'Display REFerence number
           ShowNamecode,            _   'Highlight namecode while searching
           ShowPostcode                 'Highlight postcode while searching
        SearchState = 3                 'advance to search process supervision
        gosub ClearBottomRightWindow    'Display search/load FMM display panel
     elseif FindRecState = 6 then       'If entry aborted or Esc key pressed
        FindRecState = 0                'De-activate Record Retrieval Utility
        QuitFlag = 1                    'Set for quitting this load module
     end if
     return
     '
Search3:
     if FindRecState < 5 then return    'If the required record not yet found
     if FindRecState = 5 then           'If required record has been found OK,
        FindRecState = 0                'De-activate record retrieval utility
        LoadRecordState = 1             'Activate the record loader
        SearchState = 0                 'De-activate the Search FMM
     else
        SearchState = 1                 'then return to initial search state.
     end if
     return                             'Return control to FMM polling loop.
     '





     'TRANSFER PROTOCOL RESPONSES ONTO THE TRANSMISSION STACK
     'AND RECEIVED CHARACTERS TO PRINT & DISPLAY STACKS

     'This routine transfers received characters from the Receive Stack RxStr$
     'to the Printer Stack PrStr$. However, if the printer cannot handle
     'chars fast enough to keep up with the line and as a result, PrStr$
     'becomes full, the display is also held up and no more characters are
     'taken from RxStr$ until the printer catches up. If the incoming text
     'is to be displayed but not printed (ie when PrinterSwitch=0) then the
     'characters are simply passed to the ticker tape display routine.

StakProc:  'THIS ROUTINE MUST BE AFTER MODEM.FMM & PROTOCOL.FMM IN POLLING LOOP

     if Response$>"" and   _  'If there is a protocol response to send, and
        len(TxStr$)<255 then  'there's space on the transmission stack, then
        TxChar$=Response$     'put it into the transmission block variable
        gosub ModemEF         'and transfer it onto the transmission stack
        Response$=""          'then clear the response string for next pass.
        end if
     x=len(CharsSent$):for k=1 to x     'For each chr in CharsSent$
     TickTape1$=right$(TickTape1$,21)_  'Shift all characters 1 position left
               +mid$(CharsSent$,k,1)    'within the ticker-tape display field.
     gosub TickTape1:next:CharsSent$="" 'Display ticker tape field (Modem I/O)

     If RxStr$="" then return    'Do not proceed if no received data is waiting
     if PrinterSwitch=1 and  _
       (len(PrStr$)>MaxStack _   'or the Printer Stack full
        or PrintIOstate<>3   _   'or the printer is not ready to print
        or PrCTS=0) then return  'or the printer is `not clear to send'.

     'Note: PrintIO.FMM forces PrCTS to 1 unconditionally for parallel printer.

     x=instr(RxStr$,chr$(25))       'Look for End-of-Media character
     if x>0 then EndOfCall=1        'If EM chr found, set the End-of-Call flag

     if PrinterSwitch=1 then        'If inbound characters to be printed, then
        if EndOfCall =0 then        'if EM chr not found in inbound stream,
           PrStr$=PrStr$+RxStr$     'add all received chrs onto printer stack
      else PrStr$=PrStr$+left$(RxStr$,x-1)  
           PrinterSwitch=0          'add only upto the chr before the EM
           end if                   'and disengage the printer output
        end if

     if ProtocolState>0 then     _  'If the Protocol FMM is active, then
        PromptIn$=RxStr$            'transfer received data to Protocol FMM

     'Note: Control characters like CR LF FF do not need to be substituted here
     'because when displayed via ScrSub, they are automatically substituted
     'for displayed symbols and don't invoke their actual control functions.

     x=len(RxStr$):for k=1 to x          'For each chr in RxStr$
     TickTape2$=right$(TickTape2$,21)_   'Shift all characters 1 position left
               +mid$(RxStr$,k,1)         'within the ticker-tape display field.
     gosub TickTape2:next:RxStr$=""      'Display ticker tape field (Modem I/O)
     return                              'Clear RxStr$ ready for next pass.

TickTape1: call ScrSub(TickTape1$,TickRo1,TickCol,TickClr):return
TickTape2: call ScrSub(TickTape2$,TickRo2,TickCol,TickClr):return
     '





     'KEY-INITIATED EXIT FROM HELP SCREEN

     'Unfortunately, striking a key is the only practical means of exiting the
     'Help Screen. Therefore, this routine has to be somewhat specific to the
     'main program in that it has to test the state of the Help FMM. If the
     'Help FMM is active, this routine therefore re-displays the main screen
     'and de-activates the Help FMM. In this event, the character struck is
     'not regarded as part of a command input, but is ignored.

Trip:if HelpState>3 then
        gosub TripSub
        if help=4 then           'If Record Retrieval Help Screen was displayed 
           gosub ShowTasks
           SearchState=1         'then re-activate the Record Retrieval FMM
           gosub ClearBottomRightWindow
      else gosub DisplayRecord   'Re-display the record
           end if 
        HelpState=0
        end if
     if ManualState=8 then
        gosub TripSub
        gosub DisplayRecord      'Re-display the record
        ManualState=0
        end if
     return                      'Return control to FMM polling loop.
TripSub:
     MessagesVisible=1        'Enable Modem/Printer/DOS messages display
     LampsVisible=1           'Enable task-lamps display
     LeftBox$="":gosub ShowAbox   'Re-display the name & address box
     gosub StatusBoxDisplay   'Box for modem/printer status messages
     gosub ClearBottomRightWindow
     gosub ShowServiceName    'Show Email Service name & message title
     gosub TickTape1          'Re-display the modem outbound
     gosub TickTape2          'Re-display the modem inbound
     ShowMessages=1           'Trigger a display of the messages
     return
     '





     'COMMAND EXECUTOR

     'When a keyboard command has been entered, the Command Word Processor FMM
     'sets a value in CWPfkey corresponding to the command entered. This routine
     'initiates the processes required to execute the entered command.

CWPfkeys:
     if CWPfkey=0 then return           'Return control to the FMM polling loop
     ps$="              "
     row=4:column=26:colour=7:gosub 50  'Clear `Call completed' msg
     DosMsg$="":DosClr=12               'Clear general error message field
     ShowMessages=1                     'Activate message display routine

     if CWPfkey=99 then ACTIVE=0:ExitPath=1:return
     if CWPfkey=3 then updown= 1:goto CWPfkeys2  'NEXT
     if CWPfkey=4 then updown=-1:goto CWPfkeys2  'PREV

     if CWPfkey=1 and _           'Help text
        CallCtrlState=0 then
        MessagesVisible=0         'Enable modem/printer/DOS messages display
        LampsVisible=0            'Disable task lamp display
        help=LocalHelp            'Help screen for single-shot Telex calls
        HelpState=1:goto CWPfkeys1'Set the HelpFMM state to `initializing'
        end if

     CWPstate=1                   'Re-activate the Command Word Processor FMM
     if CWPfkey=5 then            'If the `PRNT' command were entered,
        ManualNext=1              'Suppress cyclic list scanning
        PrtrCtrlState=1           'Activate the Call Control FMM via watchdog
        CallCtrlState=1           'activate the Call Control Supervisor FMM
        DontSend = 1
 elseif CWPfkey=6 then            'If the `SEND' command were entered,
        ManualNext=1              'Suppress cyclic list scanning
        PrtrCtrlState=1           'Activate the Call Control FMM via watchdog
        CallCtrlState=1           'activate the Call Control Supervisor FMM
        DontSend = 0
 elseif CWPfkey=2 then            'If the `QUIT' command was entered,
        QuitFlag=1                'Set up a `quit' request
 elseif CWPfkey=10 then           'If the `KILL' command were entered, then
        CallCtrlState=4           'Shift Call Control State FMM to Call Release
   else beep                      'Bum keystroke
        end if
CWPfkeys1: CWPfkey=0:return       'Clear to avoid a repeat next pass

CWPfkeys2:
     if TelxShotFlag=1 then
        NextTelxState=1
 elseif CallCtrlState=0 then      'and a Telex Call is not in progress
        NextPrevState=1           'activate the next/previous record search FMM
        end if
     CWPfkey=0:return             'Clear to avoid a repeat next pass
     '





     'GET NEXT/PREVIOUS RECORD [FMM]

NextPrevFMM: IF NextPrevState=0 THEN RETURN

     gosub FindNextRec
     gosub OpenIndexFile              'Index File Opener + get index parameters
     gosub GetKeysRecord              'Gets the retrieved record's status keys

     IF NextPrevState=1 THEN
        if CallCtrlState=0 then       'A call is not in progress
           gosub ClearBottomRightWindow
           task=1                     'Light SEEKING lamp
           IndexType=PrevIndexType    'N of index used to retrieve last record
           FindNextState=1            'Activate Next/Prev record retrieval FMM
           NextPrevState=2            'Advance to the Wait State
    elseif CallCtrlState<4 then       'If not in the process of releasing the
           CallCtrlState=4            'call, then initiate a call release
           end if

 elseIF NextPrevState=2 THEN
        if FindNextState=4 then       'If next/previous record has been found
           FindNextState=0            'De-activate Next/Prev search FMM
           UpDown=0                   'Clear `get next/previous record' request
           NextPrevState=0            'De-activate Next/prev search manager FMM
           LoadRecordState=1          'Activate record loader
    elseif FindNextState=5 then       'If no record found, or error occurred,
           FindNextState=0            'De-activate Next/Prev search FMM
           UpDown=0                   'Clear `get next/previous record' request
           NextPrevState=0            'De-activate Next/prev search manager FMM
           LeftBox$="":gosub ShowAbox     'then re-display name & address box
           end if                     'in order to clear it,
        END IF

     RETURN                           'Return control to the FMM polling loop.
     '





     'LOAD THE RETRIEVED RECORD

     'Uses LoadRec.FMM RecordIO.FMM and GetAreas.FMM to load the required 
     'prospect record, and then displays the record in the name & address
     'box. Also lights the task lamps as appropriate.

     'State 8: successful termination
     'State 9: error termination

LoadRecord: if LoadRecordState=0 then return   'Load Record FMM idle


     'LOAD THE RETRIEVED RECORD

     IF LoadRecordState=1 THEN
        task=2                       'Kill `seek' lamp/light the LOADING lamp
        LoadRecState=1               'Activate Record Loading Supervisor FMM
        LoadRecordState=2            'Advance self to next state
        END IF                       'Return (indirectly) to FMM polling loop


     'LOAD THE RETRIEVED RECORD

     IF LoadRecordState=2 THEN
        gosub LoadRec                   'Record loading supervisor FMM
        gosub RecordIO                  'Prospect Record Input/Output FMM
        gosub GetAreas                  'Sales Area search FMM
        if LoadRecState<6 then return   'If required record not yet loaded
        task=0                          'Clear the `load' lamps
        if LoadRecState=6 then          'If required record not yet loaded
           LoadRecState=0               'De-activate the record load supervisor
           LoadRecordState=8            'Go to successful termination state
           if TelxInitState=0 then      'If not `own' record being loaded, then
              if TelxShotFlag=0 then    'If single shot telex mode
                 LoadRecordState=0      'then de-activate self
                 end if
              gosub ExtrAddressee       'Extract Addressee name
              gosub ExtrTelexNum        'Extract Telex/Emailbox number
              gosub DisplayRecord       'Display the Prospect Record
              end if
      else LoadRecState=0               'De-activate record load supervisor
           SearchState=1                'activate Command Word Processor FMM
           LoadRecordState=9            'go to error termination state
           end if
        END IF

     RETURN                             'Return control to FMM polling loop.
     '





     'DISPLAY RETRIEVED RECORD

DisplayRecord:
     gosub ShowAddress            'Display the name & address
     gosub DefineCmndWords        'Display the main command words
     task=0                       'Light the READY lamp
     CWPstate=1                   'Activate the command processor
     return


     'FORM THE ADDRESSEE DETAILS LINE FOR THE TELEX MESSAGE

ExtrAddressee:
     x$="*"                   'Set up comment delimiter character
     y$=rec$( 1)              'Get the addressee Company Name
     gosub ExtrAddressee1     'Strip possible comments off it
     ToWhom$=y$               'Set it in the Telex `To Whom' variable
     y$=rec$(10)              'Get the addressee Contact's Name
     gosub ExtrAddressee1     'Get de-commented Contact Name
     x$="("                   'Set up familiar name delimiter character
     gosub ExtrAddressee1     'Strip off the familiar name
     ToWhom$=y$+":"+ToWhom$   'Add Contact name plus separator
     return

ExtrAddressee1:
     x=instr(y$,x$)               'Find position of delimiter if present
     if x>0 then y$=left$(y$,x-1) 'Strip delimiter & beyond
     y=len(y$):x=0
     while x=0 and y>0
     if mid$(y$,y,1)=" " then y=y-1 else x=1
     wend
     y$=left$(y$,y)               'Strip off all right-most spaces
     return
     '





     'PRINTER INITIALLIZATION FMM

PrtrCtrl:
     if PrtrCtrlState=0 then return
     IF PrtrCtrlState=1 THEN            'SEE IF PRINTER IN OPEN
        if PrintIOstate=3 then          'If the printer is on and ready then
           gosub ClearBottomRightWindow
           RxChar$=chr$(25)             'Marketeer's underline command chr
           gosub PrintDriver:x$=RxChar$ 'LQ printer's underline command esc seq
           RxChar$=chr$(25)             'Marketeer's underline command chr
           gosub PrintDriver            'LQ printer's underline command esc seq
           PrStr$=pp$(8)+pp$(9)        _'Reset printer & set top & left margins
                 +x$+"OUTGOING MESSAGE"_'Enable Underline
                 +RxChar$+NewLine$      'Disable Underline
           PrtrCtrlState=3              're-set to printer watchdog monitoring
      else PrtrCtrlState=2              'advance to wait for printer on
           PrintIOstate=1               'Activate the printer I/O FMM
           InstructionsColour=10        'display instructions asking user to
           gosub ShowInstructions       'switch on the printer.
           end if
 elseIF PrtrCtrlState=2 THEN            'WAIT FOR PRINTER TO OPEN
        if PrintIOstate>2 then          'If the printer is on and ready, then
           PrtrCtrlState=1              're-set Printer Watchdog to monitoring
           end if
 elseIF PrtrCtrlState=3 THEN            'CHECK PRINTER STAYS OPERATIONAL
        if PrintIOstate>4 then          'If the printer in error condition,
           PrintIOstate=0               'De-activate the Printer I/O FMM
           PrtrCtrlState=1              'Re-set Printer Watchdog to monitoring
           end if
        END IF
     RETURN                             'Return control to FMM polling loop.
     '





     'DISPLAY THE STATUS MESSAGES BOX

     'This routine displays the boxing and fixed text for the ticker-tape and
     'machine-state displays.

StatusBoxDisplay:
     row=3:column=41:colour=grey:ps$=space$(40)  :gosub Display    ' 4
     ps$="  ":for row=5 to 18:gosub 50:next
     row=4:column=43:colour=27
     ps$=" TRANSMISSION STATUS:                 ":gosub Display    ' 5
     colour=19
     ps$=" Service Name                        ":gosub Display    ' 6
     ps$=" Message Name                        ":gosub Display    ' 7
     ps$=" Call Status:                        ":gosub Display    ' 8
     ps$=" (Why Failed)                        ":gosub Display    ' 9
     ps$=" Last Command                        ":gosub Display    '10
     ps$=" Modem Ackmnt                        ":gosub Display    '11
     ps$="   To Modem                          ":gosub Display    '12
     ps$=" From Modem                          ":gosub Display    '13
     ps$=" Printer                             ":gosub Display    '14
     ps$="  ":gosub Display    '15
     ps$=" Target N 00  Target Serial N 0000  ":gosub Display    '16
     ps$=" Sending Telex N   0000   of   0000  ":gosub Display    '17
     ps$=string$(38,223):colour=1:gosub Display                    '18
     column=41:colour=grey
     ps$="     TxOff  RxOff  Remote Echo  Print   ":gosub Display  '19
     ps$="":colour=8
     column=45:gosub 50:column=52:gosub 50:column=59:gosub 50:column=72:gosub 50


     'SET UP THE PRINTER INSTRUCTIONS

     MessageRow1$="    SWITCH ON LETTER PRINTER Ŀ       "
     MessageRow2$="       MAKE SURE ITS HOPPER           "
     MessageRow3$="     CONTAINS A4 PLAIN PAPER.         "
     MessageRow4$="          "
     return                     'Return control to the FMM polling loop.


     'DISPLAY EMAIL SERVICE NAME & MESSAGE TITLE

ShowServiceName: column=57:colour=23

     ps$=ems$     :row=6:gosub ShowMessagesSub    'Display comms name
     ps$=MsgTitle$:row=7:gosub ShowMessagesSub    'Display message title
     x=TargNum :y=2:gosub LeadingZeros:TargNum$=x$
     x=ExtrFlag:y=4:gosub LeadingZeros:TargSer$=x$

     if TelxShotFlag=1 then
        row=16
        ps$=TargNum$:column=53:gosub 50
        ps$=TargSer$:column=74:gosub 50
        row=17
        x=TargItem:y=4:gosub LeadingZeros:ps$=x$:column=62:gosub 50
        x=TargSize:y=4:gosub LeadingZeros:ps$=x$:column=74:gosub 50
        colour=31:column=14
        row=15:ps$="READY TO SEND TELEXES":gosub 50
        row=16:ps$="FROM THE CALLING LIST":gosub 50
        end if
     return
     '





     'NUMERIC FORMATTERS

     'This routine formats an interger x into a string x$ containing the number
     'padded out with leading zeros as necessary to make it y digits long, plus
     'an extra leading space or minus sign according to the sign of x.

LeadingZeros:
     x$=str$(x)        'Number x as a string with a leading space or - sign
     x=len(x$)-1
     if x>y then x$=string$(y,"!"):return   'Out of range
     x$=right$(x$,x)
     if x<y then x$=string$(y-x,"0")+x$
     if x<0 then x$="-"+x$ else x$=" "+x$
     return
     '





     'SHOW THE MODEM STATUS MESSAGES

     'Displays the modem status messages etc. whenever a status condition
     'changes as indicated by one of the status flags becoming non-zero.

ShowMessages:
     if LastTask<>Task then
        LastTask=Task
        if connect>8 then
           if task=0 then task=5
           else
           if task=5 then task=0
           end if
        gosub ShowTaskLamps
        end if

     if LastConnect<>Connect then
        LastTask=-1
        row=2:column=73:colour=connect:ps$="":gosub 50
        end if

     if MessagesVisible=0 then return   'Exit if not on main display screen.

     if connect<>lastconnect      _     'If connection or echo status
        or echo<>lastecho then          'has changed since last pass, then
        lastconnect=connect             'Remember current connect status
        lastecho   =echo                'Remember current echo status
        if connect=8 or echo=8 then     'If no call connected or local echo set
           colour=8                     'then show the echo-lamp as unlit
      else colour=14                    'else show it as lit.
           end if
        ps$="":row=19:column=59:gosub 50  'Display the lamp
        end if

     if LastTxOffLamp<>TxOffLamp then        'If TxOff Lamp state has changed,
        LastTxOffLamp=TxOffLamp              'then display the lamp.
        colour=TxOffLamp
        ps$="":row=19:column=45:gosub 50
        end if

     if LastRxOffLamp<>RxOffLamp then        'If RxOff Lamp state has changed,
        LastRxOffLamp=RxOffLamp              'then display the lamp.
        colour=RxOffLamp
        ps$="":row=19:column=52:gosub 50
        end if

     if LastPrinterSwitch<>PrinterSwitch then    'If printer state has changed,
        LastPrinterSwitch=PrinterSwitch          'then display the lamp.
        colour=PrinterSwitch+PrinterSwitch+8
        ps$="":row=19:column=72:gosub 50
        end if
     '





     'SHOW THE MODEM STATUS MESSAGES [CONTINUED]

     IF ShowMessages>0 THEN             'If a message waiting to be displayed
        ShowMessages=0
        column=57                       'Start of status message fields
        colour=23                       'Normal display colour

        if MstatClr>0 then ps$=Mstatus$:row=8:gosub ShowMessagesSub:MstatClr=0
        if CstatClr>0 then ps$=Cstatus$:row=9:gosub ShowMessagesSub:CstatClr=0

        if ModemCmndClr>0 then               
           ModemCmndClr=0:ps$=""
           if ModemCmnd=1 then ps$="DIAL"
           if ModemCmnd=3 then ps$="DISCONNECT"
           if ModemCmnd=5 then ps$="CONFIGURE MODEM"
           if ModemCmnd=6 then ps$="SET CCITT MODE"
           if ModemCmnd=7 then ps$="SET DIALLING METHOD"
           row=10:gosub ShowMessagesSub         'Display modem command
           end if

        if Astatus>0 then                       ' 
           if Astatus=1 then
              colour=23
         else colour=79
              end if
           row=11:ps$=Astatus$                  'Display modem's command
           gosub ShowMessagesSub                'acknowledgement message
           end if
        if PrtClr>0 then
           ps$=Pstatus$:row=14:colour=PrtClr    'Display printIO error message
           gosub ShowMessagesSub:PrtClr=0       'PrtClr used as display trigger
           end if
        if DosClr>0 then
           colour=DOSclr:ps$=left$(DosMsg$,38)  'Display DOS error message
           ps$=ps$+space$(36-len(ps$))          'Pad message field to 35 chrs
           row=4:column=43:gosub 50:DosClr=0    'DosClr used as display trigger
           end if
        if LastTargItem<>TargItem then          'Whenever the Calling List N
           LastTargItem=TargItem:colour=23      'of the telex being sent 
           x=TargItem:y=4:gosub LeadingZeros    'increases, then display it.
           row=17:column=62:ps$=x$:gosub 50
           end if
        END IF
     RETURN                             'Return control to FMM polling loop.

ShowMessagesSub: ps$=left$(ps$,22):ps$=ps$+space$(22-len(ps$)):goto 50
     '





     'EMERGENCY MESSAGE

     'This message warns the operator that the modem will not acknowledge
     'its acceptance and execution of a DISCONNECT command. Therefore, it
     'may not release the call. The operator's only option is to unplug it
     'from the Telecom Line wall socket.

EmergencyMessage:
     if Astatus=3 then      'If modem failed to acknowledged last command then
        TelxInitState = 0   'Set initialization supervisor FMM state `inactive'
        CallCtrlState = 0   'Set Call Control FMM state to `inactive'
        DataDialState = 0   'Set Data call dialling FMM state to `inactive'
        ProtocolState = 0   'Set Data call dialling FMM state to `inactive'
        SendTelxState = 0   'Set Telex Transmission FMM state to `inactive'
        KillCallState = 0   'Set Call Disconnection FMM state to `inactive'
        AmendKeyState = 0   'Set Event Update       FMM state to `inactive' 

        MessageRow1$="   POSSIBLE MODEM MALFUNCTION: Unplug   "
        MessageRow2$="   it immediately from telephone line   "
        MessageRow3$="   and investigate the cause of its     "
        MessageRow4$="   non-acknowledgement of commands.     "
        InstructionsColour=12      'Bright red
        gosub ShowInstructions     'Display the above
        CWPstate=1
        end if
     return          'Return control to the FMM polling loop.
     '



   

     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION

     'This FMM controls the activities of the Telex Module initialization FMM
     'TelxInit.FMM. Once initialization has been completed upon first
     'entry into the FMM polling loop, the TelxInitState is set to zero thus
     'ensuring that this whole subsystem takes no further part in the proceed-
     'ings and is thus not a burden to the FMM polling loop cycle.

Initializer:
     if TelxInitState = 0 then return   'Initialization FMM inactive
     IF instr(KbStr$,chr$(27)) > 0 THEN 'If Esc key hit during initialization
        ACTIVE = 0                      'then de-activate the polling loop
     ELSEIF TelxInitState < 11 THEN     'Initialization in progress
        gosub TelxInit                  'Loop initialization FMM
     ELSE
        Signatory$ = TelexSig$
        JobTitle$ = TelexTit$
        gosub ShowServiceName           'Show Email Service name & message title
        if TelxShotFlag = 0 then        'If we are doing a one-off telex,
           if RecNum = 0 then
              SearchState = 1           'then activate the Record Search FMM
           else
              UpDown = 0
              NextPrevState = 1
           end if
        else
           CWPstate=1                   'else activate command word processor
        end if
        if TelxInitState = 11 then      'If initialization process succeeded,
           gosub ClearBottomRightWindow
        else
           beep                         'else beep
        end if
        PollState = 1                   'Activate modem status polling
        TelxInitState = 0               'De-activate the Initialization FMM
     END IF
     RETURN                             'Return control to FMM polling loop.


     'QUIT FMM POLLING LOOP

QuitLoop:
     if QuitFlag = 0 then return        'No `quit' request pending
     if CallCtrlState > 0 and  _        'If a call is in progress, and
        CallCtrlState < 8 then          'it has not yet terminated, then
        if CallCtrlState < 4 then       'If not in the process of releasing the
           CallCtrlState = 4            'call, then initiate a call release
           QuitFlag = 0
        end if
     elseif SearchState = 0 and _       'If exiting from search FMM 
            TelxShotFlag = 0 then       'or we are in teleshot mode
        CallCtrlState = 0               'De-activate the call control FMM
        CWPstate = 0                    'De-activate the command processor
        SearchState = 1                 'Re-activate the search key entry FMM
        QuitFlag = 0                    'Cancel the quit process
        LeftBox$ = "" : gosub ShowAbox  'Clear the name & address box
        PrintIOstate = 0                'De-activate the Printer I/O FMM
        Pstatus$ = "" : PrtClr = 23     'Clear printer status message
        DosMsg$ = "" : DosClr = 7       'Clear possible error message
        ShowMessages = 1                'Activate the message display routine
        PrtrCtrlState = 0               'De-activate printer integrity monitor
        gosub ClearBottomRightWindow
     else
        ACTIVE = 0                      'else de-activate the polling loop.
     end if
     RETURN                             'Return control to FMM polling loop.
     '





     'CALL OUTCOME MESSAGES

ShowCallResult:
     IF CallCtrlState>7        _        'If Call Control FMM has terminated
        OR EndOfCall=1 THEN             'or End Transmission chr found, then
        if CallCtrlError=0 then         'Call has completed successfully
           ps$="Call completed"         'so display the `call complete' message
           colour=10                    'in bright green
    elseif CallCtrlError=8 then         'Call has completed successfully
           ps$="Call skipped"           'so display the `call complete' message
           colour=14                    'in bright green
    elseif CallCtrlError=7 then         'If the call was manually aborted, then
           ps$="  Call aborted"         'display the `call aborted' message
           colour=12                    'in bright red
      else ps$="  Call failed:"         'otherwise the `call failed' message
           colour=12                    'in bright red
           end if
        row=4:column=26:gosub 50        'Display the message
        Pstatus$="":PrtClr=23
        ShowMessages=1                  'Clear status messages
        CallCtrlState=0                 'De-activate Call Control FMM
        PrtrCtrlState=0                 'De-activate Print Control FMM
        PrintIOState =0                 'De-activate Printer I/O FMM
        EndOfCall=0                     'Clear the End-of-Call flag
        TxStr$="":RxSrt$=""             'Clear the Transmit & Receive Stacks
        FileNum=0:gosub CloseFile       'Close files & printer channel
        END IF
     RETURN                             'Return control to FMM polling loop.


    'DISPLAY THE MAIN SET OF COMMAND WORDS & THE TASKS AVAILABLE

DefineCmndWords:
    cmdw$(1)="HELP":cmdw$(2)="QUIT"
    cmdw$(3)="NEXT":cmdw$(4)="PREV"
    cmdw$(5)="PRNT":cmdw$(6)="SEND"
    cmdw$(10)="KILL"
    cmdw=10                             'Number of effective command words
    task$(1)="SEEKING"
    task$(2)="LOADING"
    task$(3)="STORING"
    task$(4)="CALLING"
    task$(5)="CONNECT"
    tasks=4:return                      'Number of effective tasks


    'DISPLAY/CLEAR INSTRUCTIONS

ShowInstructions:
     row=19:column=41:colour=InstructionsColour
     ps$=MessageRow1$:gosub Display
     ps$=MessageRow2$:gosub Display
     ps$=MessageRow3$:gosub Display
     ps$=MessageRow4$:gosub Display
ClearBottomLeftWindow: column=1:x=23:goto ClearBottomWindow
ClearBottomRightWindow: column=41:if SearchState=0 then x=23 else x=24
ClearBottomWindow:
     ps$=space$(40):colour=7:for row=20 to X:gosub 50:next:return

