





     '-------------------------------------------------------------------------
     'TERMINAL SET UP DACOM ADM10 MODEM      04SEP1988        File:Terminal.BAS 
     '-------------------------------------------------------------------------
     'Author : R J Morton
     'Intelligent terminal program set up for the `Breakout' modem.
     '-------------------------------------------------------------------------
     defint a-z                'All variables are intergers
     rem $include: 'ComVars.INC'
     common EMS$               'Name of the selected service for auto-logon
     common EMS                'N of the selected service for auto-logon
     common EM
     Terminal=1                'Indicates terminal base for GetEMSD etc
     '
     '-------------------------------------------------------------------------
     'DEFINITION & ARRAY DIMENSIONING
     '
     dim rec$(12)
     dim Macro$(20)            'Holds the communications macro lines
     dim tty$(31)              'Teletype control code mnemonics
     dim pp$(20)               'Printer control strings
     dim EMSD$(6)              'Subscriber data
     goto Start
     '
     '-------------------------------------------------------------------------
     'EXTERNAL SUBROUTINES
     '
Display: row=row+1
50   call ScrSub(ps$,row,column,colour):return
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'FINITE-STATE MACHINES INCLUDED IN THIS LOAD MODULE
     ' 
     rem $include: 'KeyBoard.FMM' 
     rem $include: 'ADM10.FMM'          'I/O FMM for type of modem in use.  
     rem $include: 'Expiry.INC'
     rem $include: 'Decrypt.INC'
     '
     rem $include: 'TermInit.FMM'       'THE INITIALIZATION GROUP
     rem $include: 'GetPrt.FMM'
     rem $include: 'GetTTY.FMM'
     rem $include: 'GetSigna.FMM'
     rem $include: 'MsgTitle.FMM'
     rem $include: 'GetMacro.FMM'
     rem $include: 'GetEMSD.FMM'
     rem $include: 'SubstMac.FMM'
     rem $include: 'PrintIO.FMM'
     rem $include: 'OpenFile.FMM'
     '
     rem $include: 'AutoLogn.FMM'       'THE CALL PROCESSING GROUP
     rem $include: 'DataDial.FMM'
     rem $include: 'Protocol.FMM'
     rem $include: 'SendFile.FMM'
     rem $include: 'SaveFile.FMM'
     rem $include: 'KillCall.FMM'
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'SET UP & INITIALIZE THE TERMINAL PARAMETERS
     '
Start:
     ScrRow= 7          'Row for start of display of screen display string
     ScrCol= 1          'Column for start of display of screen display string
     ScrClr=23          'Colour for of display of screen display string
     RowRow=7
     ColCol=1
     PadCount=80        'Padding necessary for current line if C/R occurs
     scr$=""            'Post-scroll re-display string
     ScrBl$=space$(80)  'To clear last line after scrolling
     ClearWindow$=space$(1200)
     ScrRowx=21         'Bottom line of window (for wipe-after-scroll)
     '
     gosub ShowTerminalScreen      'Display the Terminal Screen format
     ps$="Initialising Terminal":colour=2:row=3:column=53:gosub 50:DosMsg$=ps$
     '
     PrFileNum=2      'File number under which printer is opened
     RxFileNum=3      'File number under which RxFile is opened.
     TxFileNum=4      'File number under which TxFile is opened.
     TxRecLen=1024    '1k input block for getting message from message file
     MoFileNum=5      'File number under which modem is opened if applicable
     '
     PrtType$="LQ"               'Set printer port for correspondence printer
     ComType$="TERML"            'Set modem for `Terminal Mode' operation
     LastMacroLine=4             'Only part of macro procedure is to be used.
     CrLf$=chr$(13)+chr$(10)     'New-Line string as found in text files
     NewLine$=chr$(13)+chr$(10)  'New-line string for outgoing telexes
     BlankLine$="     "+NewLine$ 'Blank line hold character for telexes
     '
     MaxStack=255     'Maximum length of strings used as inter-process buffers
     Emergency=3      'N quit attempts required in event of call control error
     '
     EMSrow=4
     EMScol=12
     PrtRow  = 5
     PrtCol  =12
     DosRow  = 3
     DosCol  =53
     ModemRow= 4      'Row on which messages from modem control are to appear
     ModemCol=53      'Column   "      "       "    "      "     "       "
     CallRow = 5      'Row on which messages from modem control are to appear
     CallCol =53      'Column   "      "       "    "      "     "       "
     '
     gosub ExpiryTest            'Protection lock
     '
     '--------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'THE FINITE STATE MACHINE POLLING LOOP
     '
     'The service programs which perform the various tasks here are written as
     'Message-drived Finite State Machines. Each FMM is continually polled in
     'sequence from the following polling loop.
     '
     TermInitState = 1        'Kick-start the initialization FMM hierarchy
     PollState = 0            'Suppress modem status polling
     PrinterLamp=8            'Set printer off
     SaveFileLamp=8           'Set `save to file' off
     SendFile  = 8            'Clear the `file being transmitted' flag
     LineFeed  = 8            'Set for no line feed after carriage returns
     Connect   = 8            'Clear the `call connected' flag
     Echo      =10            'Default: set to `remote' echo
     TxOffLamp = 8            'Set to X-on
     RxOffLamp = 8            'Set to X-on
     help      = 0            'Set `not help screen'
     EchoTrain = 0            'Holds N of characters which have been send but
                              'for which an echo has not yet been received.
     KbStr$ =""               'Clear keyboard input string
     TxStr$ =""               'Clear the transmission string
     '
     locate 7,1,1,6,7         'Cursor to start of Terminal Display Window
     '
     '-------------------------------------------------------------------------
     'AWAIT THE NEXT CHARACTER FROM KEYBOARD OR MODEM
     '
PollingLoop:    'NOTE the Show FMMs clear the delta flags set by other FMMs
     gosub Initializer          'Transfer of control from initialization
     gosub Keyboard             'Poll keyboard for incoming characters
     gosub ModemIO              'Modem character input/output
     gosub CallCtrl             'Call Control supervisor FMM
     gosub CheckFunctionKeys    'Function key processor
     gosub ProtocolResponses    'Put macro responses onto Tx Stack
     gosub ProcessKeyboardInput 'Keyboard input processor
     gosub ProcessIncomingData  'Character from modem
     gosub SendFile             'Send text frm Tx File if required.
     gosub SaveFile             'Save incoming text if required.
     gosub DisplayWindow        'Display any text in ScrStr$ in terminal window
     gosub PrtrCtrl             'Check printer integrity (calls PrintIO.FMM)
     gosub OpenFileFMM          'General File Opening FMM
     gosub ShowLamps            'Display any lamps which have changed state
     gosub ShowMessages         'Display any pending messages
     gosub QuitLoop             'Means of escape from the FMM polling loop
     goto  PollingLoop          'Return to the start of the polling loop.
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'TRANSFER OF CONTROL FROM LOAD MODULE INITIALIZATION
     '
     'This FMM supervisor routine controls the activities of the Telex Module
     'initialization FMM TermInit.FMM and the display routine ShowInitStates
     'which displays the states of TermInit.FMM. Once the initialization
     'process has been completed once upon first entry into the FMM polling
     'loop, the TermInitState is set to zero thus ensuring that this whole
     'subsystem takes no further part in the proceedings and is thus not a
     'burden to the FMM polling loop cycle.
     '
Initializer: 
     if TermInitState=0  then return  'Initialization FMM inactive
     if instr(KbStr$,chr$(27))>0 then return QuitLoop2
     if TermInitState<13 then _       'Initialization in progress
        gosub TermInit:return         'Loop initialization FMM
     if TermInitState=13 then         'If initialization successful, then
        PollState=1                   'Activate modem status polling
        if ems>0 then CallCtrlState=1 'If a comms service has been selected,
        end if                        'activate the autologon procedure.
     if MsgTitle$>"" then
        ps$=MsgTitle$:column=12:colour=2:row=3
        x=27:gosub ShowMessages1
        end if
     if DosMsg$="Initialising Terminal" then
        DosMsg$="":DosClr=2:ShowMessages=1
        end if
     TermInitState=0                  'De-activate the Initialization FMM
     return                           'Return control to the FMM polling loop
     '
     '-------------------------------------------------------------------------
     '





     '--------------------------------------------------------------------------
     'QUIT FMM POLLING LOOP
     '
QuitLoop:
     if QuitFlag=0 then return    'No `quit' request pending
     if Emergency<1 then return QuitLoop2
     Emergency=Emergency-1        'control error exists to make the 
     if SaveFileState>0 then      'If file saving is active, then
        if SaveFileState=3 then   'if file saver is in main state, then
           SaveFileState=4        'set it to termination state
           end if                 'else wait till it terminates.
        return                    '
        end if                    '
     '
     if CallCtrlState>4 and   _   'If currently in the process of clearing
        CallCtrlState<8 then  _   'a call, then continue until the call has
        return                    'been disconnected. [States 5,6,7]
     '
     if CallCtrlState>0 and   _   'If a call sequence is active, but
        CallCtrlState<5       _   'not in the disconnecting phase, or
        or connect>8    then  _   'still connected to remote station, then
        CallCtrlState=5:return    'initiate a call release. [States 1,2,3,4]
     '
     if CallCtrlState=9 and   _   'Several quit attempts must be made to
        Emergency>0 then          'quit the terminal program if a call
        Emergency=Emergency-1     'control error exists to make the 
        QuitFlag=0:return         'operator aware of modem malfunction.
        end if
     '
QuitLoop2:
     gosub DisplayWindow6         'Clear terminal window
     '
     row=7:column=1:colour=23:ps$="Closing terminal":gosub 50
     gosub WipeV24Lamps
     locate 21,5
     FileNum=0:gosub CloseFile    'Close all files and printer
     prog$="TERMINAL"             'Set where control came from
     chain"Tmenu"                 'Exit this load module; go back to Tmenu
     '
     '-------------------------------------------------------------------------
     'PROCESS PROTOCOL MACRO RESPONSES
     '
ProtocolResponses:
     if Response$="" then return           'No macro response to send
     if len(TxStr$)>MaxStack then return   'No space left in TxStack$
     gosub AutoHelpTrip                    'Auto-revert from help screen
     x$=Response$:Response$=""
     if echo>8 then                        'If remote echo is operational, then
        EchoTrain=EchoTrain+len(x$) _      'add number of new characters to the
       -SuppressedEcho                     'less N of echo-suppressed chrs
        else                               'else zeroise
        EchoTrain=0                        'total of chrs waiting to be echoed.
        end if
     SuppressedEcho=0
     if LineFeed>8 then               _    'If LFs required after CRs then
        gosub InsertLFafterCR              'Insert line feeds after CRs
     TxChar$=x$:gosub ModemEF              'Put on transmission block
     return                                'Return control to FMM polling loop
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'TRANSFER KEYBOARD INPUT TO TRANSMISSION STACK
     '
ProcessKeyboardInput:
     if KbStr$="" then return              'Nothing from keyboard or protocol
     if CallCtrlState>0 and        _       'In an autologon phase
        CallCtrlState<4 and        _
        KbStr$>"" then                     'and a keystroke occurs, then
        CallCtrlState=5                    'abort the autologon procedure and
        DosMsg$="Auto-Logon aborted!"      'display the message to this effect.
        DosClr=12                          'display it in bright red
        ShowMessages=1                     'set the message display flag
        end if
     if len(TxStr$)>MaxStack then return   'No space left in TxStack$
     if connect=8 then PollState=0         'Keystroke stops status polling
     gosub AutoHelpTrip                    'Auto-revert from help screen
     x$=KbStr$:KbStr$=""                   'Form total output string
     '
     if connect>8 and echo>8 then          'If connected and remote echo, then
        EchoTrain=EchoTrain+len(x$)        'add N of new chrs to the total N
        end if                             'currently waiting to be echoed.
     '
     if LineFeed>8 then                    'If LFs required after CRs then
        gosub InsertLFafterCR              'Insert line feeds after CRs
        end if
     '
     if PollState=0 then                   'If status polling is not active
        TxStr$=TxStr$+x$                   'then add chrs straight to Tx Stack
   else TxChar$=x$:gosub ModemEF           'else pass them thru + stuffer
        end if
     '
     return                                'Return control to FMM polling loop
     '
     '-------------------------------------------------------------------------
     '





     '-------------------------------------------------------------------------
     'NORMAL CHARACTER [RxChar$] RECEIVED FROM REMOTE END
     '
ProcessIncomingData:
     if RxStr$="" then return             'No received characters waiting.
     if len(ScrStr$)>MaxStack then return 'If screen has not caught up
                                          'then leave data on Rx Stack.
     if PrtrCtrlState>0 and    (  _       'IF {[the printer is active] AND
        PrintIOstate<>3 or PrCTS=0_       '[the printer is not ready OR the
        or len(PrStr$)>MaxStack)  _       'printer stack is currently full]}
        then return                       'THEN leave data on Rx Stack.
     '
     gosub AutoHelpTrip                   'Auto-revert from help screen
     x$=RxStr$:RxStr$=""                  'Transfer received stack to x$
     '
     '-------------------------------------------------------------------------
     'SET DISPLAY COLOUR FOR ECHOED CHARACTERS
     '
     if connect=8 then                  'If not connected to a remote service
        TermClr=19                      'then set display colour bright green
        else                            'otherwise...
        if EchoTrain=0 then             'If no echoed characters expected,
           TermClr=23                   'then set display colour to dim cyan
      else TermClr=31                   'Set display colour to bright cyan
           x=len(x$)
           if EchoTrain<x then          'If N chrs rec'd > N expected in echo,
              RxStr$                 _  'Put chrs beyond end of echo
             =right$(x$,x-EchoTrain) _  'back at the front of the Rx
             +RxStr$                    'Stack to be handled next pass.
              x$=left$(x$,EchoTrain)    'Do only chrs within the echo this pass
              EchoTrain=0               'and clear the N of chrs to be echoed.
         else EchoTrain=EchoTrain-x     'expected to be echoed, decrement the
              end if                    'length of the echo train by this
           end if                       'amount and deal with the echo so far.
        end if
     '
     '-------------------------------------------------------------------------
     'PASS RECEIVED DATA TO SCREEN, PRINTER AND RX FILE
     '
     ScrStr$=ScrStr$+x$                   'Send received characters to screen
     if ProtocolState>0 then PromptIn$=x$ 'Pass incoming data to Protocol.FMM
     if PrtrCtrlState>0 then              'If the printer is active then
        gosub InsertLFafterCR             'Insert LFafterCR in MS-DOS text file
        PrStr$=PrStr$+x$                  'Send received characters to printer
        end if
     if SaveFileState=3 then              'If saving to Rx File is active, then
        gosub InsertLFafterCR             'Insert LFafterCR in MS-DOS text file
        RxFileStr$=RxFileStr$+x$          'Put character to the save file
        end if
     return                               'Return to FMM polling loop.
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'FUNCTION KEY ROUTINE
     '
CheckFunctionKeys:
     '
     if KbCtrl$="" then return               'No function keystrokes pending
     DosMsg$="":DosClr=1:ShowMessages=1      'Clear any error message
     Fkey=asc(left$(KbCtrl$,1))-58           'Function key number
     KbCtrl$=right$(KbCtrl$,len(KbCtrl$)-1)  'Chop character off string
     '
     if Fkey=1 goto ShowHelpScreen
     gosub AutoHelpTrip                      'Auto-revert from help screen
     '
     if Fkey=2 then QuitFlag=1         'Set to quit the terminal program
     '
     if Fkey=3 then               _    'Clear the screen by
        ScrStr$=ScrStr$+chr$(12)       'setting up an FF character
     '
     if Fkey=4 then                    'If the Tx File key is toggled, then
        if SendFileState=0        _    'if a send file process is not active
           then SendFileState=1   _    'then activate the SendFile.FMM
           else SendFileState=0        'else de-activate the SendFile.FMM
        end if                         '
     '
     if Fkey=5 then                    'Toggle the printer on/off
        if PrtrCtrlState=0 then        'If printer is currently off
           PrtrCtrlState=1             'then initiate a printer open
      else PrtrCtrlState=4             'else initiate a printer shut-down
           end if                      '
        end if                         '
     '
     if Fkey=6 then                    'Toggle the Save File on/off
        if SaveFileState=0        _    'If the Save File is inactive
           then SaveFileState=1   _    'then activate it
           else SaveFileState=4        'else activate the closing procedure
        end if                         '
     '  
     if Fkey=7 then                    'Toggle the Remote Echo on/off
        if echo=8                 _    '
           then echo=10           _    '
           else echo =8                'F7
        EchoTrain=0                    '
        end if                         '
     '
     if Fkey=8 then                    'Toggle LFafterCR on outgoing data
        if LineFeed=8             _    '
           then LineFeed=10       _    '
           else LineFeed=8             'F8
        end if
     '
     if Fkey=9 and CallCtrlState>0 _   'Disconnect call if one connected.
               and CallCtrlState<5 _   '
              then CallCtrlState=5     '
     '
     if Fkey=10 and Connect=8 then CallCtrlState=1  'Retry logon
     return
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'TERMINAL HELP SCREEN
     '
ShowHelpScreen:
     '
     if help=1 goto AutoHelpTrip        'Cancel help screen
     Xpos=pos(0):Ypos=csrlin
     row=ScrRow-2:column=ScrCol:colour=112
     '
     ps$="":gosub Display
     ps$=" INSTRUCTIONS FOR USING THE TERMINAL    ":gosub Display    'left   1
     ps$="                                        ":gosub Display    'left   2
     ps$=" Refer to the Modem Manual on how to    ":gosub Display    'left   3
     ps$=" control the modem & dial a number.     ":gosub Display    'left   4
     ps$=" Refer to Communications Service's      ":gosub Display    'left   5
     ps$=" Manual on how to use the service.      ":gosub Display    'left   6
     ps$="                                        ":gosub Display    'left   7
     ps$=" Press:                                 ":gosub Display    'left   8
     ps$=" F1 to return to the terminal screen.   ":gosub Display    'left   9
     ps$=" F2 to disconnect/return to Comms Menu. ":gosub Display    'left  10
     ps$=" F3 to clear Terminal Display Window.   ":gosub Display    'left  11
     ps$=" F4 to send current contents of TX-FILE ":gosub Display    'left  12
     ps$=" F5 to cause all incoming & outgoing    ":gosub Display    'left  13
     ps$="":gosub Display
     row=ScrRow-2:column=41
     ps$="":gosub Display
     ps$="    text to be printed.                 ":gosub Display    'right  1
     ps$=" F5 again to disable printer output.    ":gosub Display    'right  2
     ps$=" To print what is already on screen,    ":gosub Display    'right  3
     ps$=" press PrtSc, but only if incoming      ":gosub Display    'right  4
     ps$=" text is not scrolling the screen.      ":gosub Display    'right  5
     ps$="                                        ":gosub Display    'right  6
     ps$=" F6 to capture incoming text in RX-FILE ":gosub Display    'right  7
     ps$=" F6 a second time to close the RX-FILE  ":gosub Display    'right  8
     ps$=" F7 enable/disable remote echo          ":gosub Display    'right  9
     ps$=" F8 enable/disable line-feed after C/R  ":gosub Display    'right 10
     ps$=" F9 Disconnect current call             ":gosub Display    'right 11
     ps$=" F10 Retry to log on to comms service   ":gosub Display    'right 12
     ps$="    in event of an auto-logon failure.  ":gosub Display    'right 13
     ps$="":gosub Display
     '
     locate 23,5,0,6,7:help=1:return                     'Turn cursor off
     '
     '-------------------------------------------------------------------------
     'HELP TEXT DISPLAY INTERRUPT SUBROUTINE
     '
AutoHelpTrip: if help=0 then return
     '
     row= 6:column=1:colour=1:ps$=string$(80,""):gosub 50
     gosub DisplayWindow6a    'Clear the terminal window
     gosub DisplayWindow5     'Redisplay the original screen string
     locate Ypos,Xpos,1,6,7   'and turn cursor back on.
     RowRow=Ypos:ColCol=Xpos
     help=0                   'Clear the help flag
     return                   'Exit
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'TERMINAL SCREEN FORMAT
     '
ShowTerminalScreen:
     '
     ps$="[COMMS TERMINAL]                     "       'Module title
     row=1:column=19:colour=7:gosub 50
     '
     colour=grey:column=1 '    -------------27-------------
     row=3:ps$="TX-FILE:                                ":gosub 50
     row=4:ps$="LOGGED ON:                              ":gosub 50
     row=5:ps$="PRINTER:                                ":gosub 50
     '
     column=41     '        -------------27-------------
     row=3:ps$="                                        ":gosub 50
     row=4:ps$="CALL STATE:                             ":gosub 50 'Mstatus$
     row=5:ps$="MODEM MSGS:                             ":gosub 50 'Cstatus$
     column=1
     row= 6:colour=1:ps$=string$(80,""):gosub 50
     row= 7:colour=23:ps$=space$(1200)  :gosub 50
     row=22:colour=1:ps$=string$(80,""):gosub 50
     '
     ps$="F1-HELPF2-EXITF3-WIPEF4 SENDF5 PRNTF6 SAVEF7 ECHOF8 CRLFF9-HANGF10-AL"
     row=24:column=1:colour=112:gosub 50
     ps$="":colour=120
     column=28:gosub 50:column=36:gosub 50:column=44:gosub 50:column=52:gosub 50:column=60:gosub 50
     ps$="  AUTO-LOGON   ON-LINE   X-OFF OUTGOING   X-OFF INCOMING     RECEIVE FILES FREE "
     row=23:column=1:colour=7:gosub 50
     ps$="":colour=8
     column=2:gosub 50:column=15:gosub 50:column=25:gosub 50:column=42:gosub 50
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'SHOW INDICATOR LAMPS & N OF RX-FILES LEFT
     '
     'Entered each polling cycle, this routine checks current status of each
     'on-screen indicator `lamp'. If a lamp has changed state since previous 
     'pass, the new state of the lamp is displayed. It also displays current
     'N of receiver files if the N available has changed since previous pass.
     '
ShowLamps:
     '
     if LastPrinterLamp<>PrinterLamp then  _    'Printer on lamp
        LastPrinterLamp= PrinterLamp       _    '
       :row=24:column=36:colour=PrinterLamp     :gosub ShowLamps1
     '
     if LastSaveFileLamp<>SaveFileLamp then_    'Saving to file lamp
        LastSaveFileLamp= SaveFileLamp     _    '
       :row=24:column=44:colour=SaveFileLamp    :gosub ShowLamps1
     '
     if LastEcho<>echo then                _    'Remote echo on lamp
        LastEcho= echo                     _    '
       :row=24:column=52:colour=echo            :gosub ShowLamps1
     '
     if LastLineFeed<>LineFeed then        _    'LF after CR on Tx lamp
        LastLineFeed= LineFeed             _    '
       :row=24:column=60:colour=LineFeed        :gosub ShowLamps1
     '
     if LastSendFileLamp<>SendFileLamp then_    'Sending from Tx File lamp
        LastSendFileLamp= SendFileLamp     _    '
       :row=24:column=28:colour=SendFileLamp    :gosub ShowLamps1
     '
     if LastLogonLamp<>LogonLamp then      _    'Auto Logon in progress lamp
        LastLogonLamp= LogonLamp           _    '
       :row=23:column=2:colour=LogonLamp        :gosub ShowLamps2
     '
     if LastConnect<>Connect then          _    'On-Line (connected) lamp
        LastConnect= Connect               _    '
       :LoggedOn=0                         _    'Clear the Logged-On flag
       :row=23:column=15:colour=Connect         :gosub ShowLamps2
     '
     if LastTxOffLamp<>TxOffLamp then      _    'Outgoing data is Xed off
        LastTxOffLamp= TxOffLamp           _    '
       :row=23:column=25:colour=TxOffLamp       :gosub ShowLamps2
     '
     if LastRxOffLamp<>RxOffLamp then      _    'Incoming data is Xed off
        LastRxOffLamp= RxOffLamp           _    '
       :row=23:column=42:colour=RXoffLamp       :gosub ShowLamps2
     '
     if LastNumRxFiles<>NumRxFiles then    _    'If N of spare Rx Files left 
        LastNumRxFiles= NumRxFiles         _    '
       :ps$=left$(str$(NumRxFiles),4)      _    'in the Rx Library has changed
       :ps$=space$(4-len(ps$))+ps$         _    'then display the new number.
       :row=23:column=57:colour=7:gosub 50      '
     '
     return                                     'Return to the FMM polling loop
ShowLamps1: if colour=8 then colour=120 else colour=122
ShowLamps2: ps$="":goto 50
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'SHOW DOS, PRINTER, MODEM ERROR MESSAGES & CALL STATUS MESSAGES
     '
     'This routine is passed through once every polling loop cycle. Each pass,
     'it checks the current status of each message source to see if there is
     'a message to be displayed. It displays the respective source's message
     'string if, and only if there is a message from that source.
     '
ShowMessages:
     IF ShowMessages>0 THEN             'If there are messages to display, then
        ShowMessages=0                  'Clear message display trigger
        if AstatClr>0 then              'Modem command acknowledgements
           ps$=Astatus$:row=CallRow
           column=CallCol:colour=AstatClr
           gosub ShowMessages0:AstatClr=0
           end if
        if MstatClr>0 then              'Modem activity message
           ps$=Mstatus$:row=ModemRow
           column=ModemCol:colour=MstatClr
           gosub ShowMessages0:MstatClr=0
           end if                       '
        if CstatClr>0 then              'Call status message
           ps$=Cstatus$:row=CallRow
           column=CallCol:colour=CstatClr
           gosub ShowMessages0:CstatClr=0
           end if                       '
        if PrtClr>0 then                'Printer control message
           ps$=Pstatus$:row=PrtRow
           column=PrtCol:colour=PrtClr  '
           gosub ShowMessages0:PrtClr=0 '
           end if                       '
        if DosClr>0 then                'DOS error message
           ps$=DosMsg$:row=DosRow
           column=DosCol:colour=DosClr  '
           x=28:gosub ShowMessages1:DosClr=0
           end if                       '
        if EMS>0 then                   '
           if LastLoggedOn<>LoggedOn then
              LastLoggedOn =LoggedOn    '
              if LoggedOn=1 then        'If connected and logged on, then
                 colour=2:ps$="to "+ems$'Display the name of Comms Service
                 else colour=grey:ps$=""'Clear name of Comms Service
                 end if                 '
              row=EMSrow:column=EMScol  '
              gosub ShowMessages0       '
              end if                    '
           end if                       '
        END IF                          '
     RETURN                             'Return to the FMM polling loop
     '
ShowMessages0: x=27
ShowMessages1: ps$=left$(ps$,x):ps$=ps$+space$(x-len(ps$)):goto 50

     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'PRINTER INITIALLIZATION FMM
     '
PrtrCtrl:
     IF PrtrCtrlState=0 THEN return     'PRINTER INACTIVE
     '
     IF PrtrCtrlState=1 THEN            'SEE IF PRINTER IS OPEN
        if PrintIOstate=3 then          'If the printer is on and ready then
           PrtrCtrlState=3              're-set to printer watchdog monitoring
      else PrintIOstate=1               'else activate the printer I/O FMM
           PrtrCtrlState=2              'and advance to wait for printer on
           end if
     '
 ELSEif PrtrCtrlState=2 THEN            'WAIT FOR PRINTER TO OPEN
        if PrintIOstate=3 then          'Printer has initialized, then
           PrStr$=pp$(8)+pp$(9)         'Set top and left margin.
           PrtrCtrlState=3              'Re-set Printer Watchdog to monitoring
           PrinterLamp=10               'Set printer on (lamp lit)
           end if
     '
 ELSEif PrtrCtrlState=3 THEN            'CHECK PRINTER STAYS OPERATIONAL
        if PrintIOstate=6 then          'If printer gone to error state, then
           PrintIOstate=0               'De-activate the Printer I/O FMM
           PrtrCtrlState=1              'Re-set Printer Watchdog to monitoring
           PrinterLamp=12               'Set printer red (error indication)
           end if
     '
 ELSEif PrtrCtrlState=4 THEN            'SHUT DOWN THE PRINTER
        PrintIOstate=5                  'Force printer shut-down
        PrtrCtrlState=5                 'Re-set Printer Watchdog to monitoring
     '
 ELSEif PrtrCtrlState=5 THEN            'ENTERED AFTER SETTING PrtrCtrlState=5
        if PrintIOstate=6 then          'If the printer has de-activated, then
           PrtrCtrlState=0              'De-activate the printer control FMM
           PrintIOstate=0               'De-activate the print I/O FMM
           PrinterLamp=8                'Set printer off (lamp out)
           end if
        END IF
     '
     goto PrintIO              'return to the FMM polling loop via PrintIO.FMM
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'TERMINAL SCREEN DISPLAY WINDOW ROUTINE [POLLED FROM FMM LOOP]
     '
     'This routine displays each character as it is received from the line.
     'As characters are displayed, they are tacked onto the screen display
     'string `scr$'. When the Terminal Display Window (lines 7 to 21 of the
     'screen) have been filled completely, the first 80 characters are chopped
     'off the beginning of `scr$' which is then displayed from line 7 column 1
     'by the fast screen display subroutine `ScrSub' which is then used to wipe
     'line 21. The character which caused the scroll overflow is then printed
     'in column 1 of line 21 in the usual way.
     '
     '-------------------------------------------------------------------------
     'FORM-FEED CHARACTER CLEARS THE SCREEN
     '
DisplayWindow:
     x=1:y=1:While x>0
     x=instr(y,ScrStr$,chr$(12))        'Find next form-feed character.
     if x>0 then y=x+1                  'If one is found, then
     wend
     if y>1 then
        gosub DisplayWindow6
        ScrStr$=right$(ScrStr$,len(ScrStr$)-y+1)
        end if
     '
     '-------------------------------------------------------------------------
     'PAD OUT THE INPUT STRING TO FILL LINES TO 80 CHRACTERS
     '
     x=1:y=1:While x>0                  'While there is a C/R present
     x=instr(y,ScrStr$,chr$(13))        'Locate the next C/R character
     if x>0 then                        'If a new C/R is found, then
        z=x-y                           'N of chrs between successive C/Rs
        if z<=PadCount then             'If chrs will fit on current line, then
           ScrStr$=left$(ScrStr$,x-1) _ 'remove the C/R character and insert in
          +space$(PadCount-z)         _ 'its place enough spaces to lengthen
          +right$(ScrStr$,len(ScrStr$)-x)'the line to the full width of 80 chrs.
           end if                       '
        y=y+PadCount                    'Advance pointer to start of next line.
        PadCount=80                     'Next line is empty as yet.
        end if                          '
     wend                               '
     '
     '-------------------------------------------------------------------------
     '







     '-------------------------------------------------------------------------
     'DISPLAY THE NEW TEXT
     '
     scr$=scr$+ScrStr$                  'Add new text to screen string
     '
     if len(scr$)<1200 then             'If not reached scrolling point
        call ScrSub(ScrStr$,RowRow,ColCol,TermClr)
        ColCol=ColCol+len(ScrStr$)
        while ColCol>80:ColCol=ColCol-80
        RowRow=RowRow+1
        wend
        locate RowRow,ColCol
   else x=len(scr$)
        while x>1199:x=x-80:wend
        scr$=right$(scr$,x)             'Chop off the old line 7
        gosub DisplayWindow5            'Re-display lines 7 to 18
        while x>79:x=x-80:wend
        RowRow=21:ColCol=1
        if x=0 then
           ps$=ScrBl$
      else ps$=right$(scr$,x)+space$(80-x) 
           end if
        call ScrSub(ps$,RowRow,ColCol,TermClr)   'Wipe last line of window
        ColCol=x+1
        locate 21,ColCol                'Set cursor to start last line
        end if
     '
     PadCount=81-ColCol
     ScrStr$="":return
     '
     '-------------------------------------------------------------------------
     'RE-DISPLAY THE TERMINAL WINDOW CONTENTS AFTER A SCROLL
     'OR ON RETURN FROM THE HELP SCREEN
     '
DisplayWindow5: call scrsub(scr$,ScrRow,ScrCol,ScrClr):return
     '
     '-------------------------------------------------------------------------
     'CLEAR THE TERMINAL DISPLAY WINDOW
     '
DisplayWindow6:  gosub DisplayWindow6a
                 scr$="":PadCount=80:locate 7,1
                 RowRow=7:ColCol=1
                 if connect=8 then print S4$;:ColCol=2:scr$=S4$
                 return
DisplayWindow6a: call scrsub(ClearWindow$,ScrRow,ScrCol,ScrClr):return
     '
     '-------------------------------------------------------------------------
     '
